﻿if select(2, UnitClass("player")) ~= "PALADIN" then
 return
end

local LCI = LibStub("libCandyIcon-2.0", true)

local Removed = GetLocale() == "ruRU" and " рассеивается!" or " was removed!"

local SpellName, _, SpellIcon = GetSpellInfo(53563) -- Частица света
local playerID

local extraOptions = {
 {
  [0] = "Additional",
  { type = "Check", var = "colGradientTime", default = true, label = "Use Gradient Color for Time", tip = "", y = 12 },
  { type = "Check", var = "colGradient", default = true, label = "Use Gradient Color for Bar", tip = "", y = 8 },
  { type = "Color", var = "colNormal", default = { 0.4, 0.6, 0.8, 1.0 }, label = "Bar Color", y = 8 },
  { type = "Check", var = "Animation", default = true, label = "Use Animation", tip = "" },
  { type = "Slider", var = "AnimationTime", default = 5, label = "Animation time", min = 1, max = 59, step = 1, y = 4 },
  { type = "Slider", var = "AnimationX", default = 610, label = "Animation Icon Offset X", min = 0, max = 2048, step = 1, y = 4 },
  { type = "Slider", var = "AnimationY", default = 546, label = "Animation Icon Offset Y", min = 0, max = 1536, step = 1, y = 4 },
  { type = "Slider", var = "AnimationSize", default = 60, label = "Animation Icon Size", min = 20, max = 200, step = 1, y = 16 },
  { type = "Check", var = "AnimationLock", default = true, label = "Lock/Unlock", tip = "" },
 },
}
local bcr, bcg, bcb = 0.4, 0.6, 0.8
local tcr, tcg, tcb = 0, 1, 0
local useGradient, useGradientTime, useAnimation, useLocked = true, true, true, true

-- http://www.wowwiki.com/ColorGradient
local function ColorGradient(perc, ...)
 if perc >= 1 then
  local r, g, b = select(select('#', ...) - 2, ...)
  return r, g, b
 elseif perc <= 0 then
  local r, g, b = ...
  return r, g, b
 end
 local num = select('#', ...) / 3
 local segment, relperc = math.modf(perc*(num-1))
 local r1, g1, b1, r2, g2, b2 = select((segment*3)+1, ...)
 return r1 + (r2-r1)*relperc, g1 + (g2-g1)*relperc, b1 + (b2-b1)*relperc
end

local button = CreateFrame("Frame", "_"..SpellName.."_", UIParent)
button:SetScale(1)
button:SetClampedToScreen(true)

local icon = button:CreateTexture(nil, "BACKGROUND")
icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
icon:SetAllPoints(button)
icon:SetVertexColor(1.0, 0.6, 0.3, 1)
icon:SetTexture(SpellIcon)
icon:SetVertexColor(1, 1, 1, 1)
icon:SetBlendMode("DISABLE")

button.icon = icon
button:Hide()

if LCI then
 local animation = {
  ["alpha"] = 1.0,
  ["fadein_anim"] = "id",
  ["fadein_duration"] = 0.2,
  ["fadeout_anim"] = "magnify",
  ["fadeout_duration"] = 0.2,
  ["idle_anim"] = "bounce",
  ["idle_duration"] = 1.0,
 }

 LCI:MakeCandyIcon(button, animation)

 button.RealShow = button.Show

 button.Show = function(self)
  self:RealShow()
  self:Play()
 end

 button.Hide = function(self)
  self:Stop()
 end
end

-- Plugin
local plugin = AzCastBar.CreateMainBar("Frame", "Beacon", extraOptions)

-------------------------------------------------------------------------------
-- Code
-------------------------------------------------------------------------------
function plugin:OnConfigChanged(cfg)
 if cfg.enabled then
  playerID = UnitGUID("player")
  self.InCombat = UnitAffectingCombat("player")
  self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
  self:RegisterEvent("PLAYER_REGEN_DISABLED")
  self:RegisterEvent("PLAYER_REGEN_ENABLED")
  self:Show()
 else
  self:UnregisterAllEvents()
  self:Hide()
 end
 bcr, bcg, bcb = unpack(cfg.colNormal)
 tcr, tcg, tcb = unpack(cfg.colTimeLabel)
 useGradient = cfg.colGradient
 if not useGradient then
  self.status:SetStatusBarColor(bcr, bcg, bcb, 1)
 end
 useGradientTime = cfg.colGradientTime
 if not useGradientTime then
  self.time:SetTextColor(tcr, tcg, tcb, 1)
 end
 useAnimation = cfg.Animation
 useLocked = cfg.AnimationLock
 if useLocked then
  button:Hide()
 else
  button:Show()
 end
 button:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", cfg.AnimationX, cfg.AnimationY)
 button:SetSize(cfg.AnimationSize, cfg.AnimationSize)
end

-------------------------------------------------------------------------------
-- Finalize
-------------------------------------------------------------------------------
-- Init AzCastBar Entry

plugin:SetScript("OnUpdate", function(self, elapsed)
 self.timeleft = self.timeleft - elapsed
 if self.timeleft > 0 then
  self.status:SetValue(self.timeleft)
  if self.timeleft > 60 then
   self.time:SetFormattedText("%d:%02d", floor(self.timeleft / 60), mod(self.timeleft, 60))
  else
   self.time:SetFormattedText("%d", ceil(self.timeleft))
  end
  local percent = self.timeleft/self.duration
  local cr, cg, cb
  if useGradient then
   cr, cg, cb = ColorGradient(percent, 1, 0, 0, bcr, bcg, bcb)
   self.status:SetStatusBarColor(cr, cg, cb, 1)
  end
  if useGradientTime then
   cr, cg, cb = ColorGradient(percent, 1, 0, 0, tcr, tcg, tcb)
   self.time:SetTextColor(cr, cg, cb, 1)
  end
  if self.timeleft < self.cfg.AnimationTime and self.InCombat and useAnimation and useLocked then
   if not button:IsShown() then
    button:Show()
   end
  elseif button:IsShown() and useAnimation and useLocked then
   button:Hide()
  end
 else
  if useAnimation and useLocked then button:Hide() end
  self:Hide()
 end
end)

plugin:SetScript("OnEvent", function(self, event, ...)
--(timeStamp, eventType, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellID, spellName, spellSchool, detail1, detail2, detail3)
--(   arg1  ,      arg2,    arg3,    arg4,     arg5,    arg6,    arg7,     arg8,    arg9,     arg10,       arg11, detail1, detail2, detail3)
 if event == "COMBAT_LOG_EVENT_UNFILTERED" then
  local _, eventType, srcGUID, _, _, dstGUID, dstName, _, spellID, spellName = ...
  if (eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_REFRESH") and srcGUID == playerID and spellID == 53563 then
   self.timeleft = self.duration
   self.name:SetText(dstName.." ("..spellName..")")
   self:Show()
  elseif eventType == "SPELL_AURA_REMOVED" and srcGUID == playerID and spellID == 53563 then
   PlaySound("RaidWarning")
   RaidNotice_AddMessage(RaidWarningFrame, spellName.." -> "..dstName..Removed, ChatTypeInfo["RAID_WARNING"])
   self.timeleft = 0
  end
 elseif event == "PLAYER_REGEN_DISABLED" then
  self.InCombat = true
 elseif event == "PLAYER_REGEN_ENABLED" then
  self.InCombat = false
 elseif event == "PLAYER_ENTERING_WORLD" then
  playerID = UnitGUID("player")
  self.InCombat = UnitAffectingCombat("player")
  self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
  self:RegisterEvent("PLAYER_REGEN_DISABLED")
  self:RegisterEvent("PLAYER_REGEN_ENABLED")
  self:UnregisterEvent(event)
 end
end)

-- Events
plugin:RegisterEvent("PLAYER_ENTERING_WORLD")

-- Init Bar
plugin.icon:SetTexture(SpellIcon)
plugin.name:SetText(SpellName)
plugin.name:SetJustifyV("CENTER")
plugin:SetPoint("CENTER", -50)
plugin.status:SetMinMaxValues(0, 300)
plugin.status:SetValue(0)
plugin.timeleft = 0
plugin.duration = 300
