
local L = LibStub("AceLocale-3.0"):GetLocale("mDate")

local db
local dateDisplayed

local mDate = LibStub("AceAddon-3.0"):NewAddon("mDate", 'AceTimer-3.0')
local mDateBlock = LibStub("LibDataBroker-1.1"):NewDataObject("mDate", {
	type = "data source",
    icon = "Interface\\Icons\\INV_Misc_PocketWatch_02",

    OnClick = function(self, button)
		if button == "LeftButton" then
			if IsShiftKeyDown() then
				if IsAddOnLoaded("GroupCalendar5") then -- Version 5
					if GroupCalendar.UI.Window:IsShown() then
						GroupCalendar.UI.Window:Hide()
					else
						GroupCalendar.UI.Window:Show()
					end
				elseif IsAddOnLoaded("GroupCalendar") then -- Version 4
					GroupCalendar.ToggleCalendarDisplay()
				else
					ToggleCalendar()
				end
			else
				ToggleTimeManager()
			end
        elseif button == "RightButton" then
			InterfaceOptionsFrame_OpenToCategory("Broker: mDate")
		end
    end,
})

function mDate:OnEnable()

	self.db = LibStub("AceDB-3.0"):New("mDateDB", {
        profile = { dateShown = false,
                    dateFormat = "%A, %B %d, %Y",
        }
    }, "Default")

	db = self.db.profile
	LibStub("AceConfig-3.0"):RegisterOptionsTable("mDate", {
		name = "Broker: mDate", type = "group",
		get = function(key) return db[key.arg] end,
		set = function(key, value) db[key.arg] = value mDate:UpdateDateString() end,
		args = {
			header1 = { name = "Date Options", type = "header", order = 1 },

            dateShown = {
                name = L["Show Date"],
                type = "toggle", order = 2, arg = "dateShown",
            },
            dateFormat = {
                name = L["Format Date"],
                type = "input", order = 3, arg = "dateFormat",
				disabled = function() return not db.dateShown end,
            },    
            header2 = { name = "Date Formatting Guide", type = "header", order = 4 },
            
            dateGuide = {
                name = L["Date Formatting Guide"],
                type = "description", order = 5, arg = "dateGuide",                
            },
        },
    })
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("mDate", "Broker: mDate")

	_G.SlashCmdList["MDATE"] = function() InterfaceOptionsFrame_OpenToCategory("Broker: mDate") end
	_G["SLASH_MDATE1"] = "/mdate"
    
    if 
        db.dateShown then 
        self.timer = self:ScheduleRepeatingTimer("UpdateDateString", 1) 
    else 
        self:CancelTimer(self.timer)
        self:UpdateDateString()
    end
end

function mDate:UpdateDateString()
    dateDisplayed = ""
    if db.dateShown then dateDisplayed = date(db.dateFormat) else dateDisplayed = "mDate" end

	mDateBlock.text = dateDisplayed
end
