local function am(msg)
	ChatFrame1:AddMessage(msg);
end

local LibRingBar = LibStub("LibRingBar", true);
local MessGUI = LibStub("LibMessGUI", true);
local _name, _addon = ...;

local FOMAT_WATCHSPELL = "Current watched spell : %s";
-------------------------------------------------------------------------------------------------------------------------

local configPanel = CreateFrame("Frame", _name, InterfaceOptionsFramePanelContainer);

do	--layouts
	local H_SHIFT, V_SHIFT = 8, -8;
	-- checkboxs
	local frameLockCheck = CreateFrame("CheckButton", "$ParentLockCheck", configPanel, "OptionsCheckButtonTemplate");
	_G[frameLockCheck:GetName().."Text"]:SetText("lock anchor");
	frameLockCheck:SetPoint("TOPLEFT", configPanel, "TOPLEFT", 2 * H_SHIFT, 2 * V_SHIFT);
	frameLockCheck:SetScript("OnClick", function(self)
		_addon:setMovable(not self:GetChecked());
	end);
	configPanel.frameLockCheck = frameLockCheck;
	
	local traditionalTriggerCheck = CreateFrame("CheckButton", "$ParentTraditionalTriggerCheck", configPanel, "OptionsCheckButtonTemplate");
	_G[traditionalTriggerCheck:GetName().."Text"]:SetText("Tradtional Trigger");
	traditionalTriggerCheck:SetPoint("TOPLEFT", frameLockCheck, "BOTTOMLEFT", 0, V_SHIFT);
	traditionalTriggerCheck:SetScript("OnClick", function(self)
		_addon:setTTrigger(self:GetChecked());
	end);
	configPanel.traditionalTriggerCheck = traditionalTriggerCheck;
	
	local smoothCheck = CreateFrame("CheckButton", "$ParentSmoothCheck", configPanel, "OptionsCheckButtonTemplate");
	_G[smoothCheck:GetName().."Text"]:SetText("enable smoother (report to author if weird behavior)");
	smoothCheck:SetPoint("TOPLEFT", traditionalTriggerCheck, "BOTTOMLEFT", 0, V_SHIFT);
	smoothCheck:SetScript("OnClick", function(self)
		_addon:setSmooth(self:GetChecked());
	end);
	configPanel.smoothCheck = smoothCheck;
	
	local testModeCheck = CreateFrame("CheckButton", "$ParentTestModeCheck", configPanel, "OptionsCheckButtonTemplate");
	_G[testModeCheck:GetName().."Text"]:SetText("Test Mode");
	testModeCheck:SetPoint("TOPLEFT", smoothCheck, "BOTTOMLEFT", 0, V_SHIFT);
	testModeCheck:SetScript("OnClick", function(self)
		_addon:SetTestMode(self:GetChecked());
	end);
	configPanel.testModeCheck = testModeCheck;
	
	--dropdowns
	local textureDropDownLabel = configPanel:CreateFontString(nil, "BACKGROUND", "GameFontNormal");
	textureDropDownLabel:SetPoint("TOPLEFT", testModeCheck, "BOTTOMLEFT", 0, V_SHIFT);
	textureDropDownLabel:SetText("Ring Texture");
	textureDropDownLabel:SetJustifyH("RIGHT");
	configPanel.textureDropDown = CreateFrame("Frame", "$ParentTDropdown", configPanel, "UIDropDownMenuTemplate");
	configPanel.textureDropDown:SetPoint("TOPLEFT", textureDropDownLabel, "TOPRIGHT", H_SHIFT, 0);
	UIDropDownMenu_SetWidth(configPanel.textureDropDown, 200);

	local sparkDropDownLabel = configPanel:CreateFontString(nil, "BACKGROUND", "GameFontNormal");
	sparkDropDownLabel:SetPoint("TOPLEFT", textureDropDownLabel, "BOTTOMLEFT", 0, V_SHIFT);
	sparkDropDownLabel:SetText("Ring Spark");
	sparkDropDownLabel:SetJustifyH("RIGHT");
	configPanel.sparkDropDown = CreateFrame("Frame", "$ParentSDropdown", configPanel, "UIDropDownMenuTemplate");
	configPanel.sparkDropDown:SetPoint("TOPLEFT", sparkDropDownLabel, "TOPRIGHT", H_SHIFT, 0);
	UIDropDownMenu_SetWidth(configPanel.sparkDropDown, 200);

	local align = max(textureDropDownLabel:GetStringWidth(), sparkDropDownLabel:GetStringWidth()) + 2 * H_SHIFT;
	textureDropDownLabel:SetWidth(align);
	sparkDropDownLabel:SetWidth(align);
	--sliders
	configPanel.slider_1 = MessGUI:GetSlider(configPanel, function(self, value)
		_addon:setRingCfg("startDegree", value);
	end);
	configPanel.slider_1:SetTitle("Ring Start Degree");
	configPanel.slider_1:SetMinMaxValues(0, 270);
	configPanel.slider_1:SetValueStep(90);
 	configPanel.slider_1:SetPoint("TOPLEFT", sparkDropDownLabel, "BOTTOMLEFT", 0, 2 * V_SHIFT);
 	configPanel.slider_1:SetEditable(nil);

 	configPanel.slider_2 = MessGUI:GetSlider(configPanel, function(self, value)
 		_addon:setRingCfg("totalDegree", value);
 	end);
	configPanel.slider_2:SetTitle("Ring Total Degree");
	configPanel.slider_2:SetMinMaxValues(-360, 360);
	configPanel.slider_2:SetValueStep(1);
 	configPanel.slider_2:SetPoint("TOPLEFT", configPanel.slider_1, "TOPRIGHT", H_SHIFT, 0);
 	configPanel.slider_2:SetEditable(nil);
 	
 	configPanel.slider_3 = MessGUI:GetSlider(configPanel, function(self, value)
 		_addon:SetRingAlpha(value);
 	end);
	configPanel.slider_3:SetTitle("RingAlpha (%)");
	configPanel.slider_3:SetMinMaxValues(0, 100);
	configPanel.slider_3:SetValueStep(1);
 	configPanel.slider_3:SetPoint("TOPLEFT", configPanel.slider_1, "BOTTOMLEFT", 0, V_SHIFT);
 	configPanel.slider_3:SetEditable(nil);
 	
 	configPanel.slider_4 = MessGUI:GetSlider(configPanel, function(self, value)
 		_addon:SetRingSize(value);
 	end);
	configPanel.slider_4:SetTitle("RingSize");
	configPanel.slider_4:SetMinMaxValues(1, 200);
	configPanel.slider_4:SetValueStep(1);
 	configPanel.slider_4:SetPoint("TOPLEFT", configPanel.slider_3, "TOPRIGHT", H_SHIFT, 0);
 	
 	--color select
 	local beginColorLabel = configPanel:CreateFontString(nil, "BACKGROUND", "GameFontNormal");
	beginColorLabel:SetPoint("TOPLEFT", configPanel.slider_3, "BOTTOMLEFT", 0, 2 * V_SHIFT);
	beginColorLabel:SetText("Color begins : ");
	
 	local beginColorBtn =  MessGUI:GetColorChooserBtn(configPanel, function(self, r, g, b, a)
 		_addon:SetBeginColor(r, g, b, a);
 	end);
 	beginColorBtn:SetPoint("LEFT", beginColorLabel, "RIGHT", H_SHIFT, 0);
 	configPanel.beginColorBtn = beginColorBtn;
 	
 	local endColorLabel = configPanel:CreateFontString(nil, "BACKGROUND", "GameFontNormal");
	endColorLabel:SetPoint("LEFT", beginColorBtn, "RIGHT", H_SHIFT, 0);
	endColorLabel:SetText("Color ends : ");
	
 	local endColorBtn =  MessGUI:GetColorChooserBtn(configPanel, function(self, r, g, b, a)
 		_addon:SetEndColor(r, g, b, a);
 	end);
 	endColorBtn:SetPoint("LEFT", endColorLabel, "RIGHT", H_SHIFT, 0);
 	configPanel.endColorBtn = endColorBtn;
 	
 	--editbox
 	local watchSpellLabel = configPanel:CreateFontString(nil, "BACKGROUND", "GameFontNormal");
	watchSpellLabel:SetPoint("TOPLEFT", beginColorLabel, "BOTTOMLEFT", 0, 2 * V_SHIFT);
	watchSpellLabel:SetText("Enter custom GCD watch spell name (separate with \"/\")");
	
 	configPanel.editBox = MessGUI:GetTextField(configPanel, function(self, text)
 		_addon:SetWatchSpellStr(text);
 		configPanel.watchedLabel:SetText(format(FOMAT_WATCHSPELL, _addon:GetWatchSpell()));
 	end);
	configPanel.editBox:SetPoint("TOPLEFT", watchSpellLabel, "BOTTOMLEFT", 0, V_SHIFT);
	configPanel.editBox:SetPoint("RIGHT", -2 * H_SHIFT, 0);
	
	configPanel.watchedLabel = configPanel:CreateFontString(nil, "BACKGROUND", "GameFontHighlight");
	configPanel.watchedLabel:SetJustifyH("LEFT");
	configPanel.watchedLabel:SetText("");
	configPanel.watchedLabel:SetPoint("TOPLEFT", configPanel.editBox, "BOTTOMLEFT", 0, V_SHIFT);
end

local function textureDropDownInitializer(self)
	local info = UIDropDownMenu_CreateInfo();
	info.text = "empty";
	info.value = "empty";
	info.owner = self;
	info.func = function(s)
		UIDropDownMenu_SetSelectedValue(s.owner, s.value);
		UIDropDownMenu_SetText(s.owner, s.value);
		_addon:setRingCfg("textureID", nil);
	end;
	UIDropDownMenu_AddButton(info, 1);

	local itemSelected = function(s)
		UIDropDownMenu_SetSelectedValue(s.owner, s.value);
		UIDropDownMenu_SetText(s.owner, s.value);
		_addon:setRingCfg("textureID", s.value);
	end;	
	for name, _ in LibRingBar:TextureIterator() do
		local info = UIDropDownMenu_CreateInfo();
		info.text = name;
		info.value = name;
		info.owner = self;
		info.func = itemSelected;
		UIDropDownMenu_AddButton(info, 1);
	end
end

local function sparkDropDownInitializer(self)
	local info = UIDropDownMenu_CreateInfo();
	info.text = "empty";
	info.value = "empty";
	info.owner = self;
	info.func = function(s)
		UIDropDownMenu_SetSelectedValue(s.owner, s.value);
		UIDropDownMenu_SetText(s.owner, s.value);
		_addon:setRingCfg("sparkID", nil);
	end;
	UIDropDownMenu_AddButton(info, 1);

	local itemSelected = function(s)
		UIDropDownMenu_SetSelectedValue(s.owner, s.value);
		UIDropDownMenu_SetText(s.owner, s.value);
		_addon:setRingCfg("sparkID", s.value);
	end;	
	for name, _ in LibRingBar:SparkIterator() do
		local info = UIDropDownMenu_CreateInfo();
		info.text = name;
		info.value = name;
		info.owner = self;
		info.func = itemSelected;
		UIDropDownMenu_AddButton(info, 1);
	end
end

function configPanel:okay()
	self:cancel();
end

function configPanel:cancel()
	_addon:SetTestMode(false);
end

configPanel.name = _name;
configPanel:Hide();
configPanel:SetScript("OnShow", function(self)
	self.frameLockCheck:SetChecked(not _addon:getMovable());
	self.traditionalTriggerCheck:SetChecked(_addon:getTTrigger());
	self.smoothCheck:SetChecked(_addon:getSmooth());
	self.testModeCheck:SetChecked(nil);
	
	UIDropDownMenu_Initialize(self.textureDropDown, textureDropDownInitializer);
	UIDropDownMenu_Initialize(self.sparkDropDown, sparkDropDownInitializer);
	
	local textureID = _addon:getRingCfg("textureID");
	UIDropDownMenu_SetSelectedValue(self.textureDropDown, textureID);
	UIDropDownMenu_SetText(self.textureDropDown, textureID);
	local sparkID = _addon:getRingCfg("sparkID");
	UIDropDownMenu_SetSelectedValue(self.sparkDropDown, sparkID);
	UIDropDownMenu_SetText(self.sparkDropDown, sparkID);
	
	self.slider_1:SetValue(_addon:getRingCfg("startDegree"));
	self.slider_2:SetValue(_addon:getRingCfg("totalDegree"));
	self.slider_3:SetValue(floor(_addon:getRingAlpha() * 100));
	self.slider_4:SetValue(_addon:GetRingSize());

	self.beginColorBtn:SetColor(_addon:GetBeginColor());
	self.endColorBtn:SetColor(_addon:GetEndColor());

	self.watchedLabel:SetText(format(FOMAT_WATCHSPELL, _addon:GetWatchSpell()));
	self.editBox:SetText(_addon:GetWatchSpellString());
end);

InterfaceOptions_AddCategory(configPanel);

-------------------------------------------------------------------------------------------------------------------------Misc
function _addon:OpenConfig()
	InterfaceOptionsFrame_OpenToCategory(configPanel.name);
end

SLASH_GCDRING1 = "/gcdring";
SlashCmdList.GCDRING = function(msg, editBox)
	_addon:OpenConfig();
end