local EQ = LibStub("AceAddon-3.0"):NewAddon("eQueue", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local abacus = LibStub( "LibAbacus-3.0")

local lfgReadyCheckTime
local lfgMode
local lfgInstanceName
local lfgTankWait
local lfgHealerWait
local lfgDamageWait
local lfgMyWait
local lfgQueuedTime
local lfgQueuedTimeX
local lfgMarkedTank
local lfgTankIcon
local lfgHealerIcon
local lfgDpsIcon1
local lfgDpsIcon2
local lfgDpsIcon3
local lootMaxID
local lfgLeavingParty
local lfgNewDungeon
local pvpQueued
local pvpReadyCheck
local pvpInBG
local iconString

---------- LDB ------------------
local eLDB = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("eQueue", {
	type = "data source",
	icon = "Interface\\Addons\\eQueue\\icons\\EyeBall1",
	OnClick = function(self, button)
		if button == "RightButton" then
		    if pvpQueued or pvpInBG or pvpReadyCheck then
				ToggleDropDownMenu(1, nil, MiniMapBattlefieldDropDown, self, 0, 0)
				GameTooltip:Hide()
			elseif lfgMode then
			    ToggleDropDownMenu(1, nil, MiniMapLFGFrameDropDown, self, 0, 0)
				GameTooltip:Hide()
			else
				ToggleLFRParentFrame()
			end
		else
		    if IsShiftKeyDown() then
				TogglePVPFrame()
		    elseif pvpInBG then
		        if WorldStateScoreFrame:IsVisible() then
					HideUIPanel(WorldStateScoreFrame)
				else
					ShowUIPanel(WorldStateScoreFrame)	
				end
		    else
		    	ToggleLFDParentFrame()
			end
		end
	end,
})

function eLDB.OnEnter(frame, update)
		if EQ.enabledState then
		if not refreshTimer then
			refreshTimer = EQ:ScheduleRepeatingTimer(eLDB.refreshTimerFeedback, 1, nil)
		end
		if frame then
			GameTooltip:SetOwner(frame, "ANCHOR_NONE")
			GameTooltip:SetPoint(GetTipAnchor(frame))
		end
		GameTooltip:AddLine("eQueue", 0, 1, 0)
	
		if UnitHasLFGDeserter("player") or UnitHasLFGRandomCooldown("player") or UnitDebuff("player", "Deserter") then
	        GameTooltip:AddLine(" ")
			GameTooltip:AddLine("Cooldown:", 1, 1, 1)
			if UnitHasLFGDeserter("player") then
				GameTooltip:AddDoubleLine("Dungeon Deserter:", abacus:FormatDurationCondensed((GetTime() - GetLFGDeserterExpiration()) / (-1), nil, nil))
			end
			if UnitHasLFGRandomCooldown("player") then
				GameTooltip:AddDoubleLine("Random Cooldown:", abacus:FormatDurationCondensed((GetTime() - GetLFGRandomCooldownExpiration()) / (-1), nil, nil))
			end
			if UnitDebuff("player", "Deserter") then
			    local _,_,_,_,_,_,desertertime = UnitDebuff("player", "Deserter")
				GameTooltip:AddDoubleLine("Battleground Deserter:", abacus:FormatDurationCondensed(desertertime - GetTime(), nil, nil))
			end
		end
	
		if lfgReadyCheckTime or pvpReadyCheck then
			GameTooltip:AddLine(" ")
			GameTooltip:AddLine("Ready Check:", 1, 1, 1)
			if pvpReadyCheck then
				for i = 1, MAX_BATTLEFIELD_QUEUES do
					local status, mapname = GetBattlefieldStatus(i)
					if status == "confirm" then
						if mapname == "Eastern Kingdoms" then
							mapname = "All Arenas"
							GameTooltip:AddDoubleLine(mapname .. ":", abacus:FormatDurationCondensed(60 - GetBattlefieldPortExpiration(i), nil, nil) .. "/1:00")
						else
							GameTooltip:AddDoubleLine(mapname .. ":", abacus:FormatDurationCondensed(40 - GetBattlefieldPortExpiration(i), nil, nil) .. "/0:40")
						end
					end
				end
			elseif lfgReadyCheckTime then
				GameTooltip:AddDoubleLine("Time Elapsed:", abacus:FormatDurationCondensed(GetTime() - lfgReadyCheckTime, nil, nil) .. "/0:40")
		        GameTooltip:AddLine(" ")
				if lfgQueuedTime then
					GameTooltip:AddLine(iconString .. lfgTankIcon .. "   " .. lfgHealerIcon .. "   " .. lfgDpsIcon1 .. "   " .. lfgDpsIcon2 .. "   " .. lfgDpsIcon3 .. iconString)
				else
		    		GameTooltip:AddLine("     " .. lfgTankIcon .. "   " .. lfgHealerIcon .. "   " .. lfgDpsIcon1 .. "   " .. lfgDpsIcon2 .. "   " .. lfgDpsIcon3 .. "     ")
	            end
			end
		end
	
		if lfgMode == 'queued' or lfgReadyCheckTime or pvpQueued then
			GameTooltip:AddLine(" ")
			GameTooltip:AddLine("Queue:", 1, 1, 1)
			if pvpQueued then
				for i = 1, MAX_BATTLEFIELD_QUEUES do
					local status, mapname = GetBattlefieldStatus(i)
					if status == "queued" then
						GameTooltip:AddDoubleLine(mapname .. ":", abacus:FormatDurationCondensed(GetBattlefieldTimeWaited(i) / 1000, nil, nil) .. "/" .. abacus:FormatDurationCondensed(GetBattlefieldEstimatedWaitTime(i) / 1000, nil, nil))
					end
				end
		    elseif lfgQueuedTime then
	    		GameTooltip:AddDoubleLine(lfgInstanceName .. ":", abacus:FormatDurationCondensed(GetTime() - lfgQueuedTime, nil, nil) .. "/" .. abacus:FormatDurationCondensed(lfgMyWait, nil, nil))
				GameTooltip:AddLine(" ")
				if not lfgReadyCheckTime then
					GameTooltip:AddLine(iconString .. lfgTankIcon .. "   " .. lfgHealerIcon .. "   " .. lfgDpsIcon1 .. "   " .. lfgDpsIcon2 .. "   " .. lfgDpsIcon3 .. iconString)
					GameTooltip:AddLine(" ")
				end
				GameTooltip:AddLine("Average Wait Times:", 1, 1, 1)
				GameTooltip:AddDoubleLine("Tank:", abacus:FormatDurationCondensed(lfgTankWait, nil, nil))
				GameTooltip:AddDoubleLine("Healer:", abacus:FormatDurationCondensed(lfgHealerWait, nil, nil))
				GameTooltip:AddDoubleLine("Damage:", abacus:FormatDurationCondensed(lfgDamageWait, nil, nil))
			else
			    GameTooltip:AddLine("Waiting...")
			end
		end		
		GameTooltip:Show()
	end
end

function eLDB.OnLeave()
	EQ:CancelTimer(refreshTimer, true)
	refreshTimer = nil
	GameTooltip:Hide()
end

function eLDB.refreshTimerFeedback()
	GameTooltip:ClearLines()
	eLDB.OnEnter()
end

function GetTipAnchor(frame)
	local x,y = frame:GetCenter()
	if not x or not y then return "TOPLEFT", "BOTTOMLEFT" end
	local hhalf = (x > UIParent:GetWidth()*2/3) and "RIGHT" or (x < UIParent:GetWidth()/3) and "LEFT" or ""
	local vhalf = (y > UIParent:GetHeight()/2) and "TOP" or "BOTTOM"
  	return vhalf..hhalf, frame, (vhalf == "TOP" and "BOTTOM" or "TOP")..hhalf
end

function eLDB.UpdateText()
 	if lfgReadyCheckTime then eLDB.text = abacus:FormatDurationCondensed(GetTime() - lfgReadyCheckTime, nil, nil) .. "/0:40"
	elseif pvpReadyCheck then
		local bgTime = 99
		for i = 1, MAX_BATTLEFIELD_QUEUES do
			local status, mapname = GetBattlefieldStatus(i)
			if status == "confirm" then			
				if GetBattlefieldPortExpiration(i) < bgTime then
					if mapname == "Eastern Kingdoms" then
						eLDB.text = abacus:FormatDurationCondensed(60 - GetBattlefieldPortExpiration(i), nil, nil) .. "/1:00"
					else
						eLDB.text = abacus:FormatDurationCondensed(40 - GetBattlefieldPortExpiration(i), nil, nil) .. "/0:40"
					end
					bgTime = GetBattlefieldPortExpiration(i)
				end
			end
		end
	elseif pvpQueued then
		local bgTime = 9999999
		for i = 1, MAX_BATTLEFIELD_QUEUES do
			local status, mapname = GetBattlefieldStatus(i)
			if status == "queued" then
				if (GetBattlefieldEstimatedWaitTime(i) - GetBattlefieldTimeWaited(i)) < bgTime then 
					bgTime = (GetBattlefieldEstimatedWaitTime(i) - GetBattlefieldTimeWaited(i))
					eLDB.text = abacus:FormatDurationCondensed(GetBattlefieldTimeWaited(i) / 1000, nil, nil) .. "/" .. abacus:FormatDurationCondensed(GetBattlefieldEstimatedWaitTime(i) / 1000, nil, nil)
				end
			end
		end
	elseif lfgQueuedTime then eLDB.text = abacus:FormatDurationCondensed(GetTime() - lfgQueuedTime, nil, nil) .. "/" .. abacus:FormatDurationCondensed(lfgMyWait, nil, nil)
	elseif lfgMode == 'queued' then eLDB.text = "Waiting"
	else
		eLDB.text = EQ.db.profile.DefText
		EQ:CancelTimer(textRefreshTimer, true)
		textRefreshTimer = nil
	end
end

function eLDB.TextTimer()
	if not textRefreshTimer then
		textRefreshTimer = EQ:ScheduleRepeatingTimer(eLDB.UpdateText, 1, nil)
	end
end
---------- End LDB ----------

---------- Options --------------
local options = {
	name = 'eQueue',
	handler = EQ,
	type = 'group',
	args = {
		desc = {
			type = 'description',
			name = 'eQueue is an add-on for LDB that is meant to satisfy all of your WoW queueing needs. It simulates the functionality of the default LFG and PvP buttons and mini-map icons while adding many extra helpful features.' .. '\n',
			order = 1
		},
		enable = {
			type = 'toggle',
			order = 2,
			name = 'Enabled',
			desc = 'Enable or disable this addon.',
			set = function(info, val) if (val) then	EQ:Enable() else EQ:Disable() end end,
			get = function(info) return EQ.enabledState end,
		},
		DefText = {
			type = 'input',
			order = 3,
			name = 'Default Text',
			desc = 'Text to display on the DataBroker plugin when not in queue.',
			disabled = function() return not EQ.enabledState end,
			set = function(info, val)
					EQ.db.profile.DefText = val 
					if (lfgMode ~= "queued") and not pvpQueued then eLDB.text = val end
				end,
			get = function(info) return EQ.db.profile.DefText end,
		},
        MinimapGroup = {
			type = 'group',
			name = 'Mini-map',
			desc = 'Options for what to do with the default Blizzard mini-map icons.',
			guiInline = true,
			order = 4,
			args = {
				HideLFGIcon = {
					type = 'toggle',
					order = 1,
					name = 'Hide LFG Icon',
					desc = 'Hide the LFG mini-map icon.',
					disabled = function() return not EQ.enabledState end,
					set = function(info, val)
							EQ.db.profile.HideLFGIcon = val
							if (val) then
								MiniMapLFGFrame:Hide()
							elseif lfgMode then
								MiniMapLFGFrame:Show()
							end
						  end,
					get = function(info) return EQ.db.profile.HideLFGIcon end,
				},
				HidePvPIcon = {
					type = 'toggle',
					order = 2,
					name = 'Hide PvP Icon',
					desc = 'Hide the PvP mini-map icon.',
					disabled = function() return not EQ.enabledState end,
					set = function(info, val)
						EQ.db.profile.HidePvPIcon = val
							if (val) then
								MiniMapBattlefieldFrame:Hide()
							elseif pvpQueued or pvpReadyCheck or pvpInBG then
								MiniMapBattlefieldFrame:Show()
							end
						  end,
					get = function(info) return EQ.db.profile.HidePvPIcon end,
				},
			},
		},
		ReadyCheckGroup = {
			type = 'group',
			name = 'Ready Check',
			desc = 'Options for what to do when your your dungeon, battleground, or arena is ready to enter.',
			guiInline = true,
			order = 5,
			args = {
				UnMute = {
					type = 'toggle',
					order = 1,
					name = 'Enable Sound',
					desc = 'Turns your sound on temporarily so that you can hear when your dungeon, battleground, or arena is ready. Also causes the sound to play based on your Master Volume instead of your Sound Volume which will make the sound louder if your Sound Volume is below max. \n\nNote: "Sound in background" must be enabled for this to work while tabbed out.',
					disabled = function() return not EQ.enabledState end,
					set = function(info, val) EQ.db.profile.UnMute = val end,
					get = function(info) return EQ.db.profile.UnMute end,
				},
				FlashScreen = {
					type = 'toggle',
					order = 2,
					name = 'Flash Screen',
					desc = 'Flashes your screen red when your dungeon, battleground, or arena is ready.',
					disabled = function() return not EQ.enabledState end,
					set = function(info, val) EQ.db.profile.FlashScreen = val end,
					get = function(info) return EQ.db.profile.FlashScreen end,
				},
				HideRole = {
					type = 'toggle',
					order = 3,
					name = 'Hide Role Window',
					desc = 'Hide the lingering role window that appears after accepting the dungeon proposal.',
					disabled = function() return not EQ.enabledState end,
					set = function(info, val) EQ.db.profile.HideRole = val end,
					get = function(info) return EQ.db.profile.HideRole end,
				},
			},
		},
		InDungeonGroup = {
			type = 'group',
			name = 'In Dungeon',
			desc = 'Options for what to do when while inside of a dungeon.',
			guiInline = true,
			order = 6,
			args = {
				MarkTank = {
					type = 'toggle',
					order = 1,
					name = 'Mark Tank',
					desc = 'Enable to automatically mark your groups tank with a {star} icon.',
					disabled = function() return not EQ.enabledState end,
					set = function(info, val) EQ.db.profile.MarkTank = val end,
					get = function(info) return EQ.db.profile.MarkTank end,
				},
				LeaveAfter = {
					type = 'toggle',
					order = 2,
					name = 'Leave After Loot',
					desc = 'Automatically leave the party after all of the final boss loot roles have completed.\n\nNote: Currently only works for WotLK Heroics and is voided if changing zones before loot is finished.',
					disabled = function() return not EQ.enabledState end,
					set = function(info, val) EQ.db.profile.LeaveAfter = val end,
					get = function(info) return EQ.db.profile.LeaveAfter end,
				},
				LeavePrompt = {
					type = 'toggle',
					order = 3,
					name = 'Leave Prompt',
					desc = 'Enable to trigger a confirm prompt when loot has finished instead of automatically leaving.',
					disabled = function() return not EQ.enabledState or not EQ.db.profile.LeaveAfter end,
					set = function(info, val) EQ.db.profile.LeavePrompt = val end,
					get = function(info) return EQ.db.profile.LeavePrompt end,
				},
				IntroEnabled = {
					type = 'toggle',
					order = 4,
					name = 'Introduction',
					desc = 'Enable to say an introduction in party chat upon entering a dungeon.',
					disabled = function() return not EQ.enabledState end,
					set = function(info, val) EQ.db.profile.IntroEnabled = val end,
					get = function(info) return EQ.db.profile.IntroEnabled end,
				},
				FarewellEnabled = {
					type = 'toggle',
					order = 5,
					name = 'Farewell',
					desc = "Enable to say a farewell message in party chat when leaving a dungeon using the 'Leave After Loot' feature.",
					disabled = function() return not EQ.enabledState end,
					set = function(info, val) EQ.db.profile.FarewellEnabled = val end,
					get = function(info) return EQ.db.profile.FarewellEnabled end,
				},
				IntroText = {
					type = 'input',
					order = 6,
					name = 'Introduction Text',
					desc = 'Text to send to party chat upon entering a dungeon as an introduction.\n\nNote: 243 character maximum.',
					disabled = function() return not EQ.enabledState or not EQ.db.profile.IntroEnabled end,
					set = function(info, val) EQ.db.profile.IntroText = val end,
					get = function(info) return EQ.db.profile.IntroText end,
					width = 'full',
				},
				FarewellText = {
					type = 'input',
					order = 7,
					name = 'Farewell Text',
					desc = "Text to send to party chat when leaving a dungeon using the 'Leave After Loot' feature.\n\nNote: 243 character maximum.",
					disabled = function() return not EQ.enabledState or not EQ.db.profile.FarewellEnabled end,
					set = function(info, val) EQ.db.profile.FarewellText = val end,
					get = function(info) return EQ.db.profile.FarewellText end,
					width = 'full',
				},
			},
		},
	},
}

local defaults = {
  profile = {
    MarkTank = false,
    UnMute = true,
    FlashScreen = true,
	HideRole = false,
	IntroEnabled = false,
	IntroText = "You pull it, you tank it!",
	FarewellEnabled = false,
	FarewellText = "So long suckers!",
	DefText = "",
	HideLFGIcon = false,
	HidePvPIcon = false,
	LeaveAfter = true,
	LeavePrompt = true,
  }
}
---------- End Options ----------

---------- Console --------------
function EQ:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("eQueueDB", defaults, true)
	local parent = LibStub("AceConfig-3.0"):RegisterOptionsTable("eQueue", options)
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("eQueue", "eQueue")
 	profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("eQueue.profiles", profiles)
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("eQueue.profiles", "Profiles", "eQueue")
	SLASH_EQUEUE1 = "/equ"
	SLASH_EQUEUE2 = "/eqq"
	SLASH_EQUEUE3 = "/equeue"
	SlashCmdList["EQUEUE"] = function() InterfaceOptionsFrame_OpenToCategory("eQueue") end
	eLDB.text = EQ.db.profile.DefText
end

function EQ:OnEnable()
	self:RegisterEvent("LFG_UPDATE")
	self:RegisterEvent("LFG_QUEUE_STATUS_UPDATE")
	self:RegisterEvent("LFG_PROPOSAL_UPDATE")
	self:RegisterEvent("LFG_PROPOSAL_SHOW")
	self:RegisterEvent("PARTY_MEMBERS_CHANGED")
	self:RegisterEvent("START_LOOT_ROLL")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	self:RegisterEvent("UPDATE_BATTLEFIELD_STATUS")
	self:RegisterEvent("LFG_PROPOSAL_FAILED")
	_, _, tankNeeds, healerNeeds, dpsNeeds, _, lfgInstanceName, _, lfgTankWait, lfgHealerWait, lfgDamageWait, lfgMyWait, lfgQueuedTime = GetLFGQueueStats()	
end

function EQ:OnDisable()
	lfgQueuedTime = nil
	EQ:UnregisterAllEvents()
	eLDB.text = EQ.db.profile.DefText
	EQ:CancelTimer(textRefreshTimer, true)
	textRefreshTimer = nil
end
---------- End Console ----------

---------- Event Handlers ----------
function EQ:LFG_UPDATE()
	lfgReadyCheckTime = nil
	Sleep(0.1, function()
		lfgMode = GetLFGMode()
		if lfgMode ~= 'queued' and lfgMode ~= 'proposal' then 
			lfgQueuedTime = nil 
		end 
	end)	
	eLDB.TextTimer()
end

function EQ:LFG_PROPOSAL_SHOW()
	lfgMarkedTank = nil
	lfgReadyCheckTime = GetTime()
	if self.db.profile.IntroEnabled then lfgNewDungeon = true end
	if self.db.profile.UnMute then
		if GetCVar("Sound_EnableAllSound") == "0" then
			SetCVar("Sound_EnableAllSound", 1)
			PlaySoundFile([[sound\Interface\levelup2.wav]])
			SetCVar("Sound_EnableAllSound", 0)
		else
		    PlaySoundFile([[sound\Interface\levelup2.wav]])
		end
	end
	if self.db.profile.FlashScreen then
		EQ.FlashScreen()
	end
	eLDB.TextTimer()
end

function EQ:LFG_QUEUE_STATUS_UPDATE()
	local tankNeeds, healerNeeds, dpsNeeds
	_, _, tankNeeds, healerNeeds, dpsNeeds, _, lfgInstanceName, _, lfgTankWait, lfgHealerWait, lfgDamageWait, lfgMyWait, lfgQueuedTime = GetLFGQueueStats()
	if tankNeeds == 1 then
		lfgTankIcon = "|TInterface\\LFGFrame\\LFGRole_BW.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:32:47:1:16|t"
	else
		lfgTankIcon = "|TInterface\\LFGFrame\\LFGRole.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:32:47:1:16|t"
	end
	if healerNeeds == 1 then
		lfgHealerIcon = "|TInterface\\LFGFrame\\LFGRole_BW.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:48:63:1:16|t"
	else
		lfgHealerIcon = "|TInterface\\LFGFrame\\LFGRole.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:48:63:1:16|t"
	end
	if dpsNeeds == 0 then
		lfgDpsIcon1 = "|TInterface\\LFGFrame\\LFGRole.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
		lfgDpsIcon2 = "|TInterface\\LFGFrame\\LFGRole.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
		lfgDpsIcon3 = "|TInterface\\LFGFrame\\LFGRole.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
	elseif dpsNeeds == 1 then
		lfgDpsIcon1 = "|TInterface\\LFGFrame\\LFGRole.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
		lfgDpsIcon2 = "|TInterface\\LFGFrame\\LFGRole.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
		lfgDpsIcon3 = "|TInterface\\LFGFrame\\LFGRole_BW.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
	elseif dpsNeeds == 2 then
		lfgDpsIcon1 = "|TInterface\\LFGFrame\\LFGRole.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
		lfgDpsIcon2 = "|TInterface\\LFGFrame\\LFGRole_BW.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
		lfgDpsIcon3 = "|TInterface\\LFGFrame\\LFGRole_BW.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
	elseif dpsNeeds == 3 then
		lfgDpsIcon1 = "|TInterface\\LFGFrame\\LFGRole_BW.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
		lfgDpsIcon2 = "|TInterface\\LFGFrame\\LFGRole_BW.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
		lfgDpsIcon3 = "|TInterface\\LFGFrame\\LFGRole_BW.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
	end
	iconString = ""
	for i = 1, math.ceil((string.len(lfgInstanceName) + 4) / 2) do
			iconString = iconString .. " "
	end
	eLDB.TextTimer()
end

function EQ:PARTY_MEMBERS_CHANGED()
    if lfgNewDungeon then
        SendChatMessage(self.db.profile.IntroText ,"PARTY")
        lfgNewDungeon = false
	end
	if lfgLeavingParty == true then EQ.CheckLoot() end
	if self.db.profile.MarkTank then
		if UnitGroupRolesAssigned("player") == "TANK" then
			if lfgMarkedTank ~= UnitName("player") then
				SetRaidTarget("player", 1)
				lfgMarkedTank = UnitName("player")
			end
		else
			for i = 1, 4 do
				if UnitGroupRolesAssigned("party" .. i) == "TANK" then
					if lfgMarkedTank ~= UnitName("party" .. i) then
						SetRaidTarget("party" .. i, 1)
						lfgMarkedTank = UnitName("party" .. i)
						break
					end
				end
			end
		end
	end
end

function EQ:LFG_PROPOSAL_UPDATE()
	if self.db.profile.HideRole then LFDDungeonReadyStatus:Hide() end
	local dps = 0
	for i = 1, 5 do
	    local _, role, _, _, accepted = GetLFGProposalMember(i)
	    if role == "TANK" then
		    if accepted then
				lfgTankIcon = "|TInterface\\LFGFrame\\LFGRole.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:32:47:1:16|t"
			else
				lfgTankIcon = "|TInterface\\LFGFrame\\LFGRole_BW.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:32:47:1:16|t"
			end
		elseif role == "HEALER" then
		    if accepted then
		    	lfgHealerIcon = "|TInterface\\LFGFrame\\LFGRole.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:48:63:1:16|t"
			else
				lfgHealerIcon = "|TInterface\\LFGFrame\\LFGRole_BW.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:48:63:1:16|t"
			end
		elseif role == "DAMAGER" then				
			dps = dps + 1
			if dps == 1 then
				if accepted then
			    	lfgDpsIcon1 = "|TInterface\\LFGFrame\\LFGRole.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
				else
	    			lfgDpsIcon1 = "|TInterface\\LFGFrame\\LFGRole_BW.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
				end
	        elseif dps == 2 then
				if accepted then
			    	lfgDpsIcon2 = "|TInterface\\LFGFrame\\LFGRole.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
				else
	    			lfgDpsIcon2 = "|TInterface\\LFGFrame\\LFGRole_BW.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
				end
	        elseif dps == 3 then
				if accepted then
			    	lfgDpsIcon3 = "|TInterface\\LFGFrame\\LFGRole.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
				else
	    			lfgDpsIcon3 = "|TInterface\\LFGFrame\\LFGRole_BW.blp:" .. 24 .. ":" .. 24 .. ":0:0:64:16:16:31:1:16|t"
				end
			end
		end
	end
end

function EQ:START_LOOT_ROLL(_, id)
	if self.db.profile.LeaveAfter then
		local _, name = GetLootRollItemInfo(id)
		lootMaxID = id
		if (name == "Frozen Orb") or (name == "Chaos Orb") then
			self:RegisterEvent("CHAT_MSG_LOOT")
			lfgLeavingParty = true
		end
	end
end

function EQ:CHAT_MSG_LOOT()
	EQ.CheckLoot()
end

function EQ:ZONE_CHANGED_NEW_AREA()
	if lfgLeavingParty == true then
	    self:UnregisterEvent("CHAT_MSG_LOOT")
	    print("Zone change detected. Cancelling 'Leave After Loot'.")
	    lfgLeavingParty = false			    
	end
end

function EQ:UPDATE_BATTLEFIELD_STATUS()	
	local newreadycheck = false
	if not pvpReadyCheck then newreadycheck = true end
	pvpQueued = false
	pvpReadyCheck = false
	pvpInBG = false
	for i = 1, MAX_BATTLEFIELD_QUEUES do
		status, mapName = GetBattlefieldStatus(i)
		if status == "active" then pvpInBG = true
		elseif status == "queued" then pvpQueued = true
		elseif status == "confirm" then
			pvpReadyCheck = true
			if newreadycheck then
			    if self.db.profile.UnMute then
					if GetCVar("Sound_EnableAllSound") == "0" then
						SetCVar("Sound_EnableAllSound", 1)
						PlaySoundFile([[Sound\Spells\PVPThroughQueue.wav]])
						SetCVar("Sound_EnableAllSound", 0)
					else
					    PlaySoundFile([[Sound\Spells\PVPThroughQueue.wav]])
					end
				end
				if self.db.profile.FlashScreen then
					EQ.FlashScreen()
				end
			end
		end
	end
	eLDB.TextTimer()	
end

function EQ:LFG_PROPOSAL_FAILED()
	if self.db.profile.HideRole then LFDDungeonReadyStatus:Hide() end
end
---------- End Event Handlers ----------

------------- Loot Check ---------------
StaticPopupDialogs["LEAVEAFTER"] = {
	text = "Loot has finished. Would you like to leave the group now?",
	button1 = "Yes",
	button2 = "No",
	OnAccept = function()
		if EQ.db.profile.FarewellEnabled then 
			SendChatMessage(EQ.db.profile.FarewellText ,"PARTY") 
			Sleep(1.0, function() LeaveParty() end)
		else
			LeaveParty()
		end
	end,
	timeout = 30,
	whileDead = true,
	hideOnEscape = true,
}

function EQ.CheckLoot()
	local lootInProgress = false
	for i = 1, lootMaxID do
		if GetLootRollItemInfo(i) then
			lootInProgress = true
			break
		end
	end
	if lootInProgress == false then
		EQ:UnregisterEvent("CHAT_MSG_LOOT")		
		if EQ.db.profile.LeavePrompt then
			StaticPopup_Show ("LEAVEAFTER")
		else
			if EQ.db.profile.FarewellEnabled then 
				SendChatMessage(EQ.db.profile.FarewellText ,"PARTY") 
				Sleep(1.0, function() LeaveParty() end)
			else
				LeaveParty()
			end
		end
		lfgLeavingParty = false
	end
end
------------- End Loot Check -----------

------------- Flash Screen -------------
local eqFlash = CreateFrame("Frame")
local FlashFrame = nil
function EQ.FlashScreen()
	if not FlashFrame then
		local flasher = CreateFrame("Frame", "eqFlash")
		flasher:SetToplevel(true)
		flasher:SetFrameStrata("FULLSCREEN_DIALOG")
		flasher:SetAllPoints(UIParent)
		flasher:EnableMouse(false)
		flasher:Hide()
		flasher.texture = flasher:CreateTexture(nil, "BACKGROUND")
		flasher.texture:SetTexture("Interface\\FullScreenTextures\\LowHealth")
		flasher.texture:SetAllPoints(UIParent)
		flasher.texture:SetBlendMode("ADD")
		flasher:SetScript("OnShow", function(self)
			self.elapsed = 0
			self:SetAlpha(0)
		end)
		flasher:SetScript("OnUpdate", function(self, elapsed)
			elapsed = self.elapsed + elapsed
			if elapsed < 5 then
				local alpha = elapsed % 1.3
				if alpha < 0.15 then
					self:SetAlpha(alpha / 0.15)
				elseif alpha < 0.9 then
					self:SetAlpha(1 - (alpha - 0.15) / 0.6)
				else
					self:SetAlpha(0)
				end
			else
				self:Hide()
			end
			self.elapsed = elapsed
		end)
		FlashFrame = flasher
	end
	FlashFrame:Show()
end
------------- End Flash Screen ----------

------------ Icon Hiding ----------------
MiniMapLFGFrame:SetScript("OnShow", function(self)
	if EQ.db.profile.HideLFGIcon then
		self:Hide()
	end
end)

MiniMapBattlefieldFrame:SetScript("OnShow", function(self)
	if EQ.db.profile.HidePvPIcon then
		self:Hide()
	end
end)
------------ End Icon Hiding ------------

---------- Delay Handler ----------------
local f = CreateFrame("Frame")
local delays = {}
local funcs = {}
f:Hide()
f:SetScript('OnUpdate', function(self, elapsed)
  if delays[1] > 0 then
    delays[1] = delays[1] - elapsed
  else
    funcs[1]()
    tremove(delays, 1)
    tremove(funcs, 1)
    if #delays == 0 then
      self:Hide()
    end
  end
end)

function Sleep(delay, func)
  tinsert(delays, delay)
  tinsert(funcs, func)
  f:Show()
end	
---------- End Delay Handler ----------