﻿local o, n, r, f, _ = CreateFrame("Frame"), UnitName("player"), GetRealmName(), UnitFactionGroup("player")
local gMoney = LibStub("LibDataBroker-1.1"):NewDataObject("gMoney", {["type"] = "data source"})
local start, delta = 0, 0

function money_to_string(value)
	if value == 0 then return nil end

	local gold = math.floor(value / 10000)
	local silver = mod(math.floor(value / 100), 100)
	local copper = mod(value, 100)

	return string.format("|cffffd700%i|r.|cffc7c7cf%02i|r.|cffeda55f%02i|r", gold, silver, copper)
end

function earned(value)
	return value > 0 and "|cff00ff00Profit|r" or value < 0 and "|cffff0000Loss|r" or nil
end

function SlashCmdList.GMONEY(msg)
	local cmd, arg = msg:match("^(%a*)%s*(.-)$")
	if cmd == "reset" then
		-- Clear all data
		delta = 0
		start = GetMoney()
		gMoney_DB = {}
		gMoney_DB[r] = {}
		gMoney_DB[r][f] = {}
		gMoney_DB[r][f][n] = GetMoney()
		print("Database reset.")
	elseif cmd == "remove" then
		-- Remove character "arg"
		gMoney_DB[r][f][arg] = nil
		print(string.format("%s removed from database.", arg))
	elseif cmd == "session" then
		-- Start a new session
		delta = 0
		start = GetMoney()
		gMoney_DB[r][f][n] = GetMoney()
		print("New |cFF9482CAg|rMoney session started.")
	else
		-- Print help
		print("Usage: /|cFF9482CAg|rmoney cmd arg\nreset - Clear database.\nremove <Character Name> - Remove <Character Name> from database.\nsession - Start a new session for profit/loss.")
	end
end

gMoney.OnTooltipShow = function(Tooltip)
	local server_total = 0

	Tooltip:AddLine("gMoney")

	for i,v in pairs(gMoney_DB[r][f]) do
		Tooltip:AddDoubleLine(i, money_to_string(v), 1,1,1, 1,1,1)
		server_total = server_total + v
	end
	Tooltip:AddLine(" ")
	Tooltip:AddDoubleLine(r, money_to_string(server_total), 1,1,1, 1,1,1)
	Tooltip:AddDoubleLine(earned(delta), money_to_string(math.abs(delta)), 1,1,1, 1,1,1)
	Tooltip:AddLine(" ")
	for i=1,_G["MAX_WATCHED_TOKENS"] do
		name, count, _, _, _ = GetBackpackCurrencyInfo(i)
		Tooltip:AddDoubleLine(name, count, 1,1,1, 1,1,1)
	end
end

o:SetScript("OnEvent", function(_, event)
	if event == "PLAYER_LOGIN" then
		gMoney_DB = gMoney_DB or {}
		gMoney_DB[r] = gMoney_DB[r] or {}
		gMoney_DB[r][f] = gMoney_DB[r][f] or {}
		start = GetMoney()
	end
	gMoney_DB[r][f][n] = GetMoney()
	gMoney.text = money_to_string(GetMoney())

	delta = GetMoney() - start
end)

o:RegisterEvent("PLAYER_LOGIN")
o:RegisterEvent("PLAYER_MONEY")
o:RegisterEvent("PLAYER_TRADE_MONEY")
o:RegisterEvent("TRADE_MONEY_CHANGED")
o:RegisterEvent("SEND_MAIL_MONEY_CHANGED")
o:RegisterEvent("SEND_MAIL_COD_CHANGED")

SLASH_GMONEY1 = "/gmoney"
