local frame = CreateFrame("FRAME", "nibPLFrame");
frame:RegisterEvent("VARIABLES_LOADED");

-- BEGIN USER OPTIONS --
-- InterfaceName = Name to describe your UI
-- ProfileName = Addon profile name to use with /reflux switch
local InterfaceName  = "Kiseki's HOLY Paladin UI!"
local ProfileName = "KisekiUI"
-- END USER OPTIONS --

local CID, CE, HasAdded = "", false, false

local function AddChar()
  if (CID ~= "") and not HasAdded then 
    tinsert(nibPLNames, CID)
	HasAdded = true
  end
end

local function CharAnswered(ans)
  AddChar()
  if ans then
    local RefluxArg = string.format("%s %s", "switch", ProfileName)
    SlashCmdList.REFLUX(RefluxArg) -- This will cause a UI reload
  end
end

local SetrBBSPSV = function()
if(rBottomBarStyler) then table.wipe(rBottomBarStyler) end

rBottomBarStyler = {
	["movable"] = 1,
	["scalevalue"] = 1.01,
	["artvalue"] = "aion",
	["manaorb"] = 3,
	["locked"] = 1,
	["healthorb"] = 0,
	["barvalue"] = "bar2",
	["automana"] = 1,
}
end

local function AskNewChar()
  StaticPopupDialogs["PUDASKNEWCHAR"] = {
    text = "New character detected! Do you wish to load the settings from %s?",
    button1 = "Yes",
    button2 = "No",
    OnAccept = function()
	  SetrBBSPSV();
      CharAnswered(true)
    end,
	OnCancel = function()
	  CharAnswered(false)
	end,
    timeout = 0,
    whileDead = true,
    hideOnEscape = false,
	notClosableByLogout = true,
  }
  StaticPopup_Show ("PUDASKNEWCHAR", InterfaceName);
end

local function CheckNewChar()
  CID = string.format("%s - %s", GetRealmName(), UnitName("player"))
  CE = false
  if (nibPLNames == nil) then nibPLNames = { }; end
  for i,v in pairs(nibPLNames) do
	if (v == CID) then CE = true; end
  end
  if not CE then AskNewChar(); end
end 

local function eventHandler(self, event, ...)
  if (event == "VARIABLES_LOADED") then
    CheckNewChar()
  end
end
frame:SetScript("OnEvent", eventHandler);