  --++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--
  --						Release 1							  --
  -- 						12.29.2010							  --
  -- 				 Protonova of Rexxar - US					  --
  --															  --
  --   This addon is going to install profiles without having     --
  --   Pre-installed the WTF folder. This means no more messing   --
  --   up on UI installations due to miss reading instructions    --
  --   or lack of it. This addon will essentially load once per   --
  --   character then disable itself every time it runs. It       --
  --   tracks what chars are new or not via the meekaI_Names.lua  --
  --   found in the SavedVariables folder. The code to track      --
  --   was taken from nibProfileLoader. All credits goes to       --
  --   Nibelheim. Thank you for using my UI.					  --
  --   PSV suffix = Per-character Saved Variable.
  --++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--

-- ===================== --
-- [[DEFINED VARIABLES]] --
-- ===================== --
local frame = CreateFrame("FRAME", "MeekaInitFrame");
frame:RegisterEvent("VARIABLES_LOADED");
local CID, CE, HasAdded = "", false, false
local ProfileName = "KisekiUI"

-- ===================================== --
-- Default configuration for some addons --
-- ===================================== --
local SetMSBT = function()

MSBTProfiles_SavedVars = {
	["profiles"] = {
		["Female"] = {
			["abbreviateAbilities"] = true,
			["critOutlineIndex"] = 2,
			["qualityExclusions"] = {
				true, -- [1]
			},
			["healThreshold"] = 900,
			["normalOutlineIndex"] = 2,
			["creationVersion"] = "5.4.78",
			["critFontName"] = "Neuropol",
			["powerThreshold"] = 800,
			["events"] = {
				["PET_INCOMING_SPELL_DAMAGE"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_REFLECT"] = {
					["disabled"] = true,
				},
				["OUTGOING_MISS"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_IMMUNE"] = {
					["disabled"] = true,
				},
				["INCOMING_BLOCK"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_MISS"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_DODGE"] = {
					["disabled"] = true,
				},
				["INCOMING_HEAL"] = {
					["scrollArea"] = "Custom2",
				},
				["PET_INCOMING_MISS"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_DODGE"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_RESIST"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_MISS"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_ABSORB"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_DAMAGE"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_BLOCK"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_ABSORB"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_HEAL"] = {
					["disabled"] = true,
				},
				["INCOMING_MISS"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_PARRY"] = {
					["disabled"] = true,
				},
				["INCOMING_IMMUNE"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_PARRY"] = {
					["disabled"] = true,
				},
				["OUTGOING_DODGE"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_DODGE"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_ABSORB"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_BLOCK"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_IMMUNE"] = {
					["disabled"] = true,
				},
				["INCOMING_ABSORB"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_DOT"] = {
					["disabled"] = true,
				},
				["OUTGOING_PARRY"] = {
					["disabled"] = true,
				},
				["OUTGOING_BLOCK"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_IMMUNE"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_RESIST"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_DAMAGE_CRIT"] = {
					["disabled"] = true,
				},
				["NOTIFICATION_COOLDOWN"] = {
					["soundFile"] = "Debuff_Get",
				},
				["PET_INCOMING_SPELL_DEFLECT"] = {
					["disabled"] = true,
				},
				["INCOMING_DODGE"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_BLOCK"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_HOT"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_DAMAGE_CRIT"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_HEAL_CRIT"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_PARRY"] = {
					["disabled"] = true,
				},
				["INCOMING_PARRY"] = {
					["disabled"] = true,
				},
			},
			["hideFullOverheals"] = true,
			["scrollAreas"] = {
				["Outgoing"] = {
					["direction"] = "Right",
					["offsetX"] = 131,
					["behavior"] = "AngleUp",
					["offsetY"] = -157,
					["animationStyle"] = "Angled",
				},
				["Notification"] = {
					["direction"] = "Alternate",
					["offsetX"] = -171,
					["behavior"] = "GrowUp",
					["offsetY"] = 92,
					["animationStyle"] = "Horizontal",
				},
				["Static"] = {
					["offsetY"] = 97,
					["skillIconsDisabled"] = true,
					["offsetX"] = -17,
				},
				["Incoming"] = {
					["stickyDirection"] = "Down",
					["direction"] = "Left",
					["offsetX"] = -164,
					["behavior"] = "AngleDown",
					["offsetY"] = -157,
					["animationStyle"] = "Angled",
				},
			},
			["normalFontName"] = "Neuropol",
			["regenAbilitiesDisabled"] = true,
			["triggers"] = {
				["MSBT_TRIGGER_LOW_HEALTH"] = {
					["soundFile"] = "HP_F",
					["iconSkill"] = "3273",
				},
				["MSBT_TRIGGER_LOW_MANA"] = {
					["iconSkill"] = "33448",
					["soundFile"] = "MP_F",
				},
			},
		},
		["Male"] = {
			["triggers"] = {
				["MSBT_TRIGGER_LOW_HEALTH"] = {
					["iconSkill"] = "3273",
					["soundFile"] = "HP_M",
				},
				["MSBT_TRIGGER_LOW_MANA"] = {
					["iconSkill"] = "33448",
					["soundFile"] = "MP_M",
				},
			},
			["abbreviateAbilities"] = true,
			["critOutlineIndex"] = 2,
			["regenAbilitiesDisabled"] = true,
			["critFontName"] = "Neuropol",
			["normalOutlineIndex"] = 2,
			["creationVersion"] = "5.4.78",
			["qualityExclusions"] = {
				true, -- [1]
			},
			["powerThreshold"] = 800,
			["hideFullOverheals"] = true,
			["events"] = {
				["PET_INCOMING_SPELL_DAMAGE"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_REFLECT"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_PARRY"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_IMMUNE"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_PARRY"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_MISS"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_DODGE"] = {
					["disabled"] = true,
				},
				["INCOMING_HEAL"] = {
					["scrollArea"] = "Custom2",
				},
				["PET_INCOMING_MISS"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_DODGE"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_RESIST"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_MISS"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_ABSORB"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_DAMAGE"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_BLOCK"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_ABSORB"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_HEAL"] = {
					["disabled"] = true,
				},
				["INCOMING_MISS"] = {
					["disabled"] = true,
				},
				["INCOMING_BLOCK"] = {
					["disabled"] = true,
				},
				["INCOMING_IMMUNE"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_PARRY"] = {
					["disabled"] = true,
				},
				["OUTGOING_DODGE"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_DODGE"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_DAMAGE_CRIT"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_DOT"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_IMMUNE"] = {
					["disabled"] = true,
				},
				["INCOMING_ABSORB"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_BLOCK"] = {
					["disabled"] = true,
				},
				["NOTIFICATION_COOLDOWN"] = {
					["soundFile"] = "Debuff_Get",
				},
				["OUTGOING_BLOCK"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_IMMUNE"] = {
					["disabled"] = true,
				},
				["INCOMING_DODGE"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_DAMAGE_CRIT"] = {
					["disabled"] = true,
				},
				["OUTGOING_PARRY"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_SPELL_DEFLECT"] = {
					["disabled"] = true,
				},
				["INCOMING_SPELL_RESIST"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_BLOCK"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_HOT"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_ABSORB"] = {
					["disabled"] = true,
				},
				["PET_INCOMING_HEAL_CRIT"] = {
					["disabled"] = true,
				},
				["OUTGOING_MISS"] = {
					["disabled"] = true,
				},
				["INCOMING_PARRY"] = {
					["disabled"] = true,
				},
			},
			["scrollAreas"] = {
				["Outgoing"] = {
					["direction"] = "Right",
					["offsetX"] = 131,
					["behavior"] = "AngleUp",
					["offsetY"] = -157,
					["animationStyle"] = "Angled",
				},
				["Incoming"] = {
					["stickyDirection"] = "Down",
					["direction"] = "Left",
					["offsetX"] = -164,
					["behavior"] = "AngleDown",
					["offsetY"] = -157,
					["animationStyle"] = "Angled",
				},
				["Static"] = {
					["offsetY"] = 97,
					["skillIconsDisabled"] = true,
					["offsetX"] = -17,
				},
				["Notification"] = {
					["direction"] = "Alternate",
					["offsetX"] = -171,
					["behavior"] = "GrowUp",
					["offsetY"] = 92,
					["animationStyle"] = "Horizontal",
				},
			},
			["normalFontName"] = "Neuropol",
			["healThreshold"] = 400,
			["damageThreshold"] = 900,
		},
	},
}
MSBT_SavedMedia = {
	["fonts"] = {
	},
	["sounds"] = {
		["MP_M"] = "\\\\Interface\\\\AddOns\\\\MikScrollingBattleText\\\\Sounds\\\\MP_M.wav",
		["MP_F"] = "\\\\Interface\\\\AddOns\\\\MikScrollingBattleText\\\\Sounds\\\\MP_F.wav",
		["HP_M"] = "\\\\Interface\\\\AddOns\\\\MikScrollingBattleText\\\\Sounds\\\\HP_M.wav",
		["HP_F"] = "\\\\Interface\\\\AddOns\\\\MikScrollingBattleText\\\\Sounds\\\\HP_F.wav",
	},
}
end

local SetMSBTPSV = function()
if(MSBTProfiles_SavedVarsPerChar) then table.wipe(MSBTProfiles_SavedVarsPerChar) end

MSBTProfiles_SavedVarsPerChar = {
	["currentProfileName"] = "Female",
}
end

local SetSkada = function()
if(SkadaDB) then table.wipe(SkadaDB) end
SkadaDB = {
	["profiles"] = {
		["KisekiUI"] = {
			["modules"] = {
				["threatsound"] = true,
				["threattreshold"] = 85,
				["notankwarnings"] = true,
				["threatshake"] = false,
				["threatflash"] = true,
				["threatsoundname"] = "Fel Nova",
			},
			["hidepvp"] = true,
			["windows"] = {
				{
					["point"] = "BOTTOMRIGHT",
					["barmax"] = 7,
					["scale"] = 1,
					["barfontsize"] = 10,
					["modeincombat"] = "Threat",
					["barslocked"] = true,
					["background"] = {
						["borderthickness"] = 4.5,
						["color"] = {
							["a"] = 0.760000005364418,
							["b"] = 0,
						},
						["height"] = 106,
						["texture"] = "Blizzard Tooltip",
					},
					["mode"] = "Threat",
					["name"] = "Threat",
					["bartexture"] = "Minimalist",
					["enablebackground"] = true,
					["barwidth"] = 225,
					["y"] = 132.4203161990493,
					["barfont"] = "Friz Quadrata TT",
					["title"] = {
						["font"] = "Friz Quadrata TT",
						["borderthickness"] = 0,
						["color"] = {
							["a"] = 0,
						},
						["menubutton"] = false,
					},
					["x"] = -194.2172746832775,
					["returnaftercombat"] = true,
					["barheight"] = 16,
				}, -- [1]
				{
					["classcolortext"] = false,
					["barmax"] = 7,
					["scale"] = 1,
					["barcolor"] = {
						["a"] = 1,
						["b"] = 0.8,
						["g"] = 0.3,
						["r"] = 0.3,
					},
					["reversegrowth"] = false,
					["barfontsize"] = 11,
					["barheight"] = 16,
					["modeincombat"] = "Healing and Absorbs",
					["barslocked"] = true,
					["display"] = "bar",
					["barorientation"] = 1,
					["enabletitle"] = true,
					["set"] = "current",
					["name"] = "Absorbs & Heals",
					["barfont"] = "Negotiate Free",
					["enablebackground"] = false,
					["spark"] = true,
					["bartexture"] = "fer06",
					["barwidth"] = 250,
					["barspacing"] = 0,
					["hidden"] = false,
					["returnaftercombat"] = true,
					["y"] = -29.31600652868974,
					["x"] = -99.11567590500658,
					["title"] = {
						["borderthickness"] = 0,
						["font"] = "Neuropol",
						["fontsize"] = 11,
						["bordertexture"] = "None",
						["color"] = {
							["a"] = 0,
							["b"] = 0,
							["g"] = 0,
							["r"] = 0,
						},
						["menubutton"] = true,
						["margin"] = 0,
						["texture"] = "VuhDo - Aluminium",
					},
					["classcolorbars"] = true,
					["baraltcolor"] = {
						["a"] = 1,
						["b"] = 0.8,
						["g"] = 0.45,
						["r"] = 0.45,
					},
					["mode"] = "Healing and Absorbs",
					["background"] = {
						["borderthickness"] = 0,
						["color"] = {
							["a"] = 0.5,
							["b"] = 0.5,
							["g"] = 0,
							["r"] = 0,
						},
						["height"] = 150,
						["bordertexture"] = "None",
						["margin"] = 0,
						["texture"] = "None",
					},
					["point"] = "TOPRIGHT",
				}, -- [2]
			},
			["icon"] = {
				["hide"] = true,
			},
			["feed"] = "Damage: Raid DPS",
			["report"] = {
				["number"] = 5,
				["channel"] = "Party",
				["mode"] = "DPS",
			},
			["total"] = {
				["fails"] = 0,
				["absorbTotal"] = 0,
				["dispells"] = 0,
				["absorbs"] = 0,
				["ccbreaks"] = 0,
				["time"] = 0,
				["interrupts"] = 0,
				["ovaleMax"] = 0,
				["damage"] = 1467,
				["players"] = {
					{
						["class"] = "PALADIN",
						["damaged"] = {
						},
						["auras"] = {
							["Hand of Reckoning"] = {
								["id"] = 62124,
								["uptime"] = 11,
								["name"] = "Hand of Reckoning",
								["active"] = 0,
							},
						},
						["fails"] = 0,
						["ffdamagedonespells"] = {
						},
						["absorbTotal"] = 0,
						["dispells"] = 0,
						["ffdamagedone"] = 0,
						["healingspells"] = {
							["Enlightened Judgements"] = {
								["min"] = 0,
								["name"] = "Enlightened Judgements",
								["critical"] = 0,
								["max"] = 0,
								["id"] = 87189,
								["healing"] = 0,
								["overhealing"] = 1378,
								["hits"] = 1,
							},
						},
						["time"] = 83,
						["interrupts"] = 0,
						["deathts"] = 0,
						["maxhp"] = 0,
						["uptime"] = 11,
						["damage"] = 1467,
						["damagespells"] = {
							["Judgement of Truth"] = {
								["DODGE"] = 0,
								["REFLECT"] = 0,
								["crushing"] = 0,
								["IMMUNE"] = 0,
								["glancing"] = 0,
								["totalhits"] = 1,
								["MISS"] = 0,
								["damage"] = 149,
								["DEFLECT"] = 0,
								["id"] = 31804,
								["max"] = 149,
								["min"] = 149,
								["PARRY"] = 0,
								["critical"] = 0,
								["hit"] = 1,
								["EVADE"] = 0,
								["RESIST"] = 0,
								["BLOCK"] = 0,
								["ABSORB"] = 0,
							},
							["Attack"] = {
								["DODGE"] = 0,
								["REFLECT"] = 0,
								["crushing"] = 0,
								["IMMUNE"] = 0,
								["glancing"] = 0,
								["totalhits"] = 7,
								["MISS"] = 0,
								["damage"] = 1318,
								["DEFLECT"] = 0,
								["id"] = 6603,
								["max"] = 302,
								["min"] = 133,
								["PARRY"] = 0,
								["critical"] = 2,
								["hit"] = 5,
								["EVADE"] = 0,
								["RESIST"] = 0,
								["BLOCK"] = 0,
								["ABSORB"] = 0,
							},
						},
						["deaths"] = 0,
						["healed"] = {
							["Apiphany"] = {
								["amount"] = 0,
								["class"] = "PALADIN",
							},
						},
						["deathlog"] = {
						},
						["failevents"] = {
						},
						["healing"] = 0,
						["power"] = {
							[9] = {
								["amount"] = 6,
								["spells"] = {
									[89023] = 6,
								},
							},
						},
						["damagetakenspells"] = {
							["Attack"] = {
								["id"] = 6603,
								["name"] = "Attack",
								["damage"] = 16,
							},
						},
						["overhealing"] = 1378,
						["ccbreaks"] = 0,
						["ffdamagedonetargets"] = {
						},
						["absorbSpells"] = {
						},
						["id"] = "0x03800000045F8D0E",
						["damagetaken"] = 16,
						["name"] = "Apiphany",
						["absorbed"] = {
						},
					}, -- [1]
				},
				["deaths"] = 0,
				["mobs"] = {
				},
				["mobtaken"] = 0,
				["ovale"] = 0,
				["healing"] = 0,
				["power"] = {
					[9] = 6,
				},
				["overhealing"] = 1378,
				["name"] = "Total",
				["ffdamagedone"] = 0,
				["starttime"] = 1293623922,
				["damagetaken"] = 16,
				["last_action"] = 1293623922,
				["mobdone"] = 0,
			},
			["columns"] = {
				["Death log_Health"] = false,
				["Threat_TPS"] = true,
			},
			["tooltiprows"] = 4,
			["setstokeep"] = 6,
			["tooltippos"] = "topleft",
			["reset"] = {
				["instance"] = 2,
				["join"] = 2,
			},
		},
	},
}
end

local SetPrat = function()
if(Prat3DB) then table.wipe(Prat3DB) end

Prat3DB = {
	["namespaces"] = {
		["Prat_ChatTabs"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["displaymode"] = {
						["ChatFrame2"] = true,
						["ChatFrame1"] = true,
						["ChatFrame3"] = true,
					},
					["on"] = true,
					["preventdrag"] = true,
				},
			},
		},
		["Prat_AltNames"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["on"] = true,
					["pncol"] = "alt",
				},
			},
		},
		["Prat_PlayerNames"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["showtargeticon"] = true,
				},
			},
		},
		["Prat_Frames"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["minchatwidthdefault"] = 296.0000050607818,
					["maxchatheightdefault"] = 399.9999786322549,
					["maxchatwidthdefault"] = 608.000033738545,
					["initialized"] = true,
					["minchatheightdefault"] = 119.9999971884546,
				},
			},
		},
		["Prat_ChannelColorMemory"] = {
		},
		["Prat_Editbox"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["border"] = "fer10",
					["editW"] = 418.7324375234193,
					["attach"] = "LOCK",
					["editY"] = 332.3121802262465,
					["editX"] = 86.46112142284441,
				},
			},
		},
		["Prat_Fading"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["duration"] = 20,
					["textfade"] = {
						["ChatFrame3"] = false,
					},
				},
			},
		},
		["Prat_SMFHax"] = {
		},
		["Prat_Font"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["fontface"] = "Russel Square",
					["rememberfont"] = true,
				},
			},
		},
		["Prat_Bubbles"] = {
		},
		["Prat_Scroll"] = {
		},
		["Prat_Paragraph"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["on"] = true,
				},
			},
		},
		["Prat_ChannelNames"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["colon"] = false,
					["shortnames"] = {
						["guild"] = "g ||",
						["channel3"] = "lD ||",
						["battlegroundleader"] = "bL ||",
						["channel2"] = "tra ||",
						["yell"] = "y ||",
						["raidwarning"] = "rW ||",
						["raid"] = "r ||",
						["raidleader"] = "rL ||",
						["officer"] = "o ||",
						["partyleader"] = "pL ||",
						["whisper"] = "W >> ||",
						["channel4"] = "lfg ||",
						["whisperincome"] = "W << ||",
						["say"] = "s ||",
						["partyguide"] = "dG ||",
						["party"] = "p ||",
						["channel1"] = "gen ||",
						["battleground"] = "bG ||",
					},
				},
			},
		},
		["Prat_Alias"] = {
		},
		["Prat_OriginalButtons"] = {
		},
		["Prat_TellTarget"] = {
		},
		["Prat_Sounds"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["on"] = true,
				},
			},
		},
		["Prat_ChannelSticky"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["raid_warning"] = false,
					["bn_whisper"] = false,
					["yell"] = false,
					["bn_conversation"] = false,
					["whisper"] = false,
					["channel"] = false,
					["emote"] = false,
					["officer"] = false,
				},
			},
		},
		["Prat_ChatLog"] = {
		},
		["Prat_PopupMessage"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["sinkoptions"] = {
						["sink20OutputSink"] = "MikSBT",
						["sink20ScrollArea"] = "Static",
					},
					["on"] = true,
				},
			},
		},
		["Prat_CopyChat"] = {
		},
		["Prat_Timestamps"] = {
		},
		["Prat_History"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["chatlinesframes"] = {
						["ChatFrame1"] = true,
					},
					["chatlines"] = 300,
					["savehistory"] = true,
					["cmdhistory"] = {
						"/s /gn", -- [1]
						"/s /rl", -- [2]
						"/s /fortewarlock", -- [3]
						"/s /rl", -- [4]
						"/s /fortewarlock", -- [5]
						"/s /rl", -- [6]
						"/s /prat", -- [7]
						"/s /fortewarlock", -- [8]
						"/s /rl", -- [9]
						"/s /fortress", -- [10]
					},
					["maxlines"] = 10,
				},
			},
		},
		["Prat_Buttons"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["showBnet"] = false,
					["showButtons"] = false,
					["showminimize"] = false,
					["showMenu"] = false,
				},
			},
		},
		["Prat_ServerNames"] = {
		},
		["Prat_UrlCopy"] = {
		},
	},
	["profiles"] = {
		["KisekiUI"] = {
			["modules"] = {
				["Alias"] = 1,
				["Timestamps"] = 1,
				["ChatTabs"] = 3,
				["SMFHax"] = 2,
				["ChatLog"] = 1,
			},
		},
	},
}
end

local SetBartender = function()
if(Bartender4DB) then table.wipe(Bartender4DB) end

Bartender4DB = {
	["namespaces"] = {
		["ActionBars"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["actionbars"] = {
						{
							["skin"] = {
								["Colors"] = {
									["Border"] = {
										0.09803921568627451, -- [1]
										1, -- [2]
										0.09803921568627451, -- [3]
										1, -- [4]
									},
								},
								["ID"] = "Aion",
								["Backdrop"] = false,
							},
							["version"] = 3,
							["position"] = {
								["y"] = 67,
								["x"] = -310,
								["point"] = "BOTTOM",
								["scale"] = 0.95,
							},
							["padding"] = 4,
							["hidemacrotext"] = true,
						}, -- [1]
						{
							["skin"] = {
								["Colors"] = {
									["Border"] = {
										0.09803921568627451, -- [1]
										1, -- [2]
										0.09803921568627451, -- [3]
										1, -- [4]
									},
								},
								["ID"] = "Aion",
								["Backdrop"] = false,
							},
							["buttons"] = 4,
							["hidemacrotext"] = true,
							["version"] = 3,
							["position"] = {
								["y"] = 67,
								["x"] = 147,
								["point"] = "BOTTOM",
								["scale"] = 0.95,
							},
							["padding"] = 4,
							["visibility"] = {
								["vehicleui"] = false,
							},
						}, -- [2]
						{
							["skin"] = {
								["Colors"] = {
									["Border"] = {
										0.09803921568627451, -- [1]
										1, -- [2]
										0.09803921568627451, -- [3]
										1, -- [4]
									},
								},
								["ID"] = "Aion",
								["Backdrop"] = false,
							},
							["version"] = 3,
							["hidehotkey"] = true,
							["position"] = {
								["y"] = 113,
								["x"] = -230.8499903177405,
								["point"] = "BOTTOM",
								["scale"] = 0.95,
							},
							["hidemacrotext"] = true,
							["padding"] = 4,
							["visibility"] = {
								["vehicleui"] = false,
							},
						}, -- [3]
						{
							["rows"] = 12,
							["skin"] = {
								["Colors"] = {
									["Border"] = {
										0.09803921568627451, -- [1]
										1, -- [2]
										0.09803921568627451, -- [3]
										1, -- [4]
									},
								},
								["ID"] = "Aion",
								["Backdrop"] = false,
							},
							["hidehotkey"] = true,
							["version"] = 3,
							["position"] = {
								["y"] = 250,
								["x"] = -97,
								["point"] = "RIGHT",
								["scale"] = 1.2,
							},
							["hidemacrotext"] = true,
							["visibility"] = {
								["vehicleui"] = false,
							},
						}, -- [4]
						{
							["rows"] = 12,
							["skin"] = {
								["Colors"] = {
									["Border"] = {
										0.09803921568627451, -- [1]
										1, -- [2]
										0.09803921568627451, -- [3]
										1, -- [4]
									},
								},
								["ID"] = "Aion",
								["Backdrop"] = false,
							},
							["hidehotkey"] = true,
							["version"] = 3,
							["position"] = {
								["y"] = 250,
								["x"] = -50,
								["point"] = "RIGHT",
								["scale"] = 1.2,
							},
							["hidemacrotext"] = true,
						}, -- [5]
						{
							["skin"] = {
								["ID"] = "Aion",
								["Backdrop"] = false,
							},
							["enabled"] = false,
							["version"] = 3,
							["position"] = {
								["y"] = -37.49998915638332,
								["x"] = -231.4999302115951,
								["point"] = "CENTER",
							},
						}, -- [6]
						{
						}, -- [7]
						{
						}, -- [8]
						nil, -- [9]
						{
						}, -- [10]
					},
				},
			},
		},
		["MicroMenu"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["enabled"] = false,
					["version"] = 3,
					["skin"] = {
						["ID"] = "Aion",
						["Backdrop"] = false,
					},
					["position"] = {
						["y"] = 42.39985521214499,
						["x"] = -188.8000765751081,
						["point"] = "CENTER",
						["scale"] = 0.800000011920929,
					},
				},
			},
		},
		["XPBar"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["position"] = {
						["y"] = 9.999954401201535,
						["x"] = 385.4084111988424,
						["point"] = "LEFT",
					},
					["version"] = 3,
				},
			},
		},
		["BlizzardArt"] = {
			["profiles"] = {
				["Kromede - Rexxar"] = {
					["enabled"] = true,
					["version"] = 3,
					["position"] = {
						["y"] = 47,
						["x"] = -512,
						["point"] = "BOTTOM",
					},
				},
			},
		},
		["BagBar"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["skin"] = {
						["ID"] = "Aion",
						["Backdrop"] = false,
					},
					["enabled"] = false,
					["version"] = 3,
					["position"] = {
						["y"] = 1.499946894082314,
						["x"] = 58.50027776341233,
						["point"] = "CENTER",
					},
				},
			},
		},
		["StanceBar"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["version"] = 3,
					["skin"] = {
						["Colors"] = {
							["Border"] = {
								0.09803921568627451, -- [1]
								1, -- [2]
								0.09803921568627451, -- [3]
								1, -- [4]
							},
						},
						["ID"] = "Aion",
						["Backdrop"] = false,
					},
					["padding"] = 10,
					["position"] = {
						["y"] = -0.7999745512870504,
						["x"] = -365.144636093893,
						["point"] = "TOPRIGHT",
						["scale"] = 0.800000011920929,
					},
				},
			},
		},
		["Vehicle"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["version"] = 3,
					["skin"] = {
						["Colors"] = {
							["Border"] = {
								0.09803921568627451, -- [1]
								1, -- [2]
								0.09803921568627451, -- [3]
								1, -- [4]
							},
						},
						["ID"] = "Aion",
						["Backdrop"] = false,
					},
					["position"] = {
						["y"] = 87.63176189864487,
						["x"] = 323.7022843329758,
						["point"] = "LEFT",
					},
				},
			},
		},
		["PetBar"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["rows"] = 10,
					["version"] = 3,
					["skin"] = {
						["Colors"] = {
							["Border"] = {
								0.09803921568627451, -- [1]
								1, -- [2]
								0.09803921568627451, -- [3]
								1, -- [4]
							},
						},
						["ID"] = "Aion",
						["Backdrop"] = false,
					},
					["position"] = {
						["y"] = 112.3071446088039,
						["x"] = -132,
						["point"] = "RIGHT",
						["scale"] = 1.1,
					},
				},
			},
		},
		["RepBar"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["position"] = {
						["y"] = 9.999954401201535,
						["x"] = 385.4084111988424,
						["point"] = "LEFT",
					},
					["version"] = 3,
				},
			},
		},
	},
	["profiles"] = {
		["KisekiUI"] = {
			["minimapIcon"] = {
				["hide"] = true,
			},
			["selfcastrightclick"] = true,
			["focuscastmodifier"] = false,
			["selfcastmodifier"] = false,
			["onkeydown"] = true,
		},
	},
}
end

local SetmDate = function()
if(mDateDB) then table.wipe(mDateDB) end

mDateDB = {
	["profiles"] = {
		["KisekiUI"] = {
			["dateFormat"] = "%a, %d  %I:%M %p",
			["dateShown"] = true,
		},
	},
}
end

local SetALT = function()
if(AutoLagToleranceDB) then table.wipe(AutoLagToleranceDB) end

AutoLagToleranceDB = {
	["Offset"] = 0,
	["Threshold"] = 5,
	["Version"] = 0.6,
	["Interval"] = 30,
}
end

local SetBankStack = function()
if(BankStackDB) then table.wipe(BankStackDB) end

BankStackDB = {
	["namespaces"] = {
		["LDB"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["minimap"] = {
						["hide"] = true,
					},
				},
			},
		},
		["Auto"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["afk"] = "sort_bags",
				},
			},
		},
	},
	["profiles"] = {
		["KisekiUI"] = {
			["conjured"] = true,
		},
	},
}
end

local SetButtonFacade = function()
if(ButtonFacadeDB) then table.wipe(ButtonFacadeDB) end

ButtonFacadeDB = {
	["profiles"] = {
		["KisekiUI"] = {
			["Gloss"] = 0,
			["Colors"] = {
				["Border"] = {
					0.09803921568627451, -- [1]
					1, -- [2]
					0.09803921568627451, -- [3]
					1, -- [4]
				},
				["Normal"] = {
					0.25, -- [1]
					0.25, -- [2]
					0.25, -- [3]
					1, -- [4]
				},
			},
			["SkinID"] = "Svelte Shadow",
		},
	},
}
end

local SetDXE = function()
if(DXEDB) then table.wipe(DXEDB) end

DXEDB = {
	["namespaces"] = {
		["RDB"] = {
		},
		["LibDualSpec-1.0"] = {
		},
		["RaidIcons"] = {
		},
		["Distributor"] = {
		},
		["Alerts"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["TopScale"] = 1,
					["CenterBarWidth"] = 289,
					["WarningAnchor"] = true,
					["SinkStorage"] = {
						["sink20OutputSink"] = "ChatFrame",
					},
					["CenterScale"] = 1,
					["DecimalYOffset"] = 0,
					["BarTextJustification"] = "LEFT",
					["TimerXOffset"] = 0,
					["BarHeight"] = 27,
					["TopBarWidth"] = 220,
				},
			},
		},
		["Arrows"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["Scale"] = 0.7,
				},
			},
		},
	},
	["global"] = {
		["L_NPC"] = {
			[33993] = "Emalon the Storm Watcher",
			[35013] = "Koralon the Flame Watcher",
			[35144] = "Acidmaw",
			[16061] = "Instructor Razuvious",
			[33271] = "General Vezax",
			[34799] = "Dreadscale",
			[32906] = "Freya",
			[36597] = "The Lich King",
			[36855] = "Lady Deathwhisper",
			[32930] = "Kologarn",
			[32934] = "Right Arm",
			[34466] = "Anthar Forgemender",
			[34470] = "Saamul",
			[34474] = "Serissa Grimdabbler",
			[28860] = "Sartharion",
			[15956] = "Anub'Rekhan",
			[33113] = "Flame Leviathan",
			[32867] = "Steelbreaker",
			[32871] = "Algalon the Observer",
			[34780] = "Lord Jaraxxus",
			[34796] = "Gormok the Impaler",
			[37217] = "Precious",
			[33288] = "Yogg-Saron",
			[32919] = "Storm Lasher",
			[32927] = "Runemaster Molgeim",
			[34463] = "Shaabad",
			[37007] = "Deathbound Ward",
			[34471] = "Baelnor Lightbearer",
			[34475] = "Shocuul",
			[30452] = "Tenebron",
			[36789] = "Valithria Dreamwalker",
			[37813] = "Deathbringer Saurfang",
			[33118] = "Ignis the Furnace Master",
			[36678] = "Professor Putricide",
			[32872] = "Runic Colossus",
			[33515] = "Auriaya",
			[34035] = "Feral Defender",
			[33670] = "Aerial Command Unit",
			[31125] = "Archavon the Stone Watcher",
			[32916] = "Snaplasher",
			[34825] = "Nether Portal",
			[33432] = "Leviathan Mk II",
			[33186] = "Razorscale",
			[34460] = "Kavina Grovesong",
			[34468] = "Noozle Whizzlestick",
			[34472] = "Irieth Shadowstep",
			[28859] = "Malygos",
			[33890] = "Brain of Yogg-Saron",
			[33134] = "Sara",
			[38433] = "Toravon the Ice Watcher",
			[32845] = "Hodir",
			[33202] = "Ancient Water Spirit",
			[36627] = "Rotface",
			[32857] = "Stormcaller Brundir",
			[10184] = "Onyxia",
			[32865] = "Thorim",
			[16028] = "Patchwerk",
			[32873] = "Ancient Rune Giant",
			[36980] = "Ice Tomb",
			[33329] = "Heart of the Deconstructor",
			[34473] = "Brienna Nightfell",
			[33651] = "VX-001",
			[35610] = "Cat",
			[33524] = "Saronite Animus",
			[34496] = "Eydis Darkbane",
			[34813] = "Infernal Volcano",
			[36829] = "Deathspeaker High Priest",
			[34564] = "Anub'arak",
			[36853] = "Sindragosa",
			[34826] = "Mistress of Pain",
			[35465] = "Zhaagrym",
			[36612] = "Lord Marrowgar",
			[32933] = "Left Arm",
			[34461] = "Tyrius Duskblade",
			[34465] = "Velanaa",
			[34469] = "Melador Valestrider",
			[33203] = "Ancient Conservator",
			[33293] = "XT-002 Deconstructor",
			[34797] = "Icehowl",
			[37025] = "Stinky",
			[37955] = "Blood-Queen Lana'thel",
			[36626] = "Festergut",
			[34497] = "Fjola Lightbane",
			[34467] = "Alyssia Moonstalker",
		},
	},
	["profiles"] = {
		["KisekiUI"] = {
			["Misc"] = {
				["BlockRaidWarningMessages"] = true,
			},
			["Proximity"] = {
				["AutoPopup"] = false,
			},
			["Globals"] = {
				["BarTexture"] = "fer03",
				["Border"] = "None",
				["Font"] = "Russel Square",
			},
			["Encounters"] = {
				["sindragosa"] = {
					["frostbeaconself"] = {
						["sound"] = "ALERT10",
						["color1"] = "INDIGO",
					},
					["chilledstackself"] = {
						["counter"] = true,
					},
					["chilledself"] = {
						["sound"] = "ALERT9",
						["counter"] = true,
					},
				},
				["festergut"] = {
					["gassporeself"] = {
						["sound"] = "ALERT10",
					},
				},
				["anubcoliseum"] = {
					["proxwindow"] = {
						["enabled"] = true,
					},
				},
				["lichking"] = {
					["infestwarn"] = {
						["sound"] = "None",
					},
					["defileself"] = {
						["counter"] = true,
						["sound"] = "ALERT12",
						["color1"] = "RED",
					},
				},
				["lanathel"] = {
					["swarmingshadowself"] = {
						["color2"] = "VIOLET",
						["sound"] = "ALERT10",
					},
				},
				["putricide"] = {
					["gasbombcd"] = {
						["flashscreen"] = true,
						["sound"] = "ALERT10",
					},
				},
			},
			["Positions"] = {
				["DXEPane"] = {
					["point"] = "RIGHT",
					["relativePoint"] = "RIGHT",
					["yOfs"] = -91.11528622481215,
					["xOfs"] = -234.3097863359033,
				},
				["DXEAlertsTopStackAnchor"] = {
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
					["yOfs"] = -241.1725697647714,
					["xOfs"] = 8.547416355399259,
				},
				["DXEArrowsAnchor1"] = {
					["yOfs"] = -159.8554896226588,
					["xOfs"] = -5.383008219461456,
				},
				["DXEArrowsAnchor3"] = {
					["yOfs"] = -159.8554540333527,
					["xOfs"] = 82.3942616692608,
				},
				["DXEArrowsAnchor2"] = {
					["yOfs"] = -160.410842949397,
					["xOfs"] = -91.28287770680306,
				},
				["DXEAlertsWarningStackAnchor"] = {
					["yOfs"] = 224.7636397405762,
					["xOfs"] = -325.4927823219019,
				},
				["DXEWindowProximity"] = {
					["point"] = "BOTTOM",
					["relativePoint"] = "BOTTOM",
					["yOfs"] = 103.3366557834087,
					["xOfs"] = -9.084492351928731,
					["height"] = 100.0000363820114,
					["width"] = 110.0001021705358,
				},
				["DXEDistributorStackAnchor"] = {
					["point"] = "RIGHT",
					["relativePoint"] = "RIGHT",
					["yOfs"] = -186.6634753751849,
					["xOfs"] = -173.7619997285453,
				},
				["DXEAlertsCenterStackAnchor"] = {
					["point"] = "TOP",
					["relativePoint"] = "TOP",
					["yOfs"] = -198.4055056656507,
					["xOfs"] = -0.9685554578703248,
				},
			},
			["Pane"] = {
				["OnlyIfRunning"] = true,
			},
		},
	},
}
end

local SetDXEL = function()
if(DXEIconDB) then table.wipe(DXEIconDB) end

DXEIconDB = {
	["minimapPos"] = 214.1456492475252,
	["hide"] = true,
}
end

local SetFortress = function()
if(FortressDB) then table.wipe(FortressDB) end

FortressDB = {
	["profiles"] = {
		["KisekiUI"] = {
			["pluginSettings"] = {
				["ArkInventory_Tracking_Item"] = {
					["isNew"] = false,
				},
				["|cffffb366Ara|r Reputations"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
					["showIcon"] = false,
				},
				["ArkInventory_Pet"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
					["showText"] = false,
					["showLabel"] = false,
				},
				["ArkInventory_Tracking_Currency"] = {
					["isNew"] = false,
				},
				["|cFFFFB366Ara|r SpecSwitcher"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
					["textAlignXOffs"] = 5,
				},
				["Panda"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
					["blockLocked"] = true,
					["showIcon"] = false,
				},
				["shFPS"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
				},
				["ArkInventory_Currency"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
				},
				["VuhDo"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["mDate"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
					["font"] = "Russel Square",
					["hideTooltipInCombat"] = true,
					["fontSize"] = 16,
					["border"] = "None",
					["blockLocked"] = true,
					["showIcon"] = false,
					["textColor"] = {
						["a"] = 1,
					},
				},
				["ArkInventory_Pets"] = {
					["isNew"] = false,
				},
				["|cFFFFB366Ara|r Guild"] = {
					["isNew"] = false,
					["blockWidth"] = 75,
					["border"] = "fer12",
					["showIcon"] = false,
					["textAlignXOffs"] = -2,
					["fixedWidth"] = true,
					["borderColor"] = {
						["a"] = 0.7199999988079071,
						["g"] = 1,
					},
				},
				["shMem"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
				},
				["ArkInventory_Money"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["shLatency"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
					["showIcon"] = false,
				},
				["BagSyncLDB"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["eQueue"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
					["borderColor"] = {
						["a"] = 0,
					},
				},
				["Broker_Equipment"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
					["textAlignXOffs"] = 5,
				},
				["Broker_GotMail"] = {
					["frameColor"] = {
						["a"] = 0.3100000023841858,
					},
					["isNew"] = false,
					["background"] = "Solid",
					["borderColor"] = {
						["a"] = 0.7199999988079071,
						["r"] = 1,
						["b"] = 0.7215686274509804,
					},
					["border"] = "fer08",
					["textAlignXOffs"] = 3,
				},
				["Looking for Dungeon"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
					["showLabel"] = false,
					["showIcon"] = false,
				},
				["Skada"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["ArkInventory_Bags"] = {
					["isNew"] = false,
				},
				["|cFFFFB366Ara|r Friends"] = {
					["isNew"] = false,
					["blockWidth"] = 75,
					["font"] = "Russel Square",
					["borderColor"] = {
						["a"] = 0.7000000178813934,
						["r"] = 1,
						["g"] = 1,
						["b"] = 0.09803921568627451,
					},
					["border"] = "fer12",
					["showIcon"] = false,
					["textAlignXOffs"] = -2,
					["fixedWidth"] = true,
					["blockHeight"] = 20,
				},
				["WIM"] = {
					["isNew"] = false,
					["blockWidth"] = 172,
					["font"] = "Russel Square",
					["border"] = "fer12",
					["showLabel"] = false,
					["textAlignXOffs"] = 10,
					["fixedWidth"] = true,
					["borderColor"] = {
						["a"] = 0.7000000178813934,
						["r"] = 1,
						["b"] = 0.8862745098039215,
					},
				},
				["PallyPower"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
					["showIcon"] = false,
				},
				["Prat"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["gMoney"] = {
					["frameColor"] = {
						["a"] = 0.3100000023841858,
					},
					["isNew"] = false,
					["background"] = "Solid",
					["border"] = "fer08",
					["blockLocked"] = true,
					["forceVisible"] = true,
					["borderColor"] = {
						["a"] = 0.8400000035762787,
						["r"] = 0.05098039215686274,
						["g"] = 0.3568627450980392,
						["b"] = 1,
					},
				},
				["ArkInventory_Mount"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["MrTrader"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["TimeToLevel"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["AdiBags"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["ArkInventory_Bag"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["Volumizer"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
					["showLabel"] = false,
				},
				["Bartender4"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["XToLevel"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["AtlasLoot"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
				},
				["ArkInventory_Ammo"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["DXE"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["tekErr"] = {
					["isNew"] = false,
					["enabled"] = false,
				},
				["BankStack"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
					["showIcon"] = false,
				},
				["shFps"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
					["showIcon"] = false,
				},
				["tekability"] = {
					["frameColor"] = {
						["a"] = 0,
					},
					["isNew"] = false,
				},
				["ArkInventory_Mounts"] = {
					["isNew"] = false,
				},
			},
			["pluginUseMaster"] = {
				["Looking for Dungeon"] = {
					["frameColor"] = false,
					["showLabel"] = false,
					["showIcon"] = false,
				},
				["|cffffb366Ara|r Reputations"] = {
					["frameColor"] = false,
					["showIcon"] = false,
				},
				["ArkInventory_Pet"] = {
					["frameColor"] = false,
					["showText"] = false,
					["showLabel"] = false,
				},
				["|cFFFFB366Ara|r SpecSwitcher"] = {
					["frameColor"] = false,
					["textAlignXOffs"] = false,
				},
				["Panda"] = {
					["frameColor"] = false,
					["showIcon"] = false,
				},
				["shFPS"] = {
					["frameColor"] = false,
				},
				["PallyPower"] = {
					["frameColor"] = false,
					["showIcon"] = false,
					["borderColor"] = false,
				},
				["AtlasLoot"] = {
					["frameColor"] = false,
				},
				["ArkInventory_Currency"] = {
					["frameColor"] = false,
				},
				["mDate"] = {
					["frameColor"] = false,
					["borderColor"] = false,
					["font"] = false,
					["fontSize"] = false,
					["showIcon"] = false,
					["textColor"] = false,
				},
				["|cFFFFB366Ara|r Guild"] = {
					["blockWidth"] = false,
					["borderColor"] = false,
					["border"] = false,
					["showIcon"] = false,
					["textAlignXOffs"] = false,
					["fixedWidth"] = false,
				},
				["shMem"] = {
					["frameColor"] = false,
				},
				["gMoney"] = {
					["frameColor"] = false,
					["borderColor"] = false,
					["border"] = false,
					["forceVisible"] = false,
					["background"] = false,
				},
				["tekability"] = {
					["frameColor"] = false,
				},
				["shLatency"] = {
					["frameColor"] = false,
					["showIcon"] = false,
				},
				["|cFFFFB366Ara|r Friends"] = {
					["blockWidth"] = false,
					["font"] = false,
					["borderColor"] = false,
					["border"] = false,
					["showIcon"] = false,
					["textAlignXOffs"] = false,
					["fixedWidth"] = false,
				},
				["Volumizer"] = {
					["frameColor"] = false,
					["showLabel"] = false,
					["borderColor"] = false,
				},
				["eQueue"] = {
					["frameColor"] = false,
					["borderColor"] = false,
				},
				["WIM"] = {
					["blockWidth"] = false,
					["font"] = false,
					["borderColor"] = false,
					["border"] = false,
					["showLabel"] = false,
					["textAlignXOffs"] = false,
					["fixedWidth"] = false,
				},
				["BankStack"] = {
					["frameColor"] = false,
					["showIcon"] = false,
					["borderColor"] = false,
				},
				["shFps"] = {
					["frameColor"] = false,
					["showIcon"] = false,
				},
				["Broker_Equipment"] = {
					["frameColor"] = false,
					["borderColor"] = false,
					["textAlignXOffs"] = false,
				},
				["Broker_GotMail"] = {
					["frameColor"] = false,
					["borderColor"] = false,
					["border"] = false,
					["textAlignXOffs"] = false,
					["background"] = false,
				},
			},
			["blockDB"] = {
				["ArkInventory_Tracking_Item"] = {
					["scale"] = 1,
					["y"] = -242.000013495418,
					["x"] = 0,
					["showIcon"] = false,
					["locked"] = true,
					["height"] = 20,
					["anchor"] = "TOP",
					["showText"] = true,
					["noResize"] = false,
				},
				["|cffffb366Ara|r Reputations"] = {
					["scale"] = 1,
					["y"] = 0,
					["x"] = 0,
					["showIcon"] = false,
					["locked"] = true,
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "TOPLEFT",
					["noResize"] = false,
				},
				["ArkInventory_Pet"] = {
					["scale"] = 1,
					["relative"] = "LegoFortressshMem",
					["locked"] = true,
					["y"] = 0,
					["x"] = 149.445902308467,
					["showIcon"] = true,
					["stickPoint"] = "RC",
					["height"] = 20,
					["showText"] = false,
					["anchor"] = "BOTTOM",
					["noResize"] = false,
				},
				["ArkInventory_Tracking_Currency"] = {
					["scale"] = 1,
					["y"] = -194.0000101215635,
					["x"] = 0,
					["showIcon"] = false,
					["locked"] = true,
					["height"] = 20,
					["anchor"] = "TOP",
					["showText"] = true,
					["noResize"] = false,
				},
				["|cFFFFB366Ara|r SpecSwitcher"] = {
					["scale"] = 1,
					["relative"] = "LegoFortressBroker_Equipment",
					["locked"] = true,
					["y"] = 0,
					["x"] = 59.82608764107193,
					["showIcon"] = true,
					["stickPoint"] = "RC",
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "BOTTOMLEFT",
					["noResize"] = false,
				},
				["Panda"] = {
					["scale"] = 1,
					["y"] = 0,
					["x"] = -419.2463880251782,
					["showIcon"] = false,
					["locked"] = true,
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "TOP",
					["noResize"] = false,
				},
				["shFPS"] = {
					["scale"] = 1,
					["relative"] = "LegoFortressshLatency",
					["locked"] = true,
					["y"] = 0,
					["x"] = -80.47895198390916,
					["showIcon"] = true,
					["stickPoint"] = "LC",
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "BOTTOM",
					["noResize"] = false,
				},
				["ArkInventory_Currency"] = {
					["scale"] = 1,
					["relative"] = "LegoFortressshFPS",
					["locked"] = true,
					["y"] = 0,
					["x"] = -138.3005416803602,
					["showIcon"] = true,
					["stickPoint"] = "LC",
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "BOTTOM",
					["noResize"] = false,
				},
				["VuhDo"] = {
					["scale"] = 1,
					["y"] = -770.0000506078175,
					["x"] = 0,
					["showText"] = true,
					["locked"] = false,
					["height"] = 20,
					["showIcon"] = true,
					["anchor"] = "TOP",
					["noResize"] = false,
				},
				["mDate"] = {
					["scale"] = 1,
					["y"] = 0,
					["x"] = -8.623104254001646,
					["showIcon"] = false,
					["locked"] = true,
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "BOTTOMRIGHT",
					["noResize"] = false,
				},
				["ArkInventory_Pets"] = {
					["scale"] = 1,
					["y"] = -98.0000033738545,
					["x"] = 0,
					["showIcon"] = true,
					["locked"] = true,
					["height"] = 20,
					["anchor"] = "TOP",
					["showText"] = true,
					["noResize"] = false,
				},
				["|cFFFFB366Ara|r Guild"] = {
					["scale"] = 1,
					["relative"] = "LegoFortressWIM",
					["locked"] = true,
					["width"] = 75,
					["y"] = 221.6338271905635,
					["x"] = -9.774389379261265,
					["showIcon"] = false,
					["stickPoint"] = "TR",
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "BOTTOMRIGHT",
					["noResize"] = true,
				},
				["shMem"] = {
					["scale"] = 1,
					["relative"] = "LegoFortressshLatency",
					["locked"] = true,
					["y"] = 0,
					["x"] = 85.52110251221575,
					["showIcon"] = true,
					["stickPoint"] = "RC",
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "BOTTOM",
					["noResize"] = false,
				},
				["ArkInventory_Money"] = {
					["scale"] = 1,
					["y"] = 190.1972237004759,
					["x"] = 292.957857256854,
					["showText"] = true,
					["locked"] = false,
					["height"] = 24,
					["showIcon"] = true,
					["anchor"] = "CENTER",
					["noResize"] = false,
				},
				["shLatency"] = {
					["scale"] = 1,
					["y"] = 0,
					["x"] = 266.2029138716099,
					["showIcon"] = false,
					["locked"] = true,
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "BOTTOM",
					["noResize"] = false,
				},
				["BagSyncLDB"] = {
					["scale"] = 1,
					["y"] = -50,
					["x"] = 0,
					["showIcon"] = true,
					["height"] = 20,
					["locked"] = false,
					["anchor"] = "TOP",
					["showText"] = true,
					["noResize"] = false,
				},
				["eQueue"] = {
					["scale"] = 1,
					["y"] = 0,
					["x"] = 3.710196301398014,
					["showIcon"] = true,
					["height"] = 20,
					["locked"] = true,
					["showText"] = true,
					["anchor"] = "TOP",
					["noResize"] = false,
				},
				["Broker_Equipment"] = {
					["scale"] = 1,
					["y"] = 0,
					["x"] = 0,
					["showIcon"] = true,
					["locked"] = true,
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "BOTTOMLEFT",
					["noResize"] = false,
				},
				["Broker_GotMail"] = {
					["scale"] = 1,
					["y"] = 0,
					["x"] = -404.6948255929373,
					["showIcon"] = true,
					["locked"] = true,
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "BOTTOM",
					["noResize"] = false,
				},
				["Looking for Dungeon"] = {
					["scale"] = 1,
					["y"] = 0,
					["x"] = -1.85509815069895,
					["showIcon"] = false,
					["locked"] = true,
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "TOP",
					["noResize"] = false,
				},
				["Skada"] = {
					["scale"] = 1,
					["y"] = -338.000020243127,
					["x"] = 0,
					["showText"] = true,
					["locked"] = false,
					["height"] = 24,
					["showIcon"] = true,
					["anchor"] = "TOP",
					["noResize"] = false,
				},
				["ArkInventory_Bags"] = {
					["scale"] = 1,
					["y"] = -50,
					["x"] = 0,
					["showIcon"] = true,
					["locked"] = true,
					["height"] = 20,
					["anchor"] = "TOP",
					["showText"] = true,
					["noResize"] = false,
				},
				["|cFFFFB366Ara|r Friends"] = {
					["scale"] = 1,
					["relative"] = "LegoFortressWIM",
					["locked"] = true,
					["width"] = 75,
					["y"] = 221.6338271905635,
					["x"] = -106.7744666747856,
					["showIcon"] = false,
					["stickPoint"] = "TL",
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "BOTTOMRIGHT",
					["noResize"] = true,
				},
				["WIM"] = {
					["scale"] = 1,
					["width"] = 172,
					["y"] = 203.633823854066,
					["x"] = -9.774531736485642,
					["showIcon"] = true,
					["locked"] = true,
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "BOTTOMRIGHT",
					["noResize"] = true,
				},
				["tekErr"] = {
					["scale"] = 1,
					["y"] = -242.000013495418,
					["x"] = 0,
					["showText"] = true,
					["locked"] = false,
					["height"] = 24,
					["showIcon"] = true,
					["anchor"] = "TOP",
					["noResize"] = false,
				},
				["Prat"] = {
					["scale"] = 1,
					["y"] = -722.000047233963,
					["x"] = 0,
					["showText"] = true,
					["locked"] = false,
					["height"] = 24,
					["showIcon"] = true,
					["anchor"] = "TOP",
					["noResize"] = false,
				},
				["gMoney"] = {
					["scale"] = 1,
					["y"] = 0,
					["x"] = 402.5507565833567,
					["showIcon"] = false,
					["height"] = 20,
					["locked"] = true,
					["anchor"] = "BOTTOM",
					["showText"] = true,
					["noResize"] = false,
				},
				["ArkInventory_Mount"] = {
					["scale"] = 1,
					["y"] = 155.042178332452,
					["x"] = -195.6759838357821,
					["showText"] = true,
					["locked"] = false,
					["height"] = 24,
					["showIcon"] = true,
					["anchor"] = "RIGHT",
					["noResize"] = false,
				},
				["MrTrader"] = {
					["scale"] = 1,
					["y"] = -98.0000033738545,
					["x"] = 0,
					["showText"] = true,
					["locked"] = false,
					["height"] = 24,
					["showIcon"] = true,
					["anchor"] = "TOP",
					["noResize"] = false,
				},
				["AdiBags"] = {
					["scale"] = 1,
					["y"] = -50,
					["x"] = 0,
					["showIcon"] = true,
					["height"] = 20,
					["locked"] = true,
					["anchor"] = "TOP",
					["showText"] = true,
					["noResize"] = false,
				},
				["ArkInventory_Mounts"] = {
					["scale"] = 1,
					["y"] = -146.000006747709,
					["x"] = 0,
					["showIcon"] = true,
					["locked"] = true,
					["height"] = 20,
					["anchor"] = "TOP",
					["showText"] = true,
					["noResize"] = false,
				},
				["ArkInventory_Bag"] = {
					["scale"] = 1,
					["y"] = -35.15500977871795,
					["x"] = -391.4509059424688,
					["showText"] = true,
					["locked"] = false,
					["height"] = 24,
					["showIcon"] = true,
					["anchor"] = "RIGHT",
					["noResize"] = false,
				},
				["BankStack"] = {
					["scale"] = 1,
					["y"] = 0,
					["x"] = -85.60874182569523,
					["showIcon"] = false,
					["locked"] = true,
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "TOPRIGHT",
					["noResize"] = false,
				},
				["Bartender4"] = {
					["scale"] = 1,
					["y"] = -50,
					["x"] = 0,
					["showText"] = true,
					["height"] = 24,
					["locked"] = false,
					["showIcon"] = true,
					["anchor"] = "TOP",
					["noResize"] = false,
				},
				["PallyPower"] = {
					["scale"] = 1,
					["y"] = 0,
					["x"] = 0,
					["showText"] = true,
					["locked"] = true,
					["height"] = 20,
					["showIcon"] = false,
					["anchor"] = "TOPLEFT",
					["noResize"] = false,
				},
				["ArkInventory_Ammo"] = {
					["scale"] = 1,
					["y"] = -183.6056571426348,
					["x"] = 269.4835068590047,
					["showText"] = true,
					["locked"] = false,
					["height"] = 24,
					["showIcon"] = true,
					["anchor"] = "TOP",
					["noResize"] = false,
				},
				["Volumizer"] = {
					["scale"] = 1,
					["y"] = 0,
					["x"] = 0.0001423572243766103,
					["showIcon"] = true,
					["locked"] = true,
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "TOPRIGHT",
					["noResize"] = false,
				},
				["DXE"] = {
					["scale"] = 1,
					["y"] = -434.000026990836,
					["x"] = 0,
					["showText"] = true,
					["locked"] = false,
					["height"] = 24,
					["showIcon"] = true,
					["anchor"] = "TOP",
					["noResize"] = false,
				},
				["AtlasLoot"] = {
					["scale"] = 1,
					["y"] = 0,
					["x"] = 0,
					["showIcon"] = true,
					["locked"] = true,
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "TOPLEFT",
					["noResize"] = false,
				},
				["shFps"] = {
					["scale"] = 1,
					["y"] = 0,
					["x"] = -256.0000179938907,
					["showIcon"] = false,
					["locked"] = true,
					["height"] = 20,
					["showText"] = true,
					["anchor"] = "BOTTOM",
					["noResize"] = false,
				},
				["XToLevel"] = {
					["scale"] = 1,
					["y"] = 12.05795804063678,
					["x"] = 285.6812285272612,
					["showIcon"] = true,
					["height"] = 20,
					["locked"] = false,
					["showText"] = true,
					["anchor"] = "CENTER",
					["noResize"] = false,
				},
				["tekability"] = {
					["scale"] = 1,
					["relative"] = "LegoFortress|cffffb366Ara|r Reputations",
					["height"] = 20,
					["y"] = 0,
					["x"] = 222.8405883974128,
					["showIcon"] = true,
					["stickPoint"] = "RC",
					["locked"] = true,
					["showText"] = true,
					["anchor"] = "TOPLEFT",
					["noResize"] = false,
				},
				["TimeToLevel"] = {
					["scale"] = 1,
					["y"] = -42.66668166157558,
					["x"] = 383.9999190274922,
					["showIcon"] = true,
					["height"] = 20,
					["locked"] = false,
					["showText"] = true,
					["anchor"] = "CENTER",
					["noResize"] = false,
				},
			},
			["masterSettings"] = {
				["frameColor"] = {
					["a"] = 0.3100000023841858,
				},
				["font"] = "Russel Square",
				["hideTooltipInCombat"] = true,
				["border"] = "None",
				["blockLocked"] = true,
				["blockHeight"] = 20,
			},
		},
	},
}
end

local SetGCDRing = function()
if(GCDRingDB) then table.wipe(GCDRingDB) end

GCDRingDB = {
	["watchSpells"] = {
	},
	["scale"] = 0.9375,
	["alpha"] = 0.7,
	["smoother"] = 1,
	["endColor"] = {
		["a"] = 1,
		["r"] = 0.1529411764705883,
		["g"] = 0.9921568627450981,
		["b"] = 1,
	},
	["anchor"] = {
		["anchorpoint"] = "CENTER",
		["_getFrame"] = nil --[[ skipped inline function ]],
		["anchorposx"] = 489.7390876014994,
		["movable"] = 0,
		["anchorposy"] = 91.82623833990614,
		["refpoint"] = "BOTTOMLEFT",
	},
	["traditionalTrigger"] = 1,
	["ring"] = {
		["startDegree"] = 0,
		["_getFrame"] = nil --[[ skipped inline function ]],
		["minValue"] = 0,
		["maxValue"] = 1.424372648751161,
		["color"] = {
			["a"] = 1,
			["b"] = 0.9957876428628534,
			["g"] = 0.9879692841793464,
			["r"] = 0.1522473764715289,
		},
		["sparkID"] = "castbar spark",
		["totalDegree"] = -360,
		["textureID"] = "ring_default",
	},
	["beginColor"] = {
		["a"] = 1,
		["r"] = 0.04313725490196078,
		["g"] = 0.3294117647058824,
		["b"] = 0.3333333333333333,
	},
}
end

local SetMapster = function()
if(MapsterDB) then table.wipe(MapsterDB) end

MapsterDB = {
	["namespaces"] = {
		["FogClear"] = {
		},
		["Coords"] = {
		},
		["GroupIcons"] = {
		},
		["BattleMap"] = {
		},
	},
	["profiles"] = {
		["KisekiUI"] = {
			["arrowScale"] = 0.95,
			["point"] = "CENTER",
			["miniMap"] = true,
			["mini"] = {
				["y"] = 67.70997457222109,
				["x"] = -13.91304875540391,
				["disableMouse"] = false,
				["scale"] = 1.299999952316284,
				["alpha"] = 0.6,
			},
			["poiScale"] = 0.9900000095367432,
			["y"] = -0.9013258684765333,
			["x"] = -1.878020989905508,
			["questObjectives"] = 1,
		},
	},
}
end

local SetnibCT = function()
if(nibChatTabsDB) then table.wipe(nibChatTabsDB) end

nibChatTabsDB = {
	["profiles"] = {
		["Default"] = {
			["font"] = {
				["name"] = "Russel Square",
			},
		},
		["KisekiUI"] = {
			["font"] = {
				["name"] = "Russel Square",
			},
		},
	},
}
end

local SetnibMM = function()
if(nibMicroMenuDB) then table.wipe(nibMicroMenuDB) end

nibMicroMenuDB = {
	["profiles"] = {
		["KisekiUI"] = {
			["normal"] = {
				["colors"] = {
					["class"] = {
						["enabled"] = true,
					},
				},
			},
			["combatfader"] = {
				["enabled"] = true,
			},
			["font"] = {
				["name"] = "Russel Square",
			},
			["colors"] = {
				["useclass"] = true,
			},
			["position"] = {
				["y"] = 15,
				["anchorto"] = "TOPRIGHT",
				["parent"] = "ChatFrame3",
				["anchorfrom"] = "RIGHT",
			},
			["disabled"] = {
				["colors"] = {
					["class"] = {
						["enabled"] = true,
					},
				},
			},
		},
	},
}
end

local SetnibSAC = function()
if(nibSpellAlertConfigDB) then table.wipe(nibSpellAlertConfigDB) end

nibSpellAlertConfigDB = {
	["profiles"] = {
		["KisekiUI"] = {
			["size"] = {
				["scale"] = 1.2,
			},
		},
	},
}
end

local SetNugsCB = function()
if(NugComboBarDB_Global) then table.wipe(NugComboBarDB_Global) end

NugComboBarDB_Global = {
	["y"] = 184.1159363244006,
	["x"] = -395.1310117606242,
	["point"] = "BOTTOM",
	["animation"] = false,
	["scale"] = 0.9,
	["colors"] = {
		{
			0.9607843137254902, -- [1]
			0, -- [2]
			0.08627450980392157, -- [3]
		}, -- [1]
		{
			0.9607843137254902, -- [1]
			0, -- [2]
			0.08627450980392157, -- [3]
		}, -- [2]
		{
			0.9607843137254902, -- [1]
			0, -- [2]
			0.08627450980392157, -- [3]
		}, -- [3]
		{
			0.9607843137254902, -- [1]
			0.8392156862745098, -- [2]
			0, -- [3]
		}, -- [4]
		{
			0.09411764705882353, -- [1]
			0.9607843137254902, -- [2]
			0, -- [3]
		}, -- [5]
	},
	["charspec"] = {
	},
	["anchorpoint"] = "LEFT",
}
end

local SetonSH = function()
if(OnScreenHealthDB) then table.wipe(OnScreenHealthDB) end

OnScreenHealthDB = {
	["profiles"] = {
		["KisekiUI"] = {
			["fontFace"] = "Russel Square",
			["alphaMode"] = "COMBAT",
			["textFormatPowerMonster"] = "$c:s",
			["textFormatHealthMonster"] = "$p %",
			["posX"] = 220,
			["alphaCombat"] = 0.7000000000000001,
			["alphaOOC"] = 0.05,
			["posY"] = -50,
			["playerFrequentUpdates"] = true,
			["textFormatHealthPlayer"] = "$c:s || $d",
			["petEnable"] = false,
			["powerColors"] = {
				["HOLY_POWER"] = "f8e13e",
			},
			["textFormatPowerPlayer"] = "$c:s",
		},
	},
}
end

local SetoPie = function()
if(OneRing_Config) then table.wipe(OneRing_Config) end

OneRing_Config = {
	["ProfileStorage"] = {
		["default"] = {
			["ClickActivation"] = true,
			["Bindings"] = {
				["PaladinSeal"] = "F4",
				["CommonTrades"] = "F2",
				["OPieTracker"] = false,
				["PaladinTools"] = false,
				["OPieWorldMarkers"] = "F3",
				["OPieAutoQuest"] = "F1",
				["PaladinAuras"] = "F5",
				["OPieTrinkets"] = false,
				["OPieRaidSymbols"] = false,
			},
			["ShowCenterCaption"] = true,
			["UseBF"] = true,
			["ShowCooldowns"] = true,
			["LBFConfig"] = {
				["Gloss"] = 0,
				["Colors"] = {
				},
				["Backdrop"] = false,
				["SkinID"] = "Aion",
			},
		},
	},
	["PersistentStorage"] = {
	},
	["CharProfiles"] = {
	},
}
OPie_Locale = nil
end

local SetPassLoot = function()
if(PassLootDB) then table.wipe(PassLootDB) end

PassLootDB = {
	["DBVersion"] = 12,
	["global"] = {
		["Modules"] = {
			["Inventory"] = {
				["Version"] = 2,
			},
			["Zone Name"] = {
				["Version"] = 4,
			},
			["Player Name"] = {
				["Version"] = 2,
			},
			["Learned Item"] = {
				["Version"] = 3,
			},
			["Unique"] = {
				["Version"] = 4,
			},
			["Item Name"] = {
				["Version"] = 3,
			},
			["Quality"] = {
				["Version"] = 4,
			},
			["Item Level"] = {
				["Version"] = 3,
			},
			["Confirm DE"] = {
				["Version"] = 1,
			},
			["Required Level"] = {
				["Version"] = 3,
			},
			["Item Price"] = {
				["Version"] = 3,
			},
			["Binds On"] = {
				["Version"] = 4,
			},
			["Guild Group"] = {
				["Version"] = 2,
			},
			["Class Spec"] = {
				["Version"] = 2,
			},
			["Equipable"] = {
				["Version"] = 2,
			},
			["Zone Type"] = {
				["Version"] = 4,
			},
			["Confirm BoP"] = {
				["Version"] = 1,
			},
			["Equip Slot"] = {
				["Version"] = 4,
			},
			["Group / Raid"] = {
				["Version"] = 4,
			},
			["Type / SubType"] = {
				["Version"] = 4,
			},
			["Usable"] = {
				["Version"] = 2,
			},
			["Loot Won"] = {
				["Version"] = 4,
			},
			["Can I Roll"] = {
				["Version"] = 2,
			},
		},
	},
	["profiles"] = {
		["KisekiUI"] = {
			["AllowMultipleConfirmPopups"] = true,
			["Modules"] = {
				["Inventory"] = {
					["Status"] = true,
				},
				["Zone Name"] = {
					["Status"] = true,
				},
				["Player Name"] = {
					["Status"] = true,
				},
				["Learned Item"] = {
					["Status"] = true,
				},
				["Unique"] = {
					["Status"] = true,
				},
				["Item Name"] = {
					["Status"] = true,
				},
				["Quality"] = {
					["Status"] = true,
				},
				["Item Level"] = {
					["Status"] = true,
				},
				["Confirm DE"] = {
					["Status"] = true,
				},
				["Required Level"] = {
					["Status"] = true,
				},
				["Item Price"] = {
					["Status"] = true,
				},
				["Binds On"] = {
					["Status"] = true,
				},
				["Guild Group"] = {
					["Status"] = true,
				},
				["Class Spec"] = {
					["Status"] = true,
				},
				["Equipable"] = {
					["Status"] = true,
				},
				["Zone Type"] = {
					["Status"] = true,
				},
				["Confirm BoP"] = {
					["Status"] = true,
				},
				["Equip Slot"] = {
					["Status"] = true,
				},
				["Group / Raid"] = {
					["Status"] = true,
				},
				["Type / SubType"] = {
					["Status"] = true,
				},
				["Usable"] = {
					["Status"] = true,
				},
				["Loot Won"] = {
					["Status"] = true,
				},
				["Can I Roll"] = {
					["Status"] = true,
				},
			},
			["Rules"] = {
				{
					["ZoneType"] = {
						{
							3, -- [1]
							false, -- [2]
						}, -- [1]
					},
					["Desc"] = "DE Greens",
					["CanIRoll"] = {
						{
							5, -- [1]
							false, -- [2]
						}, -- [1]
					},
					["Bind"] = {
						{
							3, -- [1]
							false, -- [2]
						}, -- [1]
					},
					["RequiredLevel"] = {
						{
							5, -- [1]
							"67", -- [2]
							false, -- [3]
						}, -- [1]
					},
					["ConfirmDE"] = true,
					["Loot"] = {
						"de", -- [1]
					},
					["Quality"] = {
						{
							2, -- [1]
							false, -- [2]
						}, -- [1]
					},
				}, -- [1]
				{
					["ZoneType"] = {
						{
							3, -- [1]
							false, -- [2]
						}, -- [1]
					},
					["Loot"] = {
						"greed", -- [1]
					},
					["Quality"] = {
						{
							2, -- [1]
							false, -- [2]
						}, -- [1]
					},
					["RequiredLevel"] = {
						{
							4, -- [1]
							"57", -- [2]
							false, -- [3]
						}, -- [1]
						{
							5, -- [1]
							"70", -- [2]
							false, -- [3]
						}, -- [2]
					},
					["Items"] = {
						{
							"Pattern:", -- [1]
							"Partial", -- [2]
							true, -- [3]
						}, -- [1]
						{
							"Design:", -- [1]
							"Partial", -- [2]
							true, -- [3]
						}, -- [2]
						{
							"Formula:", -- [1]
							"Partial", -- [2]
							true, -- [3]
						}, -- [3]
						{
							"Plans:", -- [1]
							"Partial", -- [2]
							true, -- [3]
						}, -- [4]
						{
							"Schematic:", -- [1]
							"Partial", -- [2]
							true, -- [3]
						}, -- [5]
					},
					["Bind"] = {
						{
							4, -- [1]
							true, -- [2]
						}, -- [1]
					},
					["Desc"] = "Greed Greens",
				}, -- [2]
				{
					["Items"] = {
						{
							"Frozen Orb", -- [1]
							"Exact", -- [2]
							false, -- [3]
						}, -- [1]
					},
					["Loot"] = {
						"greed", -- [1]
					},
					["Quality"] = {
						{
							3, -- [1]
							false, -- [2]
						}, -- [1]
					},
					["ItemLevel"] = {
						{
							2, -- [1]
							"80", -- [2]
							false, -- [3]
						}, -- [1]
					},
					["CanIRoll"] = {
						{
							4, -- [1]
							false, -- [2]
						}, -- [1]
					},
					["Desc"] = "Greed Orbs",
				}, -- [3]
				{
					["ZoneType"] = {
						{
							3, -- [1]
							false, -- [2]
						}, -- [1]
					},
					["TypeSubType"] = {
						{
							11, -- [1]
							2, -- [2]
							false, -- [3]
						}, -- [1]
					},
					["Loot"] = {
						"greed", -- [1]
					},
					["Desc"] = "OtherBoEs",
					["Items"] = {
						{
							"Plans:", -- [1]
							"Partial", -- [2]
							true, -- [3]
						}, -- [1]
						{
							"Design:", -- [1]
							"Partial", -- [2]
							true, -- [3]
						}, -- [2]
						{
							"Formula:", -- [1]
							"Partial", -- [2]
							true, -- [3]
						}, -- [3]
						{
							"Schematic:", -- [1]
							"Partial", -- [2]
							true, -- [3]
						}, -- [4]
						{
							"Pattern:", -- [1]
							"Partial", -- [2]
							true, -- [3]
						}, -- [5]
					},
					["Quality"] = {
						{
							2, -- [1]
							false, -- [2]
						}, -- [1]
						{
							3, -- [1]
							false, -- [2]
						}, -- [2]
					},
				}, -- [4]
				{
					["Loot"] = {
						"greed", -- [1]
					},
					["ConfirmBoP"] = true,
					["GroupRaid"] = {
						{
							1, -- [1]
							true, -- [2]
						}, -- [1]
					},
					["Bind"] = {
						{
							4, -- [1]
							false, -- [2]
						}, -- [1]
					},
					["Desc"] = "Solo Blues/Greens",
				}, -- [5]
			},
			["SinkOptions"] = {
				["sink20OutputSink"] = "MikSBT",
				["sink20ScrollArea"] = "Incoming",
			},
		},
	},
}
end

local SetQuartz = function()
if(Quartz3DB) then table.wipe(Quartz3DB) end

Quartz3DB = {
	["namespaces"] = {
		["Swing"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["swingposition"] = "bottom",
				},
			},
		},
		["Buff"] = {
		},
		["Interrupt"] = {
		},
		["Flight"] = {
		},
		["Pet"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["font"] = "Russel Square",
					["fontsize"] = 17,
					["x"] = 648.9783126524253,
					["texture"] = "fer04",
					["y"] = 341.1912655686692,
				},
			},
		},
		["Player"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["h"] = 20,
					["w"] = 400,
					["y"] = 116.9022949309734,
					["font"] = "Russel Square",
					["border"] = "fer06",
					["fontsize"] = 17,
					["texture"] = "fer04",
					["timefontsize"] = 13,
					["x"] = 690.4348045143016,
					["timetexty"] = 2,
				},
			},
		},
		["GCD"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["y"] = 332.4503848927844,
					["gcdposition"] = "free",
					["gcdalpha"] = 1,
					["gcdheight"] = 6,
					["x"] = 700.2960429696384,
				},
			},
		},
		["Focus"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["noInterruptChangeColor"] = true,
					["noInterruptBorderColor"] = {
						0.7294117647058823, -- [1]
						0.08627450980392157, -- [2]
						0.2156862745098039, -- [3]
						1, -- [4]
					},
					["showtarget"] = false,
					["y"] = 341.8391176077179,
					["x"] = 952.5929723594861,
					["iconposition"] = "right",
					["fontsize"] = 17,
					["texture"] = "fer04",
					["font"] = "Russel Square",
					["noInterruptChangeBorder"] = false,
				},
			},
		},
		["Target"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["h"] = 20,
					["w"] = 305,
					["y"] = 743.0259012918418,
					["x"] = 737.9348045143016,
					["iconalpha"] = 1,
					["icongap"] = 5,
					["iconposition"] = "left",
					["border"] = "fer12",
					["texture"] = "TukTex",
					["noInterruptChangeColor"] = false,
					["noInterruptChangeBorder"] = false,
				},
			},
		},
		["Range"] = {
		},
		["Mirror"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["mirroranchor"] = "focus",
					["mirrortexture"] = "TukTex",
					["mirrorfont"] = "Russel Square",
					["mirrorposition"] = "topright",
				},
			},
		},
		["Latency"] = {
			["profiles"] = {
				["KisekiUI"] = {
					["lagalpha"] = 1,
					["lagfont"] = "Emblem",
					["lagfontsize"] = 8,
				},
			},
		},
	},
	["profiles"] = {
		["KisekiUI"] = {
			["modules"] = {
				["Flight"] = false,
				["GCD"] = false,
				["Buff"] = false,
			},
		},
	},
}
end

local SetRatingBuster = function()
if(RatingBusterDB) then table.wipe(RatingBusterDB) end

RatingBusterDB = {
	["namespaces"] = {
		["LibDualSpec-1.0"] = {
		},
	},
	["profiles"] = {
		["Holy"] = {
			["sumGemBlue"] = {
				["gemID"] = 4006,
				["itemID"] = "52244",
				["gemName"] = "Sparkling Ocean Sapphire",
				["gemText"] = "+40 Spirit",
				["gemLink"] = "|cff0070dd|Hitem:52244:0:0:0:0:0:0:0:64:0|h[Sparkling Ocean Sapphire]|h|r",
			},
			["sumSpellPower"] = true,
			["profileVersion"] = 1,
			["sumGemYellow"] = {
				["gemID"] = 4010,
				["itemID"] = "52208",
				["gemName"] = "Reckless Ember Topaz",
				["gemText"] = "+20 Intellect and +20 Haste Rating",
				["gemLink"] = "|cff0070dd|Hitem:52208:0:0:0:0:0:0:0:64:0|h[Reckless Ember Topaz]|h|r",
			},
			["sumSpellHit"] = true,
			["sumIgnorePlate"] = false,
			["showSpellDmgFromInt"] = true,
			["showSpellCritFromInt"] = true,
			["sumSpi"] = true,
			["ratingSpell"] = true,
			["ratingPhysical"] = true,
			["showMP5FromInt"] = true,
			["sumGemMeta"] = {
				["gemID"] = 4051,
				["itemID"] = "52296",
				["gemName"] = "Ember Shadowspirit Diamond",
				["gemText"] = "+54 Intellect and +2% Maximum Mana",
				["gemLink"] = "|cff0070dd|Hitem:52296:0:0:0:0:0:0:0:64:0|h[Ember Shadowspirit Diamond]|h|r",
			},
			["sumSpellCrit"] = true,
			["sumSpellHaste"] = true,
			["showMP5FromSpi"] = true,
			["sumMP"] = true,
			["showManaFromInt"] = true,
			["showHealingFromInt"] = true,
			["showHealthFromSta"] = true,
			["sumMP5"] = true,
			["sumGemRed"] = {
				["gemID"] = 3995,
				["itemID"] = "52207",
				["gemName"] = "Brilliant Inferno Ruby",
				["gemText"] = "+40 Intellect",
				["gemLink"] = "|cff0070dd|Hitem:52207:0:0:0:0:0:0:0:64:0|h[Brilliant Inferno Ruby]|h|r",
			},
			["showSpellHitFromSpi"] = true,
		},
	},
}
end

local SetSBF = function()
if(SBFDB) then table.wipe(SBFDB) end

SBFDB = {
	["global"] = {
		["message"] = false,
		["version"] = 3.1,
		["fixspells"] = true,
		["minor"] = 25,
		["spellTTL"] = 30,
		["spells"] = {
			[30482] = {
				3600, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1293243527, -- [5]
				{
				}, -- [6]
				"Molten Armor", -- [7]
			},
			[18270] = {
				27, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291069475,
				[6] = {
				},
				[7] = "Dark Plague",
			},
			[1022] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293630814, -- [5]
				{
				}, -- [6]
				"Hand of Protection", -- [7]
			},
			[31665] = {
				6, -- [1]
				true, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291689099, -- [5]
				{
				}, -- [6]
				"Master of Subtlety", -- [7]
			},
			[52109] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291673837, -- [5]
				{
				}, -- [6]
				"Flametongue Totem", -- [7]
			},
			[12292] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291686086, -- [5]
				{
				}, -- [6]
				"Death Wish", -- [7]
			},
			[13323] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291171362,
				[6] = {
				},
				[7] = "Polymorph",
			},
			[79858] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291262843,
				[6] = {
				},
				[7] = "Frostbolt",
			},
			[66623] = {
				3600.002, -- [1]
				true, -- [2]
				20, -- [3]
				"ANYONE", -- [4]
				1291069375, -- [5]
				{
				}, -- [6]
				"Well Fed", -- [7]
			},
			[16448] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291170005,
				[6] = {
				},
				[7] = "Black Rot",
			},
			[69820] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293628619, -- [5]
				{
				}, -- [6]
				"Summon Sunwalker Kodo", -- [7]
			},
			[20572] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291686086, -- [5]
				{
				}, -- [6]
				"Blood Fury", -- [7]
			},
			[58567] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291686865, -- [5]
				{
				}, -- [6]
				"Sunder Armor", -- [7]
			},
			[85421] = {
				7.988, -- [1]
				true, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1291689124, -- [5]
				{
				}, -- [6]
				"Burning Embers", -- [7]
			},
			[51470] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291665487, -- [5]
				{
				}, -- [6]
				"Elemental Oath", -- [7]
			},
			[5171] = {
				21, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291688363, -- [5]
				{
				}, -- [6]
				"Slice and Dice", -- [7]
			},
			[19645] = {
				6.001, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291206380,
				[6] = {
				},
				[7] = "Anti-Magic Shield",
			},
			[75447] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291673402,
				[6] = {
				},
				[7] = "Ferocious Inspiration",
			},
			[15473] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291686090, -- [5]
				{
				}, -- [6]
				"Shadowform", -- [7]
			},
			[45524] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1293241434, -- [5]
				{
				}, -- [6]
				"Chains of Ice", -- [7]
			},
			[15497] = {
				4.001, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293623228,
				[6] = {
				},
				[7] = "Frostbolt",
			},
			[17695] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291067908,
				[6] = {
				},
				[7] = "Defiling Aura",
			},
			[2094] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291664735, -- [5]
				{
				}, -- [6]
				"Blind", -- [7]
			},
			[5211] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291671674, -- [5]
				{
				}, -- [6]
				"Bash", -- [7]
			},
			[5215] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291675253, -- [5]
				{
				}, -- [6]
				"Prowl", -- [7]
			},
			[12540] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291269122,
				[6] = {
				},
				[7] = "Gouge",
			},
			[13579] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291186493,
				[6] = {
				},
				[7] = "Gouge",
			},
			[50256] = {
				15.001, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291677203,
				[6] = {
				},
				[7] = "Demoralizing Roar",
			},
			[7321] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1291685563, -- [5]
				{
				}, -- [6]
				"Chilled", -- [7]
			},
			[47283] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291667041,
				[6] = {
				},
				[7] = "Empowered Imp",
			},
			[55531] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291481540, -- [5]
				{
				}, -- [6]
				"Mechano-Hog", -- [7]
			},
			[13443] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291254947,
				[6] = {
				},
				[7] = "Rend",
			},
			[77747] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291674231, -- [5]
				{
				}, -- [6]
				"Totemic Wrath", -- [7]
			},
			[31410] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293623228,
				[6] = {
				},
				[7] = "Coral Cut",
			},
			[7353] = {
				60, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291672756,
				[6] = {
				},
				[7] = "Cozy Fire",
			},
			[17151] = {
				300, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291171455,
				[6] = {
				},
				[7] = "Shadow Barrier",
			},
			[93987] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1293623458, -- [5]
				{
				}, -- [6]
				"Aura of Foreboding", -- [7]
			},
			[85739] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291685859, -- [5]
				{
				}, -- [6]
				"Meat Cleaver", -- [7]
			},
			[22842] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291675270, -- [5]
				{
				}, -- [6]
				"Frenzied Regeneration", -- [7]
			},
			[20253] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291686059, -- [5]
				{
				}, -- [6]
				"Intercept", -- [7]
			},
			[23338] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291674028, -- [5]
				{
				}, -- [6]
				"Swift Stormsaber", -- [7]
			},
			[67713] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291481540, -- [5]
				{
				}, -- [6]
				"Mote of Flame", -- [7]
			},
			[31554] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1293244457,
				[6] = {
				},
				[7] = "Spell Reflection",
			},
			[13747] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291265022,
				[6] = {
				},
				[7] = "Slow",
			},
			[87342] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293623884, -- [5]
				{
				}, -- [6]
				"Holy Shield", -- [7]
			},
			[1044] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293243723, -- [5]
				{
				}, -- [6]
				"Hand of Freedom", -- [7]
			},
			[543] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291674921, -- [5]
				{
				}, -- [6]
				"Mage Ward", -- [7]
			},
			[22427] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293242975,
				[6] = {
				},
				[7] = "Concussion Blow",
			},
			[13787] = {
				1800, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291171963,
				[6] = {
				},
				[7] = "Demon Armor",
			},
			[33697] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291673803, -- [5]
				{
				}, -- [6]
				"Blood Fury", -- [7]
			},
			[30659] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				[5] = 1291668755,
				[6] = {
				},
				[7] = "Fel Infusion",
			},
			[65410] = {
				3600, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291146340, -- [5]
				{
				}, -- [6]
				"Well Fed", -- [7]
			},
			[546] = {
				600.0020000000001, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293244231, -- [5]
				{
				}, -- [6]
				"Water Walking", -- [7]
			},
			[84658] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291078589, -- [5]
				{
				}, -- [6]
				"Freewind Brave", -- [7]
			},
			[16593] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293241574, -- [5]
				{
				}, -- [6]
				"Noggenfogger Elixir", -- [7]
			},
			[87023] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1291674201, -- [5]
				{
				}, -- [6]
				"Cauterize", -- [7]
			},
			[34880] = {
				900, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1293623071,
				[6] = {
				},
				[7] = "Elemental Armor",
			},
			[8100] = {
				1800.002, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291224894, -- [5]
				{
				}, -- [6]
				"Stamina", -- [7]
			},
			[44151] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291674550, -- [5]
				{
				}, -- [6]
				"Turbo-Charged Flying Machine", -- [7]
			},
			[34976] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291674917,
				[6] = {
				},
				[7] = "Netherstorm Flag",
			},
			[6434] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1293243089,
				[6] = {
				},
				[7] = "Slice and Dice",
			},
			[40120] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291207389, -- [5]
				{
				}, -- [6]
				"Swift Flight Form", -- [7]
			},
			[16001] = {
				9, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291265633,
				[6] = {
				},
				[7] = "Impale",
			},
			[45334] = {
				4.001, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291275122, -- [5]
				{
				}, -- [6]
				"Feral Charge Effect", -- [7]
			},
			[83507] = {
				5, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291175858,
				[6] = {
				},
				[7] = "Unnatural Power",
			},
			[16577] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291069160,
				[6] = {
				},
				[7] = "Disease Cloud",
			},
			[47476] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1291685915, -- [5]
				{
				}, -- [6]
				"Strangulate", -- [7]
			},
			[53646] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1293623899, -- [5]
				{
				}, -- [6]
				"Demonic Pact", -- [7]
			},
			[18671] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291068339,
				[6] = {
				},
				[7] = "Curse of Agony",
			},
			[31986] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1293241176,
				[6] = {
				},
				[7] = "Stoneskin",
			},
			[139] = {
				14.373, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291674988, -- [5]
				{
				}, -- [6]
				"Renew", -- [7]
			},
			[80886] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291480878, -- [5]
				{
				}, -- [6]
				"Primal Madness", -- [7]
			},
			[9007] = {
				18, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291675084, -- [5]
				{
				}, -- [6]
				"Pounce Bleed", -- [7]
			},
			[12964] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291685825, -- [5]
				{
				}, -- [6]
				"Battle Trance", -- [7]
			},
			[22859] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291146024,
				[6] = {
				},
				[7] = "Mortal Cleave",
			},
			[136] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291265939, -- [5]
				{
				}, -- [6]
				"Mend Pet", -- [7]
			},
			[55277] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291674149, -- [5]
				{
				}, -- [6]
				"Stoneclaw Totem", -- [7]
			},
			[8076] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293244766, -- [5]
				{
				}, -- [6]
				"Strength of Earth", -- [7]
			},
			[55021] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1291667584, -- [5]
				{
				}, -- [6]
				"Silenced - Improved Counterspell", -- [7]
			},
			[27031] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291673631,
				[6] = {
				},
				[7] = "First Aid",
			},
			[61447] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291143332, -- [5]
				{
				}, -- [6]
				"Traveler's Tundra Mammoth", -- [7]
			},
			[16097] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291265493,
				[6] = {
				},
				[7] = "Hex",
			},
			[8056] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				"SHAMAN", -- [4]
				1291675360, -- [5]
				{
				}, -- [6]
				"Frost Shock", -- [7]
			},
			[12021] = {
				5, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291268413,
				[6] = {
				},
				[7] = "Fixate",
			},
			[1130] = {
				300.001, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291683784, -- [5]
				{
				}, -- [6]
				"Hunter's Mark", -- [7]
			},
			[81782] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291143488,
				[6] = {
				},
				[7] = "Power Word: Barrier",
			},
			[51185] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291675264, -- [5]
				{
				}, -- [6]
				"King of the Jungle", -- [7]
			},
			[16145] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293244587,
				[6] = {
				},
				[7] = "Sunder Armor",
			},
			[15089] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291251878,
				[6] = {
				},
				[7] = "Frost Shock",
			},
			[16104] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291266068,
				[6] = {
				},
				[7] = "Crystallize",
			},
			[69826] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291675484, -- [5]
				{
				}, -- [6]
				"Summon Great Sunwalker Kodo", -- [7]
			},
			[16177] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291067866, -- [5]
				{
				}, -- [6]
				"Ancestral Fortitude", -- [7]
			},
			[36032] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1293244708, -- [5]
				{
				}, -- [6]
				"Arcane Blast", -- [7]
			},
			[55501] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291677275, -- [5]
				{
				}, -- [6]
				"Lifeblood", -- [7]
			},
			[91565] = {
				300, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1293244734, -- [5]
				{
				}, -- [6]
				"Faerie Fire", -- [7]
			},
			[11445] = {
				60, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291149134,
				[6] = {
				},
				[7] = "Bone Armor",
			},
			[1135] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291202856, -- [5]
				{
				}, -- [6]
				"Drink", -- [7]
			},
			[23227] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291263146, -- [5]
				{
				}, -- [6]
				"Swift Palomino", -- [7]
			},
			[89775] = {
				26.946, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291674231, -- [5]
				{
				}, -- [6]
				"Hemorrhage", -- [7]
			},
			[9080] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293243753,
				[6] = {
				},
				[7] = "Hamstring",
			},
			[16249] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291268829,
				[6] = {
				},
				[7] = "Frostbolt",
			},
			[16257] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291667663, -- [5]
				{
				}, -- [6]
				"Flurry", -- [7]
			},
			[1131] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291666818, -- [5]
				{
				}, -- [6]
				"Food", -- [7]
			},
			[93164] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291263144,
				[6] = {
				},
				[7] = "Juju Freeze",
			},
			[87090] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291686266, -- [5]
				{
				}, -- [6]
				"Goblin Trike", -- [7]
			},
			[24378] = {
				60, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291674929,
				[6] = {
				},
				[7] = "Berserking",
			},
			[31555] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291688763, -- [5]
				{
				}, -- [6]
				"Decayed Intellect", -- [7]
			},
			[65156] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291675022, -- [5]
				{
				}, -- [6]
				"Juggernaut", -- [7]
			},
			[12020] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291068003,
				[6] = {
				},
				[7] = "Call of the Grave",
			},
			[17105] = {
				12, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291206367,
				[6] = {
				},
				[7] = "Banshee Curse",
			},
			[16592] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291068054,
				[6] = {
				},
				[7] = "Shadowform",
			},
			[16337] = {
				300, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291268944,
				[6] = {
				},
				[7] = "Chromatic Chaos",
			},
			[93740] = {
				45, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1293623064, -- [5]
				{
				}, -- [6]
				"Poison Cloud", -- [7]
			},
			[50227] = {
				5, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291687021, -- [5]
				{
				}, -- [6]
				"Sword and Board", -- [7]
			},
			[35713] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291254232, -- [5]
				{
				}, -- [6]
				"Great Blue Elekk", -- [7]
			},
			[65412] = {
				3600.006, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291215643, -- [5]
				{
				}, -- [6]
				"Well Fed", -- [7]
			},
			[11366] = {
				13.011, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1291674189, -- [5]
				{
				}, -- [6]
				"Pyroblast", -- [7]
			},
			[4955] = {
				12, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291074237,
				[6] = {
				},
				[7] = "Fist of Stone",
			},
			[22812] = {
				12, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291480798, -- [5]
				{
				}, -- [6]
				"Barkskin", -- [7]
			},
			[93165] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291252992,
				[6] = {
				},
				[7] = "Juju Chill",
			},
			[22572] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291144138,
				[6] = {
				},
				[7] = "Bruising Blow",
			},
			[50259] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291675154, -- [5]
				{
				}, -- [6]
				"Dazed", -- [7]
			},
			[1161] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291264745, -- [5]
				{
				}, -- [6]
				"Challenging Shout", -- [7]
			},
			[589] = {
				21.849, -- [1]
				false, -- [2]
				30, -- [3]
				"PRIEST", -- [4]
				1291686085, -- [5]
				{
				}, -- [6]
				"Shadow Word: Pain", -- [7]
			},
			[7713] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291170162,
				[6] = {
				},
				[7] = "Wailing Dead",
			},
			[11334] = {
				7200, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291480553, -- [5]
				{
				}, -- [6]
				"Greater Agility", -- [7]
			},
			[13532] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291204797, -- [5]
				{
				}, -- [6]
				"Thunder Clap", -- [7]
			},
			[19615] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291269734,
				[6] = {
				},
				[7] = "Frenzy Effect",
			},
			[3355] = {
				78, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291265691, -- [5]
				{
				}, -- [6]
				"Freezing Trap", -- [7]
			},
			[93805] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291675296, -- [5]
				{
				}, -- [6]
				"Ironforge Champion", -- [7]
			},
			[83639] = {
				3, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291177559,
				[6] = {
				},
				[7] = "Bloodbath",
			},
			[17633] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291068054,
				[6] = {
				},
				[7] = "Arcane Focus",
			},
			[586] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291686041, -- [5]
				{
				}, -- [6]
				"Fade", -- [7]
			},
			[13444] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291205728,
				[6] = {
				},
				[7] = "Sunder Armor",
			},
			[51698] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291671750,
				[6] = {
				},
				[7] = "Honor Among Thieves",
			},
			[32019] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291211174,
				[6] = {
				},
				[7] = "Gore",
			},
			[588] = {
				1800.005, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1293245291, -- [5]
				{
				}, -- [6]
				"Inner Fire", -- [7]
			},
			[6742] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291265045,
				[6] = {
				},
				[7] = "Bloodlust",
			},
			[81082] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291209246,
				[6] = {
				},
				[7] = "Noxious Breath",
			},
			[8377] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291146422,
				[6] = {
				},
				[7] = "Earthgrab",
			},
			[88691] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291275649, -- [5]
				{
				}, -- [6]
				"Marked for Death", -- [7]
			},
			[12485] = {
				1.5, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1293244627, -- [5]
				{
				}, -- [6]
				"Chilled", -- [7]
			},
			[16866] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291206696,
				[6] = {
				},
				[7] = "Venom Spit",
			},
			[15570] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291269325,
				[6] = {
				},
				[7] = "Immolate",
			},
			[6770] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291673933, -- [5]
				{
				}, -- [6]
				"Sap", -- [7]
			},
			[93806] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291673986, -- [5]
				{
				}, -- [6]
				"Darnassus Champion", -- [7]
			},
			[30213] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293623878,
				[6] = {
				},
				[7] = "Legion Strike",
			},
			[88819] = {
				12.001, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293627289, -- [5]
				{
				}, -- [6]
				"Daybreak", -- [7]
			},
			[12541] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291150033,
				[6] = {
				},
				[7] = "Ghoul Rot",
			},
			[15618] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291170081,
				[6] = {
				},
				[7] = "Snap Kick",
			},
			[12557] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291170226,
				[6] = {
				},
				[7] = "Cone of Cold",
			},
			[89829] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291213464,
				[6] = {
				},
				[7] = "Oiled Up",
			},
			[7992] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291206564,
				[6] = {
				},
				[7] = "Slowing Poison",
			},
			[81017] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291275739, -- [5]
				{
				}, -- [6]
				"Stampede", -- [7]
			},
			[87091] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"ANYONE", -- [4]
				1293626759, -- [5]
				{
				}, -- [6]
				"Goblin Turbo-Trike", -- [7]
			},
			[3409] = {
				12.001, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291673834, -- [5]
				{
				}, -- [6]
				"Crippling Poison", -- [7]
			},
			[17] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291676584, -- [5]
				{
				}, -- [6]
				"Power Word: Shield", -- [7]
			},
			[81325] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1293623635, -- [5]
				{
				}, -- [6]
				"Brittle Bones", -- [7]
			},
			[67017] = {
				3600.01, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291272229, -- [5]
				{
				}, -- [6]
				"Flask of the North", -- [7]
			},
			[80380] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291181956,
				[6] = {
				},
				[7] = "Sand Breath",
			},
			[48438] = {
				7.368, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291171571, -- [5]
				{
				}, -- [6]
				"Wild Growth", -- [7]
			},
			[23228] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291671526, -- [5]
				{
				}, -- [6]
				"Swift White Steed", -- [7]
			},
			[74434] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1293623377, -- [5]
				{
				}, -- [6]
				"Soulburn", -- [7]
			},
			[603] = {
				71.78400000000001, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1293623891, -- [5]
				{
				}, -- [6]
				"Bane of Doom", -- [7]
			},
			[13692] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291204732,
				[6] = {
				},
				[7] = "Dire Growl",
			},
			[45529] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291688938, -- [5]
				{
				}, -- [6]
				"Blood Tap", -- [7]
			},
			[24331] = {
				10.773, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291255176,
				[6] = {
				},
				[7] = "Rake",
			},
			[605] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291675019, -- [5]
				{
				}, -- [6]
				"Mind Control", -- [7]
			},
			[7964] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291170096,
				[6] = {
				},
				[7] = "Smoke Bomb",
			},
			[43194] = {
				1800, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293244728, -- [5]
				{
				}, -- [6]
				"Agility", -- [7]
			},
			[79038] = {
				3600.002, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291481540, -- [5]
				{
				}, -- [6]
				"Dalaran Brilliance", -- [7]
			},
			[79102] = {
				3600.006, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293627170, -- [5]
				{
				}, -- [6]
				"Blessing of Might", -- [7]
			},
			[59052] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1293623876, -- [5]
				{
				}, -- [6]
				"Freezing Fog", -- [7]
			},
			[9672] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291205163,
				[6] = {
				},
				[7] = "Frostbolt",
			},
			[81340] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291273655, -- [5]
				{
				}, -- [6]
				"Sudden Doom", -- [7]
			},
			[53138] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1293242017, -- [5]
				{
				}, -- [6]
				"Abomination's Might", -- [7]
			},
			[17330] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1293623878, -- [5]
				{
				}, -- [6]
				"Poison", -- [7]
			},
			[498] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293623228, -- [5]
				{
				}, -- [6]
				"Divine Protection", -- [7]
			},
			[15850] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291254439,
				[6] = {
				},
				[7] = "Chilled",
			},
			[13812] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291683273, -- [5]
				{
				}, -- [6]
				"Explosive Trap", -- [7]
			},
			[51124] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1293623582, -- [5]
				{
				}, -- [6]
				"Killing Machine", -- [7]
			},
			[64803] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291275382, -- [5]
				{
				}, -- [6]
				"Entrapment", -- [7]
			},
			[79039] = {
				3600, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291080109,
				[6] = {
				},
				[7] = "Dalaran Brilliance",
			},
			[17538] = {
				3600.001, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291480512, -- [5]
				{
				}, -- [6]
				"Elixir of the Mongoose", -- [7]
			},
			[87095] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291265629, -- [5]
				{
				}, -- [6]
				"Thunderstruck", -- [7]
			},
			[63560] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291673843,
				[6] = {
				},
				[7] = "Dark Transformation",
			},
			[5915] = {
				60, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291262348,
				[6] = {
				},
				[7] = "Crazed",
			},
			[80382] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291181702,
				[6] = {
				},
				[7] = "Dirt Toss",
			},
			[57518] = {
				12, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291482145, -- [5]
				{
				}, -- [6]
				"Enrage", -- [7]
			},
			[88438] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291186325, -- [5]
				{
				}, -- [6]
				"Shifted", -- [7]
			},
			[85433] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293623884, -- [5]
				{
				}, -- [6]
				"Sacred Duty", -- [7]
			},
			[66060] = {
				3, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291180854,
				[6] = {
				},
				[7] = "Sprint",
			},
			[86000] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1293623878, -- [5]
				{
				}, -- [6]
				"Curse of Gul'dan", -- [7]
			},
			[30917] = {
				9, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293243022,
				[6] = {
				},
				[7] = "Poison Bolt",
			},
			[16595] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293241552, -- [5]
				{
				}, -- [6]
				"Noggenfogger Elixir", -- [7]
			},
			[31956] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				[5] = 1293244363,
				[6] = {
				},
				[7] = "Grievous Wound",
			},
			[50613] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1291688858, -- [5]
				{
				}, -- [6]
				"Arcane Torrent", -- [7]
			},
			[75651] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"ANYONE", -- [4]
				1291269995, -- [5]
				{
				}, -- [6]
				"Speedbarge Diving Helm", -- [7]
			},
			[51700] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291689134, -- [5]
				{
				}, -- [6]
				"Honor Among Thieves", -- [7]
			},
			[16432] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291206447,
				[6] = {
				},
				[7] = "Plague Mist",
			},
			[87096] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291687089, -- [5]
				{
				}, -- [6]
				"Thunderstruck", -- [7]
			},
			[81022] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291675256, -- [5]
				{
				}, -- [6]
				"Stampede", -- [7]
			},
			[24907] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1293242909, -- [5]
				{
				}, -- [6]
				"Moonkin Aura", -- [7]
			},
			[79104] = {
				3600.004, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1293622763, -- [5]
				{
				}, -- [6]
				"Power Word: Fortitude", -- [7]
			},
			[79607] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				[5] = 1291210171,
				[6] = {
				},
				[7] = "Venom Splash",
			},
			[30070] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291675308, -- [5]
				{
				}, -- [6]
				"Blood Frenzy", -- [7]
			},
			[82365] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291202130, -- [5]
				{
				}, -- [6]
				"Skull Bash", -- [7]
			},
			[8921] = {
				19.196, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1293244484, -- [5]
				{
				}, -- [6]
				"Moonfire", -- [7]
			},
			[83645] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				[5] = 1291177085,
				[6] = {
				},
				[7] = "Slippery Suds",
			},
			[16098] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291265493,
				[6] = {
				},
				[7] = "Curse of Blood",
			},
			[32064] = {
				120, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291071041,
				[6] = {
				},
				[7] = "Battle Shout",
			},
			[16867] = {
				12, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291205853,
				[6] = {
				},
				[7] = "Banshee Curse",
			},
			[79106] = {
				3600.004, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291673142,
				[6] = {
				},
				[7] = "Shadow Protection",
			},
			[15123] = {
				3600, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291264797,
				[6] = {
				},
				[7] = "Resist Fire",
			},
			[23243] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291675240, -- [5]
				{
				}, -- [6]
				"Swift Orange Raptor", -- [7]
			},
			[14100] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291269310,
				[6] = {
				},
				[7] = "Terrifying Roar",
			},
			[63529] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1293623596, -- [5]
				{
				}, -- [6]
				"Dazed - Avenger's Shield", -- [7]
			},
			[25163] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1291143332, -- [5]
				{
				}, -- [6]
				"Oozeling's Disgusting Aura", -- [7]
			},
			[16170] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291144167,
				[6] = {
				},
				[7] = "Bloodlust",
			},
			[79105] = {
				3600.007, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1293245291, -- [5]
				{
				}, -- [6]
				"Power Word: Fortitude", -- [7]
			},
			[3551] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291075211,
				[6] = {
				},
				[7] = "Skull Crack",
			},
			[17150] = {
				1800, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291171531,
				[6] = {
				},
				[7] = "Arcane Might",
			},
			[72968] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"ANYONE", -- [4]
				1291277047, -- [5]
				{
				}, -- [6]
				"Precious's Ribbon", -- [7]
			},
			[23214] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291675150, -- [5]
				{
				}, -- [6]
				"Summon Charger", -- [7]
			},
			[85563] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291077897,
				[6] = {
				},
				[7] = "Holy Fire",
			},
			[24252] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"ANYONE", -- [4]
				1291223560, -- [5]
				{
				}, -- [6]
				"Swift Zulian Tiger", -- [7]
			},
			[13165] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291683808, -- [5]
				{
				}, -- [6]
				"Aspect of the Hawk", -- [7]
			},
			[34268] = {
				22.123, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293623343,
				[6] = {
				},
				[7] = "Acid Breath",
			},
			[17139] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291171013,
				[6] = {
				},
				[7] = "Power Word: Shield",
			},
			[49016] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291482754, -- [5]
				{
				}, -- [6]
				"Unholy Frenzy", -- [7]
			},
			[51701] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291675359, -- [5]
				{
				}, -- [6]
				"Honor Among Thieves", -- [7]
			},
			[48025] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291254138, -- [5]
				{
				}, -- [6]
				"Headless Horseman's Mount", -- [7]
			},
			[17539] = {
				3600.001, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291215643, -- [5]
				{
				}, -- [6]
				"Greater Arcane Elixir", -- [7]
			},
			[9574] = {
				45, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291265597,
				[6] = {
				},
				[7] = "Flame Buffet",
			},
			[83497] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291178460,
				[6] = {
				},
				[7] = "Glass Hide",
			},
			[13237] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291144395, -- [5]
				{
				}, -- [6]
				"Goblin Mortar", -- [7]
			},
			[31589] = {
				15.001, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1293241998, -- [5]
				{
				}, -- [6]
				"Slow", -- [7]
			},
			[35099] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291677167, -- [5]
				{
				}, -- [6]
				"Rapid Killing", -- [7]
			},
			[22718] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291081119, -- [5]
				{
				}, -- [6]
				"Black War Kodo", -- [7]
			},
			[82368] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291668113, -- [5]
				{
				}, -- [6]
				"Victorious", -- [7]
			},
			[12294] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291675308, -- [5]
				{
				}, -- [6]
				"Mortal Strike", -- [7]
			},
			[56626] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291275331,
				[6] = {
				},
				[7] = "Sting",
			},
			[5116] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291683692, -- [5]
				{
				}, -- [6]
				"Concussive Shot", -- [7]
			},
			[65416] = {
				3600.005, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291266684, -- [5]
				{
				}, -- [6]
				"Well Fed", -- [7]
			},
			[642] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291674723, -- [5]
				{
				}, -- [6]
				"Divine Shield", -- [7]
			},
			[3589] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291255461,
				[6] = {
				},
				[7] = "Deafening Screech",
			},
			[29703] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291265460, -- [5]
				{
				}, -- [6]
				"Dazed", -- [7]
			},
			[24604] = {
				60, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291675369,
				[6] = {
				},
				[7] = "Furious Howl",
			},
			[82930] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1293241940, -- [5]
				{
				}, -- [6]
				"Arcane Tactics", -- [7]
			},
			[54452] = {
				7200.001, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291685886, -- [5]
				{
				}, -- [6]
				"Adept's Elixir", -- [7]
			},
			[16468] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291266079,
				[6] = {
				},
				[7] = "Mother's Milk",
			},
			[79107] = {
				3600.008, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291683327, -- [5]
				{
				}, -- [6]
				"Shadow Protection", -- [7]
			},
			[11327] = {
				3, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291687038, -- [5]
				{
				}, -- [6]
				"Vanish", -- [7]
			},
			[52437] = {
				2, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291673989, -- [5]
				{
				}, -- [6]
				"Sudden Death", -- [7]
			},
			[2584] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291675449, -- [5]
				{
				}, -- [6]
				"Waiting to Resurrect", -- [7]
			},
			[324] = {
				600.0020000000001, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293244728, -- [5]
				{
				}, -- [6]
				"Lightning Shield", -- [7]
			},
			[25771] = {
				120.001, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1293630814, -- [5]
				{
				}, -- [6]
				"Forbearance", -- [7]
			},
			[50519] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291146228,
				[6] = {
				},
				[7] = "Sonic Blast",
			},
			[44413] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291669177, -- [5]
				{
				}, -- [6]
				"Incanter's Absorption", -- [7]
			},
			[49560] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1291687772, -- [5]
				{
				}, -- [6]
				"Death Grip", -- [7]
			},
			[79683] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1293241996, -- [5]
				{
				}, -- [6]
				"Arcane Missiles!", -- [7]
			},
			[13445] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291204732,
				[6] = {
				},
				[7] = "Rend",
			},
			[15499] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291065884,
				[6] = {
				},
				[7] = "Frost Shock",
			},
			[32021] = {
				1, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1291078682, -- [5]
				{
				}, -- [6]
				"Rushing Charge", -- [7]
			},
			[31842] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293622722, -- [5]
				{
				}, -- [6]
				"Divine Favor", -- [7]
			},
			[8362] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291480514,
				[6] = {
				},
				[7] = "Renew",
			},
			[23885] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291686088, -- [5]
				{
				}, -- [6]
				"Bloodthirst", -- [7]
			},
			[82921] = {
				5, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291275837, -- [5]
				{
				}, -- [6]
				"Bombardment", -- [7]
			},
			[62124] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1293628752, -- [5]
				{
				}, -- [6]
				"Hand of Reckoning", -- [7]
			},
			[75337] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291071079, -- [5]
				{
				}, -- [6]
				"Water Explorer", -- [7]
			},
			[3639] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291168403,
				[6] = {
				},
				[7] = "Improved Blocking",
			},
			[15571] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291683283, -- [5]
				{
				}, -- [6]
				"Dazed", -- [7]
			},
			[29544] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293244495,
				[6] = {
				},
				[7] = "Frightening Shout",
			},
			[13797] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291674675, -- [5]
				{
				}, -- [6]
				"Immolation Trap", -- [7]
			},
			[15595] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291669132, -- [5]
				{
				}, -- [6]
				"Force of Will", -- [7]
			},
			[7294] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293241982, -- [5]
				{
				}, -- [6]
				"Retribution Aura", -- [7]
			},
			[12542] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291146235,
				[6] = {
				},
				[7] = "Fear",
			},
			[7302] = {
				3600, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1293244707, -- [5]
				{
				}, -- [6]
				"Frost Armor", -- [7]
			},
			[21008] = {
				6.001, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1291212522, -- [5]
				{
				}, -- [6]
				"Mocking Blow", -- [7]
			},
			[13589] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291204481,
				[6] = {
				},
				[7] = "Haste Aura",
			},
			[53301] = {
				2.998, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291683775, -- [5]
				{
				}, -- [6]
				"Explosive Shot", -- [7]
			},
			[75912] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291072250, -- [5]
				{
				}, -- [6]
				"River Boat", -- [7]
			},
			[78535] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291069053,
				[6] = {
				},
				[7] = "Call of the Grave",
			},
			[78509] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291075060,
				[6] = {
				},
				[7] = "Torch Toss",
			},
			[6307] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291689134, -- [5]
				{
				}, -- [6]
				"Blood Pact", -- [7]
			},
			[63468] = {
				8.385, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291677263, -- [5]
				{
				}, -- [6]
				"Piercing Shots", -- [7]
			},
			[25228] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1293623683, -- [5]
				{
				}, -- [6]
				"Soul Link", -- [7]
			},
			[45182] = {
				3, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291672024, -- [5]
				{
				}, -- [6]
				"Cheating Death", -- [7]
			},
			[18099] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291068073,
				[6] = {
				},
				[7] = "Chill Nova",
			},
			[1949] = {
				14.914, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1293623535, -- [5]
				{
				}, -- [6]
				"Hellfire", -- [7]
			},
			[12654] = {
				5.993, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1291686845, -- [5]
				{
				}, -- [6]
				"Ignite", -- [7]
			},
			[1330] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291480269, -- [5]
				{
				}, -- [6]
				"Garrote - Silence", -- [7]
			},
			[122] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1293243711, -- [5]
				{
				}, -- [6]
				"Frost Nova", -- [7]
			},
			[6343] = {
				30.001, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291687052, -- [5]
				{
				}, -- [6]
				"Thunder Clap", -- [7]
			},
			[59887] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291145015, -- [5]
				{
				}, -- [6]
				"Borrowed Time", -- [7]
			},
			[79877] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291078773,
				[6] = {
				},
				[7] = "Bloodthirst",
			},
			[49868] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291686085, -- [5]
				{
				}, -- [6]
				"Mind Quickening", -- [7]
			},
			[78828] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291078061,
				[6] = {
				},
				[7] = "Bladestorm",
			},
			[32065] = {
				18, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293623782,
				[6] = {
				},
				[7] = "Fungal Decay",
			},
			[22703] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1291666621, -- [5]
				{
				}, -- [6]
				"Infernal Awakening", -- [7]
			},
			[12734] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291170937,
				[6] = {
				},
				[7] = "Ground Smash",
			},
			[12742] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291144835,
				[6] = {
				},
				[7] = "Immolate",
			},
			[32645] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291665490, -- [5]
				{
				}, -- [6]
				"Envenom", -- [7]
			},
			[30615] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291683201,
				[6] = {
				},
				[7] = "Fear",
			},
			[77384] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291076799, -- [5]
				{
				}, -- [6]
				"Oil Drilling Rig Nearby", -- [7]
			},
			[93816] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291674739, -- [5]
				{
				}, -- [6]
				"Gilneas Champion", -- [7]
			},
			[17364] = {
				15.001, -- [1]
				false, -- [2]
				30, -- [3]
				"SHAMAN", -- [4]
				1293244734, -- [5]
				{
				}, -- [6]
				"Stormstrike", -- [7]
			},
			[1943] = {
				16, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291688219, -- [5]
				{
				}, -- [6]
				"Rupture", -- [7]
			},
			[30695] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291669054,
				[6] = {
				},
				[7] = "Treacherous Aura",
			},
			[5384] = {
				360, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291682925, -- [5]
				{
				}, -- [6]
				"Feign Death", -- [7]
			},
			[57330] = {
				180, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291677926, -- [5]
				{
				}, -- [6]
				"Horn of Winter", -- [7]
			},
			[14868] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291217320,
				[6] = {
				},
				[7] = "Curse of Agony",
			},
			[19506] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291676038, -- [5]
				{
				}, -- [6]
				"Trueshot Aura", -- [7]
			},
			[18499] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291685825, -- [5]
				{
				}, -- [6]
				"Berserker Rage", -- [7]
			},
			[16469] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291266050, -- [5]
				{
				}, -- [6]
				"Web Explosion", -- [7]
			},
			[13877] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291687042, -- [5]
				{
				}, -- [6]
				"Blade Flurry", -- [7]
			},
			[30823] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293244488, -- [5]
				{
				}, -- [6]
				"Shamanistic Rage", -- [7]
			},
			[5416] = {
				10.001, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291266157,
				[6] = {
				},
				[7] = "Venom Sting",
			},
			[22799] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				[5] = 1291146487,
				[6] = {
				},
				[7] = "King of the Gordok",
			},
			[54791] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291206211,
				[6] = {
				},
				[7] = "Frostbolt",
			},
			[95799] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291686090, -- [5]
				{
				}, -- [6]
				"Empowered Shadow", -- [7]
			},
			[15971] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291256101,
				[6] = {
				},
				[7] = "Demoralizing Roar",
			},
			[17620] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291206220,
				[6] = {
				},
				[7] = "Drain Life",
			},
			[82692] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291480555, -- [5]
				{
				}, -- [6]
				"Focus Fire", -- [7]
			},
			[94009] = {
				17.986, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291686967, -- [5]
				{
				}, -- [6]
				"Rend", -- [7]
			},
			[88063] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293244515, -- [5]
				{
				}, -- [6]
				"Guarded by the Light", -- [7]
			},
			[77769] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291683181, -- [5]
				{
				}, -- [6]
				"Trap Launcher", -- [7]
			},
			[19746] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293635603, -- [5]
				{
				}, -- [6]
				"Concentration Aura", -- [7]
			},
			[17716] = {
				1.5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291068318,
				[6] = {
				},
				[7] = "Consuming Shadows",
			},
			[83559] = {
				4, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291677167, -- [5]
				{
				}, -- [6]
				"Posthaste", -- [7]
			},
			[687] = {
				1800.002, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1293623656, -- [5]
				{
				}, -- [6]
				"Demon Armor", -- [7]
			},
			[85762] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291078249,
				[6] = {
				},
				[7] = "Stomp",
			},
			[31935] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1293623686, -- [5]
				{
				}, -- [6]
				"Avenger's Shield", -- [7]
			},
			[23735] = {
				7200.001, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291673706,
				[6] = {
				},
				[7] = "Sayge's Dark Fortune of Strength",
			},
			[16789] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291269749,
				[6] = {
				},
				[7] = "Rage",
			},
			[16805] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291269762,
				[6] = {
				},
				[7] = "Conflagration",
			},
			[22959] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1291687171, -- [5]
				{
				}, -- [6]
				"Critical Mass", -- [7]
			},
			[84867] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291185082,
				[6] = {
				},
				[7] = "Sundering Swipe",
			},
			[689] = {
				3.225, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1291687100, -- [5]
				{
				}, -- [6]
				"Drain Life", -- [7]
			},
			[16869] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291203036,
				[6] = {
				},
				[7] = "Ice Tomb",
			},
			[65451] = {
				300, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293621751, -- [5]
				{
				}, -- [6]
				"Using MiniZep Controller", -- [7]
			},
			[61391] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1293243217, -- [5]
				{
				}, -- [6]
				"Typhoon", -- [7]
			},
			[93435] = {
				60.00100000000001, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291683785, -- [5]
				{
				}, -- [6]
				"Roar of Courage", -- [7]
			},
			[48333] = {
				300, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291185831, -- [5]
				{
				}, -- [6]
				"Going Ape", -- [7]
			},
			[8994] = {
				5.001, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291144842,
				[6] = {
				},
				[7] = "Banish",
			},
			[12355] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1291674244, -- [5]
				{
				}, -- [6]
				"Impact", -- [7]
			},
			[20050] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291205071, -- [5]
				{
				}, -- [6]
				"Conviction", -- [7]
			},
			[20066] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1291675003, -- [5]
				{
				}, -- [6]
				"Repentance", -- [7]
			},
			[48301] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				"PRIEST", -- [4]
				1291686082, -- [5]
				{
				}, -- [6]
				"Mind Trauma", -- [7]
			},
			[34970] = {
				120, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291688615,
				[6] = {
				},
				[7] = "Frenzy",
			},
			[43265] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1293241902, -- [5]
				{
				}, -- [6]
				"Death and Decay", -- [7]
			},
			[348] = {
				18.746, -- [1]
				true, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1293623878, -- [5]
				{
				}, -- [6]
				"Immolate", -- [7]
			},
			[18100] = {
				1800, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291068069,
				[6] = {
				},
				[7] = "Frost Armor",
			},
			[54646] = {
				1800, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291667665, -- [5]
				{
				}, -- [6]
				"Focus Magic", -- [7]
			},
			[20178] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293244622, -- [5]
				{
				}, -- [6]
				"Reckoning", -- [7]
			},
			[15244] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291066302,
				[6] = {
				},
				[7] = "Cone of Cold",
			},
			[17141] = {
				8.000999999999999, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291171071,
				[6] = {
				},
				[7] = "Holy Fire",
			},
			[6673] = {
				240.001, -- [1]
				true, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291687207, -- [5]
				{
				}, -- [6]
				"Battle Shout", -- [7]
			},
			[44544] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1293244631, -- [5]
				{
				}, -- [6]
				"Fingers of Frost", -- [7]
			},
			[130] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291671600, -- [5]
				{
				}, -- [6]
				"Slow Fall", -- [7]
			},
			[17205] = {
				1200, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291216415,
				[6] = {
				},
				[7] = "Winterfall Firewater",
			},
			[80009] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291079338,
				[6] = {
				},
				[7] = "Serpent Sting",
			},
			[81224] = {
				60, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291180499,
				[6] = {
				},
				[7] = "Silithid Toxin",
			},
			[72976] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291179021, -- [5]
				{
				}, -- [6]
				"Mind-Controlled Swarmer", -- [7]
			},
			[702] = {
				120, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1291150170, -- [5]
				{
				}, -- [6]
				"Curse of Weakness", -- [7]
			},
			[83567] = {
				5, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291182263,
				[6] = {
				},
				[7] = "Sparkling Sands",
			},
			[703] = {
				18, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291481171, -- [5]
				{
				}, -- [6]
				"Garrote", -- [7]
			},
			[5487] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291675262, -- [5]
				{
				}, -- [6]
				"Bear Form", -- [7]
			},
			[12255] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291149022,
				[6] = {
				},
				[7] = "Curse of Tuten'kash",
			},
			[60433] = {
				12.001, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1293244716, -- [5]
				{
				}, -- [6]
				"Earth and Moon", -- [7]
			},
			[16454] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291683738, -- [5]
				{
				}, -- [6]
				"Searing Blast", -- [7]
			},
			[2818] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291674766, -- [5]
				{
				}, -- [6]
				"Deadly Poison", -- [7]
			},
			[31719] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1293623885, -- [5]
				{
				}, -- [6]
				"Suspension", -- [7]
			},
			[355] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291683771, -- [5]
				{
				}, -- [6]
				"Taunt", -- [7]
			},
			[36872] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293244512,
				[6] = {
				},
				[7] = "Deadly Poison",
			},
			[27675] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291673813, -- [5]
				{
				}, -- [6]
				"Chromatic Infusion", -- [7]
			},
			[55078] = {
				35.791, -- [1]
				false, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1293241998, -- [5]
				{
				}, -- [6]
				"Blood Plague", -- [7]
			},
			[28730] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1291677032, -- [5]
				{
				}, -- [6]
				"Arcane Torrent", -- [7]
			},
			[17293] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291171598,
				[6] = {
				},
				[7] = "Burning Winds",
			},
			[30808] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293244766, -- [5]
				{
				}, -- [6]
				"Unleashed Rage", -- [7]
			},
			[29801] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1293621760, -- [5]
				{
				}, -- [6]
				"Rampage", -- [7]
			},
			[120] = {
				8.000999999999999, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1293244641, -- [5]
				{
				}, -- [6]
				"Cone of Cold", -- [7]
			},
			[30802] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291204863, -- [5]
				{
				}, -- [6]
				"Unleashed Rage", -- [7]
			},
			[85509] = {
				20.002, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291146439, -- [5]
				{
				}, -- [6]
				"Denounce", -- [7]
			},
			[91711] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291675296, -- [5]
				{
				}, -- [6]
				"Nether Ward", -- [7]
			},
			[93821] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291674724, -- [5]
				{
				}, -- [6]
				"Gnomeregan Champion", -- [7]
			},
			[45440] = {
				300, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291183420, -- [5]
				{
				}, -- [6]
				"Steam Tonk Controller", -- [7]
			},
			[53656] = {
				60, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291201852, -- [5]
				{
				}, -- [6]
				"Judgements of the Pure", -- [7]
			},
			[32192] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293623222,
				[6] = {
				},
				[7] = "Frost Nova",
			},
			[5760] = {
				10.001, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291666079, -- [5]
				{
				}, -- [6]
				"Mind-numbing Poison", -- [7]
			},
			[6795] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291275943, -- [5]
				{
				}, -- [6]
				"Growl", -- [7]
			},
			[13218] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291672017, -- [5]
				{
				}, -- [6]
				"Wound Poison", -- [7]
			},
			[16430] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291206066,
				[6] = {
				},
				[7] = "Soul Tap",
			},
			[31224] = {
				5, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291687042, -- [5]
				{
				}, -- [6]
				"Cloak of Shadows", -- [7]
			},
			[15532] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291268582,
				[6] = {
				},
				[7] = "Frost Nova",
			},
			[75024] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				[5] = 1291214591,
				[6] = {
				},
				[7] = "Rush of Flame",
			},
			[41988] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291069064,
				[6] = {
				},
				[7] = "Corruption",
			},
			[74606] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291070995,
				[6] = {
				},
				[7] = "War Stomp",
			},
			[68055] = {
				20.001, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1293623891, -- [5]
				{
				}, -- [6]
				"Judgements of the Just", -- [7]
			},
			[15572] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291268514,
				[6] = {
				},
				[7] = "Sunder Armor",
			},
			[55095] = {
				35.951, -- [1]
				false, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1293623635, -- [5]
				{
				}, -- [6]
				"Frost Fever", -- [7]
			},
			[15588] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291068822,
				[6] = {
				},
				[7] = "Thunderclap",
			},
			[88771] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291079980,
				[6] = {
				},
				[7] = "Twilight Immolate",
			},
			[65421] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291264468, -- [5]
				{
				}, -- [6]
				"Food", -- [7]
			},
			[16886] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1293242514, -- [5]
				{
				}, -- [6]
				"Nature's Grace", -- [7]
			},
			[29178] = {
				10.001, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291689119, -- [5]
				{
				}, -- [6]
				"Elemental Devastation", -- [7]
			},
			[17941] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291687173, -- [5]
				{
				}, -- [6]
				"Shadow Trance", -- [7]
			},
			[5570] = {
				18.216, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1293244699, -- [5]
				{
				}, -- [6]
				"Insect Swarm", -- [7]
			},
			[18149] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291069608,
				[6] = {
				},
				[7] = "Volatile Infection",
			},
			[87173] = {
				4, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291268584, -- [5]
				{
				}, -- [6]
				"Long Arm of the Law", -- [7]
			},
			[92800] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291666818, -- [5]
				{
				}, -- [6]
				"Drink", -- [7]
			},
			[94462] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1293244767, -- [5]
				{
				}, -- [6]
				"Undercity Champion", -- [7]
			},
			[8515] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293244766, -- [5]
				{
				}, -- [6]
				"Windfury Totem", -- [7]
			},
			[85383] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291675359, -- [5]
				{
				}, -- [6]
				"Improved Soul Fire", -- [7]
			},
			[31407] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293623285,
				[6] = {
				},
				[7] = "Viper Sting",
			},
			[53657] = {
				60.003, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293628983, -- [5]
				{
				}, -- [6]
				"Judgements of the Pure", -- [7]
			},
			[18101] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291068148,
				[6] = {
				},
				[7] = "Chilled",
			},
			[15716] = {
				120, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291262140,
				[6] = {
				},
				[7] = "Enrage",
			},
			[54648] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291667589, -- [5]
				{
				}, -- [6]
				"Focus Magic", -- [7]
			},
			[15732] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291171495,
				[6] = {
				},
				[7] = "Immolate",
			},
			[172] = {
				20.723, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1293623773, -- [5]
				{
				}, -- [6]
				"Corruption", -- [7]
			},
			[65415] = {
				3600.01, -- [1]
				false, -- [2]
				20, -- [3]
				"ANYONE", -- [4]
				1291265207, -- [5]
				{
				}, -- [6]
				"Well Fed", -- [7]
			},
			[86087] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				[5] = 1291074371,
				[6] = {
				},
				[7] = "Burning Blaze",
			},
			[53817] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293244730, -- [5]
				{
				}, -- [6]
				"Maelstrom Weapon", -- [7]
			},
			[1463] = {
				60, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291674919, -- [5]
				{
				}, -- [6]
				"Mana Shield", -- [7]
			},
			[33667] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293244710, -- [5]
				{
				}, -- [6]
				"Ferocity", -- [7]
			},
			[31704] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293623884,
				[6] = {
				},
				[7] = "Levitate",
			},
			[94463] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293635603, -- [5]
				{
				}, -- [6]
				"Thunder Bluff Champion", -- [7]
			},
			[36554] = {
				3, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291671467, -- [5]
				{
				}, -- [6]
				"Shadowstep", -- [7]
			},
			[88453] = {
				8.856999999999999, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291683269, -- [5]
				{
				}, -- [6]
				"Serpent Sting", -- [7]
			},
			[21049] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291074228,
				[6] = {
				},
				[7] = "Bloodlust",
			},
			[24394] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291269123,
				[6] = {
				},
				[7] = "Intimidation",
			},
			[7922] = {
				1.5, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291683689, -- [5]
				{
				}, -- [6]
				"Charge Stun", -- [7]
			},
			[86663] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291685690, -- [5]
				{
				}, -- [6]
				"Rude Interruption", -- [7]
			},
			[2944] = {
				26.742, -- [1]
				false, -- [2]
				30, -- [3]
				"PRIEST", -- [4]
				1291686079, -- [5]
				{
				}, -- [6]
				"Devouring Plague", -- [7]
			},
			[8699] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291209443,
				[6] = {
				},
				[7] = "Unholy Frenzy",
			},
			[16143] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291205139,
				[6] = {
				},
				[7] = "Cadaver Worms",
			},
			[8715] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291206150,
				[6] = {
				},
				[7] = "Terrifying Howl",
			},
			[75730] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291173562, -- [5]
				{
				}, -- [6]
				"Emergency Rocket-Pack", -- [7]
			},
			[48108] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291673983, -- [5]
				{
				}, -- [6]
				"Hot Streak", -- [7]
			},
			[1490] = {
				300, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1293623783, -- [5]
				{
				}, -- [6]
				"Curse of the Elements", -- [7]
			},
			[18501] = {
				5, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291668747,
				[6] = {
				},
				[7] = "Enrage",
			},
			[24799] = {
				900, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291686086, -- [5]
				{
				}, -- [6]
				"Well Fed", -- [7]
			},
			[85730] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291675023, -- [5]
				{
				}, -- [6]
				"Deadly Calm", -- [7]
			},
			[94528] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291676573, -- [5]
				{
				}, -- [6]
				"Flare", -- [7]
			},
			[27868] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1291206591, -- [5]
				{
				}, -- [6]
				"Freeze", -- [7]
			},
			[38153] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1293244703,
				[6] = {
				},
				[7] = "Acid Spray",
			},
			[50461] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291683312, -- [5]
				{
				}, -- [6]
				"Anti-Magic Zone", -- [7]
			},
			[744] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291253995,
				[6] = {
				},
				[7] = "Poison",
			},
			[93825] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"ANYONE", -- [4]
				1293623691, -- [5]
				{
				}, -- [6]
				"Orgrimmar Champion", -- [7]
			},
			[54649] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291173586, -- [5]
				{
				}, -- [6]
				"Parachute", -- [7]
			},
			[20707] = {
				900, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291675086, -- [5]
				{
				}, -- [6]
				"Soulstone Resurrection", -- [7]
			},
			[31429] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293623691,
				[6] = {
				},
				[7] = "Echoing Roar",
			},
			[17670] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291689112, -- [5]
				{
				}, -- [6]
				"Argent Dawn Commission", -- [7]
			},
			[27880] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1293621782, -- [5]
				{
				}, -- [6]
				"Stun", -- [7]
			},
			[34984] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293623583,
				[6] = {
				},
				[7] = "Psychic Horror",
			},
			[22833] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291144028,
				[6] = {
				},
				[7] = "Booze Spit",
			},
			[50421] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291674081, -- [5]
				{
				}, -- [6]
				"Scent of Blood", -- [7]
			},
			[16727] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291146439,
				[6] = {
				},
				[7] = "War Stomp",
			},
			[55480] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291205528, -- [5]
				{
				}, -- [6]
				"Lifeblood", -- [7]
			},
			[16791] = {
				60, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291206501,
				[6] = {
				},
				[7] = "Furious Anger",
			},
			[8042] = {
				8.000999999999999, -- [1]
				false, -- [2]
				30, -- [3]
				"SHAMAN", -- [4]
				1293244449, -- [5]
				{
				}, -- [6]
				"Earth Shock", -- [7]
			},
			[14030] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291264744,
				[6] = {
				},
				[7] = "Hooked Net",
			},
			[77806] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291178360,
				[6] = {
				},
				[7] = "Stealth",
			},
			[8050] = {
				29.479, -- [1]
				false, -- [2]
				30, -- [3]
				"SHAMAN", -- [4]
				1291689093, -- [5]
				{
				}, -- [6]
				"Flame Shock", -- [7]
			},
			[31427] = {
				180, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293622221,
				[6] = {
				},
				[7] = "Allergies",
			},
			[32216] = {
				20.001, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291686987, -- [5]
				{
				}, -- [6]
				"Victorious", -- [7]
			},
			[6016] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291269761,
				[6] = {
				},
				[7] = "Pierce Armor",
			},
			[12946] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291149522,
				[6] = {
				},
				[7] = "Putrid Stench",
			},
			[76691] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1293623899, -- [5]
				{
				}, -- [6]
				"Vengeance", -- [7]
			},
			[93827] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291687215, -- [5]
				{
				}, -- [6]
				"Darkspear Champion", -- [7]
			},
			[8078] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291150133,
				[6] = {
				},
				[7] = "Thunderclap",
			},
			[75860] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291072074, -- [5]
				{
				}, -- [6]
				"River Boat", -- [7]
			},
			[14118] = {
				33, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1291263539, -- [5]
				{
				}, -- [6]
				"Rend", -- [7]
			},
			[16172] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291687198,
				[6] = {
				},
				[7] = "Head Crack",
			},
			[75627] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291081052, -- [5]
				{
				}, -- [6]
				"Speedbarge Diving Helm", -- [7]
			},
			[16188] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291069408, -- [5]
				{
				}, -- [6]
				"Nature's Swiftness", -- [7]
			},
			[85387] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1291271115, -- [5]
				{
				}, -- [6]
				"Aftermath", -- [7]
			},
			[8122] = {
				9, -- [1]
				false, -- [2]
				30, -- [3]
				"PRIEST", -- [4]
				1291674996, -- [5]
				{
				}, -- [6]
				"Psychic Scream", -- [7]
			},
			[57516] = {
				12.001, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291687020, -- [5]
				{
				}, -- [6]
				"Enrage", -- [7]
			},
			[53563] = {
				301.484, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293631051, -- [5]
				{
				}, -- [6]
				"Beacon of Light", -- [7]
			},
			[84620] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291683739, -- [5]
				{
				}, -- [6]
				"Hold the Line", -- [7]
			},
			[16236] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291069375, -- [5]
				{
				}, -- [6]
				"Ancestral Fortitude", -- [7]
			},
			[16244] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291683739,
				[6] = {
				},
				[7] = "Demoralizing Shout",
			},
			[12160] = {
				12, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291262395,
				[6] = {
				},
				[7] = "Rejuvenation",
			},
			[83853] = {
				9.790000000000001, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291674191,
				[6] = {
				},
				[7] = "Combustion",
			},
			[53755] = {
				7200.021, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291227129, -- [5]
				{
				}, -- [6]
				"Flask of the Frost Wyrm", -- [7]
			},
			[12743] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291212436,
				[6] = {
				},
				[7] = "Immolation",
			},
			[66846] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291673501, -- [5]
				{
				}, -- [6]
				"Ochre Skeletal Warhorse", -- [7]
			},
			[59638] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1293243039, -- [5]
				{
				}, -- [6]
				"Frostbolt", -- [7]
			},
			[79058] = {
				3600.003, -- [1]
				true, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1293244727, -- [5]
				{
				}, -- [6]
				"Arcane Brilliance", -- [7]
			},
			[72984] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291180207, -- [5]
				{
				}, -- [6]
				"Refurbished Ogre Suit", -- [7]
			},
			[39625] = {
				3600.001, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291215643, -- [5]
				{
				}, -- [6]
				"Elixir of Major Fortitude", -- [7]
			},
			[85388] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291675310,
				[6] = {
				},
				[7] = "Throwdown",
			},
			[17735] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291271389,
				[6] = {
				},
				[7] = "Suffering",
			},
			[16536] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291267956,
				[6] = {
				},
				[7] = "Flame Buffet",
			},
			[768] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291677402, -- [5]
				{
				}, -- [6]
				"Cat Form", -- [7]
			},
			[93828] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1293623876, -- [5]
				{
				}, -- [6]
				"Silvermoon Champion", -- [7]
			},
			[31689] = {
				21.57, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293622472,
				[6] = {
				},
				[7] = "Spore Cloud",
			},
			[53148] = {
				1, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291677107,
				[6] = {
				},
				[7] = "Charge",
			},
			[1539] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291673405,
				[6] = {
				},
				[7] = "Feed Pet",
			},
			[79443] = {
				1, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291174878,
				[6] = {
				},
				[7] = "Sand Step",
			},
			[24800] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291685487, -- [5]
				{
				}, -- [6]
				"Food", -- [7]
			},
			[5137] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291170175,
				[6] = {
				},
				[7] = "Call of the Grave",
			},
			[83664] = {
				300, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291150182,
				[6] = {
				},
				[7] = "Koristrasza's Breath",
			},
			[31801] = {
				1800.005, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293635617, -- [5]
				{
				}, -- [6]
				"Seal of Truth", -- [7]
			},
			[16856] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291683465,
				[6] = {
				},
				[7] = "Mortal Strike",
			},
			[88330] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				[5] = 1291186123,
				[6] = {
				},
				[7] = "Enchanted Imp Sack",
			},
			[774] = {
				13.957, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1293244766, -- [5]
				{
				}, -- [6]
				"Rejuvenation", -- [7]
			},
			[31865] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291676858,
				[6] = {
				},
				[7] = "Seduction",
			},
			[61684] = {
				16, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291671524,
				[6] = {
				},
				[7] = "Dash",
			},
			[5217] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291674762, -- [5]
				{
				}, -- [6]
				"Tiger's Fury", -- [7]
			},
			[55610] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1293623899, -- [5]
				{
				}, -- [6]
				"Improved Icy Talons", -- [7]
			},
			[77014] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291270075,
				[6] = {
				},
				[7] = "Mad Magus Tirth's Soul",
			},
			[85709] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291078222,
				[6] = {
				},
				[7] = "Blessed by Fire",
			},
			[30938] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293243327,
				[6] = {
				},
				[7] = "Corruption",
			},
			[77800] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291069717, -- [5]
				{
				}, -- [6]
				"Focused Insight", -- [7]
			},
			[5229] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291675264, -- [5]
				{
				}, -- [6]
				"Enrage", -- [7]
			},
			[80850] = {
				60, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291205459,
				[6] = {
				},
				[7] = "Bone Armor",
			},
			[9459] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291210174,
				[6] = {
				},
				[7] = "Corrosive Ooze",
			},
			[3714] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291689138, -- [5]
				{
				}, -- [6]
				"Path of Frost", -- [7]
			},
			[5209] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291275373, -- [5]
				{
				}, -- [6]
				"Challenging Roar", -- [7]
			},
			[79060] = {
				3600.009, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291686245, -- [5]
				{
				}, -- [6]
				"Mark of the Wild", -- [7]
			},
			[70940] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291676584, -- [5]
				{
				}, -- [6]
				"Divine Guardian", -- [7]
			},
			[34767] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291674045, -- [5]
				{
				}, -- [6]
				"Summon Charger", -- [7]
			},
			[79061] = {
				3600.016, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1293244728, -- [5]
				{
				}, -- [6]
				"Mark of the Wild", -- [7]
			},
			[783] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291674423, -- [5]
				{
				}, -- [6]
				"Travel Form", -- [7]
			},
			[7279] = {
				10.001, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291213973,
				[6] = {
				},
				[7] = "Black Sludge",
			},
			[79444] = {
				9, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291073810,
				[6] = {
				},
				[7] = "Impale",
			},
			[93830] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"ANYONE", -- [4]
				1293623899, -- [5]
				{
				}, -- [6]
				"Bilgewater Champion", -- [7]
			},
			[12528] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291149769,
				[6] = {
				},
				[7] = "Silence",
			},
			[12536] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1293241721, -- [5]
				{
				}, -- [6]
				"Clearcasting", -- [7]
			},
			[85838] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291078757,
				[6] = {
				},
				[7] = "Ancestral Fortitude",
			},
			[19386] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291265560, -- [5]
				{
				}, -- [6]
				"Wyvern Sting", -- [7]
			},
			[13583] = {
				120, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291214856,
				[6] = {
				},
				[7] = "Curse of the Deadwood",
			},
			[12051] = {
				5.737, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291666157, -- [5]
				{
				}, -- [6]
				"Evocation", -- [7]
			},
			[8936] = {
				6.285, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291675214, -- [5]
				{
				}, -- [6]
				"Regrowth", -- [7]
			},
			[3150] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291178258,
				[6] = {
				},
				[7] = "Rabies",
			},
			[20053] = {
				15.002, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293631864, -- [5]
				{
				}, -- [6]
				"Conviction", -- [7]
			},
			[54428] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293623462, -- [5]
				{
				}, -- [6]
				"Divine Plea", -- [7]
			},
			[85711] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291078240,
				[6] = {
				},
				[7] = "Blessed by Air",
			},
			[99] = {
				30.001, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291275964, -- [5]
				{
				}, -- [6]
				"Demoralizing Roar", -- [7]
			},
			[61685] = {
				4, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291671524,
				[6] = {
				},
				[7] = "Charge",
			},
			[50720] = {
				1800, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291683785, -- [5]
				{
				}, -- [6]
				"Vigilance", -- [7]
			},
			[24529] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291673402,
				[6] = {
				},
				[7] = "Spirit Bond",
			},
			[20165] = {
				1800.006, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293624201, -- [5]
				{
				}, -- [6]
				"Seal of Insight", -- [7]
			},
			[23250] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291669453, -- [5]
				{
				}, -- [6]
				"Swift Brown Wolf", -- [7]
			},
			[11641] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291265206,
				[6] = {
				},
				[7] = "Hex",
			},
			[93400] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1293244324, -- [5]
				{
				}, -- [6]
				"Shooting Stars", -- [7]
			},
			[79062] = {
				3600, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293245300, -- [5]
				{
				}, -- [6]
				"Blessing of Kings", -- [7]
			},
			[91082] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291254225,
				[6] = {
				},
				[7] = "Juju Frenzy",
			},
			[46628] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291277518, -- [5]
				{
				}, -- [6]
				"Swift White Hawkstrider", -- [7]
			},
			[44614] = {
				10.223, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1293244400, -- [5]
				{
				}, -- [6]
				"Frostfire Bolt", -- [7]
			},
			[85712] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291078257,
				[6] = {
				},
				[7] = "Blessed by Earth",
			},
			[83154] = {
				9, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291674929,
				[6] = {
				},
				[7] = "Piercing Chill",
			},
			[22371] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291065471,
				[6] = {
				},
				[7] = "Curse of Impotence",
			},
			[81236] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291066340,
				[6] = {
				},
				[7] = "Diseased Spit",
			},
			[36590] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291254944,
				[6] = {
				},
				[7] = "Rip",
			},
			[18327] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291205841,
				[6] = {
				},
				[7] = "Silence",
			},
			[72221] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293623899, -- [5]
				{
				}, -- [6]
				"Luck of the Draw", -- [7]
			},
			[46916] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291686086, -- [5]
				{
				}, -- [6]
				"Bloodsurge", -- [7]
			},
			[20549] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1293243892, -- [5]
				{
				}, -- [6]
				"War Stomp", -- [7]
			},
			[64371] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291687043, -- [5]
				{
				}, -- [6]
				"Eradication", -- [7]
			},
			[52127] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291674231, -- [5]
				{
				}, -- [6]
				"Water Shield", -- [7]
			},
			[33745] = {
				17.984, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291275965, -- [5]
				{
				}, -- [6]
				"Lacerate", -- [7]
			},
			[1604] = {
				4.001, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293622782,
				[6] = {
				},
				[7] = "Dazed",
			},
			[19574] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291269734, -- [5]
				{
				}, -- [6]
				"Bestial Wrath", -- [7]
			},
			[95879] = {
				20.001, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293244710, -- [5]
				{
				}, -- [6]
				"Devourer's Stomach", -- [7]
			},
			[74602] = {
				1800.006, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291686652, -- [5]
				{
				}, -- [6]
				"Identity Crisis", -- [7]
			},
			[60503] = {
				9, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291675037, -- [5]
				{
				}, -- [6]
				"Taste for Blood", -- [7]
			},
			[79063] = {
				3600.006, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293635603, -- [5]
				{
				}, -- [6]
				"Blessing of Kings", -- [7]
			},
			[81173] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291174503,
				[6] = {
				},
				[7] = "Frenzy",
			},
			[3220] = {
				7200, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1293622754, -- [5]
				{
				}, -- [6]
				"Armor", -- [7]
			},
			[57761] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1293244627, -- [5]
				{
				}, -- [6]
				"Brain Freeze", -- [7]
			},
			[15727] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291215693,
				[6] = {
				},
				[7] = "Demoralizing Roar",
			},
			[88590] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291079536, -- [5]
				{
				}, -- [6]
				"Heartrazor", -- [7]
			},
			[72286] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291143191, -- [5]
				{
				}, -- [6]
				"Invincible", -- [7]
			},
			[31930] = {
				11.299, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293623884, -- [5]
				{
				}, -- [6]
				"Judgements of the Wise", -- [7]
			},
			[30923] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1293243717, -- [5]
				{
				}, -- [6]
				"Domination", -- [7]
			},
			[12976] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291686856, -- [5]
				{
				}, -- [6]
				"Last Stand", -- [7]
			},
			[5277] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291674744, -- [5]
				{
				}, -- [6]
				"Evasion", -- [7]
			},
			[16045] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291267866,
				[6] = {
				},
				[7] = "Encage",
			},
			[81219] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1293242824,
				[6] = {
				},
				[7] = "Battle Shout",
			},
			[30108] = {
				14.71, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1291687171, -- [5]
				{
				}, -- [6]
				"Unstable Affliction", -- [7]
			},
			[22835] = {
				60, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291144027,
				[6] = {
				},
				[7] = "Drunken Rage",
			},
			[12968] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291686088, -- [5]
				{
				}, -- [6]
				"Flurry", -- [7]
			},
			[79064] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291070640,
				[6] = {
				},
				[7] = "Horde Banner",
			},
			[51399] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1291664796, -- [5]
				{
				}, -- [6]
				"Death Grip", -- [7]
			},
			[77978] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291170256,
				[6] = {
				},
				[7] = "Disease Cloud",
			},
			[17800] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1291689124, -- [5]
				{
				}, -- [6]
				"Shadow and Flame", -- [7]
			},
			[70893] = {
				10.001, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291683278, -- [5]
				{
				}, -- [6]
				"Culling the Herd", -- [7]
			},
			[408] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291274266, -- [5]
				{
				}, -- [6]
				"Kidney Shot", -- [7]
			},
			[91724] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291674988, -- [5]
				{
				}, -- [6]
				"Spell Warding", -- [7]
			},
			[29341] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1291689124, -- [5]
				{
				}, -- [6]
				"Shadowburn", -- [7]
			},
			[79972] = {
				300, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291064748,
				[6] = {
				},
				[7] = "Seal of Vengeance",
			},
			[35760] = {
				300, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293244643,
				[6] = {
				},
				[7] = "Decayed Strength",
			},
			[61469] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291673142, -- [5]
				{
				}, -- [6]
				"Grand Ice Mammoth", -- [7]
			},
			[91021] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291688858, -- [5]
				{
				}, -- [6]
				"Find Weakness", -- [7]
			},
			[17145] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291171499,
				[6] = {
				},
				[7] = "Blast Wave",
			},
			[20006] = {
				12.001, -- [1]
				false, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1291686079, -- [5]
				{
				}, -- [6]
				"Unholy Curse", -- [7]
			},
			[80983] = {
				120, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291078592,
				[6] = {
				},
				[7] = "Commanding Shout",
			},
			[87185] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291146286,
				[6] = {
				},
				[7] = "Demoralizing Roar",
			},
			[32330] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293623599,
				[6] = {
				},
				[7] = "Poison Spit",
			},
			[59545] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291673843,
				[6] = {
				},
				[7] = "Gift of the Naaru",
			},
			[57531] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1293241721, -- [5]
				{
				}, -- [6]
				"Arcane Potency", -- [7]
			},
			[54494] = {
				3600, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291664547, -- [5]
				{
				}, -- [6]
				"Major Agility", -- [7]
			},
			[50434] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1291671906, -- [5]
				{
				}, -- [6]
				"Chilblains", -- [7]
			},
			[18088] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291265462, -- [5]
				{
				}, -- [6]
				"Corruption", -- [7]
			},
			[23219] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291673961, -- [5]
				{
				}, -- [6]
				"Swift Mistsaber", -- [7]
			},
			[93068] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291666080, -- [5]
				{
				}, -- [6]
				"Master Poisoner", -- [7]
			},
			[23251] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291674154, -- [5]
				{
				}, -- [6]
				"Swift Timber Wolf", -- [7]
			},
			[91992] = {
				600.0020000000001, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291261734,
				[6] = {
				},
				[7] = "Juju Mending",
			},
			[74590] = {
				1800.001, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291067177, -- [5]
				{
				}, -- [6]
				"Identity Crisis", -- [7]
			},
			[20230] = {
				12, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291675038, -- [5]
				{
				}, -- [6]
				"Retaliation", -- [7]
			},
			[31803] = {
				19.483, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1293623891, -- [5]
				{
				}, -- [6]
				"Censure", -- [7]
			},
			[17883] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293244507,
				[6] = {
				},
				[7] = "Immolate",
			},
			[75614] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291215643, -- [5]
				{
				}, -- [6]
				"Celestial Steed", -- [7]
			},
			[33395] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291675361,
				[6] = {
				},
				[7] = "Freeze",
			},
			[91342] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291673808,
				[6] = {
				},
				[7] = "Shadow Infusion",
			},
			[15286] = {
				1800.001, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291686090, -- [5]
				{
				}, -- [6]
				"Vampiric Embrace", -- [7]
			},
			[82839] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291070615,
				[6] = {
				},
				[7] = "Hardened",
			},
			[16458] = {
				20.001, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291206420,
				[6] = {
				},
				[7] = "Ghoul Plague",
			},
			[58747] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293243241,
				[6] = {
				},
				[7] = "Intercept",
			},
			[31643] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291674072, -- [5]
				{
				}, -- [6]
				"Blazing Speed", -- [7]
			},
			[30636] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291683483,
				[6] = {
				},
				[7] = "Furious Howl",
			},
			[79268] = {
				8.814, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291675163, -- [5]
				{
				}, -- [6]
				"Soul Harvest", -- [7]
			},
			[34163] = {
				21, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1293622306,
				[6] = {
				},
				[7] = "Fungal Regrowth",
			},
			[61336] = {
				12, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291480798, -- [5]
				{
				}, -- [6]
				"Survival Instincts", -- [7]
			},
			[74591] = {
				1800.002, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291668787, -- [5]
				{
				}, -- [6]
				"Identity Crisis", -- [7]
			},
			[33779] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293623899, -- [5]
				{
				}, -- [6]
				"Twin Spire Blessing", -- [7]
			},
			[48517] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1293244708, -- [5]
				{
				}, -- [6]
				"Eclipse (Solar)", -- [7]
			},
			[5697] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291673706, -- [5]
				{
				}, -- [6]
				"Unending Breath", -- [7]
			},
			[58427] = {
				20, -- [1]
				true, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1293622739, -- [5]
				{
				}, -- [6]
				"Overkill", -- [7]
			},
			[33907] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291070139,
				[6] = {
				},
				[7] = "Thorns",
			},
			[8245] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291069608,
				[6] = {
				},
				[7] = "Corrosive Acid",
			},
			[81753] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291177028,
				[6] = {
				},
				[7] = "Threatening Shout",
			},
			[59578] = {
				15.001, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293241856, -- [5]
				{
				}, -- [6]
				"The Art of War", -- [7]
			},
			[8269] = {
				120, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1293244173,
				[6] = {
				},
				[7] = "Frenzy",
			},
			[5677] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293244766, -- [5]
				{
				}, -- [6]
				"Mana Spring", -- [7]
			},
			[82840] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291069981,
				[6] = {
				},
				[7] = "Vulnerable",
			},
			[74720] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291076758,
				[6] = {
				},
				[7] = "Pound",
			},
			[22724] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291481669, -- [5]
				{
				}, -- [6]
				"Black War Wolf", -- [7]
			},
			[89809] = {
				6, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291213545, -- [5]
				{
				}, -- [6]
				"Megaflare", -- [7]
			},
			[30940] = {
				5, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291677263,
				[6] = {
				},
				[7] = "Burning Nova",
			},
			[74592] = {
				1800.005, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293245026, -- [5]
				{
				}, -- [6]
				"Identity Crisis", -- [7]
			},
			[44521] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291674570, -- [5]
				{
				}, -- [6]
				"Preparation", -- [7]
			},
			[53760] = {
				3600.007, -- [1]
				false, -- [2]
				20, -- [3]
				"ANYONE", -- [4]
				1291277047, -- [5]
				{
				}, -- [6]
				"Flask of Endless Rage", -- [7]
			},
			[89151] = {
				3, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291212699, -- [5]
				{
				}, -- [6]
				"Sindweller Blindfold", -- [7]
			},
			[11426] = {
				60, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291674669, -- [5]
				{
				}, -- [6]
				"Ice Barrier", -- [7]
			},
			[91991] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291262220,
				[6] = {
				},
				[7] = "Juju Instinct",
			},
			[11442] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291149711,
				[6] = {
				},
				[7] = "Withered Touch",
			},
			[74600] = {
				1800.003, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291269577, -- [5]
				{
				}, -- [6]
				"Identity Crisis", -- [7]
			},
			[34914] = {
				16.146, -- [1]
				false, -- [2]
				30, -- [3]
				"PRIEST", -- [4]
				1291686081, -- [5]
				{
				}, -- [6]
				"Vampiric Touch", -- [7]
			},
			[2812] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1293622315, -- [5]
				{
				}, -- [6]
				"Holy Wrath", -- [7]
			},
			[48265] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291143332, -- [5]
				{
				}, -- [6]
				"Unholy Presence", -- [7]
			},
			[26017] = {
				30.001, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1293623891, -- [5]
				{
				}, -- [6]
				"Vindication", -- [7]
			},
			[6788] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				"PRIEST", -- [4]
				1291676584, -- [5]
				{
				}, -- [6]
				"Weakened Soul", -- [7]
			},
			[15407] = {
				2.775, -- [1]
				false, -- [2]
				30, -- [3]
				"PRIEST", -- [4]
				1291686084, -- [5]
				{
				}, -- [6]
				"Mind Flay", -- [7]
			},
			[21655] = {
				1, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291263540,
				[6] = {
				},
				[7] = "Blink",
			},
			[1706] = {
				120, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291145953, -- [5]
				{
				}, -- [6]
				"Levitate", -- [7]
			},
			[81754] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291177036,
				[6] = {
				},
				[7] = "Motivate",
			},
			[31821] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293622713, -- [5]
				{
				}, -- [6]
				"Aura Mastery", -- [7]
			},
			[74721] = {
				1, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291077068,
				[6] = {
				},
				[7] = "Wrangling Rope",
			},
			[20007] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293623782, -- [5]
				{
				}, -- [6]
				"Holy Strength", -- [7]
			},
			[33876] = {
				60, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291674766, -- [5]
				{
				}, -- [6]
				"Mangle", -- [7]
			},
			[24131] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291265570, -- [5]
				{
				}, -- [6]
				"Wyvern Sting", -- [7]
			},
			[853] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1293244212, -- [5]
				{
				}, -- [6]
				"Hammer of Justice", -- [7]
			},
			[74018] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291072329, -- [5]
				{
				}, -- [6]
				"Parachute", -- [7]
			},
			[35027] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291181809, -- [5]
				{
				}, -- [6]
				"Swift Purple Hawkstrider", -- [7]
			},
			[74594] = {
				1800.003, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291666175, -- [5]
				{
				}, -- [6]
				"Identity Crisis", -- [7]
			},
			[3600] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				"SHAMAN", -- [4]
				1293244446, -- [5]
				{
				}, -- [6]
				"Earthbind", -- [7]
			},
			[57821] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293241996, -- [5]
				{
				}, -- [6]
				"Champion of the Kirin Tor", -- [7]
			},
			[25651] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291210798,
				[6] = {
				},
				[7] = "Flame Buffet",
			},
			[24259] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291686877,
				[6] = {
				},
				[7] = "Spell Lock",
			},
			[48518] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1293244411, -- [5]
				{
				}, -- [6]
				"Eclipse (Lunar)", -- [7]
			},
			[61849] = {
				3600.002, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291081119, -- [5]
				{
				}, -- [6]
				"The Spirit of Sharing", -- [7]
			},
			[1715] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291675031, -- [5]
				{
				}, -- [6]
				"Hamstring", -- [7]
			},
			[11658] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291176216,
				[6] = {
				},
				[7] = "Sul'thraze",
			},
			[6268] = {
				5, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291253020,
				[6] = {
				},
				[7] = "Rushing Charge",
			},
			[70694] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291184214, -- [5]
				{
				}, -- [6]
				"Battlescar Dominance", -- [7]
			},
			[65142] = {
				33, -- [1]
				false, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1291683784, -- [5]
				{
				}, -- [6]
				"Ebon Plague", -- [7]
			},
			[13736] = {
				2, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291268963,
				[6] = {
				},
				[7] = "Whirlwind",
			},
			[12721] = {
				7, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291675309, -- [5]
				{
				}, -- [6]
				"Deep Wounds", -- [7]
			},
			[15798] = {
				12, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291262347,
				[6] = {
				},
				[7] = "Moonfire",
			},
			[745] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291148983,
				[6] = {
				},
				[7] = "Web",
			},
			[74599] = {
				1800.003, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291266657, -- [5]
				{
				}, -- [6]
				"Identity Crisis", -- [7]
			},
			[12809] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291686792, -- [5]
				{
				}, -- [6]
				"Concussion Blow", -- [7]
			},
			[30621] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291683283,
				[6] = {
				},
				[7] = "Kidney Shot",
			},
			[81500] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1291078691, -- [5]
				{
				}, -- [6]
				"War Stomp", -- [7]
			},
			[64343] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291673999, -- [5]
				{
				}, -- [6]
				"Impact", -- [7]
			},
			[16350] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291268951,
				[6] = {
				},
				[7] = "Freeze",
			},
			[49222] = {
				300.001, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291688652, -- [5]
				{
				}, -- [6]
				"Bone Shield", -- [7]
			},
			[74595] = {
				1800.004, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291274695, -- [5]
				{
				}, -- [6]
				"Identity Crisis", -- [7]
			},
			[15878] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291252831,
				[6] = {
				},
				[7] = "Ice Blast",
			},
			[73320] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291665741, -- [5]
				{
				}, -- [6]
				"Frostborn Illusion", -- [7]
			},
			[16427] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291205749,
				[6] = {
				},
				[7] = "Virulent Poison",
			},
			[50245] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291150109,
				[6] = {
				},
				[7] = "Pin",
			},
			[84590] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1293622758, -- [5]
				{
				}, -- [6]
				"Deadly Momentum", -- [7]
			},
			[48263] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1293623439, -- [5]
				{
				}, -- [6]
				"Blood Presence", -- [7]
			},
			[16491] = {
				5.995, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291671446, -- [5]
				{
				}, -- [6]
				"Blood Craze", -- [7]
			},
			[35028] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291675754, -- [5]
				{
				}, -- [6]
				"Swift Warstrider", -- [7]
			},
			[54497] = {
				3600.001, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291146340, -- [5]
				{
				}, -- [6]
				"Lesser Armor", -- [7]
			},
			[871] = {
				12, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291687022, -- [5]
				{
				}, -- [6]
				"Shield Wall", -- [7]
			},
			[81376] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291079084,
				[6] = {
				},
				[7] = "Pridewing Poison",
			},
			[48504] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291674191, -- [5]
				{
				}, -- [6]
				"Living Seed", -- [7]
			},
			[31932] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293623663,
				[6] = {
				},
				[7] = "Freezing Trap Effect",
			},
			[31948] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293244326,
				[6] = {
				},
				[7] = "Ensnaring Moss",
			},
			[33206] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291674992, -- [5]
				{
				}, -- [6]
				"Pain Suppression", -- [7]
			},
			[74596] = {
				1800.003, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291677304, -- [5]
				{
				}, -- [6]
				"Identity Crisis", -- [7]
			},
			[82844] = {
				15.001, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291070117,
				[6] = {
				},
				[7] = "Toxic Shot",
			},
			[11922] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291214541,
				[6] = {
				},
				[7] = "Entangling Roots",
			},
			[76003] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291072077, -- [5]
				{
				}, -- [6]
				"River Boat", -- [7]
			},
			[15007] = {
				600, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291181809, -- [5]
				{
				}, -- [6]
				"Resurrection Sickness", -- [7]
			},
			[2479] = {
				30.003, -- [1]
				false, -- [2]
				20, -- [3]
				"ANYONE", -- [4]
				1291675514, -- [5]
				{
				}, -- [6]
				"Honorless Target", -- [7]
			},
			[16046] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291067902,
				[6] = {
				},
				[7] = "Blast Wave",
			},
			[4962] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291205749,
				[6] = {
				},
				[7] = "Encasing Webs",
			},
			[36563] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291671467, -- [5]
				{
				}, -- [6]
				"Shadowstep", -- [7]
			},
			[46857] = {
				60, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291675309, -- [5]
				{
				}, -- [6]
				"Trauma", -- [7]
			},
			[14032] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291683016,
				[6] = {
				},
				[7] = "Shadow Word: Pain",
			},
			[15063] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291170858,
				[6] = {
				},
				[7] = "Frost Nova",
			},
			[66157] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291675447,
				[6] = {
				},
				[7] = "Honorable Defender",
			},
			[11962] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291209475,
				[6] = {
				},
				[7] = "Immolate",
			},
			[1784] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1293622720, -- [5]
				{
				}, -- [6]
				"Stealth", -- [7]
			},
			[12040] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291204784,
				[6] = {
				},
				[7] = "Shadow Shield",
			},
			[55233] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291685643, -- [5]
				{
				}, -- [6]
				"Vampiric Blood", -- [7]
			},
			[79840] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291174871,
				[6] = {
				},
				[7] = "Harden",
			},
			[28176] = {
				1804.59, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291689134, -- [5]
				{
				}, -- [6]
				"Fel Armor", -- [7]
			},
			[9005] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291675084, -- [5]
				{
				}, -- [6]
				"Pounce", -- [7]
			},
			[33878] = {
				60.00100000000001, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291671678, -- [5]
				{
				}, -- [6]
				"Mangle", -- [7]
			},
			[54370] = {
				12, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291675307, -- [5]
				{
				}, -- [6]
				"Nether Protection (Holy)", -- [7]
			},
			[7068] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291268624,
				[6] = {
				},
				[7] = "Veil of Shadow",
			},
			[15043] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291170793,
				[6] = {
				},
				[7] = "Frostbolt",
			},
			[16166] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291482580, -- [5]
				{
				}, -- [6]
				"Elemental Mastery", -- [7]
			},
			[11131] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291168908,
				[6] = {
				},
				[7] = "Icicle",
			},
			[23221] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291080032, -- [5]
				{
				}, -- [6]
				"Swift Frostsaber", -- [7]
			},
			[1776] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291672014, -- [5]
				{
				}, -- [6]
				"Gouge", -- [7]
			},
			[31405] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293623073,
				[6] = {
				},
				[7] = "Corruption",
			},
			[64856] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1293241996, -- [5]
				{
				}, -- [6]
				"Blade Barrier", -- [7]
			},
			[82654] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291671446, -- [5]
				{
				}, -- [6]
				"Widow Venom", -- [7]
			},
			[16246] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291674231, -- [5]
				{
				}, -- [6]
				"Clearcasting", -- [7]
			},
			[74598] = {
				1800.007, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291664613, -- [5]
				{
				}, -- [6]
				"Identity Crisis", -- [7]
			},
			[66478] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291068953, -- [5]
				{
				}, -- [6]
				"Food", -- [7]
			},
			[81119] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291254514,
				[6] = {
				},
				[7] = "Howling Screech",
			},
			[16278] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293244729, -- [5]
				{
				}, -- [6]
				"Flurry", -- [7]
			},
			[64057] = {
				3600, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291071346, -- [5]
				{
				}, -- [6]
				"Well Fed", -- [7]
			},
			[87194] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				"PRIEST", -- [4]
				1291686040, -- [5]
				{
				}, -- [6]
				"Paralysis", -- [7]
			},
			[47753] = {
				12, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291675159, -- [5]
				{
				}, -- [6]
				"Divine Aegis", -- [7]
			},
			[52419] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1293622758, -- [5]
				{
				}, -- [6]
				"Deflection", -- [7]
			},
			[13159] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291683720, -- [5]
				{
				}, -- [6]
				"Aspect of the Pack", -- [7]
			},
			[74604] = {
				1800.002, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291149519, -- [5]
				{
				}, -- [6]
				"Identity Crisis", -- [7]
			},
			[17307] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291203578,
				[6] = {
				},
				[7] = "Knockout",
			},
			[48391] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1293244499, -- [5]
				{
				}, -- [6]
				"Owlkin Frenzy", -- [7]
			},
			[31661] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1291686697, -- [5]
				{
				}, -- [6]
				"Dragon's Breath", -- [7]
			},
			[78943] = {
				60, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291078126,
				[6] = {
				},
				[7] = "Enrage",
			},
			[5118] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291683280, -- [5]
				{
				}, -- [6]
				"Aspect of the Cheetah", -- [7]
			},
			[89620] = {
				5, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291204225, -- [5]
				{
				}, -- [6]
				"Terrifying Rainbow", -- [7]
			},
			[2565] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291683602, -- [5]
				{
				}, -- [6]
				"Shield Block", -- [7]
			},
			[53220] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291676990, -- [5]
				{
				}, -- [6]
				"Improved Steady Shot", -- [7]
			},
			[72681] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291178879,
				[6] = {
				},
				[7] = "Wrangling a Silithid",
			},
			[13704] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291204754,
				[6] = {
				},
				[7] = "Psychic Scream",
			},
			[17467] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291207021,
				[6] = {
				},
				[7] = "Unholy Aura",
			},
			[16460] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291206318,
				[6] = {
				},
				[7] = "Festering Bite",
			},
			[32920] = {
				1, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291263360,
				[6] = {
				},
				[7] = "Warp",
			},
			[33975] = {
				12, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291171593,
				[6] = {
				},
				[7] = "Pyroblast",
			},
			[3604] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291252997,
				[6] = {
				},
				[7] = "Tendon Rip",
			},
			[15654] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291170765,
				[6] = {
				},
				[7] = "Shadow Word: Pain",
			},
			[22678] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291068126,
				[6] = {
				},
				[7] = "Fear",
			},
			[31901] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291683634,
				[6] = {
				},
				[7] = "Demonic Shield",
			},
			[74593] = {
				1800.003, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293242087, -- [5]
				{
				}, -- [6]
				"Identity Crisis", -- [7]
			},
			[93157] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291255045,
				[6] = {
				},
				[7] = "Juju Fury",
			},
			[15471] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291206077,
				[6] = {
				},
				[7] = "Enveloping Web",
			},
			[8326] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1293622792, -- [5]
				{
				}, -- [6]
				"Ghost", -- [7]
			},
			[4167] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291168731,
				[6] = {
				},
				[7] = "Web",
			},
			[35205] = {
				7, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291176231,
				[6] = {
				},
				[7] = "Vanish",
			},
			[84958] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291275848, -- [5]
				{
				}, -- [6]
				"Tranquilized", -- [7]
			},
			[51714] = {
				20.001, -- [1]
				false, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1293623891, -- [5]
				{
				}, -- [6]
				"Frost Vulnerability", -- [7]
			},
			[6229] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291675361, -- [5]
				{
				}, -- [6]
				"Shadow Ward", -- [7]
			},
			[77661] = {
				17.929, -- [1]
				false, -- [2]
				30, -- [3]
				"SHAMAN", -- [4]
				1293244735, -- [5]
				{
				}, -- [6]
				"Searing Flames", -- [7]
			},
			[11443] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291206177,
				[6] = {
				},
				[7] = "Cripple",
			},
			[24932] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291675267, -- [5]
				{
				}, -- [6]
				"Leader of the Pack", -- [7]
			},
			[50435] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1293623064, -- [5]
				{
				}, -- [6]
				"Chilblains", -- [7]
			},
			[8398] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291068113,
				[6] = {
				},
				[7] = "Frostbolt Volley",
			},
			[6253] = {
				1.7, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291269120,
				[6] = {
				},
				[7] = "Backhand",
			},
			[1822] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291674766, -- [5]
				{
				}, -- [6]
				"Rake", -- [7]
			},
			[32173] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293244478,
				[6] = {
				},
				[7] = "Entangling Roots",
			},
			[91800] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291682897,
				[6] = {
				},
				[7] = "Gnaw",
			},
			[5246] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291265184, -- [5]
				{
				}, -- [6]
				"Intimidating Shout", -- [7]
			},
			[94686] = {
				15.002, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293241857, -- [5]
				{
				}, -- [6]
				"Crusader", -- [7]
			},
			[74601] = {
				1800.001, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291482816, -- [5]
				{
				}, -- [6]
				"Identity Crisis", -- [7]
			},
			[12169] = {
				5, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291063572,
				[6] = {
				},
				[7] = "Shield Block",
			},
			[13585] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291215387,
				[6] = {
				},
				[7] = "Lightning Shield",
			},
			[17963] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291068407,
				[6] = {
				},
				[7] = "Sundering Cleave",
			},
			[51271] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291676555, -- [5]
				{
				}, -- [6]
				"Pillar of Frost", -- [7]
			},
			[15655] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293242625,
				[6] = {
				},
				[7] = "Shield Slam",
			},
			[1833] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291665405, -- [5]
				{
				}, -- [6]
				"Cheap Shot", -- [7]
			},
			[48266] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1293623876, -- [5]
				{
				}, -- [6]
				"Frost Presence", -- [7]
			},
			[2645] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293244338, -- [5]
				{
				}, -- [6]
				"Ghost Wolf", -- [7]
			},
			[11977] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291209504,
				[6] = {
				},
				[7] = "Rend",
			},
			[18075] = {
				33.13, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1291068119, -- [5]
				{
				}, -- [6]
				"Rend", -- [7]
			},
			[3248] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291208367,
				[6] = {
				},
				[7] = "Improved Blocking",
			},
			[77977] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291150170,
				[6] = {
				},
				[7] = "Frost Armor",
			},
			[50536] = {
				10.936, -- [1]
				false, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1291683784, -- [5]
				{
				}, -- [6]
				"Unholy Blight", -- [7]
			},
			[88796] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291080121, -- [5]
				{
				}, -- [6]
				"Bulwark Disguise", -- [7]
			},
			[85791] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291078422,
				[6] = {
				},
				[7] = "Rage of the Darkcloud",
			},
			[41425] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1293241648, -- [5]
				{
				}, -- [6]
				"Hypothermia", -- [7]
			},
			[34161] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1293622297,
				[6] = {
				},
				[7] = "Wild Growth",
			},
			[80868] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				"ANYONE", -- [4]
				1291669697, -- [5]
				{
				}, -- [6]
				"Stag Eye Bait", -- [7]
			},
			[54820] = {
				9, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291671666, -- [5]
				{
				}, -- [6]
				"Rake", -- [7]
			},
			[34392] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1293623545,
				[6] = {
				},
				[7] = "Stinger Rage",
			},
			[13737] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291265947,
				[6] = {
				},
				[7] = "Mortal Strike",
			},
			[48778] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291674205, -- [5]
				{
				}, -- [6]
				"Acherus Deathcharger", -- [7]
			},
			[1850] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291275031, -- [5]
				{
				}, -- [6]
				"Dash", -- [7]
			},
			[49865] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291256020,
				[6] = {
				},
				[7] = "Eye Peck",
			},
			[116] = {
				9, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1291686083, -- [5]
				{
				}, -- [6]
				"Frostbolt", -- [7]
			},
			[30283] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1291674961, -- [5]
				{
				}, -- [6]
				"Shadowfury", -- [7]
			},
			[32329] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293622220,
				[6] = {
				},
				[7] = "Itchy Spores",
			},
			[30639] = {
				18, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291683512,
				[6] = {
				},
				[7] = "Carnivorous Bite",
			},
			[76142] = {
				3600.004, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291081119, -- [5]
				{
				}, -- [6]
				"Earth Powered", -- [7]
			},
			[54149] = {
				15.001, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293627285, -- [5]
				{
				}, -- [6]
				"Infusion of Light", -- [7]
			},
			[465] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293623899, -- [5]
				{
				}, -- [6]
				"Devotion Aura", -- [7]
			},
			[74603] = {
				1800.002, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291686090, -- [5]
				{
				}, -- [6]
				"Identity Crisis", -- [7]
			},
			[12544] = {
				1800, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291171528,
				[6] = {
				},
				[7] = "Frost Armor",
			},
			[54277] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291689134, -- [5]
				{
				}, -- [6]
				"Backdraft", -- [7]
			},
			[16429] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291206183,
				[6] = {
				},
				[7] = "Piercing Shadow",
			},
			[68766] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1291683732, -- [5]
				{
				}, -- [6]
				"Desecration", -- [7]
			},
			[34936] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291674979, -- [5]
				{
				}, -- [6]
				"Backlash", -- [7]
			},
			[32197] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293242886,
				[6] = {
				},
				[7] = "Corruption",
			},
			[467] = {
				20.001, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291673450, -- [5]
				{
				}, -- [6]
				"Thorns", -- [7]
			},
			[32709] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291171131,
				[6] = {
				},
				[7] = "Death Coil",
			},
			[6136] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291262846,
				[6] = {
				},
				[7] = "Chilled",
			},
			[8178] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293243992, -- [5]
				{
				}, -- [6]
				"Grounding Totem Effect", -- [7]
			},
			[35336] = {
				300.001, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1293242238,
				[6] = {
				},
				[7] = "Energizing Spores",
			},
			[25780] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293623899, -- [5]
				{
				}, -- [6]
				"Righteous Fury", -- [7]
			},
			[54131] = {
				5.394, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291671524,
				[6] = {
				},
				[7] = "Bloodthirsty",
			},
			[59797] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291673207, -- [5]
				{
				}, -- [6]
				"Ice Mammoth", -- [7]
			},
			[11113] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1291686881, -- [5]
				{
				}, -- [6]
				"Blast Wave", -- [7]
			},
			[16637] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291268678,
				[6] = {
				},
				[7] = "Mend Dragon",
			},
			[18118] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1291689000, -- [5]
				{
				}, -- [6]
				"Aftermath", -- [7]
			},
			[30991] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1293242780,
				[6] = {
				},
				[7] = "Stealth",
			},
			[20052] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291671418, -- [5]
				{
				}, -- [6]
				"Conviction", -- [7]
			},
			[6726] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293242891,
				[6] = {
				},
				[7] = "Silence",
			},
			[92315] = {
				13.739, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1291686792, -- [5]
				{
				}, -- [6]
				"Pyroblast!", -- [7]
			},
			[93402] = {
				16.121, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1293244699, -- [5]
				{
				}, -- [6]
				"Sunfire", -- [7]
			},
			[45438] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1293241648, -- [5]
				{
				}, -- [6]
				"Ice Block", -- [7]
			},
			[11971] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291204688,
				[6] = {
				},
				[7] = "Sunder Armor",
			},
			[16071] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291265971,
				[6] = {
				},
				[7] = "Curse of the Firebrand",
			},
			[17820] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291068916,
				[6] = {
				},
				[7] = "Veil of Shadow",
			},
			[13326] = {
				1800, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291149424,
				[6] = {
				},
				[7] = "Arcane Intellect",
			},
			[9128] = {
				120, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291150139,
				[6] = {
				},
				[7] = "Battle Shout",
			},
			[30937] = {
				120.001, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293243310,
				[6] = {
				},
				[7] = "Mark of Shadow",
			},
			[46989] = {
				3, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1293241079, -- [5]
				{
				}, -- [6]
				"Improved Blink", -- [7]
			},
			[2974] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291171335, -- [5]
				{
				}, -- [6]
				"Wing Clip", -- [7]
			},
			[6533] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291077070,
				[6] = {
				},
				[7] = "Net",
			},
			[68531] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291142760, -- [5]
				{
				}, -- [6]
				"Dingy Wizard Hat", -- [7]
			},
			[51209] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1291673699, -- [5]
				{
				}, -- [6]
				"Hungering Cold", -- [7]
			},
			[15128] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291265960,
				[6] = {
				},
				[7] = "Mark of Flames",
			},
			[79976] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291064748,
				[6] = {
				},
				[7] = "Retribution Aura",
			},
			[12043] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291667841, -- [5]
				{
				}, -- [6]
				"Presence of Mind", -- [7]
			},
			[34969] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293243179,
				[6] = {
				},
				[7] = "Poison",
			},
			[81191] = {
				4, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1293244508, -- [5]
				{
				}, -- [6]
				"Lunar Shower", -- [7]
			},
			[52424] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1293622767, -- [5]
				{
				}, -- [6]
				"Retaliation", -- [7]
			},
			[76204] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291081056, -- [5]
				{
				}, -- [6]
				"River Boat", -- [7]
			},
			[26260] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291671996, -- [5]
				{
				}, -- [6]
				"Food", -- [7]
			},
			[83493] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291175033,
				[6] = {
				},
				[7] = "Blessing of Al'Akir",
			},
			[14177] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291666024, -- [5]
				{
				}, -- [6]
				"Cold Blood", -- [7]
			},
			[20154] = {
				1800.003, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293244727, -- [5]
				{
				}, -- [6]
				"Seal of Righteousness", -- [7]
			},
			[54424] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291687207,
				[6] = {
				},
				[7] = "Fel Intelligence",
			},
			[16247] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291268616,
				[6] = {
				},
				[7] = "Curse of Thorns",
			},
			[88928] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291080737, -- [5]
				{
				}, -- [6]
				"Elemental Nullifier", -- [7]
			},
			[17165] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291065496,
				[6] = {
				},
				[7] = "Mind Flay",
			},
			[79849] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291167158,
				[6] = {
				},
				[7] = "Molten Armor",
			},
			[16870] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1293243023, -- [5]
				{
				}, -- [6]
				"Clearcasting", -- [7]
			},
			[79977] = {
				300.001, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291064748,
				[6] = {
				},
				[7] = "Blessing of Might",
			},
			[31551] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293244622,
				[6] = {
				},
				[7] = "Piercing Jab",
			},
			[81162] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291685648, -- [5]
				{
				}, -- [6]
				"Will of the Necropolis", -- [7]
			},
			[11196] = {
				60, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291675034, -- [5]
				{
				}, -- [6]
				"Recently Bandaged", -- [7]
			},
			[83302] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				"MAGE", -- [4]
				1293244642, -- [5]
				{
				}, -- [6]
				"Improved Cone of Cold", -- [7]
			},
			[31615] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293623647,
				[6] = {
				},
				[7] = "Hunter's Mark",
			},
			[20578] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291673799, -- [5]
				{
				}, -- [6]
				"Cannibalize", -- [7]
			},
			[12251] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291168779,
				[6] = {
				},
				[7] = "Virulent Poison",
			},
			[86627] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291667088, -- [5]
				{
				}, -- [6]
				"Incite", -- [7]
			},
			[16359] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291268963,
				[6] = {
				},
				[7] = "Corrosive Acid Breath",
			},
			[13298] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291205558,
				[6] = {
				},
				[7] = "Poison",
			},
			[65420] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291177092, -- [5]
				{
				}, -- [6]
				"Food", -- [7]
			},
			[12550] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291077077,
				[6] = {
				},
				[7] = "Lightning Shield",
			},
			[33787] = {
				15.001, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293241334,
				[6] = {
				},
				[7] = "Cripple",
			},
			[89152] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291212702, -- [5]
				{
				}, -- [6]
				"Sindweller Blindfold", -- [7]
			},
			[13338] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293242909,
				[6] = {
				},
				[7] = "Curse of Tongues",
			},
			[34906] = {
				1800, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291689119,
				[6] = {
				},
				[7] = "Mark of Bite",
			},
			[30832] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293243183,
				[6] = {
				},
				[7] = "Kidney Shot",
			},
			[56453] = {
				12, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291683271, -- [5]
				{
				}, -- [6]
				"Lock and Load", -- [7]
			},
			[8255] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291072710,
				[6] = {
				},
				[7] = "Strong Cleave",
			},
			[64701] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291664009, -- [5]
				{
				}, -- [6]
				"Elemental Mastery", -- [7]
			},
			[62606] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291275948, -- [5]
				{
				}, -- [6]
				"Savage Defense", -- [7]
			},
			[11348] = {
				7200, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291203757, -- [5]
				{
				}, -- [6]
				"Greater Armor", -- [7]
			},
			[15976] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291264917,
				[6] = {
				},
				[7] = "Puncture",
			},
			[19643] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291266593,
				[6] = {
				},
				[7] = "Mortal Strike",
			},
			[6713] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291683711,
				[6] = {
				},
				[7] = "Disarm",
			},
			[43410] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291213754,
				[6] = {
				},
				[7] = "Chop",
			},
			[77613] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291675158, -- [5]
				{
				}, -- [6]
				"Grace", -- [7]
			},
			[65419] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291067820, -- [5]
				{
				}, -- [6]
				"Food", -- [7]
			},
			[19134] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293244491,
				[6] = {
				},
				[7] = "Frightening Shout",
			},
			[53768] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291684523, -- [5]
				{
				}, -- [6]
				"Haunted", -- [7]
			},
			[95224] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1291673361, -- [5]
				{
				}, -- [6]
				"Rainbow Generator", -- [7]
			},
			[11428] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291265207,
				[6] = {
				},
				[7] = "Knockdown",
			},
			[59888] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291675003, -- [5]
				{
				}, -- [6]
				"Borrowed Time", -- [7]
			},
			[81130] = {
				30, -- [1]
				true, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1293241998, -- [5]
				{
				}, -- [6]
				"Scarlet Fever", -- [7]
			},
			[22888] = {
				7200.015, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1293242087,
				[6] = {
				},
				[7] = "Rallying Cry of the Dragonslayer",
			},
			[974] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291674423, -- [5]
				{
				}, -- [6]
				"Earth Shield", -- [7]
			},
			[18828] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293623867, -- [5]
				{
				}, -- [6]
				"Bone Armor", -- [7]
			},
			[66041] = {
				30.001, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291264468, -- [5]
				{
				}, -- [6]
				"Drink", -- [7]
			},
			[339] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291674376, -- [5]
				{
				}, -- [6]
				"Entangling Roots", -- [7]
			},
			[58180] = {
				12.001, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291675156, -- [5]
				{
				}, -- [6]
				"Infected Wounds", -- [7]
			},
			[90785] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				[5] = 1291143493,
				[6] = {
				},
				[7] = "Glyph of Power Word: Barrier",
			},
			[12531] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291150117,
				[6] = {
				},
				[7] = "Chilling Touch",
			},
			[32223] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293622022, -- [5]
				{
				}, -- [6]
				"Crusader Aura", -- [7]
			},
			[6789] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1291671525, -- [5]
				{
				}, -- [6]
				"Death Coil", -- [7]
			},
			[13578] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291186541,
				[6] = {
				},
				[7] = "Jadefire",
			},
			[53257] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291480553, -- [5]
				{
				}, -- [6]
				"Cobra Strikes", -- [7]
			},
			[32389] = {
				12, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1291686864, -- [5]
				{
				}, -- [6]
				"Shadow Embrace", -- [7]
			},
			[980] = {
				26.328, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1293623746, -- [5]
				{
				}, -- [6]
				"Bane of Agony", -- [7]
			},
			[2895] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1293243933, -- [5]
				{
				}, -- [6]
				"Wrath of Air Totem", -- [7]
			},
			[34971] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1293623660,
				[6] = {
				},
				[7] = "Frenzy",
			},
			[15531] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291150195,
				[6] = {
				},
				[7] = "Frost Nova",
			},
			[17619] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291256149, -- [5]
				{
				}, -- [6]
				"Alchemist's Stone", -- [7]
			},
			[17038] = {
				1200, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291673142, -- [5]
				{
				}, -- [6]
				"Winterfall Firewater", -- [7]
			},
			[26261] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291671996, -- [5]
				{
				}, -- [6]
				"Drink", -- [7]
			},
			[1966] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291683085, -- [5]
				{
				}, -- [6]
				"Feint", -- [7]
			},
			[57669] = {
				15.999, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293241996, -- [5]
				{
				}, -- [6]
				"Replenishment", -- [7]
			},
			[77487] = {
				60, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291686090, -- [5]
				{
				}, -- [6]
				"Shadow Orb", -- [7]
			},
			[3583] = {
				16.178, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291067747,
				[6] = {
				},
				[7] = "Deadly Poison",
			},
			[48792] = {
				12, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291688545, -- [5]
				{
				}, -- [6]
				"Icebound Fortitude", -- [7]
			},
			[15744] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291266624,
				[6] = {
				},
				[7] = "Blast Wave",
			},
			[73651] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291674766, -- [5]
				{
				}, -- [6]
				"Recuperate", -- [7]
			},
			[8599] = {
				120, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1293623790,
				[6] = {
				},
				[7] = "Enrage",
			},
			[90806] = {
				9, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291685860, -- [5]
				{
				}, -- [6]
				"Executioner", -- [7]
			},
			[13730] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291206033,
				[6] = {
				},
				[7] = "Demoralizing Shout",
			},
			[13738] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293243755,
				[6] = {
				},
				[7] = "Rend",
			},
			[17246] = {
				120, -- [1]
				false, -- [2]
				30, -- [3]
				"PALADIN", -- [4]
				1291205813, -- [5]
				{
				}, -- [6]
				"Possessed", -- [7]
			},
			[1978] = {
				17.931, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291683784, -- [5]
				{
				}, -- [6]
				"Serpent Sting", -- [7]
			},
			[1160] = {
				30, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291685609, -- [5]
				{
				}, -- [6]
				"Demoralizing Shout", -- [7]
			},
			[85416] = {
				2, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293623745, -- [5]
				{
				}, -- [6]
				"Grand Crusader", -- [7]
			},
			[35748] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291683639,
				[6] = {
				},
				[7] = "Drain Life",
			},
			[2096] = {
				60, -- [1]
				false, -- [2]
				30, -- [3]
				"PRIEST", -- [4]
				1291482988, -- [5]
				{
				}, -- [6]
				"Mind Vision", -- [7]
			},
			[30641] = {
				20, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291668661,
				[6] = {
				},
				[7] = "Mortal Wound",
			},
			[81661] = {
				20, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291144908, -- [5]
				{
				}, -- [6]
				"Evangelism", -- [7]
			},
			[13810] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291676950, -- [5]
				{
				}, -- [6]
				"Ice Trap", -- [7]
			},
			[12795] = {
				120, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291149866,
				[6] = {
				},
				[7] = "Frenzy",
			},
			[34780] = {
				6, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1293244727,
				[6] = {
				},
				[7] = "Poison Bolt Volley",
			},
			[13884] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				[5] = 1291079711,
				[6] = {
				},
				[7] = "Withering Poison",
			},
			[10799] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291686546, -- [5]
				{
				}, -- [6]
				"Violet Raptor", -- [7]
			},
			[53290] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291683785, -- [5]
				{
				}, -- [6]
				"Hunting Party", -- [7]
			},
			[17697] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291067913,
				[6] = {
				},
				[7] = "Defiling Aura",
			},
			[81141] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291481179, -- [5]
				{
				}, -- [6]
				"Blood Swarm", -- [7]
			},
			[53386] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291688854, -- [5]
				{
				}, -- [6]
				"Cinderglacier", -- [7]
			},
			[89906] = {
				11.478, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293241908, -- [5]
				{
				}, -- [6]
				"Judgements of the Bold", -- [7]
			},
			[16511] = {
				60.00100000000001, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291674231, -- [5]
				{
				}, -- [6]
				"Hemorrhage", -- [7]
			},
			[30849] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291274418,
				[6] = {
				},
				[7] = "Spell Lock",
			},
			[26297] = {
				10, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291665489, -- [5]
				{
				}, -- [6]
				"Berserking", -- [7]
			},
			[53137] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DEATHKNIGHT", -- [4]
				1291671871, -- [5]
				{
				}, -- [6]
				"Abomination's Might", -- [7]
			},
			[84586] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291671878, -- [5]
				{
				}, -- [6]
				"Slaughter", -- [7]
			},
			[16591] = {
				600, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1293244727, -- [5]
				{
				}, -- [6]
				"Noggenfogger Elixir", -- [7]
			},
			[69369] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1291675221, -- [5]
				{
				}, -- [6]
				"Predator's Swiftness", -- [7]
			},
			[16914] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1293244625, -- [5]
				{
				}, -- [6]
				"Hurricane", -- [7]
			},
			[19708] = {
				900, -- [1]
				false, -- [2]
				20, -- [3]
				"MAGE", -- [4]
				1291273662, -- [5]
				{
				}, -- [6]
				"Well Fed", -- [7]
			},
			[2983] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				"ROGUE", -- [4]
				1291664915, -- [5]
				{
				}, -- [6]
				"Sprint", -- [7]
			},
			[24858] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"DRUID", -- [4]
				1293244708, -- [5]
				{
				}, -- [6]
				"Moonkin Form", -- [7]
			},
			[15474] = {
				5, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291067737,
				[6] = {
				},
				[7] = "Web Explosion",
			},
			[19503] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291275839, -- [5]
				{
				}, -- [6]
				"Scatter Shot", -- [7]
			},
			[22857] = {
				8, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291480514,
				[6] = {
				},
				[7] = "Retaliation",
			},
			[16498] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291215828,
				[6] = {
				},
				[7] = "Faerie Fire",
			},
			[580] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291070041, -- [5]
				{
				}, -- [6]
				"Timber Wolf", -- [7]
			},
			[79865] = {
				1800, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291262832,
				[6] = {
				},
				[7] = "Frost Armor",
			},
			[81326] = {
				0, -- [1]
				true, -- [2]
				30, -- [3]
				"DEATHKNIGHT", -- [4]
				1291677237, -- [5]
				{
				}, -- [6]
				"Brittle Bones", -- [7]
			},
			[23179] = {
				1200.001, -- [1]
				false, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291482512, -- [5]
				{
				}, -- [6]
				"Taint of Shadow", -- [7]
			},
			[7645] = {
				10, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291068329,
				[6] = {
				},
				[7] = "Dominate Mind",
			},
			[1137] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"PRIEST", -- [4]
				1291269557, -- [5]
				{
				}, -- [6]
				"Drink", -- [7]
			},
			[89766] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291204429,
				[6] = {
				},
				[7] = "Axe Toss",
			},
			[89830] = {
				3, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291214075, -- [5]
				{
				}, -- [6]
				"Slap Panicking Worker", -- [7]
			},
			[93986] = {
				3, -- [1]
				false, -- [2]
				30, -- [3]
				"WARLOCK", -- [4]
				1293623464, -- [5]
				{
				}, -- [6]
				"Aura of Foreboding", -- [7]
			},
			[16128] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291266414,
				[6] = {
				},
				[7] = "Infected Bite",
			},
			[8072] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291674419, -- [5]
				{
				}, -- [6]
				"Stoneskin", -- [7]
			},
			[82925] = {
				30, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291677167, -- [5]
				{
				}, -- [6]
				"Ready, Set, Aim...", -- [7]
			},
			[1079] = {
				16, -- [1]
				false, -- [2]
				30, -- [3]
				"DRUID", -- [4]
				1291481012, -- [5]
				{
				}, -- [6]
				"Rip", -- [7]
			},
			[16168] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291269638,
				[6] = {
				},
				[7] = "Flame Buffet",
			},
			[93347] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1293634998, -- [5]
				{
				}, -- [6]
				"Champion of Therazane", -- [7]
			},
			[44535] = {
				6, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291675475, -- [5]
				{
				}, -- [6]
				"Spirit Heal", -- [7]
			},
			[23145] = {
				16, -- [1]
				false, -- [2]
				20, -- [3]
				[5] = 1291275205,
				[6] = {
				},
				[7] = "Dive",
			},
			[23161] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"WARLOCK", -- [4]
				1291674852, -- [5]
				{
				}, -- [6]
				"Dreadsteed", -- [7]
			},
			[59752] = {
				0.1, -- [1]
				false, -- [2]
				20, -- [3]
				"PALADIN", -- [4]
				1291671663, -- [5]
				{
				}, -- [6]
				"Every Man for Himself", -- [7]
			},
			[35101] = {
				4, -- [1]
				false, -- [2]
				30, -- [3]
				"HUNTER", -- [4]
				1291673563, -- [5]
				{
				}, -- [6]
				"Concussive Barrage", -- [7]
			},
			[69179] = {
				2, -- [1]
				false, -- [2]
				30, -- [3]
				"WARRIOR", -- [4]
				1291170546, -- [5]
				{
				}, -- [6]
				"Arcane Torrent", -- [7]
			},
			[93795] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"SHAMAN", -- [4]
				1291675088, -- [5]
				{
				}, -- [6]
				"Stormwind Champion", -- [7]
			},
			[23241] = {
				0, -- [1]
				true, -- [2]
				20, -- [3]
				"ANYONE", -- [4]
				1291277047, -- [5]
				{
				}, -- [6]
				"Swift Blue Raptor", -- [7]
			},
			[78578] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291079335,
				[6] = {
				},
				[7] = "Immolation Trap",
			},
			[14202] = {
				9, -- [1]
				false, -- [2]
				20, -- [3]
				"WARRIOR", -- [4]
				1291685984, -- [5]
				{
				}, -- [6]
				"Enrage", -- [7]
			},
			[3045] = {
				15, -- [1]
				false, -- [2]
				20, -- [3]
				"HUNTER", -- [4]
				1291275837, -- [5]
				{
				}, -- [6]
				"Rapid Fire", -- [7]
			},
			[51693] = {
				8, -- [1]
				false, -- [2]
				30, -- [3]
				"ROGUE", -- [4]
				1291688858, -- [5]
				{
				}, -- [6]
				"Waylay", -- [7]
			},
			[88425] = {
				15, -- [1]
				false, -- [2]
				30, -- [3]
				[5] = 1291185519,
				[6] = {
				},
				[7] = "Bees! BEES!",
			},
		},
		["combatUpdate"] = 0.2,
	},
	["profiles"] = {
		["KisekiUI"] = {
			["buttonFacade"] = {
				["Debuffs"] = {
					["colours"] = {
						["Border"] = {
							0.09803921568627451, -- [1]
							1, -- [2]
							0.09803921568627451, -- [3]
							1, -- [4]
						},
						["Normal"] = {
							0.25, -- [1]
							0.25, -- [2]
							0.25, -- [3]
							1, -- [4]
						},
					},
					["gloss"] = 0,
					["backdrop"] = false,
					["skin"] = "Svelte Shadow",
				},
				["Target Buffs"] = {
					["colours"] = {
						["Border"] = {
							0.09803921568627451, -- [1]
							1, -- [2]
							0.09803921568627451, -- [3]
							1, -- [4]
						},
						["Normal"] = {
							0.25, -- [1]
							0.25, -- [2]
							0.25, -- [3]
							1, -- [4]
						},
					},
					["gloss"] = 0,
					["backdrop"] = false,
					["skin"] = "Shadow",
				},
				["Procs & CDs"] = {
					["gloss"] = 0,
					["colours"] = {
					},
					["backdrop"] = false,
					["skin"] = "Svelte Shadow",
				},
				["Target"] = {
					["colours"] = {
						["Normal"] = {
							0, -- [1]
							1, -- [2]
							0, -- [3]
							1, -- [4]
						},
						["Highlight"] = {
							1, -- [1]
							1, -- [2]
							1, -- [3]
							0.5, -- [4]
						},
						["Gloss"] = {
							1, -- [1]
							1, -- [2]
							1, -- [3]
							1, -- [4]
						},
						["Disabled"] = {
							1, -- [1]
							1, -- [2]
							1, -- [3]
							1, -- [4]
						},
						["Border"] = {
							1, -- [1]
							1, -- [2]
							1, -- [3]
							1, -- [4]
						},
						["Backdrop"] = {
							1, -- [1]
							1, -- [2]
							1, -- [3]
							1, -- [4]
						},
					},
					["gloss"] = 0,
					["backdrop"] = false,
					["skin"] = "Svelte Shadow",
				},
				["Buffs"] = {
					["colours"] = {
						["Border"] = {
							0, -- [1]
							1, -- [2]
							0, -- [3]
							1, -- [4]
						},
					},
					["gloss"] = 0,
					["backdrop"] = false,
					["skin"] = "Svelte Shadow",
				},
				["Pet Debuffs"] = {
					["colours"] = {
						["Border"] = {
							0.09803921568627451, -- [1]
							1, -- [2]
							0.09803921568627451, -- [3]
							1, -- [4]
						},
						["Normal"] = {
							0.25, -- [1]
							0.25, -- [2]
							0.25, -- [3]
							1, -- [4]
						},
					},
					["gloss"] = 0,
					["backdrop"] = false,
					["skin"] = "Shadow",
				},
				["Pet Buffs"] = {
					["colours"] = {
					},
					["gloss"] = 0,
					["backdrop"] = false,
					["skin"] = "Shadow",
				},
			},
			["auraMaxTime"] = 1,
			["flow"] = {
			},
			["noTotemTimers"] = false,
			["noTotemNonBuffs"] = false,
			["frames"] = {
				{
					["general"] = {
						["showVehicle"] = true,
						["frameName"] = "Buffs",
						["blacklist"] = true,
						["clickthrough"] = false,
						["buffs"] = true,
						["unit"] = "player",
					},
					["alwaysWarn"] = {
					},
					["layout"] = {
						["point"] = {
							"LEFT", -- [1]
							13.71082397891172, -- [2]
							-194.7447655877525, -- [3]
						},
						["opacity"] = 1,
						["growth"] = 1,
						["y"] = 6,
						["x"] = 6,
						["count"] = 30,
						["anchor"] = 1,
						["sort"] = 3,
						["visibility"] = 1,
						["rowCount"] = 10,
					},
					["expiry"] = {
						["minimumDuration"] = 0,
						["sctColour"] = {
							["b"] = 0.1,
							["g"] = 1,
							["r"] = 0.1,
						},
						["warnAtTime"] = 10,
						["frame"] = "ChatFrame1",
						["sound"] = "None",
						["flash"] = 1,
					},
					["count"] = {
						["outline"] = 1,
						["x"] = 0,
						["justify"] = "CENTER",
						["y"] = 3,
						["frameLevel"] = 4,
						["fontSize"] = 10,
						["font"] = "Arial Black",
						["colour"] = {
							["b"] = 1,
							["g"] = 1,
							["r"] = 1,
						},
					},
					["list"] = {
					},
					["timer"] = {
						["outline"] = 1,
						["fontSize"] = 10,
						["justify"] = "CENTER",
						["y"] = -12,
						["font"] = "Friz Quadrata TT",
						["regularColour"] = {
							["a"] = 1,
							["b"] = 0.5570000000000001,
							["g"] = 0.949,
							["r"] = 1,
						},
						["frameLevel"] = 4,
						["format"] = 6,
						["expiringColour"] = {
							["a"] = 1,
							["b"] = 0,
							["g"] = 0,
							["r"] = 1,
						},
						["x"] = 0,
					},
					["icon"] = {
						["frameLevel"] = 3,
						["suppressCooldownTimer"] = true,
						["opacity"] = 1,
						["y"] = 0,
						["x"] = 0,
						["noIconBorder"] = true,
						["noBFIconBorder"] = false,
						["cooldown"] = false,
						["size"] = 30,
					},
					["filters"] = {
						"n=blood pact", -- [1]
						"n=essence of wintergrasp", -- [2]
						"n=bloodlust", -- [3]
						"n=hyperspeed acceleration", -- [4]
						"n=hysteria", -- [5]
						"n=tricks of the trade", -- [6]
						"n=horn of winter", -- [7]
						"n=strength of earth", -- [8]
						"n=battle shout", -- [9]
						"n=abomination's might", -- [10]
						"n=trueshot aura", -- [11]
						"n=unleashed rage", -- [12]
						"n=icy talons", -- [13]
						"n=improved icy talons", -- [14]
						"n=windfury totem", -- [15]
						"n=misdirection", -- [16]
						"n=infusion of light", -- [17]
						"n=power infusion", -- [18]
						"n=light's grace", -- [19]
						"n=divine guardian", -- [20]
						"n=divine plea", -- [21]
						"n=avenging wrath", -- [22]
					},
				}, -- [1]
				{
					["general"] = {
						["blacklist"] = true,
						["debuffs"] = true,
						["frameName"] = "Debuffs",
						["unit"] = "player",
					},
					["alwaysWarn"] = {
					},
					["layout"] = {
						["point"] = {
							"LEFT", -- [1]
							152.6951124305381, -- [2]
							-190.8422325891712, -- [3]
						},
						["opacity"] = 1,
						["growth"] = 1,
						["y"] = 18,
						["x"] = 0,
						["count"] = 7,
						["anchor"] = 1,
						["sort"] = 3,
						["visibility"] = 1,
						["rowCount"] = 7,
					},
					["expiry"] = {
						["minimumDuration"] = 0,
						["sctColour"] = {
							["b"] = 0.1,
							["g"] = 1,
							["r"] = 0.1,
						},
						["warnAtTime"] = 30,
						["frame"] = "ChatFrame1",
						["sound"] = "None",
					},
					["count"] = {
						["outline"] = 1,
						["x"] = -16,
						["justify"] = "CENTER",
						["y"] = 16,
						["frameLevel"] = 4,
						["fontSize"] = 10,
						["font"] = "MUNIRG",
						["colour"] = {
							["a"] = 1,
							["b"] = 1,
							["g"] = 1,
							["r"] = 1,
						},
					},
					["list"] = {
					},
					["timer"] = {
						["outline"] = 1,
						["fontSize"] = 16,
						["justify"] = "CENTER",
						["y"] = -10,
						["font"] = "Friz Quadrata TT",
						["regularColour"] = {
							["b"] = 0,
							["g"] = 0.82,
							["r"] = 1,
						},
						["debuffColour"] = 1,
						["frameLevel"] = 4,
						["format"] = 6,
						["expiringColour"] = {
							["b"] = 0,
							["g"] = 0.82,
							["r"] = 1,
						},
						["x"] = 0,
					},
					["icon"] = {
						["y"] = 0,
						["x"] = 0,
						["noIconBorder"] = true,
						["frameLevel"] = 3,
						["opacity"] = 1,
						["noBFIconBorder"] = false,
						["size"] = 45,
					},
					["filters"] = {
					},
				}, -- [2]
				nil, -- [3]
				{
					["general"] = {
						["showVehicle"] = false,
						["debuffs"] = true,
						["frameName"] = "Target",
						["buffs"] = true,
						["unit"] = "target",
						["blacklist"] = false,
					},
					["alwaysWarn"] = {
					},
					["layout"] = {
						["point"] = {
							"TOP", -- [1]
							-99.76014509261266, -- [2]
							-147.5893369609767, -- [3]
						},
						["rows"] = 1,
						["rowCount"] = 8,
						["growth"] = 3,
						["y"] = -4,
						["x"] = -1,
						["count"] = 16,
						["anchor"] = 1,
						["sort"] = 2,
						["visibility"] = 1,
						["opacity"] = 1,
					},
					["expiry"] = {
						["minimumDuration"] = 0,
						["sctColour"] = {
							["r"] = 0.1,
							["g"] = 1,
							["b"] = 0.1,
						},
						["warnAtTime"] = 30,
						["frame"] = "ChatFrame1",
						["sound"] = "None",
						["flash"] = true,
					},
					["count"] = {
						["y"] = 13,
						["x"] = -10,
						["justify"] = "CENTER",
						["outline"] = 1,
						["frameLevel"] = 4,
						["font"] = "Friz Quadrata TT",
						["fontSize"] = 12,
						["colour"] = {
							["r"] = 1,
							["g"] = 1,
							["b"] = 1,
						},
					},
					["list"] = {
					},
					["timer"] = {
						["outline"] = 1,
						["fontSize"] = 10,
						["justify"] = "CENTER",
						["milliseconds"] = false,
						["y"] = -3,
						["font"] = "Friz Quadrata TT",
						["regularColour"] = {
							["a"] = 1,
							["r"] = 0.949,
							["g"] = 1,
							["b"] = 0.984,
						},
						["x"] = 0,
						["frameLevel"] = 4,
						["format"] = 5,
						["expiringColour"] = {
							["r"] = 1,
							["g"] = 0.82,
							["b"] = 0,
						},
						["debuffColour"] = false,
					},
					["icon"] = {
						["y"] = 0,
						["x"] = 0,
						["noIconBorder"] = true,
						["noBFIconBorder"] = false,
						["frameLevel"] = 3,
						["opacity"] = 1,
						["cooldown"] = true,
						["size"] = 28,
					},
					["filters"] = {
						"my", -- [1]
						"ha", -- [2]
						"hu", -- [3]
						"d<15", -- [4]
						"c", -- [5]
					},
				}, -- [4]
				[7] = {
					["general"] = {
						["showVehicle"] = false,
						["debuffs"] = false,
						["frameName"] = "Procs & CDs",
						["unit"] = "player",
						["clickthrough"] = true,
						["buffs"] = true,
						["blacklist"] = false,
					},
					["alwaysWarn"] = {
						["The Art of War"] = true,
						["Hyperspeed Acceleration"] = true,
					},
					["layout"] = {
						["point"] = {
							"LEFT", -- [1]
							252.743627614746, -- [2]
							-8.847800151978088, -- [3]
						},
						["opacity"] = 1,
						["growth"] = 3,
						["rowCount"] = 3,
						["y"] = 55,
						["x"] = 55,
						["count"] = 6,
						["anchor"] = 1,
						["sort"] = 1,
						["visibility"] = 1,
						["rows"] = 1,
					},
					["expiry"] = {
						["minimumDuration"] = 0,
						["sctColour"] = {
							["r"] = 0.1,
							["g"] = 1,
							["b"] = 0.1,
						},
						["warnAtTime"] = 5,
						["soundWarning"] = true,
						["flash"] = 1,
						["frame"] = "ChatFrame1",
						["sound"] = "Proc ExpAlert",
						["sctWarn"] = 1,
					},
					["count"] = {
						["y"] = 35,
						["x"] = -31,
						["justify"] = "CENTER",
						["outline"] = 1,
						["font"] = "Neuropol",
						["fontSize"] = 25,
						["frameLevel"] = 4,
						["colour"] = {
							["r"] = 1,
							["g"] = 1,
							["b"] = 1,
						},
					},
					["list"] = {
					},
					["icon"] = {
						["noIconBorder"] = true,
						["suppressCooldownTimer"] = true,
						["opacity"] = 1,
						["y"] = 0,
						["x"] = 0,
						["disableRightClick"] = 1,
						["frameLevel"] = 3,
						["noBFIconBorder"] = false,
						["cooldown"] = true,
						["size"] = 85,
					},
					["filters"] = {
						"n=bloodlust", -- [1]
						"n=hyperspeed acceleration", -- [2]
						"n=tricks of the trade", -- [3]
						"n=hysteria", -- [4]
						"n=misdirection", -- [5]
						"n=light's grace", -- [6]
						"n=infusion of light", -- [7]
						"n=power infusion", -- [8]
						"n=divine guardian", -- [9]
						"n=divine plea&my", -- [10]
						"n=avenging wrath&my", -- [11]
					},
				},
			},
			["settings"] = {
			},
		},
	},
}
end

local SetStuf = function()
if(StufDB) then table.wipe(StufDB) end

StufDB = {
	["party3target"] = {
		["frame"] = {
			["y"] = -265,
			["x"] = 162,
			["hide"] = true,
		},
	},
	["arenapet4"] = {
		["frame"] = {
			["y"] = -509,
			["h"] = 24,
			["x"] = 1152,
			["w"] = 78,
			["hide"] = true,
		},
	},
	["party3"] = {
		["frame"] = {
			["y"] = -265,
			["x"] = 16,
			["hide"] = true,
		},
	},
	["party1target"] = {
		["frame"] = {
			["y"] = -145,
			["x"] = 162,
			["hide"] = true,
		},
	},
	["arena4target"] = {
		["frame"] = {
			["y"] = -497,
			["h"] = 24,
			["x"] = 1268,
			["w"] = 78,
			["hide"] = true,
		},
	},
	["arena2target"] = {
		["frame"] = {
			["y"] = -403,
			["h"] = 24,
			["x"] = 1268,
			["w"] = 78,
			["hide"] = true,
		},
	},
	["arenapet2"] = {
		["frame"] = {
			["y"] = -415,
			["h"] = 24,
			["x"] = 1152,
			["w"] = 78,
			["hide"] = true,
		},
	},
	["boss2"] = {
		["frame"] = {
			["y"] = -236,
			["h"] = 24,
			["w"] = 78,
			["x"] = 1165,
		},
	},
	["arena1"] = {
		["text2"] = {
			["y"] = 0,
			["x"] = 0,
			["pattern"] = "",
			["h"] = 10,
			["w"] = 54,
			["hide"] = true,
		},
		["portrait"] = {
			["y"] = 0,
			["x"] = 0,
			["w"] = 24,
			["h"] = 24,
		},
		["castbar"] = {
			["baralpha"] = 0,
			["spellfontsize"] = 10,
			["bgcolor"] = {
				["a"] = 0.2,
				["r"] = 1,
				["g"] = 1,
				["b"] = 0,
			},
			["spellh"] = 12,
			["spelljustifyH"] = "CENTER",
			["iconh"] = 14,
			["iconw"] = 14,
			["h"] = 26,
			["spellshadowy"] = -1,
			["timew"] = 80,
			["spellw"] = 80,
			["timefontsize"] = 8,
			["timejustifyH"] = "CENTER",
			["spellshadowx"] = -1,
			["alpha"] = 1,
			["spelly"] = -12,
			["spellx"] = 0,
			["timey"] = 0,
			["timeh"] = 26,
			["spellfontcolor"] = {
				["a"] = 0.7,
				["r"] = 1,
				["g"] = 0.5,
				["b"] = 0.2,
			},
			["w"] = 80,
			["icony"] = 0,
			["y"] = 1,
			["x"] = -1,
			["spelljustifyV"] = "CENTER",
			["iconalpha"] = 0,
			["timejustifyV"] = "CENTER",
			["timefontcolor"] = {
				["a"] = 0,
				["r"] = 1,
				["g"] = 0.5,
				["b"] = 0.2,
			},
			["timex"] = 0,
			["iconx"] = -16,
		},
		["text3"] = {
			["y"] = -13,
			["x"] = 25,
			["pattern"] = "[perchp]%",
			["h"] = 10,
			["w"] = 54,
			["fontsize"] = 10,
			["justifyV"] = "CENTER",
			["justifyH"] = "CENTER",
		},
		["infoicon"] = {
			["y"] = 0,
			["x"] = 0,
			["h"] = 12,
			["w"] = 12,
			["hide"] = true,
		},
		["debuffgroup"] = {
			["rows"] = 1,
			["w"] = 10,
			["cols"] = 8,
			["y"] = -23,
			["x"] = 0,
			["count"] = 8,
			["h"] = 10,
			["growth"] = "LRTB",
			["push"] = "v",
		},
		["mpbar"] = {
			["y"] = -19,
			["x"] = 24,
			["barcolormethod"] = "power",
			["h"] = 5,
			["bgalpha"] = 0.3,
			["w"] = 53,
			["bgcolormethod"] = "powerdark",
		},
		["hpbar"] = {
			["y"] = -1,
			["x"] = 24,
			["barcolormethod"] = "hpgreen",
			["h"] = 17,
			["bgalpha"] = 0.3,
			["w"] = 53,
			["bgcolormethod"] = "hpgreendark",
		},
		["text4"] = {
			["y"] = 0,
			["x"] = 0,
			["pattern"] = "",
			["h"] = 10,
			["w"] = 54,
			["hide"] = true,
		},
		["frame"] = {
			["y"] = -356,
			["h"] = 24,
			["x"] = 1189,
			["w"] = 78,
			["hide"] = true,
		},
		["text1"] = {
			["pattern"] = "[class:name]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 54,
			["y"] = 0,
			["x"] = 25,
			["fontsize"] = 12,
			["h"] = 12,
			["justifyH"] = "LEFT",
			["justifyV"] = "TOP",
		},
		["buffgroup"] = {
			["y"] = -24,
			["x"] = 0,
			["count"] = 8,
			["h"] = 10,
			["w"] = 10,
			["rows"] = 1,
			["growth"] = "LRTB",
			["cols"] = 8,
		},
	},
	["global"] = {
		["bglist"] = "background",
		["bgcolor"] = {
			["a"] = 0,
			["r"] = 0,
			["g"] = 0,
			["b"] = 0,
		},
		["shortk"] = 10000,
		["powercolor"] = {
			{
				["r"] = 1,
				["g"] = 0,
				["b"] = 0,
			}, -- [1]
			{
				["r"] = 1,
				["g"] = 0.5,
				["b"] = 0.25,
			}, -- [2]
			{
				["r"] = 1,
				["g"] = 1,
				["b"] = 0,
			}, -- [3]
			{
				["r"] = 0,
				["g"] = 1,
				["b"] = 1,
			}, -- [4]
			{
				["r"] = 0.5,
				["g"] = 0.5,
				["b"] = 0.5,
			}, -- [5]
			{
				["r"] = 0,
				["g"] = 0.82,
				["b"] = 1,
			}, -- [6]
			[0] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 1,
			},
		},
		["hpgreen"] = {
			["a"] = 1,
			["r"] = 0.125,
			["g"] = 0.231,
			["b"] = 0.125,
		},
		["maxoh"] = 1.2,
		["bg"] = "Solid",
		["hpred"] = {
			["a"] = 1,
			["r"] = 0.271,
			["g"] = 0.122,
			["b"] = 0.122,
		},
		["init"] = 9,
		["aurastyle"] = 3,
		["failcolor"] = {
			["r"] = 1,
			["g"] = 0,
			["b"] = 0,
		},
		["font"] = "Franklin Gothic Medium",
		["castcolor"] = {
			["r"] = 1,
			["g"] = 0.7,
			["b"] = 0,
		},
		["bordermousecolor"] = {
			["a"] = 0,
			["r"] = 1,
			["g"] = 1,
			["b"] = 0,
		},
		["strata"] = "BACKGROUND",
		["vhcurrent"] = {
			["a"] = 0,
			["r"] = 0,
			["g"] = 0,
			["b"] = 0,
		},
		["shadowcolor"] = {
			["a"] = 0.9,
			["r"] = 0,
			["g"] = 0,
			["b"] = 0,
		},
		["lbfbackdrop"] = true,
		["vhother"] = {
			["a"] = 1,
			["r"] = 0.4,
			["g"] = 0.5725490196078431,
			["b"] = 0.4,
		},
		["classcolor"] = {
			["DEATHKNIGHT"] = {
				["r"] = 0.77,
				["g"] = 0.12,
				["b"] = 0.23,
			},
			["WARRIOR"] = {
				["r"] = 0.78,
				["g"] = 0.61,
				["b"] = 0.43,
			},
			["PALADIN"] = {
				["r"] = 0.96,
				["g"] = 0.55,
				["b"] = 0.73,
			},
			["MAGE"] = {
				["r"] = 0.41,
				["g"] = 0.8,
				["b"] = 0.94,
			},
			["PRIEST"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["WARLOCK"] = {
				["r"] = 0.58,
				["g"] = 0.51,
				["b"] = 0.79,
			},
			["HUNTER"] = {
				["r"] = 0.67,
				["g"] = 0.83,
				["b"] = 0.45,
			},
			["DRUID"] = {
				["r"] = 1,
				["g"] = 0.49,
				["b"] = 0.04,
			},
			["SHAMAN"] = {
				["r"] = 0,
				["g"] = 0.44,
				["b"] = 0.87,
			},
			["ROGUE"] = {
				["r"] = 1,
				["g"] = 0.96,
				["b"] = 0.41,
			},
		},
		["hidehints"] = false,
		["reactioncolor"] = {
			{
				["r"] = 0.8,
				["g"] = 0.3,
				["b"] = 0.22,
			}, -- [1]
			{
				["r"] = 0.8,
				["g"] = 0.3,
				["b"] = 0.22,
			}, -- [2]
			{
				["r"] = 0.75,
				["g"] = 0.27,
				["b"] = 0,
			}, -- [3]
			{
				["r"] = 0.9,
				["g"] = 0.7,
				["b"] = 0,
			}, -- [4]
			{
				["r"] = 0,
				["g"] = 0.6,
				["b"] = 0.1,
			}, -- [5]
			{
				["r"] = 0,
				["g"] = 0.6,
				["b"] = 0.1,
			}, -- [6]
			{
				["r"] = 0,
				["g"] = 0.6,
				["b"] = 0.1,
			}, -- [7]
			{
				["r"] = 0,
				["g"] = 0.6,
				["b"] = 0.1,
			}, -- [8]
			{
				["r"] = 0.8,
				["g"] = 1,
				["b"] = 0.8,
			}, -- [9]
			{
				["r"] = 1,
				["g"] = 0.8,
				["b"] = 0.8,
			}, -- [10]
		},
		["mpfadecolor"] = {
			["a"] = 0.5,
			["r"] = 1,
			["g"] = 1,
			["b"] = 1,
		},
		["lbfskin"] = "Blizzard",
		["classification"] = {
			["elite"] = "+",
			["normal"] = "",
			["worldboss"] = " B",
			["unknown"] = "??",
			["rareelite"] = "+ R",
			["rare"] = "r",
		},
		["bgmousecolor"] = {
			["a"] = 0,
			["r"] = 1,
			["g"] = 1,
			["b"] = 0,
		},
		["bartexture"] = "Flat Smooth",
		["completecolor"] = {
			["r"] = 1,
			["g"] = 1,
			["b"] = 0,
		},
		["channelcolor"] = {
			["r"] = 0,
			["g"] = 1,
			["b"] = 0,
		},
		["alpha"] = 1,
		["vhyour"] = {
			["a"] = 1,
			["r"] = 0.4509803921568628,
			["g"] = 0.4509803921568628,
			["b"] = 0.6392156862745098,
		},
		["nK"] = "k",
		["auracolor"] = {
			[""] = {
				["r"] = 0.8,
				["g"] = 0,
				["b"] = 0,
			},
			["Disease"] = {
				["r"] = 0.6,
				["g"] = 0.4,
				["b"] = 0,
			},
			["Buff"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["MyBuff"] = {
				["r"] = 0.5,
				["g"] = 0.5,
				["b"] = 0.6,
			},
			["Poison"] = {
				["r"] = 0,
				["g"] = 0.6,
				["b"] = 0,
			},
			["Curse"] = {
				["r"] = 0.6,
				["g"] = 0,
				["b"] = 1,
			},
			["Magic"] = {
				["r"] = 0.2,
				["g"] = 0.6,
				["b"] = 1,
			},
			["none"] = {
				["r"] = 0.8,
				["g"] = 0,
				["b"] = 0,
			},
		},
		["border"] = "None",
		["hpfadecolor"] = {
			["a"] = 1,
			["r"] = 0.255,
			["g"] = 0.247,
			["b"] = 0.141,
		},
		["lbfgloss"] = 0,
		["borderaggrocolor"] = {
			["a"] = 0,
			["r"] = 1,
			["g"] = 0,
			["b"] = 0,
		},
		["nM"] = "M",
		["gray"] = {
			["a"] = 0.8,
			["r"] = 0.4,
			["g"] = 0.4,
			["b"] = 0.4,
		},
	},
	["arenapet1"] = {
		["text2"] = {
			["y"] = 0,
			["x"] = 0,
			["pattern"] = "[perchp]",
			["h"] = 12,
			["w"] = 24,
			["fontsize"] = 9,
			["justifyV"] = "CENTER",
			["justifyH"] = "CENTER",
		},
		["portrait"] = {
			["y"] = 0,
			["x"] = 24,
			["w"] = 12,
			["h"] = 12,
		},
		["text3"] = {
			["y"] = 0,
			["x"] = 0,
			["pattern"] = "",
			["fontsize"] = 10,
			["h"] = 10,
			["w"] = 10,
			["hide"] = true,
		},
		["infoicon"] = {
			["y"] = 0,
			["x"] = 0,
			["h"] = 12,
			["w"] = 12,
			["hide"] = true,
		},
		["debuffgroup"] = {
			["rows"] = 1,
			["w"] = 6,
			["cols"] = 6,
			["y"] = -12,
			["x"] = 0,
			["count"] = 6,
			["push"] = "v",
			["h"] = 6,
			["hide"] = true,
		},
		["mpbar"] = {
			["y"] = -9,
			["x"] = 0,
			["hide"] = true,
			["barcolormethod"] = "power",
			["h"] = 3,
			["bgalpha"] = 0.3,
			["w"] = 24,
			["bgcolormethod"] = "powerdark",
		},
		["hpbar"] = {
			["y"] = 0,
			["x"] = 0,
			["h"] = 12,
			["barcolormethod"] = "hpgreen",
			["reverse"] = true,
			["bgalpha"] = 0.3,
			["w"] = 24,
			["bgcolormethod"] = "hpgreendark",
		},
		["text4"] = {
			["y"] = 0,
			["x"] = 0,
			["pattern"] = "",
			["fontsize"] = 10,
			["h"] = 10,
			["w"] = 10,
			["hide"] = true,
		},
		["frame"] = {
			["y"] = -368,
			["h"] = 12,
			["x"] = 1152,
			["w"] = 36,
			["hide"] = true,
		},
		["text1"] = {
			["y"] = 0,
			["x"] = 0,
			["pattern"] = "",
			["h"] = 12,
			["w"] = 24,
			["hide"] = true,
		},
		["buffgroup"] = {
			["y"] = -12,
			["x"] = 0,
			["count"] = 6,
			["hide"] = true,
			["h"] = 6,
			["rows"] = 1,
			["w"] = 6,
			["cols"] = 6,
		},
	},
	["pet"] = {
		["buffgroup"] = {
			["rows"] = 1,
			["growth"] = "LRTB",
			["cols"] = 8,
			["y"] = -24,
			["h"] = 10,
			["count"] = 8,
			["w"] = 10,
			["x"] = 0,
			["hide"] = true,
		},
		["portrait"] = {
			["y"] = -9,
			["x"] = 24,
			["w"] = 25,
			["h"] = 25,
		},
		["combattext"] = {
			["y"] = -16,
			["x"] = 16,
			["fontsize"] = 10,
			["h"] = 12,
			["w"] = 40,
			["justifyV"] = "TOP",
			["justifyH"] = "CENTER",
		},
		["text3"] = {
			["pattern"] = "[perchp]% [solid_if_hp99:deficithp]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["justifyV"] = "CENTER",
			["y"] = -22,
			["h"] = 10,
			["justifyH"] = "CENTER",
			["fontsize"] = 10,
			["w"] = 99,
			["x"] = 62,
			["font"] = "Emblem",
		},
		["infoicon"] = {
			["y"] = 0,
			["h"] = 12,
			["x"] = 0,
			["w"] = 12,
			["hide"] = true,
		},
		["debuffgroup"] = {
			["rows"] = 1,
			["w"] = 10,
			["cols"] = 8,
			["y"] = -24,
			["push"] = "v",
			["count"] = 8,
			["h"] = 10,
			["growth"] = "LRTB",
			["x"] = 0,
			["hide"] = true,
		},
		["text6"] = {
			["pattern"] = "[gray_if_dead:DEAD]",
			["w"] = 145,
			["y"] = -21,
			["h"] = 10,
			["fontsize"] = 10,
			["justifyV"] = "CENTER",
			["justifyH"] = "CENTER",
			["x"] = 1,
			["hide"] = true,
		},
		["text1"] = {
			["pattern"] = "[reaction:name]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 54,
			["y"] = -6,
			["x"] = 62,
			["fontsize"] = 12,
			["h"] = 12,
			["justifyH"] = "LEFT",
			["justifyV"] = "TOP",
		},
		["text2"] = {
			["pattern"] = "[difficulty:level]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 108,
			["y"] = -16,
			["x"] = -44,
			["fontsize"] = 9,
			["font"] = "Accidental Presidency",
			["h"] = 10,
			["justifyH"] = "CENTER",
			["justifyV"] = "CENTER",
		},
		["castbar"] = {
			["spellfontsize"] = 1,
			["bgcolor"] = {
				["a"] = 0.06,
				["r"] = 1,
				["g"] = 1,
				["b"] = 0,
			},
			["timeshadowy"] = -1,
			["spelljustifyH"] = "CENTER",
			["iconw"] = 20,
			["h"] = 16,
			["timefontsize"] = 12,
			["timeh"] = 12,
			["spellfontcolor"] = {
				["a"] = 0,
				["r"] = 1,
				["g"] = 0.502,
				["b"] = 0.2,
			},
			["w"] = 99,
			["spelljustifyV"] = "CENTER",
			["spelly"] = -26,
			["x"] = 61,
			["iconalpha"] = 0,
			["timejustifyV"] = "CENTER",
			["spellw"] = 0,
			["baralpha"] = 0,
			["spellh"] = 0,
			["iconh"] = 20,
			["spellx"] = 0,
			["timey"] = -39,
			["timeshadowx"] = -1,
			["iconx"] = 85,
			["alpha"] = 1,
			["spellshadowy"] = -1,
			["icony"] = -27,
			["y"] = -24,
			["timew"] = 191,
			["spellshadowx"] = -1,
			["timejustifyH"] = "CENTER",
			["timefontcolor"] = {
				["a"] = 0,
				["r"] = 1,
				["g"] = 0.5,
				["b"] = 0.2,
			},
			["timex"] = 0,
			["sparkcolor"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 0,
			},
		},
		["text5"] = {
			["pattern"] = "[percmp]%",
			["w"] = 140,
			["y"] = -36,
			["x"] = 63,
			["fontsize"] = 10,
			["justifyV"] = "BOTTOM",
			["h"] = 10,
			["justifyH"] = "RIGHT",
			["hide"] = true,
		},
		["dispellicon"] = {
			["y"] = -1,
			["h"] = 22,
			["x"] = 57,
			["w"] = 22,
			["hide"] = true,
		},
		["text4"] = {
			["onmouse"] = true,
			["pattern"] = "[solid_if_mp99:percmp][solid_if_mp99:%]",
			["w"] = 54,
			["y"] = -32,
			["font"] = "Blue Highway",
			["fontsize"] = 10,
			["justifyH"] = "RIGHT",
			["h"] = 10,
			["x"] = 105,
			["justifyV"] = "CENTER",
		},
		["mpbar"] = {
			["baralpha"] = 1,
			["bgcolor"] = {
				["a"] = 0,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["bartexture"] = "StatusBar-MP",
			["bordercolor"] = {
				["a"] = 0,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["w"] = 99,
			["bgcolormethod"] = "solid",
			["y"] = -33,
			["x"] = 61,
			["framelevel"] = 2,
			["barcolormethod"] = "solid",
			["h"] = 6,
			["hflip"] = true,
			["barcolor"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["bgalpha"] = 0,
		},
		["pettime"] = {
			["y"] = -25,
			["x"] = 0,
			["fontsize"] = 10,
			["h"] = 10,
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 36,
			["hide"] = true,
		},
		["hpbar"] = {
			["baralpha"] = 1,
			["bgcolor"] = {
				["a"] = 0,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["bartexture"] = "StatusBar-HP",
			["bgalpha"] = 0,
			["w"] = 99,
			["fade"] = true,
			["y"] = -24,
			["h"] = 6,
			["x"] = 61,
			["barcolormethod"] = "solid",
			["bordercolor"] = {
				["a"] = 0,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["barcolor"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["framelevel"] = 1,
			["bgcolormethod"] = "solid",
		},
		["raidtargeticon"] = {
			["y"] = 15,
			["x"] = 27,
			["w"] = 20,
			["h"] = 20,
		},
		["frame"] = {
			["fasthp"] = true,
			["h"] = 44,
			["scale"] = 1.2,
			["y"] = -200,
			["w"] = 165,
			["x"] = 400,
		},
		["happinessicon"] = {
			["y"] = -37,
			["x"] = 2,
			["w"] = 16,
			["h"] = 16,
		},
		["statusicon"] = {
			["y"] = -15,
			["h"] = 15,
			["x"] = 2,
			["w"] = 15,
			["hide"] = true,
		},
	},
	["boss4"] = {
		["frame"] = {
			["y"] = -352,
			["h"] = 24,
			["w"] = 78,
			["x"] = 1165,
		},
	},
	["player"] = {
		["dispellicon"] = {
			["y"] = -55,
			["h"] = 42,
			["counttfont"] = "Neuropol",
			["w"] = 42,
			["x"] = 61,
			["alpha"] = 1,
			["framelevel"] = 10,
		},
		["portrait"] = {
			["y"] = -1,
			["x"] = 1,
			["bgcolor"] = {
				["a"] = 0.4,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["show3d"] = true,
			["h"] = 48,
			["w"] = 48,
			["bg"] = "Flat Smooth",
			["hide"] = true,
		},
		["debuffgroup"] = {
			["rows"] = 3,
			["w"] = 17,
			["cols"] = 16,
			["y"] = -52,
			["x"] = 0,
			["count"] = 40,
			["framelevel"] = 1,
			["push"] = "v",
			["h"] = 17,
			["hide"] = true,
		},
		["incomingbar"] = {
			["y"] = -2,
			["x"] = 50,
			["h"] = 33,
			["w"] = 140,
			["hide"] = true,
		},
		["runebar"] = {
			["y"] = 11,
			["x"] = 40,
			["bgcolor"] = {
				["a"] = 0.4,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["w"] = 38,
			["h"] = 6,
		},
		["text4"] = {
			["pattern"] = "[curmp]/[maxmp]",
			["w"] = 126,
			["y"] = -38,
			["h"] = 10,
			["fontsize"] = 10,
			["justifyH"] = "RIGHT",
			["justifyV"] = "BOTTOM",
			["x"] = 64,
			["hide"] = true,
		},
		["leadericon"] = {
			["y"] = -10,
			["x"] = 105,
			["w"] = 15,
			["h"] = 15,
		},
		["mpbar"] = {
			["bgalpha"] = 0.3,
			["w"] = 127,
			["fade"] = true,
			["y"] = -37,
			["x"] = 63,
			["barcolormethod"] = "power",
			["h"] = 12,
			["bgcolormethod"] = "powerdark",
			["hide"] = true,
		},
		["druidbar"] = {
			["bgcolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["bgalpha"] = 0.4,
			["w"] = 127,
			["bgcolormethod"] = "solid",
			["y"] = -37,
			["x"] = 63,
			["barcolormethod"] = "solid",
			["h"] = 3,
			["barcolor"] = {
				["r"] = 0.3,
				["g"] = 0.3,
				["b"] = 1,
			},
		},
		["text7"] = {
			["y"] = 0,
			["x"] = 0,
			["pattern"] = "",
			["h"] = 1,
			["justifyV"] = "CENTER",
			["justifyH"] = "CENTER",
			["w"] = 1,
			["fontsize"] = 10,
		},
		["vehicleicon"] = {
			["hide"] = true,
		},
		["hpbar"] = {
			["bgalpha"] = 0.3,
			["w"] = 140,
			["fade"] = true,
			["y"] = -2,
			["x"] = 50,
			["barcolormethod"] = "hpthreshold",
			["h"] = 33,
			["bgcolormethod"] = "hpgreendark",
			["hide"] = true,
		},
		["combattext"] = {
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 52,
			["y"] = -2,
			["x"] = -1,
			["fontsize"] = 12,
			["h"] = 14,
			["justifyH"] = "CENTER",
			["justifyV"] = "TOP",
			["hide"] = true,
		},
		["text3"] = {
			["pattern"] = "[perchp]%[nl][curhp]/[maxhp]",
			["w"] = 140,
			["y"] = -14,
			["h"] = 21,
			["fontsize"] = 10,
			["justifyH"] = "RIGHT",
			["justifyV"] = "BOTTOM",
			["x"] = 50,
			["hide"] = true,
		},
		["infoicon"] = {
			["y"] = -37,
			["h"] = 12,
			["x"] = 50,
			["w"] = 12,
			["hide"] = true,
		},
		["totembar"] = {
			["y"] = 13,
			["x"] = 20,
			["bgcolor"] = {
				["a"] = 0.4,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["w"] = 32,
			["h"] = 12,
		},
		["text6"] = {
			["pattern"] = "[gray_if_dead:DEAD][gray_if_ghost:GHOST]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 189,
			["y"] = -29,
			["x"] = 1,
			["fontsize"] = 14,
			["h"] = 14,
			["justifyH"] = "CENTER",
			["justifyV"] = "CENTER",
			["hide"] = true,
		},
		["text1"] = {
			["pattern"] = "[name]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 140,
			["y"] = 0,
			["x"] = 50,
			["fontsize"] = 14,
			["h"] = 14,
			["justifyH"] = "LEFT",
			["justifyV"] = "TOP",
			["hide"] = true,
		},
		["shardbar"] = {
			["y"] = 0,
			["x"] = 0,
		},
		["voiceicon"] = {
			["y"] = 7,
			["h"] = 16,
			["x"] = -7,
			["w"] = 16,
			["hide"] = true,
		},
		["text2"] = {
			["pattern"] = "[level] [class:race]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 140,
			["y"] = -13,
			["x"] = 50,
			["fontsize"] = 12,
			["h"] = 12,
			["justifyH"] = "LEFT",
			["justifyV"] = "TOP",
			["hide"] = true,
		},
		["lfgicon"] = {
			["y"] = -100,
			["h"] = 22,
			["circular"] = true,
			["x"] = 70,
			["w"] = 22,
			["alpha"] = 0.7,
			["framelevel"] = 26,
		},
		["castbar"] = {
			["spellfontsize"] = 14,
			["bgcolor"] = {
				["a"] = 0.2,
				["r"] = 1,
				["g"] = 1,
				["b"] = 0,
			},
			["timeshadowy"] = -1,
			["spelljustifyH"] = "CENTER",
			["iconw"] = 20,
			["h"] = 52,
			["timefontsize"] = 12,
			["timeh"] = 12,
			["spellfontcolor"] = {
				["a"] = 0.7,
				["r"] = 1,
				["g"] = 0.5,
				["b"] = 0.2,
			},
			["w"] = 193,
			["spelljustifyV"] = "CENTER",
			["y"] = 1,
			["x"] = -1,
			["iconx"] = 85,
			["timejustifyV"] = "CENTER",
			["spellw"] = 193,
			["baralpha"] = 0,
			["spellh"] = 14,
			["iconh"] = 20,
			["hide"] = true,
			["spellx"] = 0,
			["timey"] = -36,
			["timeshadowx"] = -1,
			["alpha"] = 1,
			["spelly"] = -26,
			["icony"] = -27,
			["spellshadowy"] = -1,
			["timew"] = 193,
			["spellshadowx"] = -1,
			["timejustifyH"] = "CENTER",
			["timefontcolor"] = {
				["a"] = 0,
				["r"] = 1,
				["g"] = 0.5,
				["b"] = 0.2,
			},
			["timex"] = 0,
			["iconalpha"] = 0,
		},
		["text5"] = {
			["pattern"] = "[percmp]%",
			["w"] = 140,
			["y"] = -36,
			["x"] = 63,
			["fontsize"] = 10,
			["justifyV"] = "BOTTOM",
			["h"] = 10,
			["justifyH"] = "RIGHT",
			["hide"] = true,
		},
		["eclipsebar"] = {
			["y"] = 0,
			["x"] = 0,
		},
		["pvpicon"] = {
			["y"] = 0,
			["x"] = 6,
			["w"] = 28,
			["h"] = 28,
		},
		["tempenchant"] = {
			["y"] = -52,
			["x"] = -17,
			["count"] = 2,
			["h"] = 17,
			["w"] = 17,
			["growth"] = "TBLR",
			["hide"] = true,
		},
		["holybar"] = {
			["y"] = 0,
			["x"] = 0,
			["hide"] = true,
		},
		["looticon"] = {
			["y"] = -30,
			["x"] = 130,
			["w"] = 15,
			["h"] = 15,
		},
		["grouptext"] = {
			["bgcolor"] = {
				["a"] = 0.3,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 14,
			["h"] = 12,
			["y"] = -30,
			["x"] = 73,
			["justifyH"] = "CENTER",
			["bordercolor"] = {
				["a"] = 0,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["justifyV"] = "CENTER",
			["font"] = "Russel Square",
			["bg"] = "Outline",
			["fontsize"] = 12,
		},
		["buffgroup"] = {
			["y"] = -52,
			["x"] = 0,
			["count"] = 32,
			["hide"] = true,
			["h"] = 17,
			["rows"] = 2,
			["w"] = 17,
			["cols"] = 16,
		},
		["raidtargeticon"] = {
			["y"] = 15,
			["x"] = 65,
			["w"] = 30,
			["h"] = 30,
		},
		["frame"] = {
			["y"] = -948,
			["x"] = 411,
			["w"] = 151,
			["h"] = 150,
		},
		["text8"] = {
			["pattern"] = "",
			["w"] = 1,
			["y"] = 0,
			["x"] = 0,
			["fontsize"] = 10,
			["justifyV"] = "CENTER",
			["h"] = 1,
			["justifyH"] = "CENTER",
			["hide"] = true,
		},
		["statusicon"] = {
			["y"] = -115,
			["h"] = 20,
			["w"] = 20,
			["x"] = 15,
		},
	},
	["boss3target"] = {
		["frame"] = {
			["y"] = -450,
			["h"] = 24,
			["x"] = 1268,
			["w"] = 78,
			["hide"] = true,
		},
	},
	["partypet2"] = {
		["frame"] = {
			["y"] = -245,
			["x"] = 7,
			["hide"] = true,
		},
	},
	["partypet1"] = {
		["text2"] = {
			["y"] = 0,
			["x"] = 12,
			["pattern"] = "[perchp]",
			["h"] = 12,
			["w"] = 24,
			["fontsize"] = 9,
			["justifyV"] = "CENTER",
			["justifyH"] = "CENTER",
		},
		["portrait"] = {
			["y"] = 0,
			["x"] = 0,
			["w"] = 12,
			["h"] = 12,
		},
		["text3"] = {
			["y"] = 0,
			["x"] = 0,
			["pattern"] = "",
			["fontsize"] = 10,
			["h"] = 10,
			["w"] = 10,
			["hide"] = true,
		},
		["infoicon"] = {
			["y"] = 0,
			["x"] = 0,
			["h"] = 12,
			["w"] = 12,
			["hide"] = true,
		},
		["debuffgroup"] = {
			["rows"] = 1,
			["w"] = 6,
			["cols"] = 6,
			["y"] = -12,
			["x"] = 0,
			["count"] = 6,
			["push"] = "v",
			["h"] = 6,
			["hide"] = true,
		},
		["mpbar"] = {
			["y"] = -9,
			["x"] = 12,
			["barcolormethod"] = "power",
			["h"] = 3,
			["bgalpha"] = 0.3,
			["w"] = 24,
			["bgcolormethod"] = "powerdark",
		},
		["hpbar"] = {
			["y"] = 0,
			["x"] = 12,
			["barcolormethod"] = "hpgreen",
			["h"] = 9,
			["bgalpha"] = 0.3,
			["w"] = 24,
			["bgcolormethod"] = "hpgreendark",
		},
		["text4"] = {
			["y"] = 0,
			["x"] = 0,
			["pattern"] = "",
			["fontsize"] = 10,
			["h"] = 10,
			["w"] = 10,
			["hide"] = true,
		},
		["raidtargeticon"] = {
			["y"] = 4,
			["x"] = 4,
			["h"] = 8,
			["w"] = 8,
			["hide"] = true,
		},
		["frame"] = {
			["y"] = -185,
			["h"] = 12,
			["x"] = 7,
			["w"] = 36,
			["hide"] = true,
		},
		["text1"] = {
			["pattern"] = "[name]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 24,
			["y"] = 0,
			["x"] = 12,
			["fontsize"] = 9,
			["justifyV"] = "TOP",
			["h"] = 12,
			["justifyH"] = "LEFT",
			["hide"] = true,
		},
		["buffgroup"] = {
			["y"] = -12,
			["x"] = 0,
			["count"] = 6,
			["hide"] = true,
			["h"] = 6,
			["rows"] = 1,
			["w"] = 6,
			["cols"] = 6,
		},
	},
	["targettargettarget"] = {
		["text2"] = {
			["y"] = 0,
			["x"] = 12,
			["pattern"] = "[reaction:perchp]",
			["h"] = 12,
			["w"] = 24,
			["fontsize"] = 10,
			["justifyV"] = "CENTER",
			["justifyH"] = "CENTER",
		},
		["portrait"] = {
			["y"] = 0,
			["x"] = 0,
			["w"] = 12,
			["h"] = 12,
		},
		["text3"] = {
			["y"] = 0,
			["x"] = 0,
			["pattern"] = "",
			["fontsize"] = 10,
			["h"] = 10,
			["w"] = 10,
			["hide"] = true,
		},
		["infoicon"] = {
			["y"] = 0,
			["x"] = 0,
			["h"] = 12,
			["w"] = 12,
			["hide"] = true,
		},
		["debuffgroup"] = {
			["rows"] = 1,
			["w"] = 6,
			["cols"] = 6,
			["y"] = -12,
			["x"] = 0,
			["count"] = 6,
			["push"] = "v",
			["h"] = 6,
			["hide"] = true,
		},
		["mpbar"] = {
			["y"] = -9,
			["x"] = 12,
			["barcolormethod"] = "power",
			["h"] = 3,
			["bgalpha"] = 0.3,
			["w"] = 24,
			["bgcolormethod"] = "powerdark",
		},
		["hpbar"] = {
			["y"] = 0,
			["x"] = 12,
			["barcolormethod"] = "hpgreen",
			["h"] = 9,
			["bgalpha"] = 0.3,
			["w"] = 24,
			["bgcolormethod"] = "hpgreendark",
		},
		["text4"] = {
			["y"] = 0,
			["x"] = 0,
			["pattern"] = "",
			["fontsize"] = 10,
			["h"] = 10,
			["w"] = 10,
			["hide"] = true,
		},
		["raidtargeticon"] = {
			["y"] = 4,
			["x"] = 4,
			["h"] = 8,
			["w"] = 8,
			["hide"] = true,
		},
		["frame"] = {
			["y"] = -37,
			["x"] = 512,
			["h"] = 12,
			["w"] = 36,
			["hide"] = true,
		},
		["text1"] = {
			["y"] = 0,
			["x"] = 12,
			["pattern"] = "[reaction:name]",
			["h"] = 12,
			["w"] = 24,
			["hide"] = true,
		},
		["buffgroup"] = {
			["y"] = -12,
			["x"] = 0,
			["count"] = 6,
			["hide"] = true,
			["h"] = 6,
			["rows"] = 1,
			["w"] = 6,
			["cols"] = 6,
		},
	},
	["arenapet5"] = {
		["frame"] = {
			["y"] = -556,
			["h"] = 24,
			["x"] = 1152,
			["w"] = 78,
			["hide"] = true,
		},
	},
	["party2target"] = {
		["frame"] = {
			["y"] = -205,
			["x"] = 162,
			["hide"] = true,
		},
	},
	["target"] = {
		["buffgroup"] = {
			["timeonlymine"] = true,
			["timefont"] = "Russel Square",
			["cols"] = 4,
			["h"] = 20,
			["timefontsize"] = 1,
			["hide"] = true,
			["rows"] = 3,
			["growth"] = "LRTB",
			["counttfontsize"] = 9,
			["y"] = -60,
			["x"] = 0,
			["showpie"] = true,
			["w"] = 20,
			["count"] = 8,
			["counttfont"] = "Russel Square",
			["timex"] = 0,
			["onlymine"] = true,
		},
		["portrait"] = {
			["bgcolor"] = {
				["a"] = 0,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["show3d"] = true,
			["w"] = 35,
			["framelevel"] = 1,
			["y"] = -40,
			["x"] = 38,
			["camera"] = 0,
			["bg"] = "Flat Smooth",
			["h"] = 38,
		},
		["text7"] = {
			["pattern"] = "",
			["w"] = 1,
			["y"] = 0,
			["x"] = 0,
			["fontsize"] = 10,
			["justifyV"] = "CENTER",
			["h"] = 1,
			["justifyH"] = "CENTER",
			["hide"] = true,
		},
		["combattext"] = {
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 52,
			["y"] = -50,
			["x"] = 28,
			["fontsize"] = 12,
			["font"] = "Russel Square",
			["h"] = 14,
			["justifyH"] = "CENTER",
			["justifyV"] = "CENTER",
		},
		["text3"] = {
			["pattern"] = "[curhp][solid_if_hp99: - ][solid_if_hp99:perchp][solid_if_hp99:%]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["justifyV"] = "CENTER",
			["y"] = -47,
			["font"] = "Russel Square",
			["justifyH"] = "CENTER",
			["h"] = 21,
			["fontsize"] = 18,
			["x"] = 168,
			["w"] = 140,
		},
		["infoicon"] = {
			["y"] = 13,
			["h"] = 12,
			["x"] = 148,
			["w"] = 12,
			["hide"] = true,
		},
		["debuffgroup"] = {
			["rows"] = 3,
			["w"] = 20,
			["cols"] = 4,
			["y"] = -17,
			["x"] = 125,
			["count"] = 8,
			["push"] = "v",
			["showpie"] = true,
			["h"] = 20,
			["growth"] = "LRTB",
			["hide"] = true,
		},
		["threatbar"] = {
			["y"] = 11,
			["x"] = 100,
			["bgcolor"] = {
				["a"] = 0.4,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["h"] = 12,
			["w"] = 32,
			["hide"] = true,
		},
		["incomingbar"] = {
			["bgcolor"] = {
				["a"] = 1,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["bordercolor"] = {
				["a"] = 0,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["w"] = 280,
			["framelevel"] = 1,
			["y"] = -51,
			["x"] = 94,
			["border"] = "Square Outline",
			["h"] = 10,
			["merge"] = true,
		},
		["text6"] = {
			["pattern"] = "[gray_if_oor:OOR ][gray_if_tapped:TAPPED ][gray_if_offline:OFFLINE ][gray_if_dead:DEAD][gray_if_ghost:GHOST]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 280,
			["framelevel"] = 3,
			["y"] = -50,
			["x"] = 100,
			["fontsize"] = 12,
			["justifyV"] = "CENTER",
			["font"] = "Russel Square",
			["h"] = 10,
			["justifyH"] = "LEFT",
		},
		["hpbar"] = {
			["baralpha"] = 1,
			["bgcolor"] = {
				["a"] = 0,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["bartexture"] = "StatusBar-HP",
			["bgalpha"] = 0,
			["w"] = 280,
			["bgcolormethod"] = "solid",
			["y"] = -51,
			["x"] = 94,
			["barcolormethod"] = "solid",
			["barcolor"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["h"] = 10,
			["bordercolor"] = {
				["a"] = 0,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["framelevel"] = 1,
		},
		["text1"] = {
			["pattern"] = "[class:name]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 185,
			["y"] = -13,
			["x"] = 130,
			["fontsize"] = 14,
			["font"] = "Russel Square",
			["h"] = 14,
			["justifyH"] = "CENTER",
			["justifyV"] = "CENTER",
		},
		["text2"] = {
			["pattern"] = "[difficulty:level][difficulty:classification]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 140,
			["y"] = -50,
			["x"] = -52,
			["fontsize"] = 12,
			["h"] = 12,
			["justifyH"] = "CENTER",
			["justifyV"] = "CENTER",
		},
		["comboframe"] = {
			["y"] = -41,
			["x"] = 160,
			["h"] = 29,
			["alpha"] = 0.94,
			["glowcolor"] = {
				["a"] = 0.8,
				["r"] = 1,
				["g"] = 1,
				["b"] = 0,
			},
			["w"] = 40,
			["combostyle"] = 1,
			["color"] = {
				["a"] = 1,
				["r"] = 0.7,
				["g"] = 0,
				["b"] = 0,
			},
		},
		["grouptext"] = {
			["bgcolor"] = {
				["a"] = 0.3,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 14,
			["y"] = -40,
			["x"] = 172,
			["fontsize"] = 10,
			["h"] = 12,
			["justifyH"] = "CENTER",
			["justifyV"] = "CENTER",
			["hide"] = true,
		},
		["mpbar"] = {
			["baralpha"] = 1,
			["bgcolor"] = {
				["a"] = 0,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["bartexture"] = "StatusBar-MP",
			["fade"] = true,
			["bgalpha"] = 0,
			["w"] = 280,
			["framelevel"] = 2,
			["y"] = -59,
			["x"] = 94,
			["h"] = 5,
			["barcolormethod"] = "solid",
			["hflip"] = true,
			["bgcolormethod"] = "solid",
			["barcolor"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["bordercolor"] = {
				["a"] = 0,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
		},
		["lfgicon"] = {
			["hide"] = true,
		},
		["text8"] = {
			["pattern"] = "",
			["w"] = 1,
			["y"] = 0,
			["x"] = 0,
			["fontsize"] = 10,
			["justifyV"] = "CENTER",
			["h"] = 1,
			["justifyH"] = "CENTER",
			["hide"] = true,
		},
		["castbar"] = {
			["baralpha"] = 0,
			["spellfontsize"] = 1,
			["bgcolor"] = {
				["a"] = 0.2,
				["r"] = 1,
				["g"] = 1,
				["b"] = 0,
			},
			["spellh"] = 0,
			["timeshadowy"] = -1,
			["spelljustifyH"] = "CENTER",
			["spellshadowx"] = -1,
			["iconh"] = 20,
			["iconw"] = 20,
			["h"] = 14,
			["spellw"] = 0,
			["timejustifyH"] = "CENTER",
			["iconalpha"] = 0,
			["timefontsize"] = 12,
			["timeh"] = 12,
			["alpha"] = 1,
			["spelly"] = -26,
			["spelljustifyV"] = "CENTER",
			["spellx"] = 0,
			["timey"] = -39,
			["timeshadowx"] = -1,
			["spellfontcolor"] = {
				["a"] = 0,
				["r"] = 1,
				["g"] = 0.502,
				["b"] = 0.2,
			},
			["w"] = 280,
			["icony"] = -27,
			["timew"] = 191,
			["x"] = 94,
			["y"] = -51,
			["iconx"] = 85,
			["timejustifyV"] = "CENTER",
			["timefontcolor"] = {
				["a"] = 0,
				["r"] = 1,
				["g"] = 0.5,
				["b"] = 0.2,
			},
			["timex"] = 0,
			["spellshadowy"] = -1,
		},
		["text5"] = {
			["pattern"] = "[percmp]%",
			["w"] = 140,
			["y"] = -36,
			["x"] = -75,
			["fontsize"] = 10,
			["justifyV"] = "BOTTOM",
			["h"] = 10,
			["justifyH"] = "LEFT",
			["hide"] = true,
		},
		["leadericon"] = {
			["y"] = -1,
			["x"] = 185,
			["w"] = 15,
			["h"] = 15,
		},
		["pvpicon"] = {
			["y"] = -12,
			["h"] = 28,
			["x"] = 176,
			["w"] = 28,
			["hide"] = true,
		},
		["dispellicon"] = {
			["y"] = -4,
			["h"] = 42,
			["x"] = -2,
			["w"] = 42,
			["hide"] = true,
		},
		["looticon"] = {
			["y"] = -1,
			["x"] = 225,
			["w"] = 15,
			["h"] = 15,
		},
		["rangetext"] = {
			["y"] = 10,
			["x"] = 0,
			["fontsize"] = 10,
			["justifyH"] = "CENTER",
			["h"] = 10,
			["w"] = 95.5,
			["hide"] = true,
		},
		["auratimers"] = {
			["rows"] = 6,
			["w"] = 70,
			["cols"] = 2,
			["y"] = -52,
			["x"] = 0,
			["count"] = 12,
			["push"] = "v",
			["h"] = 13,
			["growth"] = "TBLR",
			["hide"] = true,
		},
		["text4"] = {
			["pattern"] = "[solid_if_mp99:percmp][solid_if_mp99:%][solid_if_mp99: || ][solid_if_mp99:curmp]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 140,
			["y"] = -65,
			["h"] = 21,
			["fontsize"] = 8,
			["font"] = "Russel Square",
			["justifyV"] = "CENTER",
			["justifyH"] = "LEFT",
			["x"] = 165,
			["hide"] = true,
		},
		["raidtargeticon"] = {
			["y"] = -5,
			["x"] = 40,
			["w"] = 30,
			["h"] = 30,
		},
		["frame"] = {
			["y"] = -35,
			["h"] = 115,
			["scale"] = 1,
			["fasthp"] = true,
			["w"] = 425,
			["x"] = 680,
		},
		["inspectbutton"] = {
			["y"] = -49,
			["x"] = 376,
			["w"] = 18,
			["h"] = 19,
		},
		["statusicon"] = {
			["y"] = -86,
			["x"] = 18,
			["w"] = 14,
			["h"] = 14,
		},
	},
	["arena3target"] = {
		["frame"] = {
			["y"] = -450,
			["h"] = 24,
			["x"] = 1268,
			["w"] = 78,
			["hide"] = true,
		},
	},
	["arena2"] = {
		["frame"] = {
			["y"] = -403,
			["h"] = 24,
			["x"] = 1189,
			["w"] = 78,
			["hide"] = true,
		},
	},
	["focus"] = {
		["buffgroup"] = {
			["rows"] = 1,
			["growth"] = "LRTB",
			["cols"] = 8,
			["y"] = -24,
			["h"] = 10,
			["count"] = 8,
			["w"] = 10,
			["x"] = 0,
			["hide"] = true,
		},
		["portrait"] = {
			["y"] = -9,
			["x"] = 24,
			["w"] = 25,
			["h"] = 25,
		},
		["text3"] = {
			["pattern"] = "[perchp]% [solid_if_hp99:deficithp]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["justifyV"] = "CENTER",
			["y"] = -22,
			["h"] = 10,
			["justifyH"] = "CENTER",
			["font"] = "Emblem",
			["x"] = 62,
			["w"] = 99,
			["fontsize"] = 10,
		},
		["infoicon"] = {
			["y"] = 0,
			["x"] = 0,
			["h"] = 12,
			["w"] = 12,
			["hide"] = true,
		},
		["debuffgroup"] = {
			["rows"] = 1,
			["w"] = 10,
			["cols"] = 8,
			["y"] = -24,
			["x"] = 0,
			["count"] = 8,
			["push"] = "v",
			["h"] = 10,
			["growth"] = "LRTB",
			["hide"] = true,
		},
		["incomingbar"] = {
			["bgcolor"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["bordercolor"] = {
				["a"] = 0,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["w"] = 99,
			["framelevel"] = 1,
			["y"] = -24,
			["h"] = 6,
			["border"] = "Square Outline",
			["x"] = 61,
			["merge"] = true,
		},
		["text1"] = {
			["pattern"] = "[reaction:name]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 54,
			["y"] = -6,
			["x"] = 62,
			["fontsize"] = 12,
			["h"] = 12,
			["justifyH"] = "LEFT",
			["justifyV"] = "TOP",
		},
		["text2"] = {
			["pattern"] = "[difficulty:level]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 108,
			["y"] = -16,
			["x"] = -44,
			["fontsize"] = 9,
			["font"] = "Accidental Presidency",
			["justifyV"] = "CENTER",
			["h"] = 10,
			["justifyH"] = "CENTER",
		},
		["castbar"] = {
			["spellfontsize"] = 1,
			["spellshadowy"] = -1,
			["timeshadowy"] = -1,
			["spelljustifyH"] = "CENTER",
			["iconw"] = 20,
			["h"] = 16,
			["timefontsize"] = 12,
			["timeh"] = 12,
			["spellfontcolor"] = {
				["a"] = 0,
				["b"] = 0.2,
				["g"] = 0.502,
				["r"] = 1,
			},
			["w"] = 99,
			["spelljustifyV"] = "CENTER",
			["spelly"] = -26,
			["x"] = 61,
			["iconalpha"] = 0,
			["timejustifyV"] = "CENTER",
			["spellw"] = 0,
			["baralpha"] = 0,
			["spellh"] = 0,
			["iconh"] = 20,
			["spellx"] = 0,
			["timey"] = -39,
			["timeshadowx"] = -1,
			["sparkcolor"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["alpha"] = 1,
			["bgcolor"] = {
				["a"] = 0.06,
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["timefontcolor"] = {
				["a"] = 0,
				["b"] = 0.2,
				["g"] = 0.5,
				["r"] = 1,
			},
			["y"] = -24,
			["timew"] = 191,
			["spellshadowx"] = -1,
			["timejustifyH"] = "CENTER",
			["icony"] = -27,
			["timex"] = 0,
			["iconx"] = 85,
		},
		["comboframe"] = {
			["y"] = -16,
			["x"] = 0,
			["color"] = {
				["a"] = 1,
				["r"] = 0.7,
				["g"] = 0,
				["b"] = 0,
			},
			["glowcolor"] = {
				["a"] = 0.8,
				["r"] = 1,
				["g"] = 1,
				["b"] = 0,
			},
			["h"] = 15,
			["w"] = 25,
			["hide"] = true,
		},
		["text4"] = {
			["onmouse"] = true,
			["pattern"] = "[solid_if_mp99:percmp][solid_if_mp99:%]",
			["w"] = 54,
			["y"] = -32,
			["x"] = 105,
			["fontsize"] = 10,
			["font"] = "Blue Highway",
			["justifyV"] = "CENTER",
			["h"] = 10,
			["justifyH"] = "RIGHT",
		},
		["pvpicon"] = {
			["y"] = -5,
			["x"] = -8,
			["h"] = 16,
			["w"] = 16,
			["hide"] = true,
		},
		["hpbar"] = {
			["baralpha"] = 1,
			["bgcolor"] = {
				["a"] = 0,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["bartexture"] = "StatusBar-HP",
			["bgalpha"] = 0,
			["w"] = 99,
			["fade"] = true,
			["y"] = -24,
			["h"] = 6,
			["bgcolormethod"] = "solid",
			["barcolormethod"] = "solid",
			["framelevel"] = 1,
			["barcolor"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["bordercolor"] = {
				["a"] = 0,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["x"] = 61,
		},
		["mpbar"] = {
			["baralpha"] = 1,
			["bgcolor"] = {
				["a"] = 0,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["bartexture"] = "StatusBar-MP",
			["bgalpha"] = 0,
			["w"] = 99,
			["framelevel"] = 2,
			["y"] = -33,
			["x"] = 61,
			["bordercolor"] = {
				["a"] = 0,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["barcolormethod"] = "solid",
			["barcolor"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["bgcolormethod"] = "solid",
			["hflip"] = true,
			["h"] = 6,
		},
		["rangetext"] = {
			["y"] = 10,
			["x"] = 0,
			["fontsize"] = 10,
			["justifyH"] = "CENTER",
			["h"] = 10,
			["w"] = 39,
			["hide"] = true,
		},
		["auratimers"] = {
			["rows"] = 4,
			["w"] = 50,
			["cols"] = 1,
			["y"] = -24,
			["x"] = 0,
			["count"] = 4,
			["push"] = "v",
			["h"] = 12,
			["growth"] = "TBLR",
			["hide"] = true,
		},
		["dispellicon"] = {
			["y"] = -1,
			["x"] = 57,
			["h"] = 22,
			["w"] = 22,
			["hide"] = true,
		},
		["raidtargeticon"] = {
			["y"] = 15,
			["x"] = 27,
			["w"] = 20,
			["h"] = 20,
		},
		["frame"] = {
			["y"] = -150,
			["h"] = 44,
			["scale"] = 1.2,
			["fasthp"] = true,
			["w"] = 165,
			["x"] = 400,
		},
		["threatbar"] = {
			["y"] = 12,
			["x"] = 10,
			["bgcolor"] = {
				["a"] = 0.4,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["h"] = 12,
			["w"] = 32,
			["hide"] = true,
		},
		["statusicon"] = {
			["y"] = -15,
			["x"] = 2,
			["h"] = 15,
			["w"] = 15,
			["hide"] = true,
		},
	},
	["party1"] = {
		["buffgroup"] = {
			["y"] = -40,
			["x"] = 28,
			["count"] = 12,
			["h"] = 12,
			["rows"] = 1,
			["w"] = 12,
			["cols"] = 12,
		},
		["portrait"] = {
			["y"] = -1,
			["x"] = 1,
			["bgcolor"] = {
				["a"] = 0.4,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["show3d"] = true,
			["h"] = 36,
			["bg"] = "Flat Smooth",
			["w"] = 36,
		},
		["combattext"] = {
			["y"] = 1,
			["x"] = -1,
			["fontsize"] = 10,
			["h"] = 12,
			["w"] = 40,
			["justifyV"] = "TOP",
			["justifyH"] = "CENTER",
		},
		["text3"] = {
			["y"] = -10,
			["x"] = 37,
			["pattern"] = "[perchp]%[nl][curhp]/[maxhp]",
			["h"] = 17,
			["w"] = 108,
			["fontsize"] = 8,
			["justifyV"] = "BOTTOM",
			["justifyH"] = "RIGHT",
		},
		["infoicon"] = {
			["y"] = -28,
			["x"] = 37,
			["w"] = 9,
			["h"] = 9,
		},
		["debuffgroup"] = {
			["y"] = -14,
			["x"] = 147,
			["count"] = 8,
			["h"] = 12,
			["w"] = 12,
			["rows"] = 2,
			["growth"] = "TBLR",
			["cols"] = 4,
		},
		["incomingbar"] = {
			["y"] = -2,
			["x"] = 37,
			["w"] = 108,
			["h"] = 25,
		},
		["text6"] = {
			["y"] = -22,
			["x"] = 1,
			["pattern"] = "[gray_if_oor:OOR ][gray_if_dead:DEAD][gray_if_ghost:GHOST][gray_if_offline: OFFLINE]",
			["h"] = 10,
			["w"] = 145,
			["fontsize"] = 10,
			["justifyV"] = "CENTER",
			["justifyH"] = "CENTER",
		},
		["text1"] = {
			["pattern"] = "[name]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 108,
			["y"] = 0,
			["x"] = 37,
			["fontsize"] = 12,
			["h"] = 12,
			["justifyH"] = "LEFT",
			["justifyV"] = "TOP",
		},
		["voiceicon"] = {
			["y"] = 7,
			["x"] = -7,
			["w"] = 16,
			["h"] = 16,
		},
		["text2"] = {
			["pattern"] = "[level] [class:race]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 108,
			["y"] = -10,
			["x"] = 37,
			["fontsize"] = 10,
			["h"] = 10,
			["justifyH"] = "LEFT",
			["justifyV"] = "TOP",
		},
		["lfgicon"] = {
			["h"] = 14,
			["alpha"] = 0.6,
			["w"] = 14,
		},
		["castbar"] = {
			["baralpha"] = 0,
			["spellfontsize"] = 12,
			["bgcolor"] = {
				["a"] = 0.2,
				["r"] = 1,
				["g"] = 1,
				["b"] = 0,
			},
			["spellh"] = 12,
			["spelljustifyH"] = "CENTER",
			["alpha"] = 1,
			["iconh"] = 12,
			["iconw"] = 12,
			["h"] = 38,
			["spelljustifyV"] = "CENTER",
			["spellw"] = 147,
			["iconhide"] = true,
			["timefontsize"] = 10,
			["timejustifyH"] = "CENTER",
			["hide"] = true,
			["spellshadowx"] = -1,
			["timew"] = 147,
			["spellx"] = 0,
			["timey"] = -30,
			["timeh"] = 10,
			["spellfontcolor"] = {
				["a"] = 0.7,
				["r"] = 1,
				["g"] = 0.5,
				["b"] = 0.2,
			},
			["w"] = 147,
			["icony"] = -26,
			["y"] = 1,
			["x"] = -1,
			["spelly"] = -18,
			["iconx"] = 62,
			["timejustifyV"] = "CENTER",
			["timefontcolor"] = {
				["a"] = 0,
				["r"] = 1,
				["g"] = 0.5,
				["b"] = 0.2,
			},
			["timex"] = 0,
			["spellshadowy"] = -1,
		},
		["text5"] = {
			["pattern"] = "[percmp]%",
			["w"] = 140,
			["y"] = -36,
			["x"] = 63,
			["fontsize"] = 10,
			["justifyV"] = "BOTTOM",
			["h"] = 10,
			["justifyH"] = "RIGHT",
			["hide"] = true,
		},
		["leadericon"] = {
			["y"] = -31,
			["x"] = 6,
			["w"] = 10,
			["h"] = 10,
		},
		["pvpicon"] = {
			["y"] = -9,
			["x"] = -12,
			["w"] = 23,
			["h"] = 23,
		},
		["text4"] = {
			["y"] = -28,
			["x"] = 49,
			["pattern"] = "[curmp]/[maxmp]",
			["h"] = 8,
			["w"] = 96,
			["fontsize"] = 8,
			["justifyV"] = "CENTER",
			["justifyH"] = "RIGHT",
		},
		["dispellicon"] = {
			["y"] = -4,
			["x"] = 112,
			["w"] = 34,
			["h"] = 34,
		},
		["mpbar"] = {
			["y"] = -28,
			["x"] = 48,
			["barcolormethod"] = "power",
			["h"] = 8,
			["bgalpha"] = 0.3,
			["w"] = 97,
			["bgcolormethod"] = "powerdark",
		},
		["looticon"] = {
			["y"] = -31,
			["x"] = 15,
			["w"] = 10,
			["h"] = 10,
		},
		["hpbar"] = {
			["y"] = -2,
			["x"] = 37,
			["bgcolormethod"] = "hpgreendark",
			["barcolormethod"] = "hpthreshold",
			["h"] = 25,
			["bgalpha"] = 0.3,
			["w"] = 108,
			["fade"] = true,
		},
		["raidtargeticon"] = {
			["y"] = 7,
			["x"] = 30,
			["h"] = 14,
			["w"] = 14,
			["hide"] = true,
		},
		["frame"] = {
			["y"] = -145,
			["h"] = 38,
			["x"] = 16,
			["w"] = 145,
			["hide"] = true,
		},
		["vehicleicon"] = {
			["hide"] = true,
		},
		["statusicon"] = {
			["y"] = -31,
			["x"] = -7,
			["w"] = 12,
			["h"] = 12,
		},
	},
	["party4"] = {
		["frame"] = {
			["y"] = -325,
			["x"] = 16,
			["hide"] = true,
		},
	},
	["arena5"] = {
		["frame"] = {
			["y"] = -544,
			["h"] = 24,
			["x"] = 1189,
			["w"] = 78,
			["hide"] = true,
		},
	},
	["arena4"] = {
		["frame"] = {
			["y"] = -497,
			["h"] = 24,
			["x"] = 1189,
			["w"] = 78,
			["hide"] = true,
		},
	},
	["partypet3"] = {
		["frame"] = {
			["y"] = -305,
			["x"] = 7,
			["hide"] = true,
		},
	},
	["party4target"] = {
		["frame"] = {
			["y"] = -325,
			["x"] = 162,
			["hide"] = true,
		},
	},
	["arenapet3"] = {
		["frame"] = {
			["y"] = -462,
			["h"] = 24,
			["x"] = 1152,
			["w"] = 78,
			["hide"] = true,
		},
	},
	["focustarget"] = {
		["text2"] = {
			["pattern"] = "[difficulty:level]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 108,
			["y"] = -16,
			["font"] = "Accidental Presidency",
			["fontsize"] = 9,
			["x"] = -44,
			["justifyH"] = "CENTER",
			["h"] = 10,
			["justifyV"] = "CENTER",
			["hide"] = true,
		},
		["portrait"] = {
			["y"] = -3,
			["h"] = 17,
			["w"] = 17,
			["x"] = 66,
		},
		["text3"] = {
			["pattern"] = "[solid_if_hp99:perchp][solid_if_hp99:%]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["justifyV"] = "CENTER",
			["y"] = -4,
			["font"] = "Emblem",
			["justifyH"] = "CENTER",
			["fontsize"] = 10,
			["w"] = 57,
			["x"] = 6,
			["h"] = 10,
		},
		["infoicon"] = {
			["y"] = 0,
			["x"] = 0,
			["h"] = 12,
			["w"] = 12,
			["hide"] = true,
		},
		["debuffgroup"] = {
			["rows"] = 1,
			["w"] = 6,
			["cols"] = 6,
			["y"] = -12,
			["x"] = 0,
			["count"] = 6,
			["push"] = "v",
			["h"] = 6,
			["hide"] = true,
		},
		["mpbar"] = {
			["baralpha"] = 1,
			["bordercolor"] = {
				["a"] = 0,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["bgcolor"] = {
				["a"] = 0,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["bartexture"] = "StatusBar-MP",
			["vflip"] = true,
			["barcolor"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["w"] = 57,
			["framelevel"] = 2,
			["y"] = -12,
			["h"] = 3,
			["bgalpha"] = 0,
			["barcolormethod"] = "solid",
			["fade"] = true,
			["x"] = 6,
			["bgcolormethod"] = "solid",
			["hflip"] = true,
		},
		["hpbar"] = {
			["baralpha"] = 1,
			["hflip"] = true,
			["bgcolor"] = {
				["a"] = 0,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["bartexture"] = "StatusBar-HP",
			["vflip"] = true,
			["bgalpha"] = 0,
			["w"] = 57,
			["bgcolormethod"] = "solid",
			["y"] = -4,
			["x"] = 6,
			["reverse"] = true,
			["barcolormethod"] = "solid",
			["framelevel"] = 1,
			["bordercolor"] = {
				["a"] = 0,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["h"] = 6,
			["barcolor"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
		},
		["text4"] = {
			["y"] = 0,
			["x"] = 0,
			["pattern"] = "",
			["fontsize"] = 10,
			["h"] = 10,
			["w"] = 10,
			["hide"] = true,
		},
		["raidtargeticon"] = {
			["y"] = 10,
			["x"] = 4,
			["w"] = 12,
			["h"] = 12,
		},
		["frame"] = {
			["y"] = -185,
			["h"] = 25,
			["scale"] = 1,
			["x"] = 610,
			["w"] = 85,
			["fasthp"] = true,
		},
		["text1"] = {
			["onmouse"] = true,
			["pattern"] = "[reaction:name]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 175,
			["framelevel"] = 0,
			["y"] = -5,
			["h"] = 12,
			["fontsize"] = 12,
			["x"] = 85,
			["justifyV"] = "TOP",
			["justifyH"] = "LEFT",
		},
		["buffgroup"] = {
			["y"] = -12,
			["x"] = 0,
			["count"] = 6,
			["hide"] = true,
			["h"] = 6,
			["rows"] = 1,
			["w"] = 6,
			["cols"] = 6,
		},
	},
	["pettarget"] = {
		["text2"] = {
			["pattern"] = "[difficulty:level]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 108,
			["y"] = -16,
			["x"] = -44,
			["fontsize"] = 9,
			["font"] = "Accidental Presidency",
			["justifyV"] = "CENTER",
			["h"] = 10,
			["justifyH"] = "CENTER",
			["hide"] = true,
		},
		["portrait"] = {
			["y"] = -3,
			["x"] = 66,
			["w"] = 17,
			["h"] = 17,
		},
		["text3"] = {
			["pattern"] = "[solid_if_hp99:perchp][solid_if_hp99:%]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["justifyV"] = "CENTER",
			["y"] = -4,
			["font"] = "Emblem",
			["fontsize"] = 10,
			["h"] = 10,
			["x"] = 6,
			["w"] = 57,
			["justifyH"] = "CENTER",
		},
		["infoicon"] = {
			["y"] = 0,
			["x"] = 0,
			["h"] = 12,
			["w"] = 12,
			["hide"] = true,
		},
		["debuffgroup"] = {
			["rows"] = 1,
			["w"] = 6,
			["cols"] = 6,
			["y"] = -12,
			["x"] = 0,
			["count"] = 6,
			["push"] = "v",
			["h"] = 6,
			["hide"] = true,
		},
		["mpbar"] = {
			["baralpha"] = 1,
			["hflip"] = true,
			["bgcolor"] = {
				["a"] = 0,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["bartexture"] = "StatusBar-MP",
			["bgcolormethod"] = "solid",
			["bordercolor"] = {
				["a"] = 0,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["w"] = 57,
			["framelevel"] = 2,
			["y"] = -12,
			["vflip"] = true,
			["x"] = 6,
			["barcolormethod"] = "solid",
			["fade"] = true,
			["bgalpha"] = 0,
			["h"] = 3,
			["barcolor"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
		},
		["hpbar"] = {
			["baralpha"] = 1,
			["barcolor"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["bgcolor"] = {
				["a"] = 0,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["bartexture"] = "StatusBar-HP",
			["h"] = 6,
			["bgalpha"] = 0,
			["w"] = 57,
			["hflip"] = true,
			["y"] = -4,
			["vflip"] = true,
			["bordercolor"] = {
				["a"] = 0,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["reverse"] = true,
			["framelevel"] = 1,
			["barcolormethod"] = "solid",
			["x"] = 6,
			["bgcolormethod"] = "solid",
		},
		["text4"] = {
			["y"] = 0,
			["x"] = 0,
			["pattern"] = "",
			["fontsize"] = 10,
			["h"] = 10,
			["w"] = 10,
			["hide"] = true,
		},
		["raidtargeticon"] = {
			["y"] = 10,
			["x"] = 4,
			["w"] = 12,
			["h"] = 12,
		},
		["frame"] = {
			["y"] = -245,
			["x"] = 610,
			["scale"] = 1,
			["fasthp"] = true,
			["w"] = 85,
			["h"] = 25,
		},
		["text1"] = {
			["onmouse"] = true,
			["pattern"] = "[reaction:name]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 175,
			["framelevel"] = 0,
			["y"] = -5,
			["x"] = 85,
			["fontsize"] = 12,
			["justifyV"] = "TOP",
			["h"] = 12,
			["justifyH"] = "LEFT",
		},
		["buffgroup"] = {
			["y"] = -12,
			["x"] = 0,
			["count"] = 6,
			["hide"] = true,
			["h"] = 6,
			["rows"] = 1,
			["w"] = 6,
			["cols"] = 6,
		},
	},
	["boss2target"] = {
		["frame"] = {
			["y"] = -403,
			["h"] = 24,
			["x"] = 1268,
			["w"] = 78,
			["hide"] = true,
		},
	},
	["targettarget"] = {
		["text2"] = {
			["pattern"] = "[level]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 60,
			["framelevel"] = 32,
			["y"] = -17,
			["x"] = 180,
			["fontsize"] = 10,
			["h"] = 19,
			["justifyH"] = "LEFT",
			["justifyV"] = "TOP",
		},
		["dispellicon"] = {
			["y"] = -1,
			["x"] = 54,
			["h"] = 22,
			["w"] = 22,
			["hide"] = true,
		},
		["portrait"] = {
			["y"] = -5,
			["x"] = 139,
			["h"] = 32,
			["w"] = 32,
			["framelevel"] = 32,
		},
		["hpbar"] = {
			["bartexture"] = "StatusBar-HP",
			["bgalpha"] = 0,
			["w"] = 120,
			["bgcolormethod"] = "hpgreen",
			["y"] = -19,
			["h"] = 9,
			["reverse"] = true,
			["barcolormethod"] = "solid",
			["x"] = 9,
			["fade"] = true,
			["smoothfade"] = true,
			["framelevel"] = 32,
		},
		["pvpicon"] = {
			["y"] = -5,
			["x"] = -8,
			["h"] = 16,
			["w"] = 16,
			["hide"] = true,
		},
		["text3"] = {
			["onmouse"] = true,
			["pattern"] = "[curhp]/[maxhp]",
			["justifyV"] = "CENTER",
			["framelevel"] = 32,
			["y"] = -17,
			["h"] = 11,
			["justifyH"] = "CENTER",
			["x"] = 10,
			["w"] = 120,
			["fontsize"] = 10,
		},
		["infoicon"] = {
			["y"] = 0,
			["x"] = 0,
			["h"] = 12,
			["w"] = 12,
			["hide"] = true,
		},
		["debuffgroup"] = {
			["rows"] = 1,
			["w"] = 10,
			["cols"] = 8,
			["y"] = -24,
			["h"] = 10,
			["count"] = 8,
			["push"] = "v",
			["x"] = 0,
			["hide"] = true,
		},
		["mpbar"] = {
			["bgalpha"] = 0.3,
			["w"] = 53,
			["bgcolormethod"] = "powerdark",
			["y"] = -18,
			["h"] = 5,
			["barcolormethod"] = "power",
			["framelevel"] = 1,
			["x"] = 25,
			["hide"] = true,
		},
		["incomingbar"] = {
			["y"] = -19,
			["h"] = 9,
			["reverse"] = true,
			["framelevel"] = 32,
			["x"] = 9,
			["w"] = 120,
			["merge"] = true,
		},
		["buffgroup"] = {
			["y"] = -24,
			["x"] = 0,
			["count"] = 8,
			["cols"] = 8,
			["h"] = 10,
			["rows"] = 1,
			["w"] = 10,
			["hide"] = true,
		},
		["text4"] = {
			["pattern"] = "[curmp]/[maxmp]",
			["w"] = 54,
			["framelevel"] = 1,
			["y"] = -24,
			["x"] = 25,
			["fontsize"] = 10,
			["justifyV"] = "CENTER",
			["h"] = 10,
			["justifyH"] = "RIGHT",
			["hide"] = true,
		},
		["raidtargeticon"] = {
			["y"] = 5,
			["h"] = 15,
			["x"] = 148,
			["w"] = 15,
			["framelevel"] = 32,
		},
		["frame"] = {
			["fasthp"] = true,
			["x"] = 962,
			["scale"] = 1,
			["y"] = -100,
			["w"] = 200,
			["h"] = 45,
		},
		["text1"] = {
			["bgcolor"] = {
				["a"] = 0,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["pattern"] = "[reaction:name]",
			["justifyV"] = "CENTER",
			["shadowx"] = -1,
			["bordercolor"] = {
				["a"] = 0,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["w"] = 110,
			["framelevel"] = 32,
			["y"] = 2,
			["x"] = 0,
			["fontsize"] = 12,
			["justifyH"] = "CENTER",
			["border"] = "None",
			["h"] = 12,
			["bg"] = "Outline",
			["shadowy"] = -1,
		},
		["statusicon"] = {
			["y"] = -20,
			["x"] = -6,
			["framelevel"] = 1,
			["h"] = 10,
			["w"] = 10,
			["hide"] = true,
		},
	},
	["arena5target"] = {
		["frame"] = {
			["y"] = -544,
			["h"] = 24,
			["x"] = 1268,
			["w"] = 78,
			["hide"] = true,
		},
	},
	["partypet4"] = {
		["frame"] = {
			["y"] = -365,
			["x"] = 7,
			["hide"] = true,
		},
	},
	["arena1target"] = {
		["text2"] = {
			["y"] = -11,
			["x"] = 1,
			["pattern"] = "",
			["h"] = 10,
			["w"] = 108,
			["hide"] = true,
		},
		["portrait"] = {
			["y"] = 0,
			["x"] = 55,
			["w"] = 24,
			["h"] = 24,
		},
		["text3"] = {
			["y"] = -13,
			["x"] = 1,
			["pattern"] = "[perchp]%",
			["h"] = 10,
			["w"] = 54,
			["fontsize"] = 10,
			["justifyV"] = "CENTER",
			["justifyH"] = "CENTER",
		},
		["infoicon"] = {
			["y"] = 0,
			["x"] = 0,
			["h"] = 12,
			["w"] = 12,
			["hide"] = true,
		},
		["debuffgroup"] = {
			["rows"] = 1,
			["w"] = 10,
			["cols"] = 8,
			["y"] = -23,
			["x"] = 0,
			["count"] = 8,
			["push"] = "v",
			["h"] = 10,
			["growth"] = "LRTB",
			["hide"] = true,
		},
		["mpbar"] = {
			["y"] = -19,
			["x"] = 1,
			["h"] = 5,
			["barcolormethod"] = "power",
			["reverse"] = true,
			["bgalpha"] = 0.3,
			["w"] = 53,
			["bgcolormethod"] = "powerdark",
		},
		["hpbar"] = {
			["y"] = -1,
			["x"] = 1,
			["h"] = 17,
			["barcolormethod"] = "hpgreen",
			["reverse"] = true,
			["bgalpha"] = 0.3,
			["w"] = 53,
			["bgcolormethod"] = "hpgreendark",
		},
		["text4"] = {
			["y"] = -24,
			["x"] = 1,
			["pattern"] = "",
			["h"] = 10,
			["w"] = 54,
			["hide"] = true,
		},
		["frame"] = {
			["y"] = -356,
			["h"] = 24,
			["x"] = 1268,
			["w"] = 78,
			["hide"] = true,
		},
		["text1"] = {
			["pattern"] = "[reaction:*][class:name]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 54,
			["y"] = 0,
			["x"] = 1,
			["fontsize"] = 12,
			["h"] = 12,
			["justifyH"] = "RIGHT",
			["justifyV"] = "TOP",
		},
		["buffgroup"] = {
			["rows"] = 1,
			["w"] = 10,
			["cols"] = 8,
			["y"] = -24,
			["x"] = 0,
			["count"] = 8,
			["growth"] = "LRTB",
			["h"] = 10,
			["hide"] = true,
		},
	},
	["boss1target"] = {
		["text2"] = {
			["y"] = -11,
			["x"] = 1,
			["pattern"] = "",
			["h"] = 10,
			["w"] = 108,
			["hide"] = true,
		},
		["portrait"] = {
			["y"] = 0,
			["x"] = 55,
			["w"] = 24,
			["h"] = 24,
		},
		["text3"] = {
			["y"] = -13,
			["x"] = 1,
			["pattern"] = "[perchp]%",
			["h"] = 10,
			["w"] = 54,
			["fontsize"] = 10,
			["justifyV"] = "CENTER",
			["justifyH"] = "CENTER",
		},
		["infoicon"] = {
			["y"] = 0,
			["x"] = 0,
			["h"] = 12,
			["w"] = 12,
			["hide"] = true,
		},
		["debuffgroup"] = {
			["rows"] = 1,
			["w"] = 10,
			["cols"] = 8,
			["y"] = -23,
			["x"] = 0,
			["count"] = 8,
			["push"] = "v",
			["h"] = 10,
			["growth"] = "LRTB",
			["hide"] = true,
		},
		["mpbar"] = {
			["y"] = -19,
			["x"] = 1,
			["h"] = 5,
			["barcolormethod"] = "power",
			["reverse"] = true,
			["bgalpha"] = 0.3,
			["w"] = 53,
			["bgcolormethod"] = "powerdark",
		},
		["hpbar"] = {
			["y"] = -1,
			["x"] = 1,
			["h"] = 17,
			["barcolormethod"] = "hpgreen",
			["reverse"] = true,
			["bgalpha"] = 0.3,
			["w"] = 53,
			["bgcolormethod"] = "hpgreendark",
		},
		["buffgroup"] = {
			["rows"] = 1,
			["w"] = 10,
			["cols"] = 8,
			["y"] = -24,
			["x"] = 0,
			["count"] = 8,
			["growth"] = "LRTB",
			["h"] = 10,
			["hide"] = true,
		},
		["raidtargeticon"] = {
			["y"] = 7,
			["x"] = 4,
			["h"] = 12,
			["w"] = 12,
			["hide"] = true,
		},
		["frame"] = {
			["y"] = -356,
			["h"] = 24,
			["x"] = 1780,
			["w"] = 78,
			["hide"] = true,
		},
		["text1"] = {
			["pattern"] = "[class:name]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 54,
			["y"] = 0,
			["x"] = 1,
			["fontsize"] = 12,
			["h"] = 12,
			["justifyH"] = "RIGHT",
			["justifyV"] = "TOP",
		},
		["text4"] = {
			["y"] = -24,
			["x"] = 1,
			["pattern"] = "",
			["h"] = 10,
			["w"] = 54,
			["hide"] = true,
		},
	},
	["boss3"] = {
		["frame"] = {
			["y"] = -294,
			["h"] = 24,
			["w"] = 78,
			["x"] = 1165,
		},
	},
	["boss1"] = {
		["text2"] = {
			["pattern"] = "[reaction:*]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 20,
			["framelevel"] = 3,
			["y"] = 4,
			["x"] = -4,
			["fontsize"] = 16,
			["justifyV"] = "CENTER",
			["h"] = 20,
			["justifyH"] = "CENTER",
			["hide"] = true,
		},
		["portrait"] = {
			["bgcolor"] = {
				["a"] = 0.4,
				["b"] = 0.243,
				["g"] = 0.243,
				["r"] = 0.243,
			},
			["show3d"] = true,
			["bordercolor"] = {
				["a"] = 0,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["w"] = 100,
			["y"] = -50,
			["h"] = 48,
			["camera"] = 0,
			["x"] = 0,
			["bg"] = "fer14",
			["hide"] = true,
		},
		["castbar"] = {
			["spellfontsize"] = 14,
			["bgcolor"] = {
				["a"] = 0.2,
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["timeshadowy"] = -1,
			["spelljustifyH"] = "CENTER",
			["iconw"] = 20,
			["h"] = 52,
			["timefontsize"] = 12,
			["timeh"] = 12,
			["spellfontcolor"] = {
				["a"] = 0.7,
				["b"] = 0.2,
				["g"] = 0.5,
				["r"] = 1,
			},
			["w"] = 193,
			["spelljustifyV"] = "CENTER",
			["spelly"] = -26,
			["x"] = -1,
			["iconalpha"] = 0,
			["timejustifyV"] = "CENTER",
			["timefontcolor"] = {
				["a"] = 0,
				["b"] = 0.2,
				["g"] = 0.5,
				["r"] = 1,
			},
			["baralpha"] = 0,
			["spellh"] = 14,
			["iconh"] = 20,
			["hide"] = true,
			["spellx"] = 0,
			["timey"] = -36,
			["timeshadowx"] = -1,
			["alpha"] = 1,
			["iconx"] = 85,
			["spellshadowy"] = -1,
			["spellw"] = 193,
			["timew"] = 193,
			["spellshadowx"] = -1,
			["timejustifyH"] = "CENTER",
			["icony"] = -27,
			["timex"] = 0,
			["y"] = 1,
		},
		["text3"] = {
			["pattern"] = "[perchp]%[nl][solid_if_hp99:deficithp]",
			["justifyV"] = "CENTER",
			["y"] = -5,
			["font"] = "Liberation Sans (U)",
			["justifyH"] = "RIGHT",
			["x"] = 5,
			["w"] = 125,
			["h"] = 20,
			["fontsize"] = 8,
		},
		["infoicon"] = {
			["y"] = -37,
			["x"] = 50,
			["h"] = 12,
			["w"] = 12,
			["hide"] = true,
		},
		["debuffgroup"] = {
			["rows"] = 1,
			["w"] = 25,
			["cols"] = 9,
			["y"] = 28,
			["push"] = "v",
			["count"] = 9,
			["spacing"] = 5,
			["x"] = 1,
			["h"] = 25,
			["growth"] = "LRTB",
			["hide"] = true,
		},
		["threatbar"] = {
			["y"] = 12,
			["x"] = 10,
			["bgcolor"] = {
				["a"] = 0.4,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["h"] = 12,
			["w"] = 32,
			["hide"] = true,
		},
		["mpbar"] = {
			["bartexture"] = "cabaret3",
			["bgalpha"] = 0.3,
			["w"] = 125,
			["bgcolormethod"] = "powerdark",
			["hidemanatick"] = true,
			["h"] = 8,
			["barcolormethod"] = "power",
			["y"] = -28,
			["x"] = 5,
		},
		["text4"] = {
			["pattern"] = "[solid_if_mp99:deficitmp]",
			["w"] = 120,
			["y"] = -28,
			["x"] = 5,
			["fontsize"] = 10,
			["justifyV"] = "CENTER",
			["h"] = 8,
			["font"] = "Russel Square",
			["justifyH"] = "RIGHT",
		},
		["buffgroup"] = {
			["y"] = -52,
			["h"] = 17,
			["count"] = 32,
			["cols"] = 16,
			["x"] = 0,
			["rows"] = 2,
			["w"] = 17,
			["hide"] = true,
		},
		["raidtargeticon"] = {
			["y"] = 20,
			["h"] = 35,
			["x"] = 50,
			["w"] = 35,
			["framelevel"] = 3,
		},
		["frame"] = {
			["y"] = -181,
			["h"] = 40,
			["fasthp"] = true,
			["bordercolor"] = {
				["a"] = 0,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["w"] = 135,
			["x"] = 1165,
		},
		["text1"] = {
			["pattern"] = "[reaction:name]",
			["shadowx"] = -1,
			["shadowy"] = -1,
			["w"] = 90,
			["framelevel"] = 2,
			["y"] = -5,
			["x"] = 5,
			["fontsize"] = 12,
			["justifyV"] = "CENTER",
			["justifyH"] = "CENTER",
			["h"] = 20,
			["bgcolor"] = {
				["a"] = 0,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["font"] = "Russel Square",
		},
		["hpbar"] = {
			["bartexture"] = "Charcoal",
			["bgalpha"] = 0.3,
			["w"] = 125,
			["bgcolormethod"] = "hpthresholddark",
			["y"] = -5,
			["h"] = 20,
			["barcolormethod"] = "class",
			["barcolor"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["x"] = 5,
			["fade"] = true,
		},
	},
	["party2"] = {
		["frame"] = {
			["y"] = -205,
			["x"] = 16,
			["hide"] = true,
		},
	},
	["arena3"] = {
		["frame"] = {
			["y"] = -450,
			["h"] = 24,
			["x"] = 1189,
			["w"] = 78,
			["hide"] = true,
		},
	},
	["boss4target"] = {
		["frame"] = {
			["y"] = -497,
			["h"] = 24,
			["x"] = 1268,
			["w"] = 78,
			["hide"] = true,
		},
	},
}
end

local SetTipTac = function()
if(TipTac_Config) then table.wipe(TipTac_Config) end

TipTac_Config = {
	["showUnitTip"] = true,
	["showRealm"] = "show",
	["colReactText4"] = "|cffffff00",
	["barHeight"] = 13,
	["manaBarColor"] = {
		0.3, -- [1]
		0.55, -- [2]
		0.9, -- [3]
		1, -- [4]
	},
	["anchorPoint"] = "BOTTOMRIGHT",
	["colReactBack1"] = {
		0.2, -- [1]
		0.2, -- [2]
		0.2, -- [3]
		1, -- [4]
	},
	["backdropEdgeSize"] = 16,
	["powerBar"] = false,
	["fontFlags"] = "",
	["showAuraCooldown"] = true,
	["colReactBack7"] = {
		0.05, -- [1]
		0.05, -- [2]
		0.05, -- [3]
		1, -- [4]
	},
	["showDebuffs"] = false,
	["powerBarText"] = "value",
	["colReactText1"] = "|cffc0c0c0",
	["healthBarClassColor"] = true,
	["barFontFlags"] = "OUTLINE",
	["classification_rare"] = "%s|r (Rare) ",
	["colReactBack2"] = {
		0.3, -- [1]
		0, -- [2]
		0, -- [3]
		1, -- [4]
	},
	["left"] = 1474.838009929113,
	["colReactText3"] = "|cffff7f00",
	["hideAllTipsInCombat"] = false,
	["iconSize"] = 20,
	["manaBar"] = false,
	["gradientColor"] = {
		0.8, -- [1]
		0.8, -- [2]
		0.8, -- [3]
		0.2, -- [4]
	},
	["fadeTime"] = 0.1,
	["targetYouText"] = "<<YOU>>",
	["showGuildRank"] = true,
	["itemQualityBorder"] = true,
	["gradientTip"] = false,
	["barFontSize"] = 12,
	["aurasAtBottom"] = false,
	["gttScale"] = 1,
	["colReactText5"] = "|cff00ff00",
	["optionsBottom"] = 642.2221825169531,
	["showIcon"] = true,
	["colReactText7"] = "|cff808080",
	["overrideFade"] = true,
	["colReactBack3"] = {
		0.3, -- [1]
		0.15, -- [2]
		0, -- [3]
		1, -- [4]
	},
	["preFadeTime"] = 0.1,
	["optionsLeft"] = 313.3334119628868,
	["pvpName"] = true,
	["reactText"] = true,
	["colReactText2"] = "|cffff0000",
	["hideWorldTips"] = true,
	["tipBackdropBG"] = "\\\\Interface\\AddOns\\Ferous Media\\StatusBars\\savant7.tga",
	["reactColoredBackdrop"] = false,
	["tipColor"] = {
		0.1019607843137255, -- [1]
		0.1019607843137255, -- [2]
		0.2, -- [3]
		0.8900000005960465, -- [4]
	},
	["hideDefaultBar"] = true,
	["healthBar"] = true,
	["colRace"] = "|cffffffff",
	["showTarget"] = "second",
	["mouseOffsetY"] = -24,
	["auraMaxRows"] = 2,
	["colLevel"] = "|cffc0c0c0",
	["colReactBack4"] = {
		0.3, -- [1]
		0.3, -- [2]
		0, -- [3]
		1, -- [4]
	},
	["colReactBack5"] = {
		0, -- [1]
		0.3, -- [2]
		0.1, -- [3]
		1, -- [4]
	},
	["iconAnchor"] = "TOPLEFT",
	["colReactText6"] = "|cff25c1eb",
	["tipBackdropEdge"] = "Interface\\AddOns\\Ferous Media\\Borders\\fer6.tga",
	["colSameGuild"] = "|cffff32ff",
	["mouseOffsetX"] = 32,
	["classification_elite"] = "+%s ",
	["iconCombat"] = true,
	["fontSize"] = 12,
	["classColoredBorder"] = true,
	["selfBuffsOnly"] = false,
	["anchorType"] = "normal",
	["anchorTypeUnit"] = "normal",
	["selfDebuffsOnly"] = false,
	["showTargetedBy"] = true,
	["showBuffs"] = false,
	["classification_rareelite"] = "+%s|r (Rare) ",
	["anchorWorldUnitPoint"] = "TOPLEFT",
	["healthBarText"] = "value",
	["classification_worldboss"] = "%s|r (Boss) ",
	["showStatus"] = true,
	["manaBarText"] = "value",
	["backdropInsets"] = 1.5,
	["showTalents"] = false,
	["colorNameByClass"] = true,
	["modifyFonts"] = true,
	["auraSize"] = 18,
	["anchorWorldUnitType"] = "mouse",
	["healthBarColor"] = {
		0.3, -- [1]
		0.9, -- [2]
		0.3, -- [3]
		1, -- [4]
	},
	["classification_normal"] = "%s ",
	["hideUFTipsInCombat"] = false,
	["fontFace"] = "Interface\\Addons\\Ferous Media\\Fonts\\russelsquare.ttf",
	["tipBorderColor"] = {
		0.3, -- [1]
		0.3, -- [2]
		0.4, -- [3]
		1, -- [4]
	},
	["top"] = 178.5909121995837,
	["hookTips"] = true,
	["colReactBack6"] = {
		0, -- [1]
		0, -- [2]
		0.5, -- [3]
		1, -- [4]
	},
	["updateFreq"] = 0.5,
	["anchorPointUnit"] = "BOTTOMRIGHT",
	["barFontFace"] = "Fonts\\FRIZQT__.TTF",
}
end

local SetVolumizer = function()
if(VolumizerPresets) then table.wipe(VolumizerPresets) end

VolumizerPresets = {
	{
		["name"] = "Vent",
		["values"] = {
			["emote"] = "1",
			["ambience"] = {
				["enable"] = "1",
				["volume"] = "0.5",
			},
			["loop"] = "1",
			["master"] = {
				["enable"] = "1",
				["volume"] = "0.20000000298023",
			},
			["background"] = "1",
			["sfx"] = {
				["enable"] = "1",
				["volume"] = "0.5",
			},
			["listener"] = "1",
			["music"] = {
				["enable"] = "1",
				["volume"] = "0.30000001192093",
			},
			["error"] = "0",
			["pet"] = "1",
		},
	}, -- [1]
	{
		["name"] = "Music",
		["values"] = {
			["emote"] = "1",
			["ambience"] = {
				["enable"] = "1",
				["volume"] = "1",
			},
			["loop"] = "0",
			["master"] = {
				["enable"] = "1",
				["volume"] = "0.80000001192093",
			},
			["background"] = "1",
			["sfx"] = {
				["enable"] = "1",
				["volume"] = "1",
			},
			["listener"] = "1",
			["music"] = {
				["enable"] = "0",
				["volume"] = "0.80000001192093",
			},
			["error"] = "0",
			["pet"] = "1",
		},
	}, -- [2]
	{
		["name"] = "Game-Only",
		["values"] = {
			["emote"] = "1",
			["ambience"] = {
				["enable"] = "1",
				["volume"] = "1",
			},
			["loop"] = "1",
			["master"] = {
				["enable"] = "1",
				["volume"] = "0.80000001192093",
			},
			["background"] = "1",
			["sfx"] = {
				["enable"] = "1",
				["volume"] = "0.30000001192093",
			},
			["listener"] = "1",
			["music"] = {
				["enable"] = "1",
				["volume"] = "0.30000001192093",
			},
			["error"] = "0",
			["pet"] = "1",
		},
	}, -- [3]
	{
		["name"] = "HalfnHalf",
		["values"] = {
			["emote"] = "1",
			["ambience"] = {
				["enable"] = "1",
				["volume"] = "0.80000001192093",
			},
			["loop"] = "1",
			["master"] = {
				["enable"] = "1",
				["volume"] = "0.60000002384186",
			},
			["background"] = "1",
			["sfx"] = {
				["enable"] = "1",
				["volume"] = "1",
			},
			["listener"] = "1",
			["music"] = {
				["enable"] = "1",
				["volume"] = "0.30000001192093",
			},
			["error"] = "0",
			["pet"] = "1",
		},
	}, -- [4]
	{
		["name"] = "Fishin'",
		["values"] = {
			["emote"] = "1",
			["ambience"] = {
				["enable"] = "0",
				["volume"] = "1",
			},
			["pet"] = "0",
			["loop"] = "0",
			["music"] = {
				["enable"] = "0",
				["volume"] = "0.30000001192093",
			},
			["sfx"] = {
				["enable"] = "1",
				["volume"] = "0.5",
			},
			["background"] = "1",
			["listener"] = "1",
			["error"] = "0",
			["master"] = {
				["enable"] = "1",
				["volume"] = "0.80000001192093",
			},
		},
	}, -- [5]
}
end

local SetacbFT = function()
if(FlightTimes_Data) then table.wipe(FlightTimes_Data) end

FlightTimes_Data = {
	["Valiance Keep, Borean Tundra / Dalaran"] = 285.1100000000151,
	["Orgrimmar, Durotar / Mudsprocket, Dustwallow Marsh"] = 266.5399999999791,
	["Shattrath, Terokkar Forest / Evergrove, Blade's Edge Mountains"] = 206.1969999999856,
	["Ebon Watch, Zul'Drak / Wyrmrest Temple, Dragonblight"] = 91.875,
	["The Argent Vanguard, Icecrown / Dalaran"] = 32.34000000002561,
	["Talonbranch Glade, Felwood / Everlook, Winterspring"] = 107.8280000000086,
	["Death's Rise, Icecrown / The Shadow Vault, Icecrown"] = 94.625,
	["Feathermoon, Feralas / Thalanaar, Feralas"] = 155.3029999999999,
	["New Agamand, Howling Fjord / Camp Winterhoof, Howling Fjord"] = 80.1929999999993,
	["Warsong Camp, Wintergrasp / Death's Rise, Icecrown"] = 162.1160000000091,
	["Kargath, Badlands / Grom'gol, Stranglethorn"] = 239.2280000000028,
	["Stonebreaker Hold, Terokkar Forest / Sanctum of the Stars, Shadowmoon Valley"] = 130.2790062334389,
	["Ironforge, Dun Morogh / Southshore, Hillsbrad"] = 215.9210000000021,
	["Wintergarde Keep, Dragonblight / Transitus Shield, Coldarra"] = 320.7970000000059,
	["Shattrath, Terokkar Forest / Telaar, Nagrand"] = 88.85899999999674,
	["Gadgetzan, Tanaris / Theramore, Dustwallow Marsh"] = 154.6559999999881,
	["Southshore, Hillsbrad / Menethil Harbor, Wetlands"] = 111.0309999999881,
	["Aerie Peak, The Hinterlands / Chillwind Camp, Western Plaguelands"] = 53.79899999999907,
	["Undercity, Tirisfal / Kargath, Badlands"] = 555.5540000000001,
	["Ratchet, The Barrens / Splintertree Post, Ashenvale"] = 231.2560000000012,
	["Crossroads, The Barrens / Thunder Bluff, Mulgore"] = 107.7030000000013,
	["Dalaran / Fort Wildervar, Howling Fjord"] = 300.8280000000086,
	["Kamagua, Howling Fjord / Vengeance Landing, Howling Fjord"] = 143.18299999999,
	["Amberpine Lodge, Grizzly Hills / Ebon Watch, Zul'Drak"] = 140.4060000000172,
	["Fordragon Hold, Dragonblight / Wintergarde Keep, Dragonblight"] = 87.60999999998603,
	["Thunder Bluff, Mulgore / Ratchet, The Barrens"] = 154.375,
	["Talrendis Point, Azshara / Astranaar, Ashenvale"] = 151.0470000000005,
	["Nethergarde Keep, Blasted Lands / Booty Bay, Stranglethorn"] = 251.6509999999998,
	["River's Heart, Sholazar Basin / Fizzcrank Airstrip, Borean Tundra"] = 104.5160000000033,
	["Amberpine Lodge, Grizzly Hills / River's Heart, Sholazar Basin"] = 378.3369999999995,
	["Swamprat Post, Zangarmarsh / Thunderlord Stronghold, Blade's Edge Mountains"] = 106.9570000000022,
	["Everlook, Winterspring / Emerald Sanctuary, Felwood"] = 217.4099999999744,
	["Thunder Bluff, Mulgore / Camp Taurajo, The Barrens"] = 87.81200000000536,
	["Crossroads, The Barrens / Sun Rock Retreat, Stonetalon Mountains"] = 150.6190000000061,
	["Toshley's Station, Blade's Edge Mountains / Shattrath, Terokkar Forest"] = 169.8129999999655,
	["Ratchet, The Barrens / Cenarion Hold, Silithus"] = 442.3910000000033,
	["Silvermoon City / Tranquillien, Ghostlands"] = 66.49199999999837,
	["Sentinel Hill, Westfall / Nethergarde Keep, Blasted Lands"] = 187.5940000000046,
	["Talrendis Point, Azshara / Stonetalon Peak, Stonetalon Mountains"] = 305.1409999999887,
	["Thunder Bluff, Mulgore / Brackenwall Village, Dustwallow Marsh"] = 239.8219999999856,
	["Aerie Peak, The Hinterlands / Thorium Point, Searing Gorge"] = 325.1409999999996,
	["Shadowmoon Village, Shadowmoon Valley / Shattrath, Terokkar Forest"] = 127.0939999999973,
	["Rut'theran Village, Teldrassil / Gadgetzan, Tanaris"] = 682.2659999999996,
	["Dalaran / Bor'gorok Outpost, Borean Tundra"] = 308.1999999999825,
	["Wintergarde Keep, Dragonblight / Stars' Rest, Dragonblight"] = 114.9459999999963,
	["Camp Mojache, Feralas / Gadgetzan, Tanaris"] = 201.7980000000098,
	["Dalaran / Fordragon Hold, Dragonblight"] = 100.625,
	["Amberpine Lodge, Grizzly Hills / Kamagua, Howling Fjord"] = 134.4379999999946,
	["Thunderlord Stronghold, Blade's Edge Mountains / Shattrath, Terokkar Forest"] = 203.4599999999991,
	["Chillwind Camp, Western Plaguelands / Menethil Harbor, Wetlands"] = 193.5159999999887,
	["Wintergarde Keep, Dragonblight / Dalaran"] = 119.4220000000205,
	["Stonard, Swamp of Sorrows / Grom'gol, Stranglethorn"] = 179.4850000000006,
	["Hammerfall, Arathi / Undercity, Tirisfal"] = 259.7649999999994,
	["Ironforge, Dun Morogh / Booty Bay, Stranglethorn"] = 381.0160000000033,
	["Vengeance Landing, Howling Fjord / Unu'pe, Borean Tundra"] = 464.4509999999991,
	["Sanctum of the Stars, Shadowmoon Valley / Stonebreaker Hold, Terokkar Forest"] = 129.5480058090761,
	["Darkshire, Duskwood / Morgan's Vigil, Burning Steppes"] = 120.7970000000059,
	["Thalanaar, Feralas / Gadgetzan, Tanaris"] = 171.3590000000004,
	["Thunder Bluff, Mulgore / Orgrimmar, Durotar"] = 208.5789999999979,
	["Valormok, Azshara / Zoram'gar Outpost, Ashenvale"] = 254.1540000000096,
	["Light's Hope Chapel, Eastern Plaguelands / Aerie Peak, The Hinterlands"] = 163.2350000000006,
	["The Sepulcher, Silverpine Forest / Kargath, Badlands"] = 472.5060000000012,
	["Dalaran / The Argent Stand, Zul'Drak"] = 145.8279999999795,
	["Venomspite, Dragonblight / Wyrmrest Temple, Dragonblight"] = 52.01900000000023,
	["Shattrath, Terokkar Forest / Swamprat Post, Zangarmarsh"] = 79.97400000000198,
	["The Argent Stand, Zul'Drak / Light's Breach, Zul'Drak"] = 24.89199999999255,
	["Menethil Harbor, Wetlands / Thelsamar, Loch Modan"] = 163.625,
	["Forest Song, Ashenvale / Astranaar, Ashenvale"] = 142.2810000000027,
	["Auberdine, Darkshore / Talrendis Point, Azshara"] = 300.5130000000008,
	["Swamprat Post, Zangarmarsh / Mok'Nathal Village, Blade's Edge Mountains"] = 71.25,
	["Dalaran / The Argent Vanguard, Icecrown"] = 32.49199999999837,
	["Emerald Sanctuary, Felwood / Talonbranch Glade, Felwood"] = 128.5830000000133,
	["Wyrmrest Temple, Dragonblight / River's Heart, Sholazar Basin"] = 170.625,
	["Star's Rest, Dragonblight / Moa'ki, Dragonblight"] = 71.42199999996228,
	["Nethergarde Keep, Blasted Lands / Darkshire, Duskwood"] = 92.45699999999488,
	["Star's Rest, Dragonblight / Wintergarde Keep, Dragonblight"] = 124.375,
	["Astranaar, Ashenvale / Stonetalon Peak, Stonetalon Mountains"] = 155.125,
	["Tarren Mill, Hillsbrad / Hammerfall, Arathi"] = 118.781,
	["Thrallmar, Hellfire Peninsula / Stonebreaker Hold, Terokkar Forest"] = 129.5140069504269,
	["Conquest Hold, Grizzly Hills / Gundrak, Zul'Drak"] = 217.4250000000011,
	["Swamprat Post, Zangarmarsh / Falcon Watch, Hellfire Peninsula"] = 63.47199999995064,
	["Cosmowrench, Netherstorm / Shattrath, Terokkar Forest"] = 288.2439999999915,
	["Fordragon Hold, Dragonblight / Unu'pe, Borean Tundra"] = 171.7030000000086,
	["Southshore, Hillsbrad / Refuge Pointe, Arathi"] = 74.67200000000594,
	["Brackenwall Village, Dustwallow Marsh / Crossroads, The Barrens"] = 162.6620000000112,
	["Sunreaver's Command, Crystalsong Forest / Dalaran"] = 56.03800000000047,
	["Talrendis Point, Azshara / Talonbranch Glade, Felwood"] = 284.7650000000012,
	["Gadgetzan, Tanaris / Ratchet, The Barrens"] = 247.9280000000144,
	["Evergrove, Blade's Edge Mountains / Area 52, Netherstorm"] = 78.51600000000008,
	["Amber Ledge, Borean Tundra / Valiance Keep, Borean Tundra"] = 45.125,
	["Splintertree Post, Ashenvale / Hellscream's Watch, Ashenvale"] = 82.71100000001025,
	["Undercity, Tirisfal / Light's Hope Chapel, Eastern Plaguelands"] = 262.5630000000092,
	["Gadgetzan, Tanaris / Nijel's Point, Desolace"] = 481.2339999999967,
	["Kor'koron Vanguard, Dragonblight / Conquest Hold, Grizzly Hills"] = 149.1140000000005,
	["Stormwind, Elwynn / Thorium Point, Searing Gorge"] = 133.3120000000054,
	["Cenarion Hold, Silithus / Thunder Bluff, Mulgore"] = 389.8460000000196,
	["Brackenwall Village, Dustwallow Marsh / Freewind Post, Thousand Needles"] = 105.6800000000221,
	["Valiance Keep, Borean Tundra / Fizzcrank Airstrip, Borean Tundra"] = 75.67200000002049,
	["The Shadow Vault, Icecrown / Dun Nifflelem, The Storm Peaks"] = 270.0109999999986,
	["Menethil Harbor, Wetlands / Southshore, Hillsbrad"] = 108.3549999999959,
	["Southern Rocketway, Azshara / Orgrimmar, Durotar"] = 88.21899999992456,
	["Booty Bay, Stranglethorn / Stormwind, Elwynn"] = 199.3280000000013,
	["Shattrath, Terokkar Forest / Garadar, Nagrand"] = 82.4399999999996,
	["Thelsamar, Loch Modan / Refuge Pointe, Arathi"] = 164.6090000000004,
	["Wildhammer Stronghold, Shadowmoon Valley / Shattrath, Terokkar Forest"] = 174.6419999999998,
	["Westguard Keep, Howling Fjord / Ebon Watch, Zul'Drak"] = 182.0470000000205,
	["Valiance Landing Camp, Wintergrasp / Dun Nifflelem, The Storm Peaks"] = 237.420999999973,
	["Wintergarde Keep, Dragonblight / Fordragon Hold, Dragonblight"] = 98.63999999999942,
	["Ironforge, Dun Morogh / Thorium Point, Searing Gorge"] = 85.59400000001187,
	["Hellfire Peninsula, The Dark Portal, Alliance / Telaar, Nagrand"] = 278.1929999999993,
	["Ulduar, The Storm Peaks / Dalaran"] = 154.0039999999863,
	["Toshley's Station, Blade's Edge Mountains / Telaar, Nagrand"] = 196.9849999999997,
	["Booty Bay, Stranglethorn / Sentinel Hill, Westfall"] = 148.5319999999483,
	["Fort Wildervar, Howling Fjord / Dalaran"] = 268.125,
	["Death's Rise, Icecrown / Dalaran"] = 258.7709999999988,
	["Gundrak, Zul'Drak / River's Heart, Sholazar Basin"] = 504.3040000000037,
	["Area 52, Netherstorm / Thunderlord Stronghold, Blade's Edge Mountains"] = 108.9479999999967,
	["Allerian Stronghold, Terokkar Forest / Shattrath, Terokkar Forest"] = 75.0619999999999,
	["Dalaran / Venomspite, Dragonblight"] = 162.8800000000047,
	["Ironforge, Dun Morogh / Menethil Harbor, Wetlands"] = 114.9379999999946,
	["Emerald Sanctuary, Felwood / Orgrimmar, Durotar"] = 173.2330000000075,
	["Morgan's Vigil, Burning Steppes / Light's Hope Chapel, Eastern Plaguelands"] = 478.030999999999,
	["Transitus Shield, Coldarra / Bor'gorok Outpost, Borean Tundra"] = 52.55199999999968,
	["Tarren Mill, Hillsbrad / Undercity, Tirisfal"] = 139.7340000000004,
	["Rut'theran Village, Teldrassil / Emerald Sanctuary, Felwood"] = 331.375,
	["Ratchet, The Barrens / Crossroads, The Barrens"] = 69.20499999999993,
	["Light's Hope Chapel, Eastern Plaguelands / Chillwind Camp, Western Plaguelands"] = 150.5619999999981,
	["Warsong Hold, Borean Tundra / Dalaran"] = 294.4269999999997,
	["Refuge Pointe, Arathi / Aerie Peak, The Hinterlands"] = 72.72800000000007,
	["Ebon Watch, Zul'Drak / Conquest Hold, Grizzly Hills"] = 119.3400000000002,
	["Dalaran / Stars' Rest, Dragonblight"] = 174.0009999999893,
	["Wintergarde Keep, Dragonblight / Unu'pe, Borean Tundra"] = 212.6869999999981,
	["Chillwind Camp, Western Plaguelands / Refuge Pointe, Arathi"] = 139.0939999999973,
	["Wyrmrest Temple, Dragonblight / Dalaran"] = 65.10999999986962,
	["Freewind Post, Thousand Needles / Orgrimmar, Durotar"] = 283.1790000000037,
	["Dalaran / Ulduar, The Storm Peaks"] = 181.7250000000058,
	["Hellfire Peninsula, The Dark Portal, Alliance / Honor Hold, Hellfire Peninsula"] = 73.76599999999962,
	["Zabra'jin, Zangarmarsh / Shattrath, Terokkar Forest"] = 151.7750058472157,
	["Agmar's Hammer, Dragonblight / Conquest Hold, Grizzly Hills"] = 145.8000000000175,
	["Shattrath, Terokkar Forest / Thrallmar, Hellfire Peninsula"] = 150.2280000000028,
	["Westguard Keep, Howling Fjord / Unu'pe, Borean Tundra"] = 357.5940000000119,
	["Nethergarde Keep, Blasted Lands / Stormwind, Elwynn"] = 190.3280000000086,
	["Nijel's Point, Desolace / Astranaar, Ashenvale"] = 273.7070000000094,
	["Amberpine Lodge, Grizzly Hills / Dalaran"] = 172.6560000000027,
	["The Argent Stand, Zul'Drak / Dalaran"] = 119.9689999999973,
	["Booty Bay, Stranglethorn / Darkshire, Duskwood"] = 167.2179999999935,
	["Grom'gol, Stranglethorn / Stonard, Swamp of Sorrows"] = 173.7339999999967,
	["Garadar, Nagrand / Evergrove, Blade's Edge Mountains"] = 203.8040000000001,
	["Dun Nifflelem, The Storm Peaks / The Shadow Vault, Icecrown"] = 245.5509999999777,
	["Refuge Pointe, Arathi / Southshore, Hillsbrad"] = 87.625,
	["Emerald Sanctuary, Felwood / Shadowprey Village, Desolace"] = 377.997000000003,
	["Nesingwary Base Camp, Sholazar Basin / Dalaran"] = 518.1980000000003,
	["Valiance Keep, Borean Tundra / Unu'pe, Borean Tundra"] = 64.51499999999942,
	["Orgrimmar, Durotar / Splintertree Post, Ashenvale"] = 90.5920044677332,
	["Crusaders' Pinnacle, Icecrown / Dalaran"] = 72.17100000000005,
	["Camp Mojache, Feralas / Freewind Post, Thousand Needles"] = 108.4060000000027,
	["Amberpine Lodge, Grizzly Hills / Westguard Keep, Howling Fjord"] = 84.31199999999808,
	["Dalaran / K3, The Storm Peaks"] = 55.18699999997625,
	["The Shadow Vault, Icecrown / Dalaran"] = 166.1410000000033,
	["Westguard Keep, Howling Fjord / Valgarde Port, Howling Fjord"] = 70.20299999997951,
	["Shattrath, Terokkar Forest / Orebor Harborage, Zangarmarsh"] = 147.127999999997,
	["Mok'Nathal Village, Blade's Edge Mountains / Shadowmoon Village, Shadowmoon Valley"] = 292.9250136627816,
	["Shatter Point, Hellfire Peninsula / Honor Hold, Hellfire Peninsula"] = 62.27599999995437,
	["Valgarde Port, Howling Fjord / Unu'pe, Borean Tundra"] = 422.219000000001,
	["Shattrath, Terokkar Forest / Allerian Stronghold, Terokkar Forest"] = 76.59300000000076,
	["Talrendis Point, Azshara / Emerald Sanctuary, Felwood"] = 133.0779999999941,
	["Westfall Brigade, Grizzly Hills / Amberpine Lodge, Grizzly Hills"] = 78.92599999997765,
	["Feathermoon, Feralas / Gadgetzan, Tanaris"] = 326.125,
	["Rut'theran Village, Teldrassil / Talonbranch Glade, Felwood"] = 275.4070000000065,
	["Area 52, Netherstorm / Telaar, Nagrand"] = 289.2660000000033,
	["Westguard Keep, Howling Fjord / Kamagua, Howling Fjord"] = 51.53200000000652,
	["Brackenwall Village, Dustwallow Marsh / Desolation Hold, Southern Barrens"] = 55.84799999999814,
	["Booty Bay, Stranglethorn / Nethergarde Keep, Blasted Lands"] = 252.5620000000054,
	["Valormok, Azshara / Cenarion Hold, Silithus"] = 546.3690000000061,
	["Area 52, Netherstorm / Thrallmar, Hellfire Peninsula"] = 273.6540000000005,
	["Crossroads, The Barrens / Splintertree Post, Ashenvale"] = 163.7819999999992,
	["Allerian Stronghold, Terokkar Forest / Telaar, Nagrand"] = 150.0159999999996,
	["Windrunner's Overlook, Crystalsong Forest / Valiance Keep, Borean Tundra"] = 311.8849999999998,
	["Mudsprocket, Dustwallow Marsh / Theramore, Dustwallow Marsh"] = 52.6869999999999,
	["Crusaders' Pinnacle, Icecrown / The Argent Stand, Zul'Drak"] = 196.3899999999994,
	["Evergrove, Blade's Edge Mountains / Toshley's Station, Blade's Edge Mountains"] = 44.63399999999092,
	["Camp Taurajo, The Barrens / Brackenwall Village, Dustwallow Marsh"] = 61.32099999999628,
	["Light's Breach, Zul'Drak / The Argent Stand, Zul'Drak"] = 44.49699999999939,
	["Kamagua, Howling Fjord / Valgarde Port, Howling Fjord"] = 81.45299999997951,
	["Desolation Hold, Southern Barrens / Orgrimmar, Durotar"] = 259.6790000000037,
	["Northern Rocketway, Azshara / Bilgewater Harbor, Azshara"] = 50.74800000002142,
	["Stonetalon Peak, Stonetalon Mountains / Astranaar, Ashenvale"] = 155.5359999999928,
	["Lakeshire, Redridge / Stormwind, Elwynn"] = 113.530999999959,
	["Cosmowrench, Netherstorm / Evergrove, Blade's Edge Mountains"] = 144.7310066530481,
	["Theramore, Dustwallow Marsh / Forest Song, Ashenvale"] = 259.5079999999998,
	["Thalanaar, Feralas / Feathermoon, Feralas"] = 178.9060000000027,
	["Emerald Sanctuary, Felwood / Talrendis Point, Azshara"] = 128.4539999999979,
	["Gadgetzan, Tanaris / Cenarion Hold, Silithus"] = 198,
	["Thorium Point, Searing Gorge / Ironforge, Dun Morogh"] = 90.95700000000034,
	["Orgrimmar, Durotar / Thunder Bluff, Mulgore"] = 227.5489999999991,
	["The Shadow Vault, Icecrown / The Argent Vanguard, Icecrown"] = 135.1720000000059,
	["Moonglade / Auberdine, Darkshore"] = 142.4529999999795,
	["Everlook, Winterspring / Talonbranch Glade, Felwood"] = 108.3909999999996,
	["Dalaran / Windrunner's Overlook, Crystalsong Forest"] = 54.04700000000594,
	["Amberpine Lodge, Grizzly Hills / Westfall Brigade, Grizzly Hills"] = 84.32800000000134,
	["Undercity, Tirisfal / Tarren Mill, Hillsbrad"] = 145.0460000000021,
	["Allerian Stronghold, Terokkar Forest / Honor Hold, Hellfire Peninsula"] = 97.40499999999975,
	["Orgrimmar, Durotar / Krom'gar Fortress, Stonetalon Mountains"] = 219.8050000000512,
	["Light's Breach, Zul'Drak / Zim'Torga, Zul'Drak"] = 84.55799999996088,
	["Wyrmrest Temple, Dragonblight / Transitus Shield, Coldarra"] = 228.2970000000205,
	["Wintergarde Keep, Dragonblight / Westguard Keep, Howling Fjord"] = 126.75,
	["Shattered Sun Staging Area / Silvermoon City"] = 167.640999999996,
	["The Sepulcher, Silverpine Forest / Hammerfall, Arathi"] = 214.0939999999973,
	["Apothecary Camp, Howling Fjord / Conquest Hold, Grizzly Hills"] = 47.72399999998743,
	["Thrallmar, Hellfire Peninsula / Shattrath, Terokkar Forest"] = 138.9010065197945,
	["Forest Song, Ashenvale / Rut'theran Village, Teldrassil"] = 374.3129999999946,
	["Emerald Sanctuary, Felwood / Thalanaar, Feralas"] = 529.2959999999985,
	["Stormwind, Elwynn / Nethergarde Keep, Blasted Lands"] = 176.7029999999995,
	["Mudsprocket, Dustwallow Marsh / Stonetalon Peak, Stonetalon Mountains"] = 506.0159999999996,
	["Orgrimmar, Durotar / Valormok, Azshara"] = 95.96900000001187,
	["Fordragon Hold, Dragonblight / Wyrmrest Temple, Dragonblight"] = 65.875,
	["Darkshire, Duskwood / Light's Hope Chapel, Eastern Plaguelands"] = 574.9529999999995,
	["Evergrove, Blade's Edge Mountains / Garadar, Nagrand"] = 262.75,
	["Dalaran / The Shadow Vault, Icecrown"] = 162.3369999999995,
	["Ebon Watch, Zul'Drak / The Argent Stand, Zul'Drak"] = 64.4890000000014,
	["Temple of Telhamat, Hellfire Peninsula / Evergrove, Blade's Edge Mountains"] = 202.8589999999967,
	["Gundrak, Zul'Drak / Conquest Hold, Grizzly Hills"] = 206.2199999999994,
	["Fizzcrank Airstrip, Borean Tundra / Valiance Keep, Borean Tundra"] = 106.1710000000021,
	["River's Heart, Sholazar Basin / Dalaran"] = 519.9110000000219,
	["Sentinel Hill, Westfall / Stormwind, Elwynn"] = 86.32800000000862,
	["Crossroads, The Barrens / Orgrimmar, Durotar"] = 117.2049999999999,
	["Agmar's Hammer, Dragonblight / Wyrmrest Temple, Dragonblight"] = 51.30599999998231,
	["Brackenwall Village, Dustwallow Marsh / Splintertree Post, Ashenvale"] = 290.1650000000009,
	["Thunder Bluff, Mulgore / Shadowprey Village, Desolace"] = 160.1409999999996,
	["Fizzcrank Airstrip, Borean Tundra / Amber Ledge, Borean Tundra"] = 67.02900000009686,
	["Chillwind Camp, Western Plaguelands / Southshore, Hillsbrad"] = 86.03100000000268,
	["Freewind Post, Thousand Needles / Thunder Bluff, Mulgore"] = 223.5939999999973,
	["Fizzcrank Airstrip, Borean Tundra / Unu'pe, Borean Tundra"] = 98.20300000003772,
	["The Argent Vanguard, Icecrown / River's Heart, Sholazar Basin"] = 384.0439999999944,
	["Wintergarde Keep, Dragonblight / Wyrmrest Temple, Dragonblight"] = 55.59399999999732,
	["Ratchet, The Barrens / Orgrimmar, Durotar"] = 101.7130000000034,
	["Telaar, Nagrand / Allerian Stronghold, Terokkar Forest"] = 122.5029999999679,
	["Area 52, Netherstorm / Shadowmoon Village, Shadowmoon Valley"] = 357.2089999999989,
	["Sentinel Hill, Westfall / Morgan's Vigil, Burning Steppes"] = 191.25,
	["Darkshire, Duskwood / Rebel Camp, Stranglethorn Vale"] = 48.09299999999348,
	["Booty Bay, Stranglethorn / Grom'gol, Stranglethorn"] = 76.42500378750265,
	["Aerie Peak, The Hinterlands / Thelsamar, Loch Modan"] = 246.1820000000007,
	["Darkshire, Duskwood / Sentinel Hill, Westfall"] = 94.34399999999732,
	["Light's Breach, Zul'Drak / Amberpine Lodge, Grizzly Hills"] = 85,
	["Windrunner's Overlook, Crystalsong Forest / Amberpine Lodge, Grizzly Hills"] = 147.922,
	["Unu'pe, Borean Tundra / Moa'ki, Dragonblight"] = 118.4850000000006,
	["Dalaran / Conquest Hold, Grizzly Hills"] = 200.2920000000004,
	["Stormwind, Elwynn / Menethil Harbor, Wetlands"] = 289.875,
	["Shadowprey Village, Desolace / Gadgetzan, Tanaris"] = 395.9470000000147,
	["Rut'theran Village, Teldrassil / Theramore, Dustwallow Marsh"] = 528.8280000000086,
	["Thorium Point, Searing Gorge / Morgan's Vigil, Burning Steppes"] = 90.78299999999581,
	["Ratchet, The Barrens / Theramore, Dustwallow Marsh"] = 105.7790000000096,
	["Thorium Point, Searing Gorge / Thelsamar, Loch Modan"] = 88.82800000000134,
	["Thunderlord Stronghold, Blade's Edge Mountains / Cosmowrench, Netherstorm"] = 152.9200066979975,
	["Mudsprocket, Dustwallow Marsh / Shadowprey Village, Desolace"] = 384.2019999999975,
	["The Argent Stand, Zul'Drak / The Argent Vanguard, Icecrown"] = 141.2030000000086,
	["Nijel's Point, Desolace / Feathermoon, Feralas"] = 232.875,
	["Transitus Shield, Coldarra / Amberpine Lodge, Grizzly Hills"] = 268.765000000014,
	["Camp Winterhoof, Howling Fjord / Vengeance Landing, Howling Fjord"] = 74.81200000000536,
	["Dun Nifflelem, The Storm Peaks / Grom'arsh Crash-Site, The Storm Peaks"] = 128.5099999999948,
	["Warsong Camp, Wintergrasp / Dalaran"] = 141.6110000000335,
	["Orgrimmar, Durotar / Cenarion Hold, Silithus"] = 490.3350216601975,
	["Orgrimmar, Durotar / Brackenwall Village, Dustwallow Marsh"] = 229.4279999999562,
	["Stormwind, Elwynn / Refuge Pointe, Arathi"] = 377.3489999999874,
	["Rebel Camp, Stranglethorn Vale / Booty Bay, Stranglethorn"] = 116.9070000000065,
	["Silverwind Refuge, Ashenvale / Malaka'jin, Stonetalon Mountains"] = 144.3009999999777,
	["Evergrove, Blade's Edge Mountains / Cosmowrench, Netherstorm"] = 143.3819999999978,
	["Warsong Camp, Wintergrasp / Unu'pe, Borean Tundra"] = 164.5799999999999,
	["Allerian Stronghold, Terokkar Forest / Toshley's Station, Blade's Edge Mountains"] = 227.005999999994,
	["Mudsprocket, Dustwallow Marsh / Camp Mojache, Feralas"] = 194.4459999999963,
	["Crossroads, The Barrens / Ratchet, The Barrens"] = 53.29899999999907,
	["Thunderlord Stronghold, Blade's Edge Mountains / Evergrove, Blade's Edge Mountains"] = 26.68799999999999,
	["Dalaran / Unu'pe, Borean Tundra"] = 283.7029999999977,
	["Zul'Aman, Ghostlands / Silvermoon City"] = 118.2419999999984,
	["Aerie Peak, The Hinterlands / Menethil Harbor, Wetlands"] = 176.6090000000004,
	["Emerald Sanctuary, Felwood / Astranaar, Ashenvale"] = 81.21800000000803,
	["Cosmowrench, Netherstorm / Garadar, Nagrand"] = 369.6129999999976,
	["Orgrimmar, Durotar / Everlook, Winterspring"] = 240.5940000000119,
	["Light's Breach, Zul'Drak / Ebon Watch, Zul'Drak"] = 40.31300000002375,
	["Vengeance Landing, Howling Fjord / New Agamand, Howling Fjord"] = 80.75,
	["Camp Mojache, Feralas / Shadowprey Village, Desolace"] = 200.7730000000156,
	["Shadowprey Village, Desolace / Ratchet, The Barrens"] = 332.4110000000219,
	["Swamprat Post, Zangarmarsh / Zabra'jin, Zangarmarsh"] = 106.3710054475814,
	["Dalaran / Agmar's Hammer, Dragonblight"] = 125.4700000000003,
	["Dalaran / Gundrak, Zul'Drak"] = 239.1240000000107,
	["Ironforge, Dun Morogh / Nethergarde Keep, Blasted Lands"] = 339.125,
	["Shattrath, Terokkar Forest / Altar of Sha'tar, Shadowmoon Valley"] = 234.6759999999922,
	["Crusaders' Pinnacle, Icecrown / The Shadow Vault, Icecrown"] = 124.156,
	["Zim'Torga, Zul'Drak / Dalaran"] = 172.2969999999914,
	["Menethil Harbor, Wetlands / Sentinel Hill, Westfall"] = 308.25,
	["Astranaar, Ashenvale / Auberdine, Darkshore"] = 148.8600000000006,
	["Darkshire, Duskwood / Stormwind, Elwynn"] = 88.07799999999952,
	["Dalaran / Valiance Keep, Borean Tundra"] = 301.6879999999983,
	["Orgrimmar, Durotar / Camp Mojache, Feralas"] = 360.0869999999995,
	["Stonard, Swamp of Sorrows / Kargath, Badlands"] = 231.5769999999902,
	["Mudsprocket, Dustwallow Marsh / Orgrimmar, Durotar"] = 245.3960000000079,
	["Theramore, Dustwallow Marsh / Gadgetzan, Tanaris"] = 157.5160000000033,
	["Fordragon Hold, Dragonblight / Light's Breach, Zul'Drak"] = 163.8279999999941,
	["Kargath, Badlands / Thorium Point, Searing Gorge"] = 10.01600000000326,
	["Dalaran / Wyrmrest Temple, Dragonblight"] = 122.0540000000037,
	["Kamagua, Howling Fjord / Westguard Keep, Howling Fjord"] = 36.90599999995902,
	["Emerald Sanctuary, Felwood / Hellscream's Watch, Ashenvale"] = 70.32499999995343,
	["Light's Hope Chapel, Eastern Plaguelands / Undercity, Tirisfal"] = 261.0159999999996,
	["Garadar, Nagrand / Area 52, Netherstorm"] = 274.3199999999997,
	["Krom'gar Fortress, Stonetalon Mountains / Cliffwalker Post, Stonetalon Mountains"] = 70.46599999989849,
	["Cliffwalker Post, Stonetalon Mountains / Malaka'jin, Stonetalon Mountains"] = 63.30500000005122,
	["Brackenwall Village, Dustwallow Marsh / Mudsprocket, Dustwallow Marsh"] = 63.11000000004424,
	["Rut'theran Village, Teldrassil / Feathermoon, Feralas"] = 558.1869999999763,
	["Shattrath, Terokkar Forest / Hellfire Peninsula, The Dark Portal, Horde"] = 220.2939999999944,
	["Silverwind Refuge, Ashenvale / Splintertree Post, Ashenvale"] = 64.55299999995623,
	["Shattrath, Terokkar Forest / Wildhammer Stronghold, Shadowmoon Valley"] = 153.6089999999995,
	["Shadowprey Village, Desolace / Moonglade"] = 581.5270000000019,
	["Fordragon Hold, Dragonblight / Dalaran"] = 66.32800000000862,
	["Undercity, Tirisfal / The Sepulcher, Silverpine Forest"] = 107.1410000000033,
	["Zabra'jin, Zangarmarsh / Falcon Watch, Hellfire Peninsula"] = 148.0690066250972,
	["Flame Crest, Burning Steppes / Kargath, Badlands"] = 82.125,
	["Dalaran / Ebon Watch, Zul'Drak"] = 82.26599999999598,
	["Kamagua, Howling Fjord / Fort Wildervar, Howling Fjord"] = 121.5,
	["Westguard Keep, Howling Fjord / River's Heart, Sholazar Basin"] = 448.1719999999623,
	["Venomspite, Dragonblight / Dalaran"] = 148.3860000000568,
	["Thelsamar, Loch Modan / Aerie Peak, The Hinterlands"] = 235.7620000000461,
	["Darkshire, Duskwood / Ironforge, Dun Morogh"] = 290.8879999999772,
	["Mudsprocket, Dustwallow Marsh / Nijel's Point, Desolace"] = 387.0470000000059,
	["Theramore, Dustwallow Marsh / Everlook, Winterspring"] = 412.8130000000019,
	["Unu'pe, Borean Tundra / Warsong Hold, Borean Tundra"] = 88.35899999999674,
	["Emerald Sanctuary, Felwood / Bloodvenom Post, Felwood"] = 80.38800000003539,
	["Ratchet, The Barrens / Brackenwall Village, Dustwallow Marsh"] = 101.4660000000004,
	["Orgrimmar, Durotar / Freewind Post, Thousand Needles"] = 292.6059999999998,
	["Refuge Pointe, Arathi / Menethil Harbor, Wetlands"] = 126.7970000000005,
	["Acherus: The Ebon Hold / Chillwind Camp, Western Plaguelands"] = 197.5310000000027,
	["Cosmowrench, Netherstorm / Sylvanaar, Blade's Edge Mountains"] = 191.9579999999987,
	["Stonebreaker Hold, Terokkar Forest / Shattrath, Terokkar Forest"] = 57.35000000009313,
	["Marshal's Refuge, Un'Goro Crater / Cenarion Hold, Silithus"] = 101.0619999999908,
	["Refuge Pointe, Arathi / Ironforge, Dun Morogh"] = 271.170999999973,
	["Sylvanaar, Blade's Edge Mountains / Shattrath, Terokkar Forest"] = 179.7579999999998,
	["Shadowmoon Village, Shadowmoon Valley / Garadar, Nagrand"] = 208.6710100062192,
	["Mudsprocket, Dustwallow Marsh / Marshal's Refuge, Un'Goro Crater"] = 265.6759999999995,
	["Sentinel Hill, Westfall / Rebel Camp, Stranglethorn Vale"] = 63.0460000000021,
	["Shattrath, Terokkar Forest / Shattrath, Terokkar Forest"] = 10.00799999997253,
	["Honor Hold, Hellfire Peninsula / Telredor, Zangarmarsh"] = 156.8589999999967,
	["Booty Bay, Stranglethorn / Stonard, Swamp of Sorrows"] = 240.9029999999912,
	["Conquest Hold, Grizzly Hills / Ebon Watch, Zul'Drak"] = 120.1529999999984,
	["Lakeshire, Redridge / Morgan's Vigil, Burning Steppes"] = 113.5319999999992,
	["Transitus Shield, Coldarra / Amber Ledge, Borean Tundra"] = 30.43699999997625,
	["Dun Nifflelem, The Storm Peaks / The Argent Stand, Zul'Drak"] = 142.064000000013,
	["Southshore, Hillsbrad / Chillwind Camp, Western Plaguelands"] = 81.35900000000038,
	["Ratchet, The Barrens / Astranaar, Ashenvale"] = 197.7999999999884,
	["Thorium Point, Searing Gorge / Menethil Harbor, Wetlands"] = 160.0469999999996,
	["Aerie Peak, The Hinterlands / Southshore, Hillsbrad"] = 68.90699999999924,
	["Moonglade / Gadgetzan, Tanaris"] = 651.594000000001,
	["Valgarde Port, Howling Fjord / Moa'ki, Dragonblight"] = 290.0160000000033,
	["Amber Ledge, Borean Tundra / Transitus Shield, Coldarra"] = 25.60899999999674,
	["Crossroads, The Barrens / Mudsprocket, Dustwallow Marsh"] = 193.8349999999919,
	["Theramore, Dustwallow Marsh / Ratchet, The Barrens"] = 115.7659999999996,
	["Theramore, Dustwallow Marsh / Marshal's Refuge, Un'Goro Crater"] = 261.765000000014,
	["Lakeshire, Redridge / Darkshire, Duskwood"] = 61.30000000000291,
	["Shattrath, Terokkar Forest / Stonebreaker Hold, Terokkar Forest"] = 69.71900000004098,
	["Tarren Mill, Hillsbrad / Stonard, Swamp of Sorrows"] = 600.9389999999548,
	["Fort Wildervar, Howling Fjord / Valiance Keep, Borean Tundra"] = 414.4219999999914,
	["Astranaar, Ashenvale / Rut'theran Village, Teldrassil"] = 233.5939999999973,
	["Thunder Bluff, Mulgore / Crossroads, The Barrens"] = 102.7649999999994,
	["Blood Watch, Bloodmyst Isle / The Exodar"] = 77.53099999999995,
	["Orgrimmar, Durotar / Zoram'gar Outpost, Ashenvale"] = 249.6090000000004,
	["The Stormspire, Netherstorm / Garadar, Nagrand"] = 359.3829999999871,
	["Rut'theran Village, Teldrassil / Everlook, Winterspring"] = 355.25,
	["Altar of Sha'tar, Shadowmoon Valley / Shattrath, Terokkar Forest"] = 254.281,
	["Amber Ledge, Borean Tundra / River's Heart, Sholazar Basin"] = 65.93800000002375,
	["Stormwind, Elwynn / Darkshire, Duskwood"] = 117.125,
	["Talonbranch Glade, Felwood / Emerald Sanctuary, Felwood"] = 129.5930000000008,
	["Chillwind Camp, Western Plaguelands / Aerie Peak, The Hinterlands"] = 66.24499999999534,
	["Westguard Keep, Howling Fjord / Fizzcrank Airstrip, Borean Tundra"] = 387.3279999999795,
	["Chillwind Camp, Western Plaguelands / Light's Hope Chapel, Eastern Plaguelands"] = 147.6180000000168,
	["Aerie Peak, The Hinterlands / Refuge Pointe, Arathi"] = 76.46900000000096,
	["Astranaar, Ashenvale / Nijel's Point, Desolace"] = 281.4360000000452,
	["Southshore, Hillsbrad / Darkshire, Duskwood"] = 417.4210000000001,
	["Dalaran / Nesingwary Base Camp, Sholazar Basin"] = 375.2030000000377,
	["Southshore, Hillsbrad / Ironforge, Dun Morogh"] = 206.765999999996,
	["Thrallmar, Hellfire Peninsula / Zabra'jin, Zangarmarsh"] = 215.8220100686885,
	["Menethil Harbor, Wetlands / Ironforge, Dun Morogh"] = 89.5,
	["Zoram'gar Outpost, Ashenvale / Sun Rock Retreat, Stonetalon Mountains"] = 122.7339999999967,
	["Valormok, Azshara / Orgrimmar, Durotar"] = 76.06599999999162,
	["Temple of Telhamat, Hellfire Peninsula / Honor Hold, Hellfire Peninsula"] = 87.71800000000803,
	["Taunka'le Village, Borean Tundra / Dalaran"] = 209,
	["Valormok, Azshara / Gadgetzan, Tanaris"] = 441.5450000000128,
	["Area 52, Netherstorm / Shattrath, Terokkar Forest"] = 224.4619999999995,
	["Shattrath, Terokkar Forest / Falcon Watch, Hellfire Peninsula"] = 78.09299999999348,
	["Gadgetzan, Tanaris / Marshal's Refuge, Un'Goro Crater"] = 105.3439999999991,
	["Orgrimmar, Durotar / Crossroads, The Barrens"] = 108.848,
	["Gadgetzan, Tanaris / Feathermoon, Feralas"] = 354.9909999999218,
	["Kargath, Badlands / Revantusk Village, The Hinterlands"] = 353.0599999999977,
	["Hammerfall, Arathi / Revantusk Village, The Hinterlands"] = 91.0619999999999,
	["Valiance Keep, Borean Tundra / Amber Ledge, Borean Tundra"] = 64.82899999999791,
	["Dalaran / River's Heart, Sholazar Basin"] = 355.9690000000046,
	["Talrendis Point, Azshara / Everlook, Winterspring"] = 180.0630000000019,
	["Theramore, Dustwallow Marsh / Cenarion Hold, Silithus"] = 354.0779999999941,
	["Dun Nifflelem, The Storm Peaks / Wyrmrest Temple, Dragonblight"] = 160.4850000000006,
	["Rut'theran Village, Teldrassil / Thalanaar, Feralas"] = 687.9890000000014,
	["Splintertree Post, Ashenvale / Zoram'gar Outpost, Ashenvale"] = 164.5339999999851,
	["Telaar, Nagrand / Area 52, Netherstorm"] = 279.0159999999887,
	["Aerie Peak, The Hinterlands / Ironforge, Dun Morogh"] = 258.0629999999946,
	["Shattrath, Terokkar Forest / The Stormspire, Netherstorm"] = 284.6409999999742,
	["Malaka'jin, Stonetalon Mountains / Orgrimmar, Durotar"] = 206.280999999959,
	["Shattrath, Terokkar Forest / Sanctum of the Stars, Shadowmoon Valley"] = 197.9710000000014,
	["Allerian Stronghold, Terokkar Forest / Temple of Telhamat, Hellfire Peninsula"] = 170.6450000000186,
	["Telredor, Zangarmarsh / Shattrath, Terokkar Forest"] = 98.09799999999814,
	["Shattrath, Terokkar Forest / Shadowmoon Village, Shadowmoon Valley"] = 133.6540000000005,
	["Thunder Bluff, Mulgore / Gadgetzan, Tanaris"] = 291.0840000000026,
	["Mudsprocket, Dustwallow Marsh / Gadgetzan, Tanaris"] = 164.3539999999994,
	["Valgarde Port, Howling Fjord / Fort Wildervar, Howling Fjord"] = 71.5,
	["Camp Mojache, Feralas / Cenarion Hold, Silithus"] = 130.8279999999941,
	["Marshal's Refuge, Un'Goro Crater / Camp Mojache, Feralas"] = 224.372000000003,
	["Stormwind, Elwynn / Lakeshire, Redridge"] = 114.2339999999967,
	["Desolation Hold, Southern Barrens / Thunder Bluff, Mulgore"] = 163.7229999999981,
	["Wildhammer Stronghold, Shadowmoon Valley / Telaar, Nagrand"] = 250.0930000000008,
	["Sylvanaar, Blade's Edge Mountains / Toshley's Station, Blade's Edge Mountains"] = 58.01599999999962,
	["Ratchet, The Barrens / Shadowprey Village, Desolace"] = 335.1810000000041,
	["Camp Oneqwah, Grizzly Hills / Conquest Hold, Grizzly Hills"] = 96.93599999999788,
	["Dalaran / Camp Winterhoof, Howling Fjord"] = 284.3070000000007,
	["Dun Nifflelem, The Storm Peaks / Dalaran"] = 159.2490000000689,
	["Dalaran / Star's Rest, Dragonblight"] = 174.2030000000086,
	["Stonetalon Peak, Stonetalon Mountains / Auberdine, Darkshore"] = 177.8280000000004,
	["Dalaran / Amberpine Lodge, Grizzly Hills"] = 240.5439999999944,
	["Thunder Bluff, Mulgore / Bloodhoof Village, Mulgore"] = 51.13700000010431,
	["Kor'koron Vanguard, Dragonblight / Warsong Hold, Borean Tundra"] = 248.3299999999581,
	["Theramore, Dustwallow Marsh / Thalanaar, Feralas"] = 164.0780000000013,
	["Star's Rest, Dragonblight / Transitus Shield, Coldarra"] = 209.2810000000009,
	["Thunder Bluff, Mulgore / Zoram'gar Outpost, Ashenvale"] = 264.6749999999884,
	["Spinebreaker Ridge, Hellfire Peninsula / Thrallmar, Hellfire Peninsula"] = 63.01499999989756,
	["Moa'ki, Dragonblight / Unu'pe, Borean Tundra"] = 132.6720000000205,
	["Crossroads, Northern Barrens / Orgrimmar, Durotar"] = 120.4799999999814,
	["Auberdine, Darkshore / Emerald Sanctuary, Felwood"] = 246.4059999999881,
	["Menethil Harbor, Wetlands / Refuge Pointe, Arathi"] = 108.2719999999972,
	["Sentinel Hill, Westfall / Darkshire, Duskwood"] = 98.92199999999997,
	["Zoram'gar Outpost, Ashenvale / Orgrimmar, Durotar"] = 267.2300000000978,
	["Theramore, Dustwallow Marsh / Mudsprocket, Dustwallow Marsh"] = 64.3440000000046,
	["Ebon Watch, Zul'Drak / Dalaran"] = 67.93700000003446,
	["Auberdine, Darkshore / Moonglade"] = 151.6879999999655,
	["Dalaran / Kamagua, Howling Fjord"] = 341.9369999999908,
	["Booty Bay, Stranglethorn / Rebel Camp, Stranglethorn Vale"] = 118.2809999999881,
	["Shattrath, Terokkar Forest / Hellfire Peninsula, The Dark Portal, Alliance"] = 172.2490000000107,
	["Lakeshire, Redridge / Thorium Point, Searing Gorge"] = 130.0789999999979,
	["Rut'theran Village, Teldrassil / Cenarion Hold, Silithus"] = 708.7970000000059,
	["Evergrove, Blade's Edge Mountains / Shattrath, Terokkar Forest"] = 213.7300000000032,
	["Camp Taurajo, The Barrens / Thunder Bluff, Mulgore"] = 114.6720000000059,
	["Amber Ledge, Borean Tundra / Fizzcrank Airstrip, Borean Tundra"] = 24.43699999999808,
	["Amber Ledge, Borean Tundra / Taunka'le Village, Borean Tundra"] = 48.93699999997625,
	["Wyrmrest Temple, Dragonblight / Argent Tournament Grounds, Icecrown"] = 141.2029999999795,
	["Feathermoon, Feralas / Theramore, Dustwallow Marsh"] = 292.6689999999999,
	["Orgrimmar, Durotar / Camp Taurajo, The Barrens"] = 181.1720000000059,
	["Booty Bay, Stranglethorn / Kargath, Badlands"] = 314.8440000000001,
	["Shattrath, Terokkar Forest / Temple of Telhamat, Hellfire Peninsula"] = 166.3910000000033,
	["K3, The Storm Peaks / Dalaran"] = 71.8440000000046,
	["Toshley's Station, Blade's Edge Mountains / Sylvanaar, Blade's Edge Mountains"] = 60.67900000000373,
	["Dun Nifflelem, The Storm Peaks / Fizzcrank Airstrip, Borean Tundra"] = 438.7969999999914,
	["Swamprat Post, Zangarmarsh / Garadar, Nagrand"] = 168.9689999999973,
	["Westguard Keep, Howling Fjord / Amberpine Lodge, Grizzly Hills"] = 77.375,
	["Shattrath, Terokkar Forest / Sylvanaar, Blade's Edge Mountains"] = 175.5320000000065,
	["Everlook, Winterspring / Talrendis Point, Azshara"] = 168.75,
	["Silverwind Refuge, Ashenvale / Emerald Sanctuary, Felwood"] = 132.5540000000037,
	["Thrallmar, Hellfire Peninsula / Hellfire Peninsula, The Dark Portal, Horde"] = 70.73800000001211,
	["Windrunner's Overlook, Crystalsong Forest / Wintergarde Keep, Dragonblight"] = 76.45399999999791,
	["Dun Nifflelem, The Storm Peaks / River's Heart, Sholazar Basin"] = 438.6099999999969,
	["Camp Winterhoof, Howling Fjord / Venomspite, Dragonblight"] = 174.9829999999784,
	["Thunder Bluff, Mulgore / Bloodvenom Post, Felwood"] = 356.2920000000158,
	["Dalaran / Valgarde Port, Howling Fjord"] = 317.3530000000028,
	["Refuge Pointe, Arathi / Thelsamar, Loch Modan"] = 171.719000000001,
	["Conquest Hold, Grizzly Hills / Agmar's Hammer, Dragonblight"] = 207.7719999999972,
	["Freewind Post, Thousand Needles / Gadgetzan, Tanaris"] = 93.52800000002026,
	["Freewind Post, Thousand Needles / Crossroads, The Barrens"] = 192.4409999999916,
	["Rut'theran Village, Teldrassil / Astranaar, Ashenvale"] = 253.2480000000069,
	["Zoram'gar Outpost, Ashenvale / Crossroads, The Barrens"] = 235.867000000002,
	["Wyrmrest Temple, Dragonblight / Moa'ki, Dragonblight"] = 36.19700000000012,
	["Thunder Bluff, Mulgore / Cenarion Hold, Silithus"] = 382.5620000000054,
	["Ratchet, The Barrens / Auberdine, Darkshore"] = 345.9219999999914,
	["Ironforge, Dun Morogh / Chillwind Camp, Western Plaguelands"] = 258.1719999999987,
	["Orgrimmar, Durotar / Bilgewater Harbor, Azshara"] = 196.0779999999795,
	["Area 52, Netherstorm / The Stormspire, Netherstorm"] = 49.06299999999999,
	["Emerald Sanctuary, Felwood / Gadgetzan, Tanaris"] = 499.625,
	["Orgrimmar, Durotar / Southern Rocketway, Azshara"] = 93.49199999996927,
	["Spinebreaker Ridge, Hellfire Peninsula / Shattrath, Terokkar Forest"] = 200.8399999999965,
	["Ratchet, The Barrens / Thunder Bluff, Mulgore"] = 175.43299999999,
	["Falcon Watch, Hellfire Peninsula / Shattrath, Terokkar Forest"] = 72.61000000000058,
	["Cenarion Hold, Silithus / Marshal's Refuge, Un'Goro Crater"] = 92.13999999999987,
	["Grom'arsh Crash-Site, The Storm Peaks / Dalaran"] = 111.2069999999367,
	["Menethil Harbor, Wetlands / Light's Hope Chapel, Eastern Plaguelands"] = 324.719000000001,
	["Honor Hold, Hellfire Peninsula / Temple of Telhamat, Hellfire Peninsula"] = 76.31200000000172,
	["Everlook, Winterspring / Bloodvenom Post, Felwood"] = 196.3910000000033,
	["Honor Hold, Hellfire Peninsula / Shattrath, Terokkar Forest"] = 120.4849999999997,
	["Thrallmar, Hellfire Peninsula / Falcon Watch, Hellfire Peninsula"] = 67.49900176888332,
	["Dalaran / Dun Nifflelem, The Storm Peaks"] = 155.5300000000279,
	["Mok'Nathal Village, Blade's Edge Mountains / Thunderlord Stronghold, Blade's Edge Mountains"] = 63.82800000000009,
	["Conquest Hold, Grizzly Hills / New Agamand, Howling Fjord"] = 163.8840000000055,
	["Morgan's Vigil, Burning Steppes / Stormwind, Elwynn"] = 152.1400000000003,
	["Thelsamar, Loch Modan / Ironforge, Dun Morogh"] = 110.25,
	["Hellfire Peninsula, The Dark Portal, Horde / Thrallmar, Hellfire Peninsula"] = 60.56300000000192,
	["Auberdine, Darkshore / Stonetalon Peak, Stonetalon Mountains"] = 181.7810000000172,
	["Thunder Bluff, Mulgore / Sun Rock Retreat, Stonetalon Mountains"] = 182.8279999999941,
	["Acherus: The Ebon Hold / Kargath, Badlands"] = 539.8120000000054,
	["Sun Rock Retreat, Stonetalon Mountains / Camp Mojache, Feralas"] = 339.8590000000258,
	["Nesingwary Base Camp, Sholazar Basin / River's Heart, Sholazar Basin"] = 77.29700000000594,
	["Thorium Point, Searing Gorge / Southshore, Hillsbrad"] = 261.4369999999981,
	["Stormwind, Elwynn / Rebel Camp, Stranglethorn Vale"] = 93.57799999999952,
	["Honor Hold, Hellfire Peninsula / Telaar, Nagrand"] = 208.0309999999954,
	["Warsong Hold, Borean Tundra / Transitus Shield, Coldarra"] = 72.84400000001187,
	["Bloodhoof Village, Mulgore / Thunder Bluff, Mulgore"] = 50.76199999998789,
	["Westguard Keep, Howling Fjord / Light's Breach, Zul'Drak"] = 143.140000000014,
	["Stonetalon Peak, Stonetalon Mountains / Feathermoon, Feralas"] = 360.4530000000013,
	["Ratchet, The Barrens / Nijel's Point, Desolace"] = 439.5469999999914,
	["Kamagua, Howling Fjord / Dalaran"] = 317.2820000000065,
	["Toshley's Station, Blade's Edge Mountains / Evergrove, Blade's Edge Mountains"] = 54.27199999999721,
	["Acherus: The Ebon Hold / Undercity, Tirisfal"] = 309.5620000000054,
	["Zoram'gar Outpost, Ashenvale / Splintertree Post, Ashenvale"] = 173.3169999999809,
	["Dalaran / Wintergarde Keep, Dragonblight"] = 128.578,
	["Cenarion Hold, Silithus / Everlook, Winterspring"] = 740.6409999999996,
	["Brackenwall Village, Dustwallow Marsh / Emerald Sanctuary, Felwood"] = 351.9079999999958,
	["Cenarion Hold, Silithus / Gadgetzan, Tanaris"] = 188.9379999999946,
	["Wildhammer Stronghold, Shadowmoon Valley / Toshley's Station, Blade's Edge Mountains"] = 326.3280000000013,
	["Gadgetzan, Tanaris / Everlook, Winterspring"] = 553.0629999999997,
	["Fort Wildervar, Howling Fjord / Westguard Keep, Howling Fjord"] = 80.95299999999406,
	["Amberpine Lodge, Grizzly Hills / Transitus Shield, Coldarra"] = 396.5,
	["Westfall Brigade, Grizzly Hills / River's Heart, Sholazar Basin"] = 455.6410000000001,
	["Feathermoon, Feralas / Moonglade"] = 618.875,
	["Rut'theran Village, Teldrassil / Nijel's Point, Desolace"] = 376.655999999999,
	["Gadgetzan, Tanaris / Valormok, Azshara"] = 441.8899999999849,
	["Ironforge, Dun Morogh / Light's Hope Chapel, Eastern Plaguelands"] = 349.75,
	["Ebon Watch, Zul'Drak / Light's Breach, Zul'Drak"] = 45.75,
	["Unu'pe, Borean Tundra / Star's Rest, Dragonblight"] = 98.45399999999791,
	["Bouldercrag's Refuge, The Storm Peaks / Frosthold, The Storm Peaks"] = 79.84399999999732,
	["Tranquillien, Ghostlands / Silvermoon City"] = 74.0010000000002,
	["Thunder Bluff, Mulgore / Marshal's Refuge, Un'Goro Crater"] = 398.4700183705427,
	["The Argent Stand, Zul'Drak / Wintergarde Keep, Dragonblight"] = 120.468000000008,
	["Splintertree Post, Ashenvale / Orgrimmar, Durotar"] = 96.43699999999808,
	["Unu'pe, Borean Tundra / Transitus Shield, Coldarra"] = 158.5780000000377,
	["Lakeshire, Redridge / Sentinel Hill, Westfall"] = 134.2810000000027,
	["Telaar, Nagrand / Orebor Harborage, Zangarmarsh"] = 189.655999999999,
	["Dalaran / Argent Tournament Grounds, Icecrown"] = 123.859999999986,
	["Dalaran / Westfall Brigade, Grizzly Hills"] = 320.6849999999977,
	["The Shadow Vault, Icecrown / Death's Rise, Icecrown"] = 78.01600000000326,
	["Wyrmrest Temple, Dragonblight / Agmar's Hammer, Dragonblight"] = 47.41500000000815,
	["Kargath, Badlands / Flame Crest, Burning Steppes"] = 68.625,
	["Shattrath, Terokkar Forest / Area 52, Netherstorm"] = 236.3150000000023,
	["Zim'Torga, Zul'Drak / Amberpine Lodge, Grizzly Hills"] = 135.484999999986,
	["Camp Taurajo, The Barrens / Ratchet, The Barrens"] = 130.875,
	["Dun Nifflelem, The Storm Peaks / K3, The Storm Peaks"] = 88.92100000000028,
	["Venomspite, Dragonblight / Agmar's Hammer, Dragonblight"] = 133.3579999999784,
	["Splintertree Post, Ashenvale / Ratchet, The Barrens"] = 212.2819999999992,
	["Ratchet, The Barrens / Everlook, Winterspring"] = 361.6240000000689,
	["Kamagua, Howling Fjord / Moa'ki, Dragonblight"] = 195.75,
	["Sun Rock Retreat, Stonetalon Mountains / Freewind Post, Thousand Needles"] = 335.0160000000033,
	["Rut'theran Village, Teldrassil / Marshal's Refuge, Un'Goro Crater"] = 785.7030000000086,
	["Kamagua, Howling Fjord / Transitus Shield, Coldarra"] = 454.4380000000019,
	["Dalaran / Light's Breach, Zul'Drak"] = 251.4090000000433,
	["The Argent Stand, Zul'Drak / River's Heart, Sholazar Basin"] = 396.9629999999888,
	["Unu'pe, Borean Tundra / Wintergarde Keep, Dragonblight"] = 202.4379999999655,
	["Darkshire, Duskwood / Aerie Peak, The Hinterlands"] = 505.2659999999996,
	["Amber Ledge, Borean Tundra / Kamagua, Howling Fjord"] = 267.7030000000377,
	["Undercity, Tirisfal / Stonard, Swamp of Sorrows"] = 713.3220343026333,
	["Shadowmoon Village, Shadowmoon Valley / Thunderlord Stronghold, Blade's Edge Mountains"] = 312.1790142124519,
	["Shattrath, Terokkar Forest / Telredor, Zangarmarsh"] = 84.76600000000144,
	["Ironforge, Dun Morogh / Aerie Peak, The Hinterlands"] = 240.7189999999973,
	["Garadar, Nagrand / Zabra'jin, Zangarmarsh"] = 67.39100000000002,
	["Evergrove, Blade's Edge Mountains / Wildhammer Stronghold, Shadowmoon Valley"] = 366.0999999999767,
	["Astranaar, Ashenvale / Talrendis Point, Azshara"] = 149.0630000000001,
	["Thunder Bluff, Mulgore / Mudsprocket, Dustwallow Marsh"] = 206.4180000000015,
	["Astranaar, Ashenvale / Ratchet, The Barrens"] = 193.8280000000377,
	["Zabra'jin, Zangarmarsh / Garadar, Nagrand"] = 82.01500401552767,
	["Wyrmrest Temple, Dragonblight / Valgarde Port, Howling Fjord"] = 161,
	["Valgarde Port, Howling Fjord / Kamagua, Howling Fjord"] = 96.09400000001187,
	["Light's Hope Chapel, Eastern Plaguelands / Ironforge, Dun Morogh"] = 368.8899999999849,
	["Zabra'jin, Zangarmarsh / Cosmowrench, Netherstorm"] = 275.0540126934648,
	["Wyrmrest Temple, Dragonblight / Nesingwary Base Camp, Sholazar Basin"] = 199.4799999999814,
	["Dawnrise Expedition, Tanaris / Gadgetzan, Tanaris"] = 94.0690000000177,
	["Thrallmar, Hellfire Peninsula / Shadowmoon Village, Shadowmoon Valley"] = 193.2799999999988,
	["Stonard, Swamp of Sorrows / Booty Bay, Stranglethorn"] = 231.3010109178722,
	["Valgarde Port, Howling Fjord / Westguard Keep, Howling Fjord"] = 69.78199999999924,
	["Stormwind, Elwynn / Sentinel Hill, Westfall"] = 79.21799999999348,
	["Krom'gar Fortress, Stonetalon Mountains / Malaka'jin, Stonetalon Mountains"] = 68.59299999999348,
	["Rut'theran Village, Teldrassil / Auberdine, Darkshore"] = 86.09400000000005,
	["Thunderlord Stronghold, Blade's Edge Mountains / Garadar, Nagrand"] = 227.3600000000006,
	["Orebor Harborage, Zangarmarsh / Telredor, Zangarmarsh"] = 53.77100000000792,
	["Thrallmar, Hellfire Peninsula / Garadar, Nagrand"] = 199.7380077121779,
	["Silvermoon City / Zul'Aman, Ghostlands"] = 111.9619999999995,
	["Warsong Hold, Borean Tundra / Bor'gorok Outpost, Borean Tundra"] = 69.92200000002049,
	["Feathermoon, Feralas / Ratchet, The Barrens"] = 408.9219999999914,
	["Marshal's Refuge, Un'Goro Crater / Emerald Sanctuary, Felwood"] = 609.6399999999994,
	["Freewind Post, Thousand Needles / Mudsprocket, Dustwallow Marsh"] = 70,
	["Stormwind, Elwynn / Morgan's Vigil, Burning Steppes"] = 153.7030000000086,
	["Mok'Nathal Village, Blade's Edge Mountains / Swamprat Post, Zangarmarsh"] = 73.9120000000039,
	["Zabra'jin, Zangarmarsh / Stonebreaker Hold, Terokkar Forest"] = 220.1380097055808,
	["Gadgetzan, Tanaris / Dawnrise Expedition, Tanaris"] = 98.10899999993853,
	["Splintertree Post, Ashenvale / Sun Rock Retreat, Stonetalon Mountains"] = 286.8640000000014,
	["Kargath, Badlands / Undercity, Tirisfal"] = 498.4349999999977,
	["The Exodar / Blood Watch, Bloodmyst Isle"] = 77.85899999999674,
	["Gadgetzan, Tanaris / Silverwind Refuge, Ashenvale"] = 431.030999999959,
	["Undercity, Tirisfal / Flame Crest, Burning Steppes"] = 556.4109999999928,
	["Talonbranch Glade, Felwood / Feathermoon, Feralas"] = 660.437,
	["Amberpine Lodge, Grizzly Hills / Wintergarde Keep, Dragonblight"] = 82.85899999999674,
	["Sanctum of the Stars, Shadowmoon Valley / Thrallmar, Hellfire Peninsula"] = 257.1510114814155,
	["Gadgetzan, Tanaris / Brackenwall Village, Dustwallow Marsh"] = 194.3480000000054,
	["Silvermoon City / Shattered Sun Staging Area"] = 184.9529999999995,
	["Westguard Keep, Howling Fjord / K3, The Storm Peaks"] = 222.3600000000006,
	["Revantusk Village, The Hinterlands / Kargath, Badlands"] = 352.0000000000009,
	["Feathermoon, Feralas / Talonbranch Glade, Felwood"] = 657.5230000000447,
	["Southshore, Hillsbrad / Stormwind, Elwynn"] = 354.5469999999987,
	["Amberpine Lodge, Grizzly Hills / The Argent Stand, Zul'Drak"] = 166.2029999999795,
	["Gadgetzan, Tanaris / Thalanaar, Feralas"] = 177.6879999999983,
	["Morgan's Vigil, Burning Steppes / Ironforge, Dun Morogh"] = 171.0629999999946,
	["Dun Nifflelem, The Storm Peaks / Amberpine Lodge, Grizzly Hills"] = 224.1050000000978,
	["Kargath, Badlands / Stonard, Swamp of Sorrows"] = 224.9060000000009,
	["Dalaran / Transitus Shield, Coldarra"] = 346.9710000000196,
	["Darkshire, Duskwood / Lakeshire, Redridge"] = 60.18700000000536,
	["New Agamand, Howling Fjord / Agmar's Hammer, Dragonblight"] = 321.0230000000011,
	["Rut'theran Village, Teldrassil / Moonglade"] = 236.7179999999935,
	["Moa'ki, Dragonblight / Kamagua, Howling Fjord"] = 185.0619999999981,
	["Chillwind Camp, Western Plaguelands / Nethergarde Keep, Blasted Lands"] = 560.3119999999981,
	["Grom'gol, Stranglethorn / Booty Bay, Stranglethorn"] = 78.46800000000076,
	["Star's Rest, Dragonblight / Unu'pe, Borean Tundra"] = 100.9850000000006,
	["Thorium Point, Searing Gorge / Grom'gol, Stranglethorn"] = 234.755999999994,
	["Shattrath, Terokkar Forest / Cosmowrench, Netherstorm"] = 271.7820131359622,
	["Menethil Harbor, Wetlands / Booty Bay, Stranglethorn"] = 429.0620000000054,
	["Wyrmrest Temple, Dragonblight / Amberpine Lodge, Grizzly Hills"] = 81.82899999999972,
	["Krom'gar Fortress, Stonetalon Mountains / The Sludgewerks, Stonetalon Mountains"] = 48.002000000095,
	["Dalaran / Zim'Torga, Zul'Drak"] = 185.96,
	["Acherus: The Ebon Hold / Light's Hope Chapel, Eastern Plaguelands"] = 49.82899999999791,
	["Transitus Shield, Coldarra / Valiance Keep, Borean Tundra"] = 74.125,
	["Conquest Hold, Grizzly Hills / Wyrmrest Temple, Dragonblight"] = 138.0739999999641,
	["Orgrimmar, Durotar / Emerald Sanctuary, Felwood"] = 168.5370000000112,
	["Undercity, Tirisfal / Thorium Point, Searing Gorge"] = 544.2270000000135,
	["Unu'pe, Borean Tundra / Valiance Keep, Borean Tundra"] = 60.82800000000134,
	["Thunder Bluff, Mulgore / Camp Mojache, Feralas"] = 253.3530000000028,
	["Shattrath, Terokkar Forest / Thunderlord Stronghold, Blade's Edge Mountains"] = 186.4479999999999,
	["Hellfire Peninsula, The Dark Portal, Alliance / Shattrath, Terokkar Forest"] = 190.8910000000001,
	["Wyrmrest Temple, Dragonblight / Fordragon Hold, Dragonblight"] = 39.24200000000002,
	["Talrendis Point, Azshara / Theramore, Dustwallow Marsh"] = 240.7969999999987,
	["Unu'pe, Borean Tundra / Amberpine Lodge, Grizzly Hills"] = 273.125,
	["Bloodvenom Post, Felwood / Zoram'gar Outpost, Ashenvale"] = 136.5780000000013,
	["Morgan's Vigil, Burning Steppes / Thorium Point, Searing Gorge"] = 91.85899999999674,
	["Bor'gorok Outpost, Borean Tundra / River's Heart, Sholazar Basin"] = 57.51700000002165,
	["Agmar's Hammer, Dragonblight / Dun Nifflelem, The Storm Peaks"] = 266.8920000000071,
	["Telaar, Nagrand / Temple of Telhamat, Hellfire Peninsula"] = 209.015000000014,
	["Menethil Harbor, Wetlands / Aerie Peak, The Hinterlands"] = 177.25,
	["Orgrimmar, Durotar / Gadgetzan, Tanaris"] = 418.3489999999947,
	["Darkshire, Duskwood / Southshore, Hillsbrad"] = 439.2029999999795,
	["Rebel Camp, Stranglethorn Vale / Nethergarde Keep, Blasted Lands"] = 139.5360000000001,
	["Moonglade / Everlook, Winterspring"] = 120.0320000000065,
	["Ebon Watch, Zul'Drak / Unu'pe, Borean Tundra"] = 254.0940000000046,
	["Rut'theran Village, Teldrassil / Talrendis Point, Azshara"] = 385,
	["Telaar, Nagrand / Wildhammer Stronghold, Shadowmoon Valley"] = 199.6410000000033,
	["Wyrmrest Temple, Dragonblight / Wintergarde Keep, Dragonblight"] = 34.93699999999808,
	["Valiance Keep, Borean Tundra / Kamagua, Howling Fjord"] = 365.5620000000054,
	["Southshore, Hillsbrad / Light's Hope Chapel, Eastern Plaguelands"] = 219.5779999999941,
	["Conquest Hold, Grizzly Hills / Camp Oneqwah, Grizzly Hills"] = 101.5720000000001,
	["Dalaran / Amber Ledge, Borean Tundra"] = 343.0149999999849,
	["Fizzcrank Airstrip, Borean Tundra / Transitus Shield, Coldarra"] = 121.7970000000059,
	["Morgan's Vigil, Burning Steppes / Menethil Harbor, Wetlands"] = 240.0630000000238,
	["Mudsprocket, Dustwallow Marsh / Ratchet, The Barrens"] = 151.2179999999935,
	["Southshore, Hillsbrad / Thelsamar, Loch Modan"] = 244.5720000000147,
	["Sylvanaar, Blade's Edge Mountains / Evergrove, Blade's Edge Mountains"] = 52.18700000000536,
	["Orebor Harborage, Zangarmarsh / Shattrath, Terokkar Forest"] = 150.5,
	["Feathermoon, Feralas / Cenarion Hold, Silithus"] = 153.7190000000001,
	["Bloodvenom Post, Felwood / Gadgetzan, Tanaris"] = 518.8720000000321,
	["Gadgetzan, Tanaris / Freewind Post, Thousand Needles"] = 87.67200000000594,
	["Warsong Camp, Wintergrasp / River's Heart, Sholazar Basin"] = 77.23300000000018,
	["Orgrimmar, Durotar / Ratchet, The Barrens"] = 107.9449999999779,
	["Garadar, Nagrand / Thrallmar, Hellfire Peninsula"] = 199.5470093977638,
	["Nesingwary Base Camp, Sholazar Basin / The Shadow Vault, Icecrown"] = 277.1559999999881,
	["Valgarde Port, Howling Fjord / Dalaran"] = 316.125,
	["Sun Rock Retreat, Stonetalon Mountains / Shadowprey Village, Desolace"] = 144.6720000000059,
	["Menethil Harbor, Wetlands / Morgan's Vigil, Burning Steppes"] = 217.3130000000019,
	["Light's Hope Chapel, Eastern Plaguelands / Menethil Harbor, Wetlands"] = 333.3279999999941,
	["Moonglade / Talrendis Point, Azshara"] = 281.093000000008,
	["Garadar, Nagrand / Shattrath, Terokkar Forest"] = 78.25400000000082,
	["Stormwind, Elwynn / Booty Bay, Stranglethorn"] = 199.4060000000027,
	["Falcon Watch, Hellfire Peninsula / Thrallmar, Hellfire Peninsula"] = 73.783003305085,
	["Moa'ki, Dragonblight / Westguard Keep, Howling Fjord"] = 205.8279999999795,
	["Ironforge, Dun Morogh / Morgan's Vigil, Burning Steppes"] = 169.5779999999995,
	["Amber Ledge, Borean Tundra / Dalaran"] = 187.9760000000242,
	["Evergrove, Blade's Edge Mountains / Mok'Nathal Village, Blade's Edge Mountains"] = 91.52900397963822,
	["Menethil Harbor, Wetlands / Stormwind, Elwynn"] = 244.9840000000113,
	["The Argent Stand, Zul'Drak / Conquest Hold, Grizzly Hills"] = 98.22599999999875,
	["Gadgetzan, Tanaris / Crossroads, The Barrens"] = 301.05799999999,
	["The Stormspire, Netherstorm / Shattrath, Terokkar Forest"] = 277.7279999999992,
	["Garadar, Nagrand / Stonebreaker Hold, Terokkar Forest"] = 142.0420070923865,
	["River's Heart, Sholazar Basin / Nesingwary Base Camp, Sholazar Basin"] = 64.68499999999767,
	["Ironforge, Dun Morogh / Thelsamar, Loch Modan"] = 102.5780000000086,
	["Star's Rest, Dragonblight / Dalaran"] = 146.5,
	["Amber Ledge, Borean Tundra / Warsong Hold, Borean Tundra"] = 29.21799999999348,
	["Moa'ki, Dragonblight / Wyrmrest Temple, Dragonblight"] = 132.420999999973,
	["Brackenwall Village, Dustwallow Marsh / Camp Taurajo, The Barrens"] = 49.875,
	["Everlook, Winterspring / Orgrimmar, Durotar"] = 251.4579999999842,
	["Altar of Sha'tar, Shadowmoon Valley / Area 52, Netherstorm"] = 490.2360000000044,
	["K3, The Storm Peaks / River's Heart, Sholazar Basin"] = 417.8580000000002,
	["Mudsprocket, Dustwallow Marsh / Brackenwall Village, Dustwallow Marsh"] = 63.73399999999674,
	["Hammerfall, Arathi / Tarren Mill, Hillsbrad"] = 117.2210000000196,
	["Dalaran / Westguard Keep, Howling Fjord"] = 377.578,
	["Kamagua, Howling Fjord / New Agamand, Howling Fjord"] = 63.90599999998813,
	["Dun Nifflelem, The Storm Peaks / Zim'Torga, Zul'Drak"] = 89.71899999998277,
	["The Sepulcher, Silverpine Forest / Undercity, Tirisfal"] = 112.101999999999,
	["Ironforge, Dun Morogh / Refuge Pointe, Arathi"] = 204.1720000000005,
	["Stonetalon Peak, Stonetalon Mountains / Ratchet, The Barrens"] = 348.5470000000205,
	["Shattrath, Terokkar Forest / Zabra'jin, Zangarmarsh"] = 137.5070063676685,
	["Zul'Aman, Ghostlands / Tranquillien, Ghostlands"] = 52.93699999999808,
	["Hellscream's Watch, Ashenvale / Silverwind Refuge, Ashenvale"] = 47.68999999994412,
	["Rut'theran Village, Teldrassil / Ratchet, The Barrens"] = 446.3600000000151,
	["Valiance Landing Camp, Wintergrasp / Dalaran"] = 91.27199999999721,
	["Auberdine, Darkshore / Rut'theran Village, Teldrassil"] = 84.84399999999732,
	["Rebel Camp, Stranglethorn Vale / Darkshire, Duskwood"] = 49.14100000000326,
	["Sun Rock Retreat, Stonetalon Mountains / Orgrimmar, Durotar"] = 270.0380000000587,
	["Allerian Stronghold, Terokkar Forest / Wildhammer Stronghold, Shadowmoon Valley"] = 80.09500000000116,
	["Auberdine, Darkshore / Astranaar, Ashenvale"] = 168.3130000000001,
	["Dalaran / Moa'ki, Dragonblight"] = 159.9060000000754,
	["Sun Rock Retreat, Stonetalon Mountains / Thunder Bluff, Mulgore"] = 175.5939999999973,
	["Stonetalon Peak, Stonetalon Mountains / Nijel's Point, Desolace"] = 127.8289999999979,
	["Telaar, Nagrand / Shattrath, Terokkar Forest"] = 88.6160000000018,
	["Everlook, Winterspring / Feathermoon, Feralas"] = 724.0230000000156,
	["Grom'gol, Stranglethorn / Kargath, Badlands"] = 247.2350000000006,
	["River's Heart, Sholazar Basin / Death's Rise, Icecrown"] = 140.2330000000002,
	["Refuge Pointe, Arathi / Chillwind Camp, Western Plaguelands"] = 122.3910000000033,
	["Gadgetzan, Tanaris / Mudsprocket, Dustwallow Marsh"] = 212.4840000000004,
	["Stonard, Swamp of Sorrows / Flame Crest, Burning Steppes"] = 176.622000000003,
	["Shattrath, Terokkar Forest / Honor Hold, Hellfire Peninsula"] = 111.6100000000006,
	["Nijel's Point, Desolace / Theramore, Dustwallow Marsh"] = 308.2030000000086,
	["Valiance Keep, Borean Tundra / Moa'ki, Dragonblight"] = 76.3130000000092,
	["Transitus Shield, Coldarra / Warsong Hold, Borean Tundra"] = 57.31000000002678,
	["Ironforge, Dun Morogh / Stormwind, Elwynn"] = 210.8049999999348,
	["Moa'ki, Dragonblight / Dalaran"] = 123.3589999999967,
	["Transitus Shield, Coldarra / Camp Oneqwah, Grizzly Hills"] = 300.5890000000363,
	["Shadowprey Village, Desolace / Camp Mojache, Feralas"] = 197.1560000000027,
	["Crusaders' Pinnacle, Icecrown / Argent Tournament Grounds, Icecrown"] = 97.77000000001863,
	["Telredor, Zangarmarsh / Orebor Harborage, Zangarmarsh"] = 63.70300000000862,
	["Shadowmoon Village, Shadowmoon Valley / Sanctum of the Stars, Shadowmoon Valley"] = 65.38800000000015,
	["Auberdine, Darkshore / Everlook, Winterspring"] = 270.3120000000054,
	["Malaka'jin, Stonetalon Mountains / Krom'gar Fortress, Stonetalon Mountains"] = 70.18500000005588,
	["Undercity, Tirisfal / Hammerfall, Arathi"] = 302.0229999999865,
}
end

local SetAddonLoader = function()
if(AddonLoaderSV) then table.wipe(AddonLoaderSV) end

AddonLoaderSV = {
	["overrides"] = {
	},
	["silent"] = true,
}
end

local SetAzCastBar = function()
if(AzCastBar_Profiles) then table.wipe(AzCastBar_Profiles) end

AzCastBar_Profiles = {
	["KisekiUI"] = {
		["Beacon"] = {
			["AnimationY"] = 193,
			["colGradient"] = true,
			["bottom"] = 824.8031661136422,
			["AnimationLock"] = true,
			["AnimationTime"] = 10,
			["left"] = 1129,
			["AnimationX"] = 1180,
			["reverseGrowth"] = false,
			["showSpark"] = false,
			["colNormal"] = {
				0.4, -- [1]
				0.6, -- [2]
				0.8, -- [3]
				1, -- [4]
			},
			["strata"] = "LOW",
			["colGradientTime"] = true,
			["Animation"] = true,
			["AnimationSize"] = 60,
			["texture"] = "Interface\\AddOns\\Ferous Media\\StatusBars\\Skullflower.tga",
		},
		["Sacred"] = {
			["AnimationY"] = 193,
			["colGradient"] = true,
			["bottom"] = 849.1407707197882,
			["AnimationLock"] = true,
			["AnimationTime"] = 10,
			["left"] = 1129,
			["AnimationX"] = 559,
			["colNormal"] = {
				0.4, -- [1]
				0.6, -- [2]
				0.8, -- [3]
				1, -- [4]
			},
			["strata"] = "LOW",
			["colGradientTime"] = true,
			["Animation"] = true,
			["AnimationSize"] = 60,
			["texture"] = "Interface\\Addons\\Skada\\statusbar\\normTex",
		},
		["optionsBottom"] = 412.0316655925392,
		["BattleGround"] = {
			["enabled"] = true,
			["strata"] = "MEDIUM",
			["bottom"] = 1081.351783725243,
			["colHorde"] = {
				1, -- [1]
				0.5, -- [2]
				0.5, -- [3]
			},
			["colAlliance"] = {
				0.4, -- [1]
				0.6, -- [2]
				0.8, -- [3]
			},
			["left"] = 767.5358116028402,
			["colNeutral"] = {
				0.25, -- [1]
				0.76, -- [2]
				0.58, -- [3]
			},
		},
		["optionsLeft"] = 632.6512320789459,
		["Cooldowns"] = {
			["enabled"] = true,
			["showTotalTime"] = false,
			["left"] = 1337.798122182875,
			["bottom"] = 157.0161653318035,
			["nameFontFace"] = "Interface\\Addons\\Ferous Media\\Fonts\\russelsquare.ttf",
			["anchorPoint"] = "TOP",
			["showSpark"] = false,
			["maxShownCooldown"] = 0,
			["nameFontFlags"] = "OUTLINE",
			["timeFontFace"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
			["colNormal"] = {
				0.4, -- [1]
				0.6, -- [2]
				0.8, -- [3]
			},
			["backdropIndent"] = -2.5,
			["colBackGround"] = {
				0.3, -- [1]
				0.3, -- [2]
				0.3, -- [3]
				0.6, -- [4]
			},
			["minShownCooldown"] = 10,
			["colBackdrop"] = {
				0.1058823529411765, -- [1]
				0.2196078431372549, -- [2]
				0.3490196078431372, -- [3]
				0.7800000011920929, -- [4]
			},
			["texture"] = "Interface\\AddOns\\Ferous Media\\StatusBars\\fer3.tga",
		},
		["LootRolls"] = {
			["bgFile"] = "Interface\\AddOns\\Ferous Media\\Textures\\Smooth",
			["bottom"] = 829.2184369058633,
			["useSameBGTexture"] = true,
			["reverseGrowth"] = true,
			["showSpark"] = true,
			["width"] = 295,
			["anchorPoint"] = "TOP",
			["strata"] = "HIGH",
			["left"] = 1127.217203340313,
			["colBackdrop"] = {
				0.1, -- [1]
				0.22, -- [2]
				0.35, -- [3]
			},
			["texture"] = "Interface\\AddOns\\Ferous Media\\StatusBars\\savant7.tga",
		},
		["Mirror"] = {
			["enabled"] = true,
			["strata"] = "HIGH",
			["colNormal"] = {
				0.4, -- [1]
				0.6, -- [2]
				0.8, -- [3]
			},
			["bottom"] = 115.3945258086419,
			["anchorPoint"] = "TOP",
			["left"] = 776.4081159188186,
			["showSpark"] = true,
			["texture"] = "Interface\\AddOns\\Ferous Media\\StatusBars\\fer4.tga",
		},
		["Flight"] = {
			["enabled"] = true,
			["bgFile"] = "Interface\\AddOns\\Forte_Core\\Textures\\Smooth",
			["bottom"] = 1082.383481439689,
			["nameFontFace"] = "Fonts\\FRIZQT__.TTF",
			["reverseGrowth"] = false,
			["left"] = 765.5374820825482,
			["colNormal"] = {
				0.4, -- [1]
				0.6, -- [2]
				0.8, -- [3]
			},
			["height"] = 20,
			["showSpark"] = true,
			["strata"] = "HIGH",
			["texture"] = "Interface\\AddOns\\Ferous Media\\StatusBars\\savant7.tga",
		},
	},
}
end

local SetAzCastBarPSV = function()
if(AzCastBar_Config) then table.wipe(AzCastBar_Config) end

AzCastBar_Config = {
	["Daybreak"] = {
		["colGradient"] = true,
		["colNormal"] = {
			0.4, -- [1]
			0.6, -- [2]
			0.8, -- [3]
			1, -- [4]
		},
		["bottom"] = 849.8985275304067,
		["colGradientTime"] = true,
		["texture"] = "Interface\\Addons\\Skada\\statusbar\\normTex",
		["left"] = 1127.174161953872,
		["width"] = 250,
	},
	["Swing"] = {
		["bottom"] = 547.5217755246678,
		["left"] = 765.4347729547044,
		["colNormal"] = {
			0.4, -- [1]
			0.6, -- [2]
			0.8, -- [3]
		},
		["colParry"] = {
			1, -- [1]
			0.75, -- [2]
			0.5, -- [3]
		},
	},
	["GlobalCooldown"] = {
		["bottom"] = 547.5217755246678,
		["left"] = 765.4347729547044,
		["colNormal"] = {
			0.4, -- [1]
			0.6, -- [2]
			0.8, -- [3]
		},
		["showInstants"] = true,
	},
	["optionsBottom"] = 410.1765674418402,
	["Beacon"] = {
		["AnimationY"] = 193,
		["strata"] = "LOW",
		["AnimationLock"] = true,
		["AnimationTime"] = 10,
		["AnimationSize"] = 60,
		["AnimationX"] = 1180,
		["anchorPoint"] = "TOP",
		["colNormal"] = {
			0.4, -- [1]
			0.6, -- [2]
			0.8, -- [3]
			1, -- [4]
		},
		["colGradientTime"] = true,
		["texture"] = "Interface\\Addons\\Skada\\statusbar\\normTex",
		["Animation"] = true,
		["width"] = 250,
		["showSpark"] = false,
		["left"] = 1127.145011851015,
		["bottom"] = 825,
		["reverseGrowth"] = false,
		["colGradient"] = true,
	},
	["Sacred"] = {
		["AnimationY"] = 193,
		["colGradient"] = true,
		["bottom"] = 849.1407707197882,
		["AnimationLock"] = true,
		["AnimationTime"] = 10,
		["left"] = 1129,
		["AnimationX"] = 559,
		["colNormal"] = {
			0.4, -- [1]
			0.6, -- [2]
			0.8, -- [3]
			1, -- [4]
		},
		["strata"] = "LOW",
		["colGradientTime"] = true,
		["AnimationSize"] = 60,
		["Animation"] = true,
		["texture"] = "Interface\\Addons\\Skada\\statusbar\\normTex",
	},
	["Mirror"] = {
		["enabled"] = true,
		["strata"] = "HIGH",
		["colNormal"] = {
			0.4, -- [1]
			0.6, -- [2]
			0.8, -- [3]
		},
		["bottom"] = 115.3945258086419,
		["anchorPoint"] = "TOP",
		["showSpark"] = true,
		["left"] = 776.4081159188186,
		["texture"] = "Interface\\AddOns\\Ferous Media\\StatusBars\\fer4.tga",
	},
	["BattleGround"] = {
		["enabled"] = true,
		["strata"] = "MEDIUM",
		["bottom"] = 1081.351783725243,
		["colNeutral"] = {
			0.25, -- [1]
			0.76, -- [2]
			0.58, -- [3]
		},
		["colAlliance"] = {
			0.4, -- [1]
			0.6, -- [2]
			0.8, -- [3]
		},
		["left"] = 767.5358116028402,
		["colHorde"] = {
			1, -- [1]
			0.5, -- [2]
			0.5, -- [3]
		},
	},
	["PlayerAuras"] = {
		["hideEnchants"] = false,
		["showTracking"] = false,
		["shortBuffDuration"] = 30,
		["showBuffs"] = true,
		["left"] = 765.4347729547044,
		["selfAurasOnly"] = false,
		["defaultDebuffColors"] = true,
		["showStealable"] = false,
		["colDebuff"] = {
			1, -- [1]
			0.5, -- [2]
			0.5, -- [3]
		},
		["enabled"] = false,
		["colEnchant"] = {
			0.6, -- [1]
			0.2, -- [2]
			0.9, -- [3]
		},
		["bottom"] = 547.5217755246678,
		["showDebuffs"] = true,
		["showPetAuras"] = false,
		["fullBarTimeless"] = false,
		["hideTracking"] = false,
		["hideAuras"] = false,
		["unit"] = "player",
		["colBuff"] = {
			0.4, -- [1]
			0.6, -- [2]
			0.8, -- [3]
		},
		["colTimeOut"] = {
			0.8, -- [1]
			0.8, -- [2]
			0.2, -- [3]
		},
		["bgColorAlpha"] = 0.2,
		["showEnchants"] = true,
		["auraLabelFormat"] = "FULL",
	},
	["optionsLeft"] = 302.4484396660981,
	["LootRolls"] = {
		["strata"] = "HIGH",
		["bottom"] = 802.3198016229786,
		["useSameBGTexture"] = true,
		["reverseGrowth"] = true,
		["showSpark"] = true,
		["width"] = 295,
		["anchorPoint"] = "BOTTOM",
		["bgFile"] = "Interface\\AddOns\\Ferous Media\\Textures\\Smooth",
		["left"] = 1084,
		["colBackdrop"] = {
			0.1, -- [1]
			0.22, -- [2]
			0.35, -- [3]
		},
		["texture"] = "Interface\\AddOns\\Ferous Media\\StatusBars\\savant7.tga",
	},
	["TargetAuras"] = {
		["showTracking"] = false,
		["shortBuffDuration"] = 30,
		["showBuffs"] = true,
		["left"] = 765.4347729547044,
		["selfAurasOnly"] = true,
		["defaultDebuffColors"] = true,
		["showStealable"] = false,
		["colDebuff"] = {
			1, -- [1]
			0.5, -- [2]
			0.5, -- [3]
		},
		["enabled"] = false,
		["colEnchant"] = {
			0.6, -- [1]
			0.2, -- [2]
			0.9, -- [3]
		},
		["bottom"] = 547.5217755246678,
		["showDebuffs"] = true,
		["fullBarTimeless"] = false,
		["showPetAuras"] = false,
		["bgColorAlpha"] = 0.2,
		["colBuff"] = {
			0.4, -- [1]
			0.6, -- [2]
			0.8, -- [3]
		},
		["colTimeOut"] = {
			0.8, -- [1]
			0.8, -- [2]
			0.2, -- [3]
		},
		["unit"] = "target",
		["showEnchants"] = false,
		["auraLabelFormat"] = "FULL",
	},
	["Cooldowns"] = {
		["enabled"] = true,
		["showTotalTime"] = false,
		["showSpark"] = false,
		["bottom"] = 157.0161653318035,
		["nameFontFace"] = "Interface\\Addons\\Ferous Media\\Fonts\\russelsquare.ttf",
		["nameFontFlags"] = "OUTLINE",
		["left"] = 1337.798122182875,
		["maxShownCooldown"] = 0,
		["anchorPoint"] = "TOP",
		["timeFontFace"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
		["colNormal"] = {
			0.4, -- [1]
			0.6, -- [2]
			0.8, -- [3]
		},
		["colBackGround"] = {
			0.3, -- [1]
			0.3, -- [2]
			0.3, -- [3]
			0.6, -- [4]
		},
		["backdropIndent"] = -2.5,
		["minShownCooldown"] = 10,
		["colBackdrop"] = {
			0.1058823529411765, -- [1]
			0.2196078431372549, -- [2]
			0.3490196078431372, -- [3]
			0.7800000011920929, -- [4]
		},
		["texture"] = "Interface\\AddOns\\Ferous Media\\StatusBars\\fer3.tga",
	},
	["HolyPower"] = {
		["bottom"] = 547.5217755246678,
		["colBar1"] = {
			0, -- [1]
			1, -- [2]
			0, -- [3]
			1, -- [4]
		},
		["colBar3"] = {
			1, -- [1]
			0, -- [2]
			0, -- [3]
			1, -- [4]
		},
		["left"] = 765.4347729547044,
		["colBar2"] = {
			0, -- [1]
			1, -- [2]
			1, -- [3]
			1, -- [4]
		},
	},
	["Flight"] = {
		["enabled"] = true,
		["bgFile"] = "Interface\\AddOns\\Forte_Core\\Textures\\Smooth",
		["bottom"] = 1071.25303648662,
		["nameFontFace"] = "Fonts\\FRIZQT__.TTF",
		["reverseGrowth"] = false,
		["left"] = 777.595188208716,
		["colNormal"] = {
			0.4, -- [1]
			0.6, -- [2]
			0.8, -- [3]
		},
		["height"] = 20,
		["showSpark"] = true,
		["strata"] = "HIGH",
		["texture"] = "Interface\\AddOns\\Ferous Media\\StatusBars\\savant7.tga",
	},
	["Threat"] = {
		["threshold"] = 75,
		["left"] = 765.4347729547044,
		["bottom"] = 547.5217755246678,
	},
}
end

local SetForte = function()
if(FC_Saved) then table.wipe(FC_Saved) end

FC_Saved = {
	["Exceptions"] = {
		["Hellfire Channeler"] = 0,
		["Grand Astromancer Capernian"] = 1,
		["Lord Sanguinar"] = 1,
		["Thaladred the Darkener"] = 1,
		["Fathom-Guard Caribdis"] = 1,
		["Fathom-Guard Tidalvess"] = 1,
		["Master Engineer Telonicus"] = 1,
		["Fathom-Guard Sharkkis"] = 1,
	},
	["Update"] = 15937.483,
	["Profiles"] = {
		["Profile"] = {
			["PaladinColor"] = {
				0.96, -- [1]
				0.55, -- [2]
				0.73, -- [3]
			},
			["HealthstoneUnknownMinColor"] = {
				0.53, -- [1]
				1, -- [2]
				0, -- [3]
			},
			["SummonWidth"] = 100,
			["SummoningColor"] = {
				0.64, -- [1]
				0.21, -- [2]
				0.9300000000000001, -- [3]
			},
			["TimerFadeSoundVolume"] = 2,
			["OptionsFontInputColor"] = {
				1, -- [1]
				1, -- [2]
				1, -- [3]
			},
			["CooldownStrata"] = "MEDIUM",
			["GlobalSparkEnable"] = true,
			["SoulstoneBgColor"] = {
				0.31, -- [1]
				0, -- [2]
				0.62, -- [3]
				0.75, -- [4]
			},
			["RemoveAfterCombat"] = false,
			["TimerInstantSoundEnable"] = false,
			["TimerClearcastingSound"] = "Sound\\Spells\\SimonGame_Visual_GameStart.wav",
			["TimerResistSoundVolume"] = 1,
			["SummonDetails"] = true,
			["FWOptions"] = {
				["y"] = 457.6000854128355,
				["x"] = 613.7600782647445,
				["lock"] = true,
				["scale"] = 1,
				["alpha"] = 1,
			},
			["SoulstoneFont"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHIC.TTF",
			["MeetingStoneSummon"] = 0,
			["SoulstoneMsgEnable"] = true,
			["SummonKeyword"] = true,
			["SoulstoneTextColor"] = {
				1, -- [1]
				1, -- [2]
				1, -- [3]
			},
			["SoulstoneTexture"] = "Interface\\AddOns\\Forte_Core\\Textures\\Aluminium",
			["WarlockColor"] = {
				0.58, -- [1]
				0.51, -- [2]
				0.79, -- [3]
			},
			["DotTicksDelayNew"] = 1.5,
			["DeadColor"] = {
				0.5, -- [1]
				0.5, -- [2]
				0.5, -- [3]
			},
			["SparkOverrideColor"] = {
				1, -- [1]
				1, -- [2]
				1, -- [3]
			},
			["ShowStartupText"] = true,
			["WhisperColor"] = {
				1, -- [1]
				0, -- [2]
				1, -- [3]
			},
			["Font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHIC.TTF",
			["SummonTextColor"] = {
				1, -- [1]
				1, -- [2]
				1, -- [3]
			},
			["SummonCloser"] = false,
			["OutputMsg"] = "MyProChannel",
			["HealthstoneBgColor"] = {
				0.31, -- [1]
				0, -- [2]
				0.62, -- [3]
				0.75, -- [4]
			},
			["FrameSnap"] = true,
			["ReadyColor"] = {
				1, -- [1]
				1, -- [2]
				0, -- [3]
			},
			["FWHSFrame"] = {
				["y"] = 384.0000284843451,
				["x"] = 614.4000179363367,
				["lock"] = false,
				["scale"] = 1,
				["alpha"] = 1,
			},
			["HealthstoneTextColor"] = {
				1, -- [1]
				1, -- [2]
				1, -- [3]
			},
			["HealthstoneMax"] = 5,
			["TimerBreakSoundEnable"] = true,
			["HealthstoneDetails"] = true,
			["SoulstoneEnable"] = true,
			["Texture"] = "Interface\\AddOns\\Forte_Core\\Textures\\Aluminium",
			["FrameSnapDistance"] = 5,
			["OptionHeaderColor"] = {
				0.2, -- [1]
				0.2, -- [2]
				0.2, -- [3]
			},
			["Details"] = true,
			["SummonTexture"] = "Interface\\AddOns\\Forte_Core\\Textures\\Aluminium",
			["HealthstoneSpace"] = 1,
			["FrameDistance"] = 0,
			["AnimationInterval"] = 0.04,
			["Cooldown"] = {
				["ResTimerEnable"] = true,
				["MaxRemainingEnable"] = false,
				["SpellEnable"] = true,
				["IconSize"] = 16,
				["AlphaMax"] = 1,
				["Tags"] = 8,
				["MinRemaining"] = 0,
				["y"] = 7,
				["BuffEnable"] = true,
				["Filter"] = {
					["Recently Bandaged"] = {
						[2] = {
							-2, -- [1]
							1, -- [2]
							0.65, -- [3]
							0, -- [4]
						},
					},
				},
				["MinRangeEnable"] = false,
				["IconSizeEnable"] = false,
				["ResTimerColor"] = {
					1, -- [1]
					0, -- [2]
					0, -- [3]
				},
				["scale"] = 1,
				["PotionColor"] = {
					0, -- [1]
					1, -- [2]
					0, -- [3]
				},
				["HealthstoneColor"] = {
					0, -- [1]
					1, -- [2]
					0.5, -- [3]
				},
				["PetColor"] = {
					1, -- [1]
					0, -- [2]
					0.95, -- [3]
				},
				["MaxRangeEnable"] = false,
				["Max"] = 300,
				["Backdrop"] = {
					"Interface\\AddOns\\Forte_Core\\Textures\\Background", -- [1]
					"Interface\\AddOns\\Ferous Media\\Borders\\fer13.tga", -- [2]
					false, -- [3]
					16, -- [4]
					5, -- [5]
					3, -- [6]
				},
				["Font"] = "Interface\\Addons\\Ferous Media\\Fonts\\russelsquare.ttf",
				["DebuffEnable"] = true,
				["Height"] = 16,
				["DebuffOtherColor"] = {
					0.5, -- [1]
					0, -- [2]
					0, -- [3]
				},
				["FontSize"] = 11,
				["MinRange"] = 0,
				["Enable"] = true,
				["Loga"] = 0.33,
				["Vertical"] = false,
				["DebuffOtherEnable"] = false,
				["lock"] = true,
				["PotionEnable"] = true,
				["CustomTagsMsg"] = "0 1 10 30 60 120 180 240  300 600",
				["SoulstoneEnable"] = true,
				["Hide"] = true,
				["DebuffColor"] = {
					1, -- [1]
					0, -- [2]
					0, -- [3]
				},
				["EnchantColor"] = {
					1, -- [1]
					1, -- [2]
					1, -- [3]
				},
				["Width"] = 450,
				["BuffColor"] = {
					1, -- [1]
					1, -- [2]
					1, -- [3]
				},
				["MaxRemaining"] = 3600,
				["alpha"] = 1,
				["Alpha"] = 0.2,
				["GroupOverride"] = true,
				["TextColor"] = {
					1, -- [1]
					1, -- [2]
					1, -- [3]
					0.2, -- [4]
				},
				["ItemColor"] = {
					1, -- [1]
					1, -- [2]
					0, -- [3]
				},
				["Swing"] = false,
				["SparkEnable"] = true,
				["Warn"] = true,
				["PetEnable"] = true,
				["IconTextEnable"] = true,
				["Detail"] = true,
				["Ignore"] = true,
				["IconTextColor"] = {
					1, -- [1]
					1, -- [2]
					1, -- [3]
					0, -- [4]
				},
				["IconFont"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHIC.TTF",
				["BarColor"] = {
					0.9215686274509803, -- [1]
					0.3372549019607843, -- [2]
					1, -- [3]
					0.2000000476837158, -- [4]
				},
				["Splash"] = true,
				["EnchantEnable"] = true,
				["Spark"] = 1,
				["MaxRange"] = 3600,
				["PowerupColor"] = {
					0, -- [1]
					0.75, -- [2]
					1, -- [3]
				},
				["SoulstoneColor"] = {
					0.64, -- [1]
					0.21, -- [2]
					0.9300000000000001, -- [3]
				},
				["Texture"] = "Interface\\AddOns\\Ferous Media\\StatusBars\\fer34.tga",
				["Flip"] = false,
				["ItemEnable"] = true,
				["BgColor"] = {
					0, -- [1]
					0, -- [2]
					0, -- [3]
					0.5, -- [4]
				},
				["BuffOtherColor"] = {
					0.5, -- [1]
					0.5, -- [2]
					0.5, -- [3]
				},
				["MinRemainingEnable"] = false,
				["CustomTags"] = true,
				["IconFontSize"] = 11,
				["HealthstoneEnable"] = true,
				["SpellColor"] = {
					1, -- [1]
					0.5, -- [2]
					0, -- [3]
				},
				["SplashFactor"] = 4,
				["Test"] = false,
				["BuffOtherEnable"] = false,
				["PowerupEnable"] = true,
				["x"] = 614,
			},
			["TimerStrata"] = "MEDIUM",
			["GlobalAlpha"] = 1,
			["SummonCloseColor"] = {
				0.6, -- [1]
				0.6, -- [2]
				0.6, -- [3]
			},
			["SummonMax"] = 5,
			["OptionsHeaderFontSize"] = 11,
			["OutputRaid"] = true,
			["UpdateInterval"] = 0.5,
			["HealthstoneMaxColor"] = {
				0.53, -- [1]
				1, -- [2]
				0, -- [3]
			},
			["OptionsModuleColor"] = true,
			["SoulstoneDetailsAuto"] = false,
			["SummonExpand"] = false,
			["HealthstoneHeight"] = 12,
			["AnimateScroll"] = false,
			["OptionsFont"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHIC.TTF",
			["HealthstoneEnable"] = true,
			["SummonOldMode"] = false,
			["TimerImproveRaidTarget"] = false,
			["OptionsFontLabelColor"] = {
				1, -- [1]
				1, -- [2]
				1, -- [3]
			},
			["SoulstoneFontSize"] = 11,
			["ShowAll"] = true,
			["HealthstoneFontSize"] = 11,
			["GlobalFrameNames"] = false,
			["LoadDelay"] = 1,
			["SpellTimerInterval"] = 0.2,
			["HealthstoneAuto"] = false,
			["GlobalLock"] = false,
			["Tips"] = true,
			["HealthstoneDetailsAuto"] = false,
			["Delay"] = 0.05,
			["SparkOverrideEnable"] = false,
			["FWSSFrame"] = {
				["y"] = 384.0000284843451,
				["x"] = 614.4000179363367,
				["lock"] = false,
				["scale"] = 1,
				["alpha"] = 1,
			},
			["TimerBreakSoundVolume"] = 4,
			["OptionsBackdrop"] = {
				"Interface\\AddOns\\Forte_Core\\Textures\\Background", -- [1]
				"Interface\\AddOns\\Forte_Core\\Textures\\Border", -- [2]
				false, -- [3]
				16, -- [4]
				5, -- [5]
				5, -- [6]
			},
			["SummonInterval"] = 1,
			["SummonFontSize"] = 11,
			["TalentOffsetY"] = 0,
			["SummonEnable"] = true,
			["TimerResistSoundEnable"] = true,
			["SoulstoneReadySoundVolume"] = 1,
			["SummonBgColor"] = {
				0.31, -- [1]
				0, -- [2]
				0.62, -- [3]
				0.75, -- [4]
			},
			["SummonKeywordMsg"] = "summon",
			["TimerImprove"] = false,
			["CancelDelay"] = 0.5,
			["TimerInstantSound"] = "Sound\\Spells\\ShadowWard.wav",
			["TimerInstantSoundVolume"] = 4,
			["SummonFont"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHIC.TTF",
			["Mix"] = 0.5,
			["Timer"] = {
				["HighlightColor"] = {
					1, -- [1]
					1, -- [2]
					1, -- [3]
				},
				["FocusBgColor"] = {
					1, -- [1]
					1, -- [2]
					0.5, -- [3]
					1, -- [4]
				},
				["NoTarget"] = true,
				["MaxEnable"] = false,
				["CustomTag"] = false,
				["Expand"] = true,
				["SelfDebuffColor"] = {
					1, -- [1]
					0, -- [2]
					0, -- [3]
				},
				["HideTime"] = 2,
				["CurseEnable"] = true,
				["Shared2Color"] = {
					0, -- [1]
					0.54, -- [2]
					0.42, -- [3]
				},
				["CustomTagMsg"] = "id target :: spell stacks",
				["DebuffsOtherColor"] = {
					0, -- [1]
					0.18, -- [2]
					0.5, -- [3]
				},
				["FadeTime"] = 1,
				["NormalColor"] = {
					1, -- [1]
					1, -- [2]
					1, -- [3]
					1, -- [4]
				},
				["HealEnable"] = true,
				["y"] = 441.5199780283377,
				["Blink"] = 3,
				["Filter"] = {
				},
				["DrainColor"] = {
					0.42, -- [1]
					0, -- [2]
					1, -- [3]
				},
				["HideLonger"] = 30,
				["TicksEnable"] = true,
				["FailTime"] = 2,
				["BuffOtherEnable"] = false,
				["SelfDebuffOtherEnable"] = false,
				["scale"] = 1,
				["PetEnable"] = true,
				["TargetColor"] = {
					1, -- [1]
					1, -- [2]
					1, -- [3]
					1, -- [4]
				},
				["IgnoreLong"] = false,
				["MagicColor"] = {
					1, -- [1]
					0.5, -- [2]
					0, -- [3]
				},
				["TargetBgColor"] = {
					0, -- [1]
					0, -- [2]
					0, -- [3]
					1, -- [4]
				},
				["Backdrop"] = {
					"Interface\\AddOns\\Forte_Core\\Textures\\Background", -- [1]
					"Interface\\AddOns\\Forte_Core\\Textures\\Border", -- [2]
					false, -- [3]
					16, -- [4]
					5, -- [5]
					3, -- [6]
				},
				["Shared3Enable"] = true,
				["Target"] = true,
				["UnknownTarget"] = true,
				["ShowID"] = false,
				["FocusBgEnable"] = false,
				["MaxTimeEnable"] = true,
				["FocusEnable"] = false,
				["PetColor"] = {
					1, -- [1]
					0, -- [2]
					0.95, -- [3]
				},
				["CastSpark"] = 0.3,
				["Max"] = 15,
				["Font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHIC.TTF",
				["alpha"] = 1,
				["You"] = true,
				["Ticks"] = 0.3,
				["CooldownsEnable"] = true,
				["RaidTargetsEnable"] = false,
				["FailEnable"] = true,
				["Height"] = 14,
				["CurseColor"] = {
					0.64, -- [1]
					0.21, -- [2]
					0.9300000000000001, -- [3]
				},
				["SelfDebuffEnable"] = true,
				["CooldownsOtherColor"] = {
					0.5, -- [1]
					0.2, -- [2]
					0.18, -- [3]
				},
				["DebuffsEnable"] = true,
				["DrainEnable"] = true,
				["FontSize"] = 11,
				["Label"] = false,
				["Enable"] = true,
				["DebuffsOtherEnable"] = false,
				["Focus"] = true,
				["LabelFontSize"] = 11,
				["Texture"] = "Interface\\AddOns\\Forte_Core\\Textures\\Aluminium",
				["BarBackgroundAlpha"] = 0.3,
				["Time"] = false,
				["lock"] = false,
				["TimeSpace"] = 35,
				["TicksNext"] = true,
				["Shared3Color"] = {
					1, -- [1]
					0.5, -- [2]
					0, -- [3]
				},
				["RaidTargets"] = 0.7,
				["MaximizeName"] = false,
				["Spell"] = false,
				["Spark"] = 0.7,
				["HideLongerEnable"] = false,
				["Shared2Enable"] = true,
				["LabelHeight"] = 18,
				["LabelFont"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHIC.TTF",
				["Width"] = 250,
				["BuffColor"] = {
					0, -- [1]
					0.75, -- [2]
					1, -- [3]
				},
				["CastSparkEnable"] = true,
				["BuffEnable"] = true,
				["NormalBgColor"] = {
					0, -- [1]
					0, -- [2]
					0, -- [3]
					0.5, -- [4]
				},
				["TimeColor"] = {
					1, -- [1]
					1, -- [2]
					1, -- [3]
					1, -- [4]
				},
				["SelfDebuffOtherColor"] = {
					0.5, -- [1]
					0, -- [2]
					0, -- [3]
				},
				["FriendlyBuffEnable"] = true,
				["TargetBgEnable"] = false,
				["Other"] = true,
				["OneMax"] = true,
				["SparkEnable"] = true,
				["Flip"] = false,
				["FailColor"] = {
					1, -- [1]
					0, -- [2]
					0.3, -- [3]
				},
				["HighlightEnable"] = true,
				["CrowdEnable"] = true,
				["CrowdColor"] = {
					0, -- [1]
					1, -- [2]
					0.5, -- [3]
				},
				["FriendlyBuffColor"] = {
					1, -- [1]
					1, -- [2]
					0, -- [3]
				},
				["ExpiredColor"] = {
					0.5, -- [1]
					0.5, -- [2]
					0.5, -- [3]
					1, -- [4]
				},
				["MagicEnable"] = true,
				["MaxTime"] = 30,
				["Space"] = 2,
				["Background"] = true,
				["Outwands"] = true,
				["BlinkEnable"] = true,
				["HealColor"] = {
					0, -- [1]
					1, -- [2]
					0, -- [3]
				},
				["NormalAlpha"] = 0.5,
				["CooldownsOtherEnable"] = false,
				["TargetEnable"] = false,
				["HideLongerNoBoss"] = false,
				["BuffOtherColor"] = {
					0.5, -- [1]
					0.5, -- [2]
					0.5, -- [3]
				},
				["FocusColor"] = {
					1, -- [1]
					1, -- [2]
					0.5, -- [3]
					1, -- [4]
				},
				["ExpiredEnable"] = false,
				["RaidDebuffs"] = true,
				["CooldownsColor"] = {
					1, -- [1]
					0.39, -- [2]
					0.35, -- [3]
				},
				["DebuffsColor"] = {
					0, -- [1]
					0.36, -- [2]
					1, -- [3]
				},
				["GroupID"] = true,
				["Test"] = false,
				["ForceMax"] = false,
				["SpacingHeight"] = 2,
				["x"] = 680.9600822824676,
			},
			["RightClickOptions"] = true,
			["TimeLeftMsg"] = ">> %s on %s is fading in %s <<",
			["TimerResistSound"] = "Sound\\Spells\\SimonGame_Visual_BadPress.wav",
			["SummonStrata"] = "MEDIUM",
			["ExpandSubcats"] = false,
			["ShamanColor"] = {
				0, -- [1]
				0.86, -- [2]
				0.73, -- [3]
			},
			["SoulstoneSpace"] = 1,
			["SoulstoneMinColor"] = {
				1, -- [1]
				0, -- [2]
				0.6, -- [3]
			},
			["SoulstoneHeight"] = 12,
			["HealthstoneStrata"] = "MEDIUM",
			["SoulstoneMsgColor"] = {
				1, -- [1]
				0, -- [2]
				1, -- [3]
			},
			["SummonMeetingStone"] = false,
			["FWSUFrame"] = {
				["y"] = 384.0000284843451,
				["x"] = 614.4000179363367,
				["lock"] = false,
				["scale"] = 1,
				["alpha"] = 1,
			},
			["Strata"] = "MEDIUM",
			["SoulstoneFadeSoundEnable"] = true,
			["OptionsFontSize"] = 11,
			["RightClickIconOptions"] = true,
			["TimerBreakSound"] = "Sound\\Spells\\SimonGame_Visual_LevelStart.wav",
			["HealthstoneWidth"] = 100,
			["OfflineColor"] = {
				0, -- [1]
				0, -- [2]
				0, -- [3]
			},
			["MeetingStoneSummonMsg"] = "Summoning >> %s << Clicky clicky!",
			["TimeLeftNoTargMsg"] = ">> %s is fading in %s <<",
			["SoulstoneAuto"] = false,
			["Splash"] = {
				["SplashGlow"] = true,
				["SecondSplashMax"] = 4,
				["Enable"] = false,
				["lock"] = false,
				["scale"] = 2,
				["y"] = 384.0000284843451,
				["alpha"] = 0.7,
				["x"] = 614.4000179363367,
			},
			["SoulstoneExpand"] = false,
			["UseTokens"] = "pet pettarget vehicle focus mouseover",
			["TimeLeft"] = 1,
			["SoulstoneMaxColor"] = {
				0.64, -- [1]
				0.21, -- [2]
				0.9300000000000001, -- [3]
			},
			["TimerResistsEnable"] = true,
			["OptionsSubHeaderBackdrop"] = {
				"Interface\\AddOns\\Forte_Core\\Textures\\Smooth", -- [1]
				"None", -- [2]
				false, -- [3]
				16, -- [4]
				2, -- [5]
				2, -- [6]
			},
			["Chill"] = 0.05,
			["HealthstoneTexture"] = "Interface\\AddOns\\Forte_Core\\Textures\\Aluminium",
			["TimeLeftNoTarg"] = 1,
			["SummonHeight"] = 12,
			["TalentOffsetX"] = 0,
			["Output"] = false,
			["CustomInstances"] = {
				["Timer"] = {
				},
			},
			["TimerResistsColor"] = {
				1, -- [1]
				0, -- [2]
				0.54, -- [3]
			},
			["TimerClearcastingSoundVolume"] = 4,
			["CooldownLeft"] = 1,
			["FontSize"] = 11,
			["SoulstoneMax"] = 10,
			["TimerSortOrder"] = "buff selfdebuff debuff cooldown notarget target",
			["SoulstoneWidth"] = 100,
			["TimerFadeSound"] = "Sound\\Spells\\ShaysBell.wav",
			["SoulstoneReadySoundEnable"] = true,
			["DruidColor"] = {
				1, -- [1]
				0.49, -- [2]
				0.04, -- [3]
			},
			["TimerFadeSpeed"] = 0.5,
			["HealthstoneUnknown"] = true,
			["SoulstoneFadeSound"] = "Interface\\AddOns\\Forte_Core\\Sounds\\SoulstoneExpire.mp3",
			["GlobalSpark"] = 0.7,
			["HealthstoneMinColor"] = {
				0.9300000000000001, -- [1]
				1, -- [2]
				0, -- [3]
			},
			["SummonSpace"] = 1,
			["HealthstoneExpand"] = false,
			["SplashStrata"] = "MEDIUM",
			["OptionsHeight"] = 440,
			["SoulstoneFadeSoundVolume"] = 1,
			["SoulstoneStrata"] = "MEDIUM",
			["GlobalScale"] = 1,
			["IgnoreCooldown"] = 2.99,
			["SoulstoneReadySound"] = "Sound\\Spells\\SimonGame_Visual_GameTick.wav",
			["CooldownLeftMsg"] = ">> %s is ready in %s <<",
			["OptionsColums"] = 2,
			["SummonFarColor"] = {
				1, -- [1]
				1, -- [2]
				1, -- [3]
			},
			["OptionsHeaderBackdrop"] = {
				"Interface\\AddOns\\Forte_Core\\Textures\\Otravi", -- [1]
				"None", -- [2]
				false, -- [3]
				16, -- [4]
				1, -- [5]
				1, -- [6]
			},
			["ShowReady"] = false,
			["TimeFormat"] = true,
			["TimerClearcastingSoundEnable"] = false,
			["DisableMouseover"] = false,
			["OptionsHeaderFont"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
			["OptionBackgroundColor"] = {
				0.4, -- [1]
				0.4, -- [2]
				0.4, -- [3]
				0.9, -- [4]
			},
			["HealthstoneUnknownMaxColor"] = {
				1, -- [1]
				0, -- [2]
				0, -- [3]
			},
			["HealthstoneInterval"] = 2,
			["TimerFadeSoundEnable"] = true,
			["DisableFocus"] = false,
			["HealthstoneFont"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHIC.TTF",
		},
	},
	["Speccs"] = {
	},
	["GROUPED"] = false,
	["RAID"] = false,
	["RaidStatus"] = {
	},
	["Cooldowns"] = {
	},
	["VERSION"] = "v1.973.1",
	["ProfileNames"] = {
		{
			"Profile", -- [1]
			"Default", -- [2]
		}, -- [1]
	},
	["PROFILE"] = "Profile",
}
end

local SetPocketPlot = function()
if(PocketPlotDB) then table.wipe(PocketPlotDB) end

PocketPlotDB = {
	["coordSize"] = 16,
	["strata"] = "BACKGROUND",
	["VehicleSeatIndicator"] = {
		["a"] = "RIGHT",
		["p"] = "UIParent",
		["r"] = "RIGHT",
		["y"] = 117.7049390727762,
		["x"] = -102.4714937999536,
	},
	["scale"] = 1.25,
	["coords"] = false,
	["classfont"] = false,
	["Minimap"] = {
		["a"] = "BOTTOMRIGHT",
		["p"] = "UIParent",
		["r"] = "BOTTOMRIGHT",
		["x"] = -7.578266722942257,
		["y"] = 19.85206248369982,
	},
	["zoneSize"] = 10,
	["clock"] = false,
	["level"] = 2,
	["bg"] = {
		["b"] = 0,
		["g"] = 0,
		["r"] = 0,
	},
	["lsmfont"] = "Neuropol",
	["MiniMapInstanceDifficulty"] = {
		["a"] = "BOTTOMRIGHT",
		["p"] = "UIParent",
		["r"] = "BOTTOMRIGHT",
		["x"] = -148.9008965724718,
		["y"] = 155.4368097968462,
	},
	["DurabilityFrame"] = {
		["a"] = "BOTTOMRIGHT",
		["p"] = "UIParent",
		["r"] = "BOTTOMRIGHT",
		["y"] = 252.3803284559301,
		["x"] = -113.6769975749224,
	},
	["classbg"] = false,
	["combHide"] = false,
	["fontFlag"] = "Outline",
	["alpha"] = 1,
	["top"] = false,
	["mapPos"] = {
		["y"] = -10,
		["x"] = -10,
	},
	["insets"] = 4,
	["mmAlpha"] = 1,
	["clockSize"] = 16,
	["shape"] = "Square",
	["zoneText"] = true,
}
end

local SetQuestGuru = function()
if(QuestGuru_Settings) then table.wipe(QuestGuru_Settings) end

QuestGuru_Settings = {
	["ShowObjItemIcons"] = true,
	["ShowGuildStatus"] = true,
	["Colorize"] = {
		["PlayerName"] = {
			["Enabled"] = true,
			["Color"] = {
				["b"] = 0.8,
				["g"] = 0.4,
				["r"] = 0,
			},
		},
		["NPCNames"] = {
			["Enabled"] = true,
			["Color"] = {
				["b"] = 0.8,
				["g"] = 0.4,
				["r"] = 0,
			},
		},
		["AreaNames"] = {
			["Enabled"] = true,
			["Color"] = {
				["b"] = 0.8,
				["g"] = 0.4,
				["r"] = 0,
			},
		},
	},
	["ShowAltStatus"] = false,
	["TooltipText"] = true,
	["HeaderQuests"] = true,
	["LogAbandon"] = true,
	["Sounds"] = {
		["Progress"] = {
			["Enabled"] = true,
			["Sound"] = "AuctionWindowOpen",
		},
		["Enabled"] = true,
		["QuestComplete"] = {
			["Enabled"] = true,
			["Sound"] = "ReadyCheck",
		},
		["ObjComplete"] = {
			["Enabled"] = true,
			["Sound"] = "AuctionWindowClose",
		},
	},
	["DisableComm"] = false,
	["AutoComplete"] = true,
	["Tracker"] = {
	},
	["ShowWorldMapIcons"] = true,
	["ShowLevels"] = {
		["QuestLog"] = true,
		["Abandon"] = true,
		["History"] = true,
	},
	["Announce"] = {
		["Enabled"] = true,
		["guild"] = false,
		["QuestAccept"] = {
			["Enabled"] = true,
			["Text"] = "Started quest $qlink",
		},
		["Echo"] = false,
		["party"] = true,
		["item"] = {
			["Enabled"] = false,
			["Text"] = "Collected $done $name of $needed needed for $questTitle",
		},
		["say"] = false,
		["whisper"] = {
			["Enabled"] = false,
			["To"] = "",
		},
		["monster"] = {
			["Enabled"] = false,
			["Text"] = "$done $name of $needed needed for $questTitle",
		},
		["Quest"] = {
			["Enabled"] = true,
			["Text"] = "$qlink $complete!",
		},
		["event"] = {
			["Enabled"] = false,
			["Text"] = "$uitext",
		},
	},
	["ShowSimpleGuildStatus"] = false,
}
end

local SetQuestGuruPSV = function()
if(QGT_Settings) then table.wipe(QGT_Settings) end

QGT_Settings = {
	["ColorizeObjZero"] = {
		["b"] = 0.8,
		["g"] = 0.2,
		["r"] = 0.8,
	},
	["Lines"] = 30,
	["ColorizeObjFull"] = {
		["b"] = 1,
		["g"] = 0.8,
		["r"] = 0.3,
	},
	["Scale"] = 0.8999999761581421,
	["HideDuringCombat"] = false,
	["ShowCompletedObj"] = true,
	["ShowQuestTooltips"] = true,
	["QuestWatch"] = {
		["Minimized"] = false,
		["Bottom"] = 829.4406974432017,
		["AutoMinimize"] = false,
		["Left"] = 1610.828925825879,
		["Top"] = 888.4407215522036,
	},
	["Anchor"] = "TOP",
	["ShowQuestPercent"] = true,
	["QuestItemIcons"] = true,
	["HideBlizzardTracker"] = true,
	["QuestWatchSort"] = 0,
	["LastTracker"] = "Q",
	["BothTrackers"] = false,
	["ShowPartyTooltips"] = true,
	["ShowHeaders"] = true,
	["Alpha"] = 0.699999988079071,
	["AchievementWatch"] = {
		["Minimized"] = false,
		["AutoMinimize"] = false,
	},
	["ColorizeObjComplete"] = {
		["b"] = 1,
		["g"] = 0.9,
		["r"] = 0.1,
	},
	["AutoUnTrack"] = false,
	["Bullet"] = "-",
	["ClickThrough"] = false,
	["ColorizeObj"] = true,
	["Pin"] = true,
	["ShowLevels"] = true,
	["ShowBorder"] = true,
}
end

local SetTomTom = function()
if(TomTomDB) then table.wipe(TomTomDB) end

TomTomDB = {
	["profiles"] = {
		["KisekiUI"] = {
			["block"] = {
				["enable"] = false,
			},
		},
	},
}
end

local SetVuhDo = function()
if(VUHDO_PROFILES) then table.wipe(VUHDO_PROFILES) end

VUHDO_PROFILES = {
	{
		["SPELL_CONFIG"] = {
			["IS_LOAD_HOTS"] = false,
			["IS_FIRE_HOT"] = false,
			["smartCastModi"] = "all",
			["IS_KEEP_STANCE"] = false,
			["IS_AUTO_FIRE"] = true,
			["IS_FIRE_CUSTOM_2"] = false,
			["IS_FIRE_TRINKET_2"] = true,
			["IS_FIRE_TRINKET_1"] = true,
			["IS_AUTO_TARGET"] = false,
			["autoBattleRez"] = true,
			["FIRE_CUSTOM_1_SPELL"] = "",
			["FIRE_CUSTOM_2_SPELL"] = "",
			["IS_TOOLTIP_INFO"] = false,
			["IS_FIRE_CUSTOM_1"] = false,
			["IS_FIRE_OUT_FIGHT"] = false,
		},
		["NAME"] = "Heals-25",
		["CONFIG"] = {
			["SMARTCAST_CLEANSE"] = false,
			["RANGE_SPELL"] = "Flash of Light",
			["SHOW_OVERHEAL"] = true,
			["OMIT_DFT_MTS"] = true,
			["BLIZZ_UI_HIDE_TARGET"] = true,
			["MAX_EMERGENCIES"] = 5,
			["STANDARD_TOOLTIP"] = true,
			["LOCK_PANELS"] = true,
			["RANGE_PESSIMISTIC"] = false,
			["SMARTCAST_RESURRECT"] = true,
			["BLIZZ_UI_HIDE_PET"] = true,
			["INC_HOTS_SECS"] = 3,
			["SMARTCAST_BUFF"] = false,
			["HIDE_PANELS_PARTY"] = false,
			["SHOW_PANELS"] = true,
			["HIDE_EMPTY_PANELS"] = true,
			["RANGE_CHECK_DELAY"] = 260,
			["SHOW_MINIMAP"] = false,
			["INC_CHANNELLED_SECS"] = 3,
			["IS_SCAN_TALENTS"] = true,
			["OMIT_OWN_GROUP"] = false,
			["MODE"] = 1,
			["INC_CASTED_SECS"] = 3,
			["DETECT_DEBUFFS_REMOVABLE_ONLY"] = true,
			["CLUSTER"] = {
				["REFRESH"] = 180,
				["CHAIN_MAX_JUMP"] = 5,
				["DISPLAY_DESTINATION"] = 2,
				["RANGE"] = 8,
				["MODE"] = 1,
				["DISPLAY_SOURCE"] = 2,
				["IS_NUMBER"] = false,
				["THRESH_GOOD"] = 5,
				["COOLDOWN_SPELL"] = "",
				["BELOW_HEALTH_PERC"] = 90,
				["THRESH_FAIR"] = 3,
			},
			["OMIT_MAIN_ASSIST"] = false,
			["RES_ANNOUNCE_TEXT"] = "Come to life, vuhdo!",
			["SHOW_INC_BOMBED"] = true,
			["IS_CLIQUE_COMPAT_MODE"] = false,
			["SHOW_INC_HOTS"] = true,
			["SHOW_INC_CHANNELLED"] = true,
			["DETECT_DEBUFFS_IGNORE_DURATION"] = true,
			["SCAN_RANGE"] = "2",
			["ON_MOUSE_UP"] = false,
			["OMIT_TARGET"] = false,
			["IS_SHOW_GCD"] = false,
			["BLIZZ_UI_HIDE_FOCUS"] = true,
			["DETECT_DEBUFFS_IGNORE_NO_HARM"] = true,
			["DETECT_DEBUFFS_IGNORE_BY_CLASS"] = true,
			["OMIT_PLAYER_TARGETS"] = false,
			["LOCK_CLICKS_THROUGH"] = false,
			["OMIT_MAIN_TANKS"] = false,
			["SHOW_PLAYER_TAGS"] = true,
			["BLIZZ_UI_HIDE_PLAYER"] = true,
			["UPDATE_HOTS_MS"] = 50,
			["SHOW_INC_CASTED"] = true,
			["EMERGENCY_TRIGGER"] = 100,
			["HIDE_PANELS_SOLO"] = true,
			["CURRENT_PROFILE"] = "Heals-25",
			["AUTO_PROFILES"] = {
				["1"] = "Heals-Solo",
				["5"] = "Heals-10",
				["25"] = "Heals-25",
				["10"] = "Heals-10",
			},
			["SHOW_INCOMING"] = true,
			["INC_BOMBED_SECS"] = 3,
			["OMIT_FOCUS"] = false,
			["BLIZZ_UI_HIDE_PARTY"] = true,
			["SOUND_DEBUFF"] = "Interface\\AddOns\\Ferous Media\\Sounds\\Coin_Dead.wav",
			["OMIT_SELF"] = false,
			["IS_PALLY_POWER_COMMS"] = true,
			["IS_ALWAYS_OVERWRITE_PROFILE"] = true,
			["DETECT_DEBUFFS_IGNORE_MOVEMENT"] = true,
			["CUSTOM_DEBUFF"] = {
				["animate"] = true,
				["isStacks"] = true,
				["point"] = "TOPRIGHT",
				["isName"] = false,
				["scale"] = 0.800000011920929,
				["timer"] = true,
				["isColor"] = false,
				["STORED"] = {
					"Acid-Drenched Mandibles", -- [1]
					"Boiling Blood", -- [2]
					"Burning Bile", -- [3]
					"Chilled to the Bone", -- [4]
					"Corrosion", -- [5]
					"Defile", -- [6]
					"Delirious Slash", -- [7]
					"Essence of the Blood Queen", -- [8]
					"Expose Weakness", -- [9]
					"Feral Pounce", -- [10]
					"Fire Bomb", -- [11]
					"Frost Beacon", -- [12]
					"Frost Blast", -- [13]
					"Frost Breath", -- [14]
					"Gas Spore", -- [15]
					"Gaseous Bloat", -- [16]
					"Gastric Bloat", -- [17]
					"Glittering Sparks", -- [18]
					"Gravity Bomb", -- [19]
					"Grievous Bite", -- [20]
					"Gut Spray", -- [21]
					"Harvest Soul", -- [22]
					"Ice Tomb", -- [23]
					"Impale", -- [24]
					"Impaled", -- [25]
					"Incinerate Flesh", -- [26]
					"Infest", -- [27]
					"Instability", -- [28]
					"Instant Heal", -- [29]
					"Iron Roots", -- [30]
					"Jagged Knife", -- [31]
					"Legion Flame", -- [32]
					"Mark of the Fallen Champion", -- [33]
					"Mistress' Kiss", -- [34]
					"Mutated Infection", -- [35]
					"Mutated Plague", -- [36]
					"Napalm Shell", -- [37]
					"Necrotic Plague", -- [38]
					"Necrotic Strike", -- [39]
					"Pact of the Darkfallen", -- [40]
					"Paralytic Toxin", -- [41]
					"Penetrating Cold", -- [42]
					"Rune of Blood", -- [43]
					"Sara's Blessing", -- [44]
					"Searing Light", -- [45]
					"Shadow Prison", -- [46]
					"Shroud of Sorrow", -- [47]
					"Slag Pot", -- [48]
					"Snobolled!", -- [49]
					"Spinning Pain Spike", -- [50]
					"Stone Grip", -- [51]
					"Swarming Shadows", -- [52]
					"Touch of Darkness", -- [53]
					"Touch of Light", -- [54]
					"Vile Gas", -- [55]
					"Volatile Ooze Adhesive", -- [56]
					"Web Wrap", -- [57]
				},
				["max_num"] = 5,
				["yAdjust"] = -34,
				["version"] = 13,
				["STORED_SETTINGS"] = {
					["Burning Bile"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Snobolled!"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Frost Beacon"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Mutated Plague"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Feral Pounce"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Slag Pot"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Impaled"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Acid-Drenched Mandibles"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Shroud of Sorrow"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Paralytic Toxin"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Grievous Bite"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Iron Roots"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Incinerate Flesh"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Mistress' Kiss"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Touch of Light"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Delirious Slash"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Necrotic Plague"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Shadow Prison"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Gut Spray"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Ice Tomb"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Corrosion"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Spinning Pain Spike"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Instant Heal"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Stone Grip"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Swarming Shadows"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Fire Bomb"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Touch of Darkness"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Penetrating Cold"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Pact of the Darkfallen"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Harvest Soul"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Web Wrap"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Essence of the Blood Queen"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Glittering Sparks"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Defile"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Gravity Bomb"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Legion Flame"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Napalm Shell"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Impale"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Infest"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Chilled to the Bone"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Jagged Knife"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Boiling Blood"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Necrotic Strike"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Rune of Blood"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Gaseous Bloat"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Mutated Infection"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Sara's Blessing"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Vile Gas"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Gastric Bloat"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Volatile Ooze Adhesive"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Instability"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Searing Light"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Frost Blast"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Expose Weakness"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Gas Spore"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Mark of the Fallen Champion"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
					["Frost Breath"] = {
						["isStacks"] = false,
						["animate"] = true,
						["isIcon"] = true,
						["isColor"] = false,
						["timer"] = true,
					},
				},
				["isIcon"] = true,
				["selected"] = "",
				["xAdjust"] = -2,
				["BUTTON_FACADE"] = "Blizzard",
			},
			["THREAT"] = {
				["AGGRO_TEXT_RIGHT"] = "<<",
				["AGGRO_TEXT_LEFT"] = ">>",
				["IS_TANK_MODE"] = true,
				["AGGRO_USE_TEXT"] = true,
				["AGGRO_REFRESH_MS"] = 100,
			},
			["SHOW_TEXT_OVERHEAL"] = true,
			["DIRECTION"] = {
				["scale"] = 76,
				["isDeadOnly"] = true,
				["enable"] = true,
				["isDistanceText"] = false,
			},
			["SHOW_OWN_INCOMING"] = true,
			["BLIZZ_UI_HIDE_RAID"] = true,
			["RES_IS_SHOW_TEXT"] = true,
		},
		["LOCKED"] = false,
		["INDICATOR_CONFIG"] = {
			["CUSTOM"] = {
				["THREAT_BAR"] = {
					["invertGrowth"] = false,
					["HEIGHT"] = 4,
					["turnAxis"] = false,
					["WARN_AT"] = 85,
					["TEXTURE"] = "VuhDo - Polished Wood",
				},
				["MOUSEOVER_HIGHLIGHT"] = {
					["TEXTURE"] = "LiteStepLite",
				},
				["AGGRO_BAR"] = {
					["TEXTURE"] = "VuhDo - Polished Wood",
				},
				["BACKGROUND_BAR"] = {
					["TEXTURE"] = "VuhDo - Minimalist",
				},
				["CLUSTER_BORDER"] = {
					["WIDTH"] = 2,
				},
				["SWIFTMEND_INDICATOR"] = {
					["SCALE"] = 1,
				},
				["SIDE_RIGHT"] = {
					["turnAxis"] = false,
					["vertical"] = true,
					["invertGrowth"] = false,
					["TEXTURE"] = "VuhDo - Polished Wood",
				},
				["BAR_BORDER"] = {
					["WIDTH"] = 1,
				},
				["HEALTH_BAR"] = {
					["turnAxis"] = false,
					["vertical"] = false,
					["invertGrowth"] = false,
				},
				["MANA_BAR"] = {
					["turnAxis"] = false,
					["invertGrowth"] = false,
					["TEXTURE"] = "VuhDo - Pipe, light",
				},
				["SIDE_LEFT"] = {
					["turnAxis"] = false,
					["vertical"] = true,
					["invertGrowth"] = false,
					["TEXTURE"] = "VuhDo - Polished Wood",
				},
			},
			["BOUQUETS"] = {
				["THREAT_BAR"] = "Threat: Status Bar",
				["MOUSEOVER_HIGHLIGHT"] = "",
				["AGGRO_BAR"] = "",
				["BACKGROUND_BAR"] = "Background: Solid",
				["INCOMING_BAR"] = "",
				["SWIFTMEND_INDICATOR"] = "LowMana",
				["HEALTH_BAR_PANEL"] = {
					"", -- [1]
					"", -- [2]
					"", -- [3]
					"", -- [4]
					"", -- [5]
					"", -- [6]
					"", -- [7]
					"", -- [8]
					"", -- [9]
					"", -- [10]
				},
				["DAMAGE_FLASH_BAR"] = "",
				["THREAT_MARK"] = "",
				["SIDE_RIGHT"] = "",
				["MANA_BAR"] = "Manabars: All Powers",
				["BAR_BORDER"] = "Border: Multi + Aggro",
				["HEALTH_BAR"] = "Health (generic, class col)",
				["CLUSTER_BORDER"] = "",
				["SIDE_LEFT"] = "",
			},
		},
		["ORIGINATOR_TOON"] = "Apiphany",
		["BUFF_SETTINGS"] = {
			["Inner Fire"] = {
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
				["enabled"] = false,
				["buff"] = "Inner Fire",
			},
			["Power Infusion"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["name"] = "Vassilisa",
				["filter"] = {
					[999] = true,
				},
			},
			["Vampiric Embrace"] = {
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["enabled"] = false,
				["filter"] = {
					[999] = true,
				},
			},
			["CONFIG"] = {
				["SWATCH_EMPTY_GROUP"] = {
					["TG"] = 0.8,
					["B"] = 0,
					["TB"] = 0.8,
					["G"] = 0,
					["TR"] = 0.8,
					["TO"] = 0.6,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["SWATCH_COLOR_BUFF_OUT"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0.8,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["SHOW_LABEL"] = false,
				["REFRESH_SECS"] = 0.1000000014901161,
				["SWATCH_COLOR_BUFF_COOLDOWN"] = {
					["TG"] = 0.6,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 0.3,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["SWATCH_COLOR_BUFF_OKAY"] = {
					["TG"] = 0.8,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["PANEL_MAX_BUFFS"] = 12,
				["PANEL_BG_COLOR"] = {
					["useBackground"] = true,
					["B"] = 0,
					["R"] = 0,
					["G"] = 0,
					["O"] = 0.5,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["SWATCH_COLOR_BUFF_LOW"] = {
					["TG"] = 0.7,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["VERSION"] = 2,
				["SCALE"] = 1,
				["BAR_COLORS_TEXT"] = true,
				["SWATCH_COLOR_OUT_RANGE"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["TO"] = 0.5,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["HIGHLIGHT_COOLDOWN"] = true,
				["POSITION"] = {
					["y"] = -27.1,
					["x"] = -14.7,
					["point"] = "TOPRIGHT",
					["relativePoint"] = "TOPRIGHT",
				},
				["SHOW"] = true,
				["COMPACT"] = true,
				["SWATCH_BORDER_COLOR"] = {
					["useBackground"] = true,
					["B"] = 0.8,
					["R"] = 0.8,
					["G"] = 0.8,
					["O"] = 0,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["WHEEL_SMART_BUFF"] = true,
				["SWATCH_BG_COLOR"] = {
					["useBackground"] = true,
					["B"] = 0,
					["R"] = 0,
					["G"] = 0,
					["O"] = 1,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["REBUFF_MIN_MINUTES"] = 3,
				["HIDE_CHARGES"] = false,
				["BAR_COLORS_BACKGROUND"] = true,
				["PANEL_BORDER_COLOR"] = {
					["useBackground"] = true,
					["B"] = 0,
					["R"] = 0,
					["G"] = 0,
					["O"] = 0.5,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["REBUFF_AT_PERCENT"] = 25,
				["BAR_COLORS_IN_FIGHT"] = true,
				["BUTTON_FACADE"] = "Blizzard",
			},
			["Pain Suppression"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["name"] = "Vassilisa",
				["filter"] = {
					[999] = true,
				},
			},
			["Seal"] = {
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = true,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["R"] = 1,
				},
				["buff"] = "Seal of Truth",
				["enabled"] = true,
				["filter"] = {
					[999] = true,
				},
			},
			["Levitate"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
			},
			["Beacon of Light"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["R"] = 1,
				},
				["name"] = "Apiphany",
				["filter"] = {
					[999] = true,
				},
			},
			["Shadow Protection"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
			},
			["Power Word: Fortitude"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
			},
			["Aura"] = {
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["R"] = 1,
				},
				["buff"] = "Concentration Aura",
				["enabled"] = true,
				["filter"] = {
					[999] = true,
				},
			},
			["Shadowfiend"] = {
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
				["enabled"] = false,
				["buff"] = "Shadowfiend",
			},
			["Blessing"] = {
				["enabled"] = true,
				["buff"] = "Blessing of Might",
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = true,
					["R"] = 1,
					["TO"] = 1,
					["useBackground"] = true,
					["TR"] = 1,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["filter"] = {
					[999] = true,
				},
			},
			["Fear Ward"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["name"] = "Vassilisa",
				["filter"] = {
					[999] = true,
				},
			},
			["Righteous Fury"] = {
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["R"] = 1,
				},
				["buff"] = "Righteous Fury",
				["enabled"] = false,
				["filter"] = {
					[999] = true,
				},
			},
		},
		["BUFF_ORDER"] = {
			["04Inner Fire"] = 4,
			["04Beacon of Light"] = 5,
			["02Aura"] = 1,
			["05Righteous Fury"] = 2,
			["01Power Word: Fortitude"] = 1,
			["05Shadowfiend"] = 5,
			["03Seal"] = 3,
			["01Blessing"] = 4,
			["09Pain Suppression"] = 9,
			["03Fear Ward"] = 3,
			["07Vampiric Embrace"] = 7,
			["08Levitate"] = 8,
			["06Power Infusion"] = 6,
			["02Shadow Protection"] = 2,
		},
		["PANEL_SETUP"] = {
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 2,
					["xAdjust"] = 4,
				},
				["POSITION"] = {
					["y"] = 335.1333343782911,
					["x"] = 651.5274711533683,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 34.00000070288635,
					["growth"] = "TOPLEFT",
					["width"] = 99.99999465806371,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["groups"] = {
						1, -- [1]
						2, -- [2]
						3, -- [3]
						4, -- [4]
						5, -- [5]
						6, -- [6]
						7, -- [7]
						8, -- [8]
					},
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "TukTex",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\Addons\\Ferous Media\\Fonts\\neuropol.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 11,
						["maxChars"] = 7,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 2,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 5,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = true,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["_spacing"] = 10.00000014057727,
					["showPetOwners"] = true,
				},
			}, -- [1]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1.5,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 951.5000234412599,
					["x"] = 11.79999987348046,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 24.99999866451593,
					["growth"] = "TOPLEFT",
					["width"] = 234.0000035144318,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["groups"] = {
						41, -- [1]
					},
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 105,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 2,
					["rowSpacing"] = 1,
					["barWidth"] = 129,
					["targetSpacing"] = 0,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = true,
					["columnSpacing"] = 0,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 100,
					["maxRowsWhenLoose"] = 4,
					["showHeaders"] = true,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = true,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = false,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 1,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["_spacing"] = 10.00000014057727,
					["showPetOwners"] = true,
				},
			}, -- [2]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 652,
					["x"] = 328.5,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 128.8,
					["growth"] = "TOPLEFT",
					["width"] = 85,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["_spacing"] = 10,
					["showPetOwners"] = true,
				},
			}, -- [3]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 708,
					["x"] = 347.3,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 128.8,
					["growth"] = "TOPLEFT",
					["width"] = 85,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["_spacing"] = 17.99999985846689,
					["showPetOwners"] = true,
				},
			}, -- [4]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [5]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [6]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [7]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [8]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [9]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [10]
			["RAID_ICON_FILTER"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["PANEL_COLOR"] = {
				["TEXT"] = {
					["TR"] = 1,
					["TO"] = 1,
					["TB"] = 0,
					["useText"] = true,
					["TG"] = 0.82,
				},
				["BARS"] = {
					["useOpacity"] = true,
					["R"] = 0.7,
					["B"] = 0.7,
					["G"] = 0.7,
					["O"] = 1,
					["useBackground"] = true,
				},
				["classColorsName"] = false,
			},
			["HOTS"] = {
				["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\ariblk.ttf",
				["SLOTS"] = {
					"Sacred Shield", -- [1]
					"Beacon of Light", -- [2]
					"BOUQUET_Tank Cooldowns", -- [3]
					"OTHER", -- [4]
					"CLUSTER", -- [5]
					[9] = "Beacon of Light",
				},
				["BARS"] = {
					["radioValue"] = 1,
					["width"] = 25,
				},
				["iconRadioValue"] = 1,
				["radioValue"] = 21,
				["SLOTCFG"] = {
					["1"] = {
						["mine"] = true,
						["others"] = false,
					},
					["3"] = {
						["mine"] = false,
						["others"] = true,
					},
					["2"] = {
						["mine"] = false,
						["others"] = true,
					},
					["5"] = {
						["mine"] = true,
						["others"] = false,
					},
					["4"] = {
						["mine"] = true,
						["others"] = false,
					},
					["7"] = {
						["mine"] = true,
						["others"] = false,
					},
					["6"] = {
						["mine"] = true,
						["others"] = false,
					},
					["9"] = {
						["mine"] = true,
						["others"] = false,
					},
					["8"] = {
						["mine"] = true,
						["others"] = false,
					},
					["10"] = {
						["mine"] = true,
						["others"] = false,
					},
				},
				["stacksRadioValue"] = 2,
				["BUTTON_FACADE"] = "Blizzard",
			},
			["BAR_COLORS"] = {
				["OVERHEAL_TEXT"] = {
					["TG"] = 1,
					["TO"] = 1,
					["TB"] = 0.8,
					["useOpacity"] = true,
					["useText"] = true,
					["TR"] = 0.8,
				},
				["HOT7"] = {
					["useBackground"] = true,
					["R"] = 1,
					["B"] = 1,
					["O"] = 0.75,
					["G"] = 1,
				},
				["CLUSTER_FAIR"] = {
					["TG"] = 1,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0.8,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.8,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
				["HOT1"] = {
					["TG"] = 0.6,
					["countdownMode"] = 2,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 0.3,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = true,
					["useText"] = true,
				},
				["DEBUFF0"] = {
					["useBackground"] = false,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["HOT3"] = {
					["TG"] = 1,
					["countdownMode"] = 2,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["RAID_ICONS"] = {
					["1"] = {
						["TG"] = 1,
						["B"] = 0.305,
						["TB"] = 0.607,
						["G"] = 0.976,
						["TR"] = 0.98,
						["TO"] = 1,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["R"] = 1,
					},
					["filterOnly"] = false,
					["3"] = {
						["TG"] = 0.674,
						["B"] = 0.8,
						["TB"] = 0.921,
						["G"] = 0.29,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 0.788,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["2"] = {
						["TG"] = 0.827,
						["B"] = 0.039,
						["TB"] = 0.419,
						["G"] = 0.513,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 1,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["enable"] = false,
					["4"] = {
						["TG"] = 1,
						["B"] = 0.015,
						["TB"] = 0.698,
						["G"] = 0.8,
						["TR"] = 0.698,
						["TO"] = 1,
						["R"] = 0,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["7"] = {
						["TG"] = 0.627,
						["B"] = 0.129,
						["TB"] = 0.619,
						["G"] = 0.184,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 0.8,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["6"] = {
						["TG"] = 0.831,
						["B"] = 0.972,
						["TB"] = 1,
						["G"] = 0.69,
						["TR"] = 0.662,
						["TO"] = 1,
						["R"] = 0.121,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["8"] = {
						["TG"] = 0.231,
						["B"] = 0.89,
						["TB"] = 0.231,
						["G"] = 0.866,
						["TR"] = 0.231,
						["TO"] = 1,
						["R"] = 0.847,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["5"] = {
						["TG"] = 0.87,
						["B"] = 0.8,
						["TB"] = 1,
						["G"] = 0.717,
						["TR"] = 0.725,
						["TO"] = 1,
						["R"] = 0.466,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
				},
				["useDebuffIcon"] = true,
				["HOT9"] = {
					["TG"] = 1,
					["countdownMode"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["HOT_CHARGE_4"] = {
					["TG"] = 1,
					["B"] = 0.8,
					["TB"] = 1,
					["G"] = 0.8,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.8,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
				["HOT_CHARGE_3"] = {
					["TG"] = 1,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 1,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
				["CLUSTER_GOOD"] = {
					["TG"] = 1,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0.8,
					["TR"] = 0,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
				["DEBUFF3"] = {
					["TG"] = 0.957,
					["B"] = 0.8,
					["TB"] = 1,
					["G"] = 0.4,
					["TR"] = 0.329,
					["TO"] = 1,
					["R"] = 0.4,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["INCOMING"] = {
					["TG"] = 0.82,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.33,
					["useOpacity"] = true,
				},
				["HOT6"] = {
					["useBackground"] = true,
					["R"] = 1,
					["B"] = 1,
					["O"] = 0.75,
					["G"] = 1,
				},
				["HOT4"] = {
					["TG"] = 0.6,
					["countdownMode"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 0.3,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["DEBUFF1"] = {
					["TG"] = 1,
					["B"] = 0.8,
					["TB"] = 0.6860000000000001,
					["G"] = 0.592,
					["TR"] = 0,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["CHARMED"] = {
					["TG"] = 0.31,
					["B"] = 0.263,
					["TB"] = 0.31,
					["G"] = 0.082,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.51,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["NO_EMERGENCY"] = {
					["TG"] = 0.82,
					["B"] = 0.4,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["HOTS"] = {
					["useColorText"] = true,
					["useColorBack"] = true,
					["TEXT"] = {
						["outline"] = true,
						["shadow"] = false,
					},
					["isFadeOut"] = false,
					["factorDivineAegis"] = 1.2,
					["showShieldAbsorb"] = true,
					["WARNING"] = {
						["enabled"] = false,
						["lowSecs"] = 3,
						["B"] = 0.2,
						["TB"] = 0.6,
						["G"] = 0.2,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 0.5,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["TG"] = 0.6,
					},
				},
				["GCD_BAR"] = {
					["useBackground"] = true,
					["R"] = 0.4,
					["B"] = 0.4,
					["O"] = 0.5,
					["G"] = 0.4,
				},
				["HOT2"] = {
					["TG"] = 1,
					["countdownMode"] = 2,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 1,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = true,
					["useText"] = true,
				},
				["DEAD"] = {
					["TG"] = 0.5,
					["B"] = 0.3,
					["TB"] = 0.5,
					["G"] = 0.3,
					["TR"] = 0.5,
					["TO"] = 1,
					["R"] = 0.3,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["OFFLINE"] = {
					["TG"] = 0.576,
					["B"] = 0.298,
					["TB"] = 0.576,
					["G"] = 0.298,
					["TR"] = 0.576,
					["TO"] = 0.58,
					["R"] = 0.298,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.21,
					["useOpacity"] = true,
				},
				["OUTRANGED"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["TO"] = 0.5,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.25,
					["useOpacity"] = true,
				},
				["HOT8"] = {
					["useBackground"] = true,
					["R"] = 1,
					["B"] = 1,
					["O"] = 0.75,
					["G"] = 1,
				},
				["IRRELEVANT"] = {
					["TG"] = 0.82,
					["B"] = 0.4,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["DEBUFF2"] = {
					["TG"] = 0,
					["B"] = 0.4,
					["TB"] = 0,
					["G"] = 0.4,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.8,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["BAR_FRAMES"] = {
					["useOpacity"] = true,
					["R"] = 0,
					["B"] = 0,
					["G"] = 0,
					["O"] = 0.7,
					["useBackground"] = true,
				},
				["EMERGENCY"] = {
					["TG"] = 0.82,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["HOT10"] = {
					["TG"] = 1,
					["countdownMode"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["THREAT"] = {
					["LOW"] = {
						["useBackground"] = true,
						["R"] = 0,
						["B"] = 1,
						["O"] = 1,
						["G"] = 1,
					},
					["HIGH"] = {
						["useBackground"] = true,
						["R"] = 1,
						["B"] = 1,
						["O"] = 1,
						["G"] = 0,
					},
				},
				["DEBUFF4"] = {
					["TG"] = 0,
					["B"] = 0.7,
					["TB"] = 1,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.7,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["DEBUFF6"] = {
					["TG"] = 0.5,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0.3,
					["TR"] = 0.8,
					["TO"] = 1,
					["R"] = 0.6,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["HOT5"] = {
					["TG"] = 0.6,
					["countdownMode"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 0.3,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["LIFE_LEFT"] = {
					["GOOD"] = {
						["useBackground"] = true,
						["R"] = 0,
						["B"] = 0,
						["O"] = 1,
						["G"] = 1,
					},
					["LOW"] = {
						["useBackground"] = true,
						["R"] = 1,
						["B"] = 0,
						["O"] = 1,
						["G"] = 0,
					},
					["FAIR"] = {
						["useBackground"] = true,
						["R"] = 1,
						["B"] = 0,
						["O"] = 1,
						["G"] = 1,
					},
				},
				["HOT_CHARGE_2"] = {
					["TG"] = 1,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 1,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
			},
		},
		["ORIGINATOR_CLASS"] = "PALADIN",
		["POWER_TYPE_COLORS"] = {
			{
				["TG"] = 0,
				["R"] = 1,
				["TB"] = 0,
				["G"] = 0,
				["TR"] = 1,
				["TO"] = 1,
				["B"] = 0,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [1]
			{
				["TG"] = 0.5,
				["R"] = 1,
				["TB"] = 0.25,
				["G"] = 0.5,
				["TR"] = 1,
				["TO"] = 1,
				["B"] = 0.25,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [2]
			{
				["TG"] = 1,
				["R"] = 1,
				["TB"] = 0,
				["G"] = 1,
				["TR"] = 1,
				["TO"] = 1,
				["B"] = 0,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [3]
			{
				["TG"] = 1,
				["R"] = 0,
				["TB"] = 1,
				["G"] = 1,
				["TR"] = 0,
				["TO"] = 1,
				["B"] = 1,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [4]
			nil, -- [5]
			{
				["TG"] = 0.5,
				["R"] = 0.5,
				["TB"] = 0.5,
				["G"] = 0.5,
				["TR"] = 0.5,
				["TO"] = 1,
				["B"] = 0.5,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [6]
			[0] = {
				["TG"] = 0,
				["R"] = 0,
				["TB"] = 1,
				["G"] = 0,
				["TR"] = 0,
				["TO"] = 1,
				["B"] = 1,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			},
		},
	}, -- [1]
	{
		["SPELL_CONFIG"] = {
			["IS_LOAD_HOTS"] = false,
			["IS_KEEP_STANCE"] = false,
			["IS_TOOLTIP_INFO"] = false,
			["IS_FIRE_HOT"] = false,
			["IS_AUTO_FIRE"] = true,
			["IS_FIRE_CUSTOM_2"] = false,
			["IS_FIRE_TRINKET_2"] = true,
			["IS_FIRE_TRINKET_1"] = true,
			["IS_AUTO_TARGET"] = true,
			["autoBattleRez"] = true,
			["FIRE_CUSTOM_1_SPELL"] = "",
			["FIRE_CUSTOM_2_SPELL"] = "",
			["smartCastModi"] = "all",
			["IS_FIRE_CUSTOM_1"] = false,
			["IS_FIRE_OUT_FIGHT"] = false,
		},
		["NAME"] = "Heals-10",
		["CONFIG"] = {
			["SMARTCAST_CLEANSE"] = false,
			["RANGE_SPELL"] = "Flash of Light",
			["SHOW_OVERHEAL"] = true,
			["OMIT_DFT_MTS"] = true,
			["BLIZZ_UI_HIDE_TARGET"] = true,
			["MAX_EMERGENCIES"] = 5,
			["STANDARD_TOOLTIP"] = true,
			["LOCK_PANELS"] = true,
			["RANGE_PESSIMISTIC"] = false,
			["SMARTCAST_RESURRECT"] = true,
			["BLIZZ_UI_HIDE_PET"] = true,
			["INC_HOTS_SECS"] = 3,
			["SMARTCAST_BUFF"] = false,
			["HIDE_PANELS_PARTY"] = false,
			["SHOW_PANELS"] = true,
			["HIDE_EMPTY_PANELS"] = true,
			["RANGE_CHECK_DELAY"] = 260,
			["SHOW_MINIMAP"] = false,
			["INC_CHANNELLED_SECS"] = 3,
			["IS_SCAN_TALENTS"] = true,
			["OMIT_OWN_GROUP"] = false,
			["MODE"] = 1,
			["INC_CASTED_SECS"] = 3,
			["DETECT_DEBUFFS_REMOVABLE_ONLY"] = true,
			["CLUSTER"] = {
				["REFRESH"] = 180,
				["CHAIN_MAX_JUMP"] = 5,
				["DISPLAY_DESTINATION"] = 2,
				["RANGE"] = 8,
				["MODE"] = 1,
				["DISPLAY_SOURCE"] = 2,
				["IS_NUMBER"] = false,
				["THRESH_GOOD"] = 5,
				["COOLDOWN_SPELL"] = "",
				["BELOW_HEALTH_PERC"] = 90,
				["THRESH_FAIR"] = 3,
			},
			["OMIT_MAIN_ASSIST"] = false,
			["RES_ANNOUNCE_TEXT"] = "Come to life, vuhdo!",
			["SHOW_INC_BOMBED"] = true,
			["IS_CLIQUE_COMPAT_MODE"] = false,
			["SHOW_INC_HOTS"] = true,
			["SHOW_INC_CHANNELLED"] = true,
			["DETECT_DEBUFFS_IGNORE_DURATION"] = true,
			["SCAN_RANGE"] = "2",
			["ON_MOUSE_UP"] = false,
			["OMIT_TARGET"] = false,
			["IS_SHOW_GCD"] = false,
			["BLIZZ_UI_HIDE_FOCUS"] = true,
			["DETECT_DEBUFFS_IGNORE_NO_HARM"] = true,
			["DETECT_DEBUFFS_IGNORE_BY_CLASS"] = true,
			["OMIT_PLAYER_TARGETS"] = false,
			["LOCK_CLICKS_THROUGH"] = false,
			["OMIT_MAIN_TANKS"] = false,
			["SHOW_PLAYER_TAGS"] = true,
			["BLIZZ_UI_HIDE_PLAYER"] = true,
			["UPDATE_HOTS_MS"] = 50,
			["SHOW_INC_CASTED"] = true,
			["EMERGENCY_TRIGGER"] = 100,
			["HIDE_PANELS_SOLO"] = true,
			["CURRENT_PROFILE"] = "Heals-10",
			["AUTO_PROFILES"] = {
				["1"] = "Heals-Solo",
				["5"] = "Heals-10",
				["25"] = "Heals-25",
				["10"] = "Heals-10",
			},
			["SHOW_INCOMING"] = true,
			["INC_BOMBED_SECS"] = 3,
			["OMIT_FOCUS"] = false,
			["BLIZZ_UI_HIDE_PARTY"] = true,
			["SOUND_DEBUFF"] = "Interface\\AddOns\\Ferous Media\\Sounds\\Coin_Dead.wav",
			["OMIT_SELF"] = false,
			["IS_PALLY_POWER_COMMS"] = true,
			["IS_ALWAYS_OVERWRITE_PROFILE"] = true,
			["DETECT_DEBUFFS_IGNORE_MOVEMENT"] = true,
			["CUSTOM_DEBUFF"] = {
				["animate"] = true,
				["isStacks"] = true,
				["point"] = "TOPRIGHT",
				["isName"] = false,
				["scale"] = 0.800000011920929,
				["timer"] = true,
				["isColor"] = false,
				["STORED"] = {
					"Acid-Drenched Mandibles", -- [1]
					"Boiling Blood", -- [2]
					"Burning Bile", -- [3]
					"Chilled to the Bone", -- [4]
					"Corrosion", -- [5]
					"Defile", -- [6]
					"Delirious Slash", -- [7]
					"Essence of the Blood Queen", -- [8]
					"Expose Weakness", -- [9]
					"Feral Pounce", -- [10]
					"Fire Bomb", -- [11]
					"Frost Beacon", -- [12]
					"Frost Blast", -- [13]
					"Frost Breath", -- [14]
					"Gas Spore", -- [15]
					"Gaseous Bloat", -- [16]
					"Gastric Bloat", -- [17]
					"Glittering Sparks", -- [18]
					"Gravity Bomb", -- [19]
					"Grievous Bite", -- [20]
					"Gut Spray", -- [21]
					"Harvest Soul", -- [22]
					"Ice Tomb", -- [23]
					"Impale", -- [24]
					"Impaled", -- [25]
					"Incinerate Flesh", -- [26]
					"Infest", -- [27]
					"Instability", -- [28]
					"Instant Heal", -- [29]
					"Iron Roots", -- [30]
					"Jagged Knife", -- [31]
					"Legion Flame", -- [32]
					"Mark of the Fallen Champion", -- [33]
					"Mistress' Kiss", -- [34]
					"Mutated Infection", -- [35]
					"Mutated Plague", -- [36]
					"Napalm Shell", -- [37]
					"Necrotic Plague", -- [38]
					"Necrotic Strike", -- [39]
					"Pact of the Darkfallen", -- [40]
					"Paralytic Toxin", -- [41]
					"Penetrating Cold", -- [42]
					"Rune of Blood", -- [43]
					"Sara's Blessing", -- [44]
					"Searing Light", -- [45]
					"Shadow Prison", -- [46]
					"Shroud of Sorrow", -- [47]
					"Slag Pot", -- [48]
					"Snobolled!", -- [49]
					"Spinning Pain Spike", -- [50]
					"Stone Grip", -- [51]
					"Swarming Shadows", -- [52]
					"Touch of Darkness", -- [53]
					"Touch of Light", -- [54]
					"Vile Gas", -- [55]
					"Volatile Ooze Adhesive", -- [56]
					"Web Wrap", -- [57]
				},
				["max_num"] = 5,
				["yAdjust"] = -34,
				["version"] = 13,
				["STORED_SETTINGS"] = {
					["Burning Bile"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Snobolled!"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Frost Beacon"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Mutated Plague"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Feral Pounce"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Slag Pot"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Impaled"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Acid-Drenched Mandibles"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Shroud of Sorrow"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Paralytic Toxin"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Grievous Bite"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Iron Roots"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Incinerate Flesh"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Mistress' Kiss"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Touch of Light"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Delirious Slash"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Necrotic Plague"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Shadow Prison"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Gut Spray"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Ice Tomb"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Corrosion"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Spinning Pain Spike"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Instant Heal"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Stone Grip"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Swarming Shadows"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Fire Bomb"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Touch of Darkness"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Penetrating Cold"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Pact of the Darkfallen"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Harvest Soul"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Web Wrap"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Essence of the Blood Queen"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Glittering Sparks"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Defile"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Gravity Bomb"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Legion Flame"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Napalm Shell"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Impale"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Infest"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Chilled to the Bone"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Jagged Knife"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Boiling Blood"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Necrotic Strike"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Rune of Blood"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Gaseous Bloat"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Mutated Infection"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Sara's Blessing"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Vile Gas"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Gastric Bloat"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Volatile Ooze Adhesive"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Instability"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Searing Light"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Frost Blast"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Expose Weakness"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Gas Spore"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Mark of the Fallen Champion"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Frost Breath"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
				},
				["isIcon"] = true,
				["selected"] = "",
				["xAdjust"] = -2,
				["BUTTON_FACADE"] = "Blizzard",
			},
			["THREAT"] = {
				["AGGRO_TEXT_RIGHT"] = "<<",
				["AGGRO_TEXT_LEFT"] = ">>",
				["IS_TANK_MODE"] = true,
				["AGGRO_USE_TEXT"] = true,
				["AGGRO_REFRESH_MS"] = 100,
			},
			["SHOW_TEXT_OVERHEAL"] = true,
			["DIRECTION"] = {
				["scale"] = 76,
				["isDeadOnly"] = true,
				["enable"] = true,
				["isDistanceText"] = false,
			},
			["SHOW_OWN_INCOMING"] = true,
			["BLIZZ_UI_HIDE_RAID"] = true,
			["RES_IS_SHOW_TEXT"] = true,
		},
		["LOCKED"] = false,
		["INDICATOR_CONFIG"] = {
			["CUSTOM"] = {
				["THREAT_BAR"] = {
					["invertGrowth"] = false,
					["HEIGHT"] = 4,
					["turnAxis"] = false,
					["WARN_AT"] = 85,
					["TEXTURE"] = "VuhDo - Polished Wood",
				},
				["MOUSEOVER_HIGHLIGHT"] = {
					["TEXTURE"] = "LiteStepLite",
				},
				["AGGRO_BAR"] = {
					["TEXTURE"] = "VuhDo - Polished Wood",
				},
				["BACKGROUND_BAR"] = {
					["TEXTURE"] = "VuhDo - Minimalist",
				},
				["CLUSTER_BORDER"] = {
					["WIDTH"] = 2,
				},
				["SWIFTMEND_INDICATOR"] = {
					["SCALE"] = 1,
				},
				["SIDE_RIGHT"] = {
					["turnAxis"] = false,
					["vertical"] = true,
					["invertGrowth"] = false,
					["TEXTURE"] = "VuhDo - Polished Wood",
				},
				["BAR_BORDER"] = {
					["WIDTH"] = 1,
				},
				["HEALTH_BAR"] = {
					["turnAxis"] = false,
					["vertical"] = false,
					["invertGrowth"] = false,
				},
				["MANA_BAR"] = {
					["turnAxis"] = false,
					["invertGrowth"] = false,
					["TEXTURE"] = "VuhDo - Pipe, light",
				},
				["SIDE_LEFT"] = {
					["turnAxis"] = false,
					["vertical"] = true,
					["invertGrowth"] = false,
					["TEXTURE"] = "VuhDo - Polished Wood",
				},
			},
			["BOUQUETS"] = {
				["THREAT_BAR"] = "Threat: Status Bar",
				["MOUSEOVER_HIGHLIGHT"] = "",
				["AGGRO_BAR"] = "",
				["BACKGROUND_BAR"] = "Background: Solid",
				["INCOMING_BAR"] = "",
				["SWIFTMEND_INDICATOR"] = "LowMana",
				["HEALTH_BAR_PANEL"] = {
					"", -- [1]
					"", -- [2]
					"", -- [3]
					"", -- [4]
					"", -- [5]
					"", -- [6]
					"", -- [7]
					"", -- [8]
					"", -- [9]
					"", -- [10]
				},
				["DAMAGE_FLASH_BAR"] = "",
				["THREAT_MARK"] = "",
				["SIDE_RIGHT"] = "",
				["MANA_BAR"] = "Manabars: All Powers",
				["BAR_BORDER"] = "Border: Multi + Aggro",
				["HEALTH_BAR"] = "Health (generic, class col)",
				["CLUSTER_BORDER"] = "",
				["SIDE_LEFT"] = "",
			},
		},
		["ORIGINATOR_TOON"] = "Apiphany",
		["BUFF_SETTINGS"] = {
			["Inner Fire"] = {
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
				["enabled"] = false,
				["buff"] = "Inner Fire",
			},
			["Power Infusion"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["name"] = "Vassilisa",
				["filter"] = {
					[999] = true,
				},
			},
			["Vampiric Embrace"] = {
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["enabled"] = false,
				["filter"] = {
					[999] = true,
				},
			},
			["CONFIG"] = {
				["SWATCH_EMPTY_GROUP"] = {
					["TG"] = 0.8,
					["B"] = 0,
					["TB"] = 0.8,
					["G"] = 0,
					["TR"] = 0.8,
					["TO"] = 0.6,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["SWATCH_COLOR_BUFF_OUT"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0.8,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["SHOW_LABEL"] = false,
				["REFRESH_SECS"] = 0.1000000014901161,
				["SWATCH_COLOR_BUFF_COOLDOWN"] = {
					["TG"] = 0.6,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 0.3,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["SWATCH_COLOR_BUFF_OKAY"] = {
					["TG"] = 0.8,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["PANEL_MAX_BUFFS"] = 12,
				["PANEL_BG_COLOR"] = {
					["useBackground"] = true,
					["B"] = 0,
					["R"] = 0,
					["G"] = 0,
					["O"] = 0.5,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["SWATCH_COLOR_BUFF_LOW"] = {
					["TG"] = 0.7,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["VERSION"] = 2,
				["SCALE"] = 1,
				["BAR_COLORS_TEXT"] = true,
				["SWATCH_COLOR_OUT_RANGE"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["TO"] = 0.5,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["HIGHLIGHT_COOLDOWN"] = true,
				["POSITION"] = {
					["y"] = -27.1,
					["x"] = -14.7,
					["point"] = "TOPRIGHT",
					["relativePoint"] = "TOPRIGHT",
				},
				["SHOW"] = true,
				["COMPACT"] = true,
				["SWATCH_BORDER_COLOR"] = {
					["useBackground"] = true,
					["B"] = 0.8,
					["R"] = 0.8,
					["G"] = 0.8,
					["O"] = 0,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["WHEEL_SMART_BUFF"] = true,
				["SWATCH_BG_COLOR"] = {
					["useBackground"] = true,
					["B"] = 0,
					["R"] = 0,
					["G"] = 0,
					["O"] = 1,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["REBUFF_MIN_MINUTES"] = 3,
				["HIDE_CHARGES"] = false,
				["BAR_COLORS_BACKGROUND"] = true,
				["PANEL_BORDER_COLOR"] = {
					["useBackground"] = true,
					["B"] = 0,
					["R"] = 0,
					["G"] = 0,
					["O"] = 0.5,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["REBUFF_AT_PERCENT"] = 25,
				["BAR_COLORS_IN_FIGHT"] = true,
				["BUTTON_FACADE"] = "Blizzard",
			},
			["Pain Suppression"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["name"] = "Vassilisa",
				["filter"] = {
					[999] = true,
				},
			},
			["Seal"] = {
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = true,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["R"] = 1,
				},
				["buff"] = "Seal of Truth",
				["enabled"] = true,
				["filter"] = {
					[999] = true,
				},
			},
			["Levitate"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
			},
			["Beacon of Light"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["R"] = 1,
				},
				["name"] = "Apiphany",
				["filter"] = {
					[999] = true,
				},
			},
			["Shadow Protection"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
			},
			["Power Word: Fortitude"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
			},
			["Aura"] = {
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["R"] = 1,
				},
				["buff"] = "Concentration Aura",
				["enabled"] = true,
				["filter"] = {
					[999] = true,
				},
			},
			["Shadowfiend"] = {
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
				["enabled"] = false,
				["buff"] = "Shadowfiend",
			},
			["Blessing"] = {
				["enabled"] = true,
				["buff"] = "Blessing of Might",
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = true,
					["R"] = 1,
					["TO"] = 1,
					["useBackground"] = true,
					["TR"] = 1,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["filter"] = {
					[999] = true,
				},
			},
			["Fear Ward"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["name"] = "Vassilisa",
				["filter"] = {
					[999] = true,
				},
			},
			["Righteous Fury"] = {
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["R"] = 1,
				},
				["buff"] = "Righteous Fury",
				["enabled"] = false,
				["filter"] = {
					[999] = true,
				},
			},
		},
		["BUFF_ORDER"] = {
			["04Inner Fire"] = 4,
			["04Beacon of Light"] = 4,
			["02Aura"] = 1,
			["05Righteous Fury"] = 5,
			["01Power Word: Fortitude"] = 1,
			["05Shadowfiend"] = 5,
			["03Seal"] = 2,
			["01Blessing"] = 3,
			["09Pain Suppression"] = 9,
			["03Fear Ward"] = 3,
			["07Vampiric Embrace"] = 7,
			["08Levitate"] = 8,
			["06Power Infusion"] = 6,
			["02Shadow Protection"] = 2,
		},
		["PANEL_SETUP"] = {
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 2,
					["xAdjust"] = 4,
				},
				["POSITION"] = {
					["y"] = 263.713117215929,
					["x"] = 649.6725169537946,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 34.00000070288635,
					["growth"] = "TOPLEFT",
					["width"] = 99.99999465806371,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["groups"] = {
						1, -- [1]
						2, -- [2]
						3, -- [3]
						4, -- [4]
						5, -- [5]
						6, -- [6]
						7, -- [7]
						8, -- [8]
					},
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "TukTex",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\Addons\\Ferous Media\\Fonts\\neuropol.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 11,
						["maxChars"] = 7,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 2,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 5,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = true,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["_spacing"] = 10.00000014057727,
					["showPetOwners"] = true,
				},
			}, -- [1]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1.5,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 951.5000234412599,
					["x"] = 11.79999987348046,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 24.99999866451593,
					["growth"] = "TOPLEFT",
					["width"] = 234.0000035144318,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["groups"] = {
						41, -- [1]
					},
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 105,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 2,
					["rowSpacing"] = 1,
					["barWidth"] = 129,
					["targetSpacing"] = 0,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = true,
					["columnSpacing"] = 0,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 100,
					["maxRowsWhenLoose"] = 4,
					["showHeaders"] = true,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = true,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = false,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 1,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["_spacing"] = 10.00000014057727,
					["showPetOwners"] = true,
				},
			}, -- [2]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 652,
					["x"] = 328.5,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 128.8,
					["growth"] = "TOPLEFT",
					["width"] = 85,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["_spacing"] = 10,
					["showPetOwners"] = true,
				},
			}, -- [3]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 708,
					["x"] = 347.3,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 128.8,
					["growth"] = "TOPLEFT",
					["width"] = 85,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["_spacing"] = 17.99999985846689,
					["showPetOwners"] = true,
				},
			}, -- [4]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [5]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [6]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [7]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [8]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [9]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [10]
			["RAID_ICON_FILTER"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["PANEL_COLOR"] = {
				["TEXT"] = {
					["TR"] = 1,
					["TO"] = 1,
					["TB"] = 0,
					["useText"] = true,
					["TG"] = 0.82,
				},
				["BARS"] = {
					["useOpacity"] = true,
					["R"] = 0.7,
					["B"] = 0.7,
					["G"] = 0.7,
					["O"] = 1,
					["useBackground"] = true,
				},
				["classColorsName"] = false,
			},
			["HOTS"] = {
				["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\ariblk.ttf",
				["SLOTS"] = {
					"Sacred Shield", -- [1]
					"Beacon of Light", -- [2]
					"BOUQUET_Tank Cooldowns", -- [3]
					"OTHER", -- [4]
					"CLUSTER", -- [5]
					[9] = "Beacon of Light",
				},
				["BARS"] = {
					["radioValue"] = 1,
					["width"] = 25,
				},
				["iconRadioValue"] = 1,
				["radioValue"] = 21,
				["SLOTCFG"] = {
					["1"] = {
						["mine"] = true,
						["others"] = false,
					},
					["3"] = {
						["mine"] = false,
						["others"] = true,
					},
					["2"] = {
						["mine"] = false,
						["others"] = true,
					},
					["5"] = {
						["mine"] = true,
						["others"] = false,
					},
					["4"] = {
						["mine"] = true,
						["others"] = false,
					},
					["7"] = {
						["mine"] = true,
						["others"] = false,
					},
					["6"] = {
						["mine"] = true,
						["others"] = false,
					},
					["9"] = {
						["mine"] = true,
						["others"] = false,
					},
					["8"] = {
						["mine"] = true,
						["others"] = false,
					},
					["10"] = {
						["mine"] = true,
						["others"] = false,
					},
				},
				["stacksRadioValue"] = 2,
				["BUTTON_FACADE"] = "Blizzard",
			},
			["BAR_COLORS"] = {
				["OVERHEAL_TEXT"] = {
					["TG"] = 1,
					["TO"] = 1,
					["TB"] = 0.8,
					["useOpacity"] = true,
					["useText"] = true,
					["TR"] = 0.8,
				},
				["HOT7"] = {
					["useBackground"] = true,
					["R"] = 1,
					["B"] = 1,
					["O"] = 0.75,
					["G"] = 1,
				},
				["CLUSTER_FAIR"] = {
					["TG"] = 1,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0.8,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.8,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
				["HOT1"] = {
					["TG"] = 0.6,
					["countdownMode"] = 2,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 0.3,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = true,
					["useText"] = true,
				},
				["DEBUFF0"] = {
					["useBackground"] = false,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["HOT3"] = {
					["TG"] = 1,
					["countdownMode"] = 2,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["RAID_ICONS"] = {
					["1"] = {
						["TG"] = 1,
						["B"] = 0.305,
						["TB"] = 0.607,
						["G"] = 0.976,
						["TR"] = 0.98,
						["TO"] = 1,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["R"] = 1,
					},
					["filterOnly"] = false,
					["3"] = {
						["TG"] = 0.674,
						["B"] = 0.8,
						["TB"] = 0.921,
						["G"] = 0.29,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 0.788,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["2"] = {
						["TG"] = 0.827,
						["B"] = 0.039,
						["TB"] = 0.419,
						["G"] = 0.513,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 1,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["enable"] = false,
					["4"] = {
						["TG"] = 1,
						["B"] = 0.015,
						["TB"] = 0.698,
						["G"] = 0.8,
						["TR"] = 0.698,
						["TO"] = 1,
						["R"] = 0,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["7"] = {
						["TG"] = 0.627,
						["B"] = 0.129,
						["TB"] = 0.619,
						["G"] = 0.184,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 0.8,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["6"] = {
						["TG"] = 0.831,
						["B"] = 0.972,
						["TB"] = 1,
						["G"] = 0.69,
						["TR"] = 0.662,
						["TO"] = 1,
						["R"] = 0.121,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["8"] = {
						["TG"] = 0.231,
						["B"] = 0.89,
						["TB"] = 0.231,
						["G"] = 0.866,
						["TR"] = 0.231,
						["TO"] = 1,
						["R"] = 0.847,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["5"] = {
						["TG"] = 0.87,
						["B"] = 0.8,
						["TB"] = 1,
						["G"] = 0.717,
						["TR"] = 0.725,
						["TO"] = 1,
						["R"] = 0.466,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
				},
				["useDebuffIcon"] = true,
				["HOT9"] = {
					["TG"] = 1,
					["countdownMode"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["HOT_CHARGE_4"] = {
					["TG"] = 1,
					["B"] = 0.8,
					["TB"] = 1,
					["G"] = 0.8,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.8,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
				["HOT_CHARGE_3"] = {
					["TG"] = 1,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 1,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
				["CLUSTER_GOOD"] = {
					["TG"] = 1,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0.8,
					["TR"] = 0,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
				["DEBUFF3"] = {
					["TG"] = 0.957,
					["B"] = 0.8,
					["TB"] = 1,
					["G"] = 0.4,
					["TR"] = 0.329,
					["TO"] = 1,
					["R"] = 0.4,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["INCOMING"] = {
					["TG"] = 0.82,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.33,
					["useOpacity"] = true,
				},
				["HOT6"] = {
					["useBackground"] = true,
					["R"] = 1,
					["B"] = 1,
					["O"] = 0.75,
					["G"] = 1,
				},
				["HOT4"] = {
					["TG"] = 0.6,
					["countdownMode"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 0.3,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["DEBUFF1"] = {
					["TG"] = 1,
					["B"] = 0.8,
					["TB"] = 0.6860000000000001,
					["G"] = 0.592,
					["TR"] = 0,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["CHARMED"] = {
					["TG"] = 0.31,
					["B"] = 0.263,
					["TB"] = 0.31,
					["G"] = 0.082,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.51,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["NO_EMERGENCY"] = {
					["TG"] = 0.82,
					["B"] = 0.4,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["HOTS"] = {
					["useColorText"] = true,
					["useColorBack"] = true,
					["TEXT"] = {
						["outline"] = true,
						["shadow"] = false,
					},
					["isFadeOut"] = false,
					["factorDivineAegis"] = 1.2,
					["showShieldAbsorb"] = true,
					["WARNING"] = {
						["enabled"] = false,
						["lowSecs"] = 3,
						["B"] = 0.2,
						["TB"] = 0.6,
						["G"] = 0.2,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 0.5,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["TG"] = 0.6,
					},
				},
				["GCD_BAR"] = {
					["useBackground"] = true,
					["R"] = 0.4,
					["B"] = 0.4,
					["O"] = 0.5,
					["G"] = 0.4,
				},
				["HOT2"] = {
					["TG"] = 1,
					["countdownMode"] = 2,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 1,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = true,
					["useText"] = true,
				},
				["DEAD"] = {
					["TG"] = 0.5,
					["B"] = 0.3,
					["TB"] = 0.5,
					["G"] = 0.3,
					["TR"] = 0.5,
					["TO"] = 1,
					["R"] = 0.3,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["OFFLINE"] = {
					["TG"] = 0.576,
					["B"] = 0.298,
					["TB"] = 0.576,
					["G"] = 0.298,
					["TR"] = 0.576,
					["TO"] = 0.58,
					["R"] = 0.298,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.21,
					["useOpacity"] = true,
				},
				["OUTRANGED"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["TO"] = 0.5,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.25,
					["useOpacity"] = true,
				},
				["HOT8"] = {
					["useBackground"] = true,
					["R"] = 1,
					["B"] = 1,
					["O"] = 0.75,
					["G"] = 1,
				},
				["IRRELEVANT"] = {
					["TG"] = 0.82,
					["B"] = 0.4,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["DEBUFF2"] = {
					["TG"] = 0,
					["B"] = 0.4,
					["TB"] = 0,
					["G"] = 0.4,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.8,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["BAR_FRAMES"] = {
					["useOpacity"] = true,
					["R"] = 0,
					["B"] = 0,
					["G"] = 0,
					["O"] = 0.7,
					["useBackground"] = true,
				},
				["EMERGENCY"] = {
					["TG"] = 0.82,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["HOT10"] = {
					["TG"] = 1,
					["countdownMode"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["THREAT"] = {
					["LOW"] = {
						["useBackground"] = true,
						["R"] = 0,
						["B"] = 1,
						["O"] = 1,
						["G"] = 1,
					},
					["HIGH"] = {
						["useBackground"] = true,
						["R"] = 1,
						["B"] = 1,
						["O"] = 1,
						["G"] = 0,
					},
				},
				["DEBUFF4"] = {
					["TG"] = 0,
					["B"] = 0.7,
					["TB"] = 1,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.7,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["DEBUFF6"] = {
					["TG"] = 0.5,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0.3,
					["TR"] = 0.8,
					["TO"] = 1,
					["R"] = 0.6,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["HOT5"] = {
					["TG"] = 0.6,
					["countdownMode"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 0.3,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["LIFE_LEFT"] = {
					["GOOD"] = {
						["useBackground"] = true,
						["R"] = 0,
						["B"] = 0,
						["O"] = 1,
						["G"] = 1,
					},
					["LOW"] = {
						["useBackground"] = true,
						["R"] = 1,
						["B"] = 0,
						["O"] = 1,
						["G"] = 0,
					},
					["FAIR"] = {
						["useBackground"] = true,
						["R"] = 1,
						["B"] = 0,
						["O"] = 1,
						["G"] = 1,
					},
				},
				["HOT_CHARGE_2"] = {
					["TG"] = 1,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 1,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
			},
		},
		["ORIGINATOR_CLASS"] = "PALADIN",
		["POWER_TYPE_COLORS"] = {
			{
				["TG"] = 0,
				["R"] = 1,
				["TB"] = 0,
				["G"] = 0,
				["TR"] = 1,
				["TO"] = 1,
				["B"] = 0,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [1]
			{
				["TG"] = 0.5,
				["R"] = 1,
				["TB"] = 0.25,
				["G"] = 0.5,
				["TR"] = 1,
				["TO"] = 1,
				["B"] = 0.25,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [2]
			{
				["TG"] = 1,
				["R"] = 1,
				["TB"] = 0,
				["G"] = 1,
				["TR"] = 1,
				["TO"] = 1,
				["B"] = 0,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [3]
			{
				["TG"] = 1,
				["R"] = 0,
				["TB"] = 1,
				["G"] = 1,
				["TR"] = 0,
				["TO"] = 1,
				["B"] = 1,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [4]
			nil, -- [5]
			{
				["TG"] = 0.5,
				["R"] = 0.5,
				["TB"] = 0.5,
				["G"] = 0.5,
				["TR"] = 0.5,
				["TO"] = 1,
				["B"] = 0.5,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [6]
			[0] = {
				["TG"] = 0,
				["R"] = 0,
				["TB"] = 1,
				["G"] = 0,
				["TR"] = 0,
				["TO"] = 1,
				["B"] = 1,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			},
		},
	}, -- [2]
	{
		["SPELL_CONFIG"] = {
			["IS_LOAD_HOTS"] = false,
			["IS_TOOLTIP_INFO"] = false,
			["IS_FIRE_HOT"] = false,
			["smartCastModi"] = "all",
			["IS_AUTO_FIRE"] = true,
			["IS_FIRE_CUSTOM_2"] = false,
			["IS_FIRE_TRINKET_2"] = true,
			["IS_FIRE_TRINKET_1"] = true,
			["IS_AUTO_TARGET"] = false,
			["FIRE_CUSTOM_2_SPELL"] = "",
			["FIRE_CUSTOM_1_SPELL"] = "",
			["autoBattleRez"] = true,
			["IS_KEEP_STANCE"] = false,
			["IS_FIRE_CUSTOM_1"] = false,
			["IS_FIRE_OUT_FIGHT"] = false,
		},
		["NAME"] = "Heals-Solo",
		["CONFIG"] = {
			["SMARTCAST_CLEANSE"] = false,
			["RANGE_SPELL"] = "Flash of Light",
			["SHOW_OVERHEAL"] = true,
			["OMIT_DFT_MTS"] = true,
			["BLIZZ_UI_HIDE_TARGET"] = true,
			["MAX_EMERGENCIES"] = 5,
			["STANDARD_TOOLTIP"] = true,
			["LOCK_PANELS"] = true,
			["RANGE_PESSIMISTIC"] = false,
			["SMARTCAST_RESURRECT"] = true,
			["BLIZZ_UI_HIDE_PET"] = true,
			["INC_HOTS_SECS"] = 3,
			["SMARTCAST_BUFF"] = false,
			["HIDE_PANELS_PARTY"] = false,
			["SHOW_PANELS"] = true,
			["HIDE_EMPTY_PANELS"] = true,
			["RANGE_CHECK_DELAY"] = 260,
			["SHOW_MINIMAP"] = false,
			["INC_CHANNELLED_SECS"] = 3,
			["IS_SCAN_TALENTS"] = true,
			["OMIT_OWN_GROUP"] = false,
			["MODE"] = 1,
			["INC_CASTED_SECS"] = 3,
			["DETECT_DEBUFFS_REMOVABLE_ONLY"] = true,
			["CLUSTER"] = {
				["REFRESH"] = 180,
				["CHAIN_MAX_JUMP"] = 5,
				["DISPLAY_DESTINATION"] = 2,
				["RANGE"] = 8,
				["MODE"] = 1,
				["DISPLAY_SOURCE"] = 2,
				["IS_NUMBER"] = false,
				["THRESH_GOOD"] = 5,
				["COOLDOWN_SPELL"] = "",
				["BELOW_HEALTH_PERC"] = 90,
				["THRESH_FAIR"] = 3,
			},
			["OMIT_MAIN_ASSIST"] = false,
			["RES_ANNOUNCE_TEXT"] = "Come to life, vuhdo!",
			["SHOW_INC_BOMBED"] = true,
			["IS_CLIQUE_COMPAT_MODE"] = false,
			["SHOW_INC_HOTS"] = true,
			["SHOW_INC_CHANNELLED"] = true,
			["DETECT_DEBUFFS_IGNORE_DURATION"] = true,
			["SCAN_RANGE"] = "2",
			["ON_MOUSE_UP"] = false,
			["OMIT_TARGET"] = false,
			["IS_SHOW_GCD"] = false,
			["BLIZZ_UI_HIDE_FOCUS"] = true,
			["DETECT_DEBUFFS_IGNORE_NO_HARM"] = true,
			["DETECT_DEBUFFS_IGNORE_BY_CLASS"] = true,
			["OMIT_PLAYER_TARGETS"] = false,
			["LOCK_CLICKS_THROUGH"] = false,
			["OMIT_MAIN_TANKS"] = false,
			["SHOW_PLAYER_TAGS"] = true,
			["BLIZZ_UI_HIDE_PLAYER"] = true,
			["UPDATE_HOTS_MS"] = 50,
			["SHOW_INC_CASTED"] = true,
			["EMERGENCY_TRIGGER"] = 100,
			["HIDE_PANELS_SOLO"] = false,
			["CURRENT_PROFILE"] = "Heals-Solo",
			["AUTO_PROFILES"] = {
				["1"] = "Heals-Solo",
				["5"] = "Heals-10",
				["25"] = "Heals-25",
				["10"] = "Heals-10",
			},
			["SHOW_INCOMING"] = true,
			["INC_BOMBED_SECS"] = 3,
			["OMIT_FOCUS"] = false,
			["BLIZZ_UI_HIDE_PARTY"] = true,
			["SOUND_DEBUFF"] = "Interface\\AddOns\\Ferous Media\\Sounds\\Coin_Dead.wav",
			["OMIT_SELF"] = false,
			["IS_PALLY_POWER_COMMS"] = true,
			["IS_ALWAYS_OVERWRITE_PROFILE"] = true,
			["DETECT_DEBUFFS_IGNORE_MOVEMENT"] = true,
			["CUSTOM_DEBUFF"] = {
				["animate"] = true,
				["isStacks"] = true,
				["point"] = "TOPRIGHT",
				["isName"] = false,
				["scale"] = 0.800000011920929,
				["timer"] = true,
				["isColor"] = false,
				["STORED"] = {
					"Acid-Drenched Mandibles", -- [1]
					"Boiling Blood", -- [2]
					"Burning Bile", -- [3]
					"Chilled to the Bone", -- [4]
					"Corrosion", -- [5]
					"Defile", -- [6]
					"Delirious Slash", -- [7]
					"Essence of the Blood Queen", -- [8]
					"Expose Weakness", -- [9]
					"Feral Pounce", -- [10]
					"Fire Bomb", -- [11]
					"Frost Beacon", -- [12]
					"Frost Blast", -- [13]
					"Frost Breath", -- [14]
					"Gas Spore", -- [15]
					"Gaseous Bloat", -- [16]
					"Gastric Bloat", -- [17]
					"Glittering Sparks", -- [18]
					"Gravity Bomb", -- [19]
					"Grievous Bite", -- [20]
					"Gut Spray", -- [21]
					"Harvest Soul", -- [22]
					"Ice Tomb", -- [23]
					"Impale", -- [24]
					"Impaled", -- [25]
					"Incinerate Flesh", -- [26]
					"Infest", -- [27]
					"Instability", -- [28]
					"Instant Heal", -- [29]
					"Iron Roots", -- [30]
					"Jagged Knife", -- [31]
					"Legion Flame", -- [32]
					"Mark of the Fallen Champion", -- [33]
					"Mistress' Kiss", -- [34]
					"Mutated Infection", -- [35]
					"Mutated Plague", -- [36]
					"Napalm Shell", -- [37]
					"Necrotic Plague", -- [38]
					"Necrotic Strike", -- [39]
					"Pact of the Darkfallen", -- [40]
					"Paralytic Toxin", -- [41]
					"Penetrating Cold", -- [42]
					"Rune of Blood", -- [43]
					"Sara's Blessing", -- [44]
					"Searing Light", -- [45]
					"Shadow Prison", -- [46]
					"Shroud of Sorrow", -- [47]
					"Slag Pot", -- [48]
					"Snobolled!", -- [49]
					"Spinning Pain Spike", -- [50]
					"Stone Grip", -- [51]
					"Swarming Shadows", -- [52]
					"Touch of Darkness", -- [53]
					"Touch of Light", -- [54]
					"Vile Gas", -- [55]
					"Volatile Ooze Adhesive", -- [56]
					"Web Wrap", -- [57]
				},
				["max_num"] = 5,
				["yAdjust"] = -34,
				["version"] = 13,
				["STORED_SETTINGS"] = {
					["Burning Bile"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Snobolled!"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Frost Beacon"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Mutated Plague"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Feral Pounce"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Slag Pot"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Impaled"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Acid-Drenched Mandibles"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Shroud of Sorrow"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Paralytic Toxin"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Grievous Bite"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Iron Roots"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Incinerate Flesh"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Mistress' Kiss"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Touch of Light"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Delirious Slash"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Necrotic Plague"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Shadow Prison"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Gut Spray"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Ice Tomb"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Corrosion"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Spinning Pain Spike"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Instant Heal"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Stone Grip"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Swarming Shadows"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Fire Bomb"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Touch of Darkness"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Penetrating Cold"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Pact of the Darkfallen"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Harvest Soul"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Web Wrap"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Essence of the Blood Queen"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Glittering Sparks"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Defile"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Gravity Bomb"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Legion Flame"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Napalm Shell"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Impale"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Infest"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Chilled to the Bone"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Jagged Knife"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Boiling Blood"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Necrotic Strike"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Rune of Blood"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Gaseous Bloat"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Mutated Infection"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Sara's Blessing"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Vile Gas"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Gastric Bloat"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Volatile Ooze Adhesive"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Instability"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Searing Light"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Frost Blast"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Expose Weakness"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Gas Spore"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Mark of the Fallen Champion"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
					["Frost Breath"] = {
						["isStacks"] = false,
						["animate"] = true,
						["timer"] = true,
						["isColor"] = false,
						["isIcon"] = true,
					},
				},
				["isIcon"] = true,
				["selected"] = "",
				["xAdjust"] = -2,
				["BUTTON_FACADE"] = "Blizzard",
			},
			["THREAT"] = {
				["AGGRO_TEXT_RIGHT"] = "<<",
				["AGGRO_TEXT_LEFT"] = ">>",
				["IS_TANK_MODE"] = true,
				["AGGRO_USE_TEXT"] = true,
				["AGGRO_REFRESH_MS"] = 100,
			},
			["SHOW_TEXT_OVERHEAL"] = true,
			["DIRECTION"] = {
				["scale"] = 76,
				["isDeadOnly"] = true,
				["enable"] = true,
				["isDistanceText"] = false,
			},
			["SHOW_OWN_INCOMING"] = true,
			["BLIZZ_UI_HIDE_RAID"] = true,
			["RES_IS_SHOW_TEXT"] = true,
		},
		["LOCKED"] = false,
		["INDICATOR_CONFIG"] = {
			["CUSTOM"] = {
				["THREAT_BAR"] = {
					["invertGrowth"] = false,
					["HEIGHT"] = 4,
					["turnAxis"] = false,
					["WARN_AT"] = 85,
					["TEXTURE"] = "VuhDo - Polished Wood",
				},
				["MOUSEOVER_HIGHLIGHT"] = {
					["TEXTURE"] = "LiteStepLite",
				},
				["AGGRO_BAR"] = {
					["TEXTURE"] = "VuhDo - Polished Wood",
				},
				["BACKGROUND_BAR"] = {
					["TEXTURE"] = "VuhDo - Minimalist",
				},
				["CLUSTER_BORDER"] = {
					["WIDTH"] = 2,
				},
				["SWIFTMEND_INDICATOR"] = {
					["SCALE"] = 1,
				},
				["SIDE_RIGHT"] = {
					["turnAxis"] = false,
					["vertical"] = true,
					["invertGrowth"] = false,
					["TEXTURE"] = "VuhDo - Polished Wood",
				},
				["BAR_BORDER"] = {
					["WIDTH"] = 1,
				},
				["HEALTH_BAR"] = {
					["turnAxis"] = false,
					["vertical"] = false,
					["invertGrowth"] = false,
				},
				["MANA_BAR"] = {
					["turnAxis"] = false,
					["invertGrowth"] = false,
					["TEXTURE"] = "VuhDo - Pipe, light",
				},
				["SIDE_LEFT"] = {
					["turnAxis"] = false,
					["vertical"] = true,
					["invertGrowth"] = false,
					["TEXTURE"] = "VuhDo - Polished Wood",
				},
			},
			["BOUQUETS"] = {
				["THREAT_BAR"] = "Threat: Status Bar",
				["MOUSEOVER_HIGHLIGHT"] = "",
				["AGGRO_BAR"] = "",
				["BACKGROUND_BAR"] = "Background: Solid",
				["INCOMING_BAR"] = "",
				["SWIFTMEND_INDICATOR"] = "LowMana",
				["HEALTH_BAR_PANEL"] = {
					"", -- [1]
					"", -- [2]
					"", -- [3]
					"", -- [4]
					"", -- [5]
					"", -- [6]
					"", -- [7]
					"", -- [8]
					"", -- [9]
					"", -- [10]
				},
				["DAMAGE_FLASH_BAR"] = "",
				["THREAT_MARK"] = "",
				["SIDE_RIGHT"] = "",
				["MANA_BAR"] = "Manabars: All Powers",
				["BAR_BORDER"] = "Border: Multi + Aggro",
				["HEALTH_BAR"] = "Health (generic, class col)",
				["CLUSTER_BORDER"] = "",
				["SIDE_LEFT"] = "",
			},
		},
		["ORIGINATOR_TOON"] = "Apiphany",
		["BUFF_SETTINGS"] = {
			["Inner Fire"] = {
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
				["enabled"] = false,
				["buff"] = "Inner Fire",
			},
			["Power Infusion"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["name"] = "Vassilisa",
				["filter"] = {
					[999] = true,
				},
			},
			["Vampiric Embrace"] = {
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["enabled"] = false,
				["filter"] = {
					[999] = true,
				},
			},
			["CONFIG"] = {
				["SWATCH_EMPTY_GROUP"] = {
					["TG"] = 0.8,
					["B"] = 0,
					["TB"] = 0.8,
					["G"] = 0,
					["TR"] = 0.8,
					["TO"] = 0.6,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["SWATCH_COLOR_BUFF_OUT"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0.8,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["SHOW_LABEL"] = false,
				["REFRESH_SECS"] = 1,
				["SWATCH_COLOR_BUFF_COOLDOWN"] = {
					["TG"] = 0.6,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 0.3,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["SWATCH_COLOR_BUFF_OKAY"] = {
					["TG"] = 0.8,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["SHOW"] = true,
				["PANEL_BG_COLOR"] = {
					["useBackground"] = true,
					["B"] = 0,
					["R"] = 0,
					["G"] = 0,
					["O"] = 0.5,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["SWATCH_COLOR_BUFF_LOW"] = {
					["TG"] = 0.7,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["VERSION"] = 2,
				["SCALE"] = 1,
				["BAR_COLORS_TEXT"] = true,
				["BAR_COLORS_IN_FIGHT"] = false,
				["HIGHLIGHT_COOLDOWN"] = true,
				["HIDE_CHARGES"] = false,
				["PANEL_MAX_BUFFS"] = 5,
				["COMPACT"] = true,
				["PANEL_BORDER_COLOR"] = {
					["useBackground"] = true,
					["B"] = 0,
					["R"] = 0,
					["G"] = 0,
					["O"] = 0.5,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["BAR_COLORS_BACKGROUND"] = true,
				["REBUFF_MIN_MINUTES"] = 3,
				["SWATCH_BG_COLOR"] = {
					["useBackground"] = true,
					["B"] = 0,
					["R"] = 0,
					["G"] = 0,
					["O"] = 1,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["POSITION"] = {
					["y"] = -30.43477443076573,
					["x"] = 9.132384778827319,
					["point"] = "TOPRIGHT",
					["relativePoint"] = "TOPRIGHT",
				},
				["WHEEL_SMART_BUFF"] = true,
				["SWATCH_BORDER_COLOR"] = {
					["useBackground"] = true,
					["B"] = 0.8,
					["R"] = 0.8,
					["G"] = 0.8,
					["O"] = 0,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["REBUFF_AT_PERCENT"] = 25,
				["SWATCH_COLOR_OUT_RANGE"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["TO"] = 0.5,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["BUTTON_FACADE"] = "Blizzard",
			},
			["Pain Suppression"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["name"] = "Vassilisa",
				["filter"] = {
					[999] = true,
				},
			},
			["Seal"] = {
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = true,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["R"] = 1,
				},
				["buff"] = "Seal of Truth",
				["enabled"] = true,
				["filter"] = {
					[999] = true,
				},
			},
			["Levitate"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
			},
			["Beacon of Light"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["R"] = 1,
				},
				["name"] = "Apiphany",
				["filter"] = {
					[999] = true,
				},
			},
			["Shadow Protection"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
			},
			["Power Word: Fortitude"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
			},
			["Aura"] = {
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["R"] = 1,
				},
				["buff"] = "Concentration Aura",
				["enabled"] = false,
				["filter"] = {
					[999] = true,
				},
			},
			["Shadowfiend"] = {
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["filter"] = {
					[999] = true,
				},
				["enabled"] = false,
				["buff"] = "Shadowfiend",
			},
			["Blessing"] = {
				["enabled"] = true,
				["buff"] = "Blessing of Kings",
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = true,
					["R"] = 1,
					["TO"] = 1,
					["useBackground"] = true,
					["TR"] = 1,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["filter"] = {
					[999] = true,
				},
			},
			["Fear Ward"] = {
				["enabled"] = false,
				["missingColor"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["B"] = 1,
				},
				["name"] = "Vassilisa",
				["filter"] = {
					[999] = true,
				},
			},
			["Righteous Fury"] = {
				["missingColor"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["show"] = false,
					["useOpacity"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["TR"] = 1,
					["O"] = 1,
					["R"] = 1,
				},
				["buff"] = "Righteous Fury",
				["enabled"] = false,
				["filter"] = {
					[999] = true,
				},
			},
		},
		["BUFF_ORDER"] = {
			["04Inner Fire"] = 4,
			["04Beacon of Light"] = 5,
			["02Aura"] = 1,
			["05Righteous Fury"] = 2,
			["01Power Word: Fortitude"] = 1,
			["05Shadowfiend"] = 5,
			["03Seal"] = 3,
			["01Blessing"] = 4,
			["09Pain Suppression"] = 9,
			["03Fear Ward"] = 3,
			["07Vampiric Embrace"] = 7,
			["08Levitate"] = 8,
			["06Power Infusion"] = 6,
			["02Shadow Protection"] = 2,
		},
		["PANEL_SETUP"] = {
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 2,
					["xAdjust"] = 4,
				},
				["POSITION"] = {
					["y"] = 234.527422443344,
					["x"] = 841.3152977380906,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 34.00000070288635,
					["growth"] = "TOPLEFT",
					["width"] = 99.99999465806371,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["groups"] = {
						1, -- [1]
						2, -- [2]
						3, -- [3]
						4, -- [4]
						5, -- [5]
						6, -- [6]
						7, -- [7]
						8, -- [8]
					},
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "TukTex",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\Addons\\Ferous Media\\Fonts\\neuropol.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 11,
						["maxChars"] = 7,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = true,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["_spacing"] = 10.00000014057727,
					["showPetOwners"] = true,
				},
			}, -- [1]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1.5,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 987.6000146481516,
					["x"] = 10.89999944471978,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 24.99999866451593,
					["growth"] = "TOPLEFT",
					["width"] = 234.0000035144318,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["groups"] = {
						41, -- [1]
					},
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 105,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 2,
					["rowSpacing"] = 1,
					["barWidth"] = 129,
					["targetSpacing"] = 0,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = true,
					["columnSpacing"] = 0,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 100,
					["maxRowsWhenLoose"] = 4,
					["showHeaders"] = true,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = true,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = false,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 1,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["_spacing"] = 10.00000014057727,
					["showPetOwners"] = true,
				},
			}, -- [2]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 652,
					["x"] = 328.5,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 128.8,
					["growth"] = "TOPLEFT",
					["width"] = 85,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["_spacing"] = 10,
					["showPetOwners"] = true,
				},
			}, -- [3]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 708,
					["x"] = 347.3,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 128.8,
					["growth"] = "TOPLEFT",
					["width"] = 85,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["_spacing"] = 17.99999985846689,
					["showPetOwners"] = true,
				},
			}, -- [4]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [5]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [6]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [7]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [8]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [9]
			{
				["OVERHEAL_TEXT"] = {
					["show"] = true,
					["yAdjust"] = 0,
					["point"] = "LEFT",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["POSITION"] = {
					["y"] = 668,
					["x"] = 100,
					["orientation"] = "TOPLEFT",
					["relativePoint"] = "BOTTOMLEFT",
					["scale"] = 1,
					["height"] = 200,
					["growth"] = "TOPLEFT",
					["width"] = 200,
				},
				["RAID_ICON"] = {
					["show"] = true,
					["yAdjust"] = -20,
					["point"] = "TOP",
					["scale"] = 1,
					["xAdjust"] = 0,
				},
				["frameStrata"] = "MEDIUM",
				["MODEL"] = {
					["ordering"] = 0,
					["sort"] = 0,
					["isReverse"] = false,
				},
				["TOOLTIP"] = {
					["BACKGROUND"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["inFight"] = false,
					["BORDER"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 1,
						["useBackground"] = true,
					},
					["showBuffs"] = false,
					["show"] = true,
					["x"] = 100,
					["position"] = 2,
					["SCALE"] = 1,
					["y"] = -100,
					["point"] = "TOPLEFT",
					["relativePoint"] = "TOPLEFT",
				},
				["PANEL_COLOR"] = {
					["classColorsHeader"] = false,
					["classColorsBackHeader"] = false,
					["TARGET"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
					["BORDER"] = {
						["edgeSize"] = 1,
						["R"] = 0,
						["G"] = 0,
						["useBackground"] = true,
						["B"] = 0,
						["useOpacity"] = true,
						["file"] = "Interface\\None",
						["O"] = 0,
						["insets"] = 0,
					},
					["barTexture"] = "fer14",
					["HEADER"] = {
						["TG"] = 0.859,
						["R"] = 0.6,
						["TB"] = 0.38,
						["barTexture"] = "fer18",
						["G"] = 0.6,
						["TR"] = 1,
						["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
						["TO"] = 1,
						["B"] = 0.6,
						["O"] = 0.6,
						["useText"] = true,
						["textSize"] = 13,
						["useBackground"] = true,
					},
					["TEXT"] = {
						["useOpacity"] = true,
						["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
						["useText"] = true,
						["textSize"] = 10,
						["outline"] = false,
						["textSizeLife"] = 8,
						["maxChars"] = 8,
					},
					["BACK"] = {
						["useOpacity"] = true,
						["R"] = 0,
						["B"] = 0,
						["G"] = 0,
						["O"] = 0,
						["useBackground"] = true,
					},
					["TOT"] = {
						["TR"] = 1,
						["TO"] = 1,
						["TB"] = 1,
						["useText"] = true,
						["TG"] = 1,
					},
				},
				["HOTS"] = {
					["textSize"] = 100,
					["size"] = 76,
				},
				["SCALING"] = {
					["headerHeight"] = 20,
					["targetWidth"] = 30,
					["scale"] = 1,
					["maxColumnsWhenStructured"] = 5,
					["rowSpacing"] = 2,
					["barWidth"] = 100,
					["targetSpacing"] = 3,
					["borderGapY"] = 0,
					["ommitEmptyWhenStructured"] = true,
					["showTarget"] = false,
					["columnSpacing"] = 2,
					["sideLeftWidth"] = 6,
					["barHeight"] = 30,
					["headerSpacing"] = 5,
					["borderGapX"] = 0,
					["manaBarHeight"] = 5,
					["headerWidth"] = 33,
					["maxRowsWhenLoose"] = 6,
					["showHeaders"] = false,
					["isDamFlash"] = true,
					["isPlayerOnTop"] = false,
					["showTot"] = false,
					["totSpacing"] = 3,
					["totWidth"] = 30,
					["sideRightWidth"] = 6,
					["damFlashFactor"] = 0.75,
					["targetOrientation"] = 1,
					["arrangeHorizontal"] = true,
					["alignBottom"] = false,
				},
				["LIFE_TEXT"] = {
					["show"] = true,
					["hideIrrelevant"] = false,
					["position"] = 1,
					["mode"] = 3,
					["verbose"] = false,
				},
				["ID_TEXT"] = {
					["showClass"] = false,
					["showName"] = true,
					["version"] = 2,
					["position"] = "CENTER+CENTER",
					["showTags"] = true,
					["showPetOwners"] = true,
				},
			}, -- [10]
			["RAID_ICON_FILTER"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["PANEL_COLOR"] = {
				["TEXT"] = {
					["TR"] = 1,
					["TO"] = 1,
					["TB"] = 0,
					["useText"] = true,
					["TG"] = 0.82,
				},
				["BARS"] = {
					["useOpacity"] = true,
					["R"] = 0.7,
					["B"] = 0.7,
					["G"] = 0.7,
					["O"] = 1,
					["useBackground"] = true,
				},
				["classColorsName"] = false,
			},
			["HOTS"] = {
				["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\ariblk.ttf",
				["SLOTS"] = {
					"Sacred Shield", -- [1]
					"Beacon of Light", -- [2]
					"BOUQUET_Tank Cooldowns", -- [3]
					"OTHER", -- [4]
					"CLUSTER", -- [5]
					[9] = "Beacon of Light",
				},
				["BARS"] = {
					["radioValue"] = 1,
					["width"] = 25,
				},
				["iconRadioValue"] = 1,
				["radioValue"] = 21,
				["SLOTCFG"] = {
					["1"] = {
						["mine"] = true,
						["others"] = false,
					},
					["3"] = {
						["mine"] = false,
						["others"] = true,
					},
					["2"] = {
						["mine"] = false,
						["others"] = true,
					},
					["5"] = {
						["mine"] = true,
						["others"] = false,
					},
					["4"] = {
						["mine"] = true,
						["others"] = false,
					},
					["7"] = {
						["mine"] = true,
						["others"] = false,
					},
					["6"] = {
						["mine"] = true,
						["others"] = false,
					},
					["9"] = {
						["mine"] = true,
						["others"] = false,
					},
					["8"] = {
						["mine"] = true,
						["others"] = false,
					},
					["10"] = {
						["mine"] = true,
						["others"] = false,
					},
				},
				["stacksRadioValue"] = 2,
				["BUTTON_FACADE"] = "Blizzard",
			},
			["BAR_COLORS"] = {
				["OVERHEAL_TEXT"] = {
					["TG"] = 1,
					["TO"] = 1,
					["TB"] = 0.8,
					["useOpacity"] = true,
					["useText"] = true,
					["TR"] = 0.8,
				},
				["HOT7"] = {
					["useBackground"] = true,
					["R"] = 1,
					["B"] = 1,
					["O"] = 0.75,
					["G"] = 1,
				},
				["CLUSTER_FAIR"] = {
					["TG"] = 1,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0.8,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.8,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
				["HOT1"] = {
					["TG"] = 0.6,
					["countdownMode"] = 2,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 0.3,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = true,
					["useText"] = true,
				},
				["DEBUFF0"] = {
					["useBackground"] = false,
					["useText"] = false,
					["useOpacity"] = false,
				},
				["HOT3"] = {
					["TG"] = 1,
					["countdownMode"] = 2,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["RAID_ICONS"] = {
					["1"] = {
						["TG"] = 1,
						["B"] = 0.305,
						["TB"] = 0.607,
						["G"] = 0.976,
						["TR"] = 0.98,
						["TO"] = 1,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["R"] = 1,
					},
					["filterOnly"] = false,
					["3"] = {
						["TG"] = 0.674,
						["B"] = 0.8,
						["TB"] = 0.921,
						["G"] = 0.29,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 0.788,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["2"] = {
						["TG"] = 0.827,
						["B"] = 0.039,
						["TB"] = 0.419,
						["G"] = 0.513,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 1,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["enable"] = false,
					["4"] = {
						["TG"] = 1,
						["B"] = 0.015,
						["TB"] = 0.698,
						["G"] = 0.8,
						["TR"] = 0.698,
						["TO"] = 1,
						["R"] = 0,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["7"] = {
						["TG"] = 0.627,
						["B"] = 0.129,
						["TB"] = 0.619,
						["G"] = 0.184,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 0.8,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["6"] = {
						["TG"] = 0.831,
						["B"] = 0.972,
						["TB"] = 1,
						["G"] = 0.69,
						["TR"] = 0.662,
						["TO"] = 1,
						["R"] = 0.121,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["8"] = {
						["TG"] = 0.231,
						["B"] = 0.89,
						["TB"] = 0.231,
						["G"] = 0.866,
						["TR"] = 0.231,
						["TO"] = 1,
						["R"] = 0.847,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
					["5"] = {
						["TG"] = 0.87,
						["B"] = 0.8,
						["TB"] = 1,
						["G"] = 0.717,
						["TR"] = 0.725,
						["TO"] = 1,
						["R"] = 0.466,
						["useBackground"] = true,
						["O"] = 1,
						["useText"] = true,
					},
				},
				["useDebuffIcon"] = true,
				["HOT9"] = {
					["TG"] = 1,
					["countdownMode"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["HOT_CHARGE_4"] = {
					["TG"] = 1,
					["B"] = 0.8,
					["TB"] = 1,
					["G"] = 0.8,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.8,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
				["HOT_CHARGE_3"] = {
					["TG"] = 1,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 1,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
				["CLUSTER_GOOD"] = {
					["TG"] = 1,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0.8,
					["TR"] = 0,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
				["DEBUFF3"] = {
					["TG"] = 0.957,
					["B"] = 0.8,
					["TB"] = 1,
					["G"] = 0.4,
					["TR"] = 0.329,
					["TO"] = 1,
					["R"] = 0.4,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["INCOMING"] = {
					["TG"] = 0.82,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.33,
					["useOpacity"] = true,
				},
				["HOT6"] = {
					["useBackground"] = true,
					["R"] = 1,
					["B"] = 1,
					["O"] = 0.75,
					["G"] = 1,
				},
				["HOT4"] = {
					["TG"] = 0.6,
					["countdownMode"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 0.3,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["DEBUFF1"] = {
					["TG"] = 1,
					["B"] = 0.8,
					["TB"] = 0.6860000000000001,
					["G"] = 0.592,
					["TR"] = 0,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["CHARMED"] = {
					["TG"] = 0.31,
					["B"] = 0.263,
					["TB"] = 0.31,
					["G"] = 0.082,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.51,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["NO_EMERGENCY"] = {
					["TG"] = 0.82,
					["B"] = 0.4,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["HOTS"] = {
					["useColorText"] = true,
					["useColorBack"] = true,
					["TEXT"] = {
						["outline"] = true,
						["shadow"] = false,
					},
					["isFadeOut"] = false,
					["factorDivineAegis"] = 1.2,
					["showShieldAbsorb"] = true,
					["WARNING"] = {
						["enabled"] = false,
						["lowSecs"] = 3,
						["B"] = 0.2,
						["TB"] = 0.6,
						["G"] = 0.2,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 0.5,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["TG"] = 0.6,
					},
				},
				["GCD_BAR"] = {
					["useBackground"] = true,
					["R"] = 0.4,
					["B"] = 0.4,
					["O"] = 0.5,
					["G"] = 0.4,
				},
				["HOT2"] = {
					["TG"] = 1,
					["countdownMode"] = 2,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 1,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = true,
					["useText"] = true,
				},
				["DEAD"] = {
					["TG"] = 0.5,
					["B"] = 0.3,
					["TB"] = 0.5,
					["G"] = 0.3,
					["TR"] = 0.5,
					["TO"] = 1,
					["R"] = 0.3,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["OFFLINE"] = {
					["TG"] = 0.576,
					["B"] = 0.298,
					["TB"] = 0.576,
					["G"] = 0.298,
					["TR"] = 0.576,
					["TO"] = 0.58,
					["R"] = 0.298,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.21,
					["useOpacity"] = true,
				},
				["OUTRANGED"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["TO"] = 0.5,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.25,
					["useOpacity"] = true,
				},
				["HOT8"] = {
					["useBackground"] = true,
					["R"] = 1,
					["B"] = 1,
					["O"] = 0.75,
					["G"] = 1,
				},
				["IRRELEVANT"] = {
					["TG"] = 0.82,
					["B"] = 0.4,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["DEBUFF2"] = {
					["TG"] = 0,
					["B"] = 0.4,
					["TB"] = 0,
					["G"] = 0.4,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.8,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["BAR_FRAMES"] = {
					["useOpacity"] = true,
					["R"] = 0,
					["B"] = 0,
					["G"] = 0,
					["O"] = 0.7,
					["useBackground"] = true,
				},
				["EMERGENCY"] = {
					["TG"] = 0.82,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["HOT10"] = {
					["TG"] = 1,
					["countdownMode"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 0.6,
					["TO"] = 1,
					["R"] = 0.3,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["THREAT"] = {
					["LOW"] = {
						["useBackground"] = true,
						["R"] = 0,
						["B"] = 1,
						["O"] = 1,
						["G"] = 1,
					},
					["HIGH"] = {
						["useBackground"] = true,
						["R"] = 1,
						["B"] = 1,
						["O"] = 1,
						["G"] = 0,
					},
				},
				["DEBUFF4"] = {
					["TG"] = 0,
					["B"] = 0.7,
					["TB"] = 1,
					["G"] = 0,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 0.7,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["DEBUFF6"] = {
					["TG"] = 0.5,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0.3,
					["TR"] = 0.8,
					["TO"] = 1,
					["R"] = 0.6,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["HOT5"] = {
					["TG"] = 0.6,
					["countdownMode"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 0.3,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["O"] = 1,
					["useBackground"] = true,
					["isFullDuration"] = false,
					["useText"] = true,
				},
				["LIFE_LEFT"] = {
					["GOOD"] = {
						["useBackground"] = true,
						["R"] = 0,
						["B"] = 0,
						["O"] = 1,
						["G"] = 1,
					},
					["LOW"] = {
						["useBackground"] = true,
						["R"] = 1,
						["B"] = 0,
						["O"] = 1,
						["G"] = 0,
					},
					["FAIR"] = {
						["useBackground"] = true,
						["R"] = 1,
						["B"] = 0,
						["O"] = 1,
						["G"] = 1,
					},
				},
				["HOT_CHARGE_2"] = {
					["TG"] = 1,
					["B"] = 0.3,
					["TB"] = 0.6,
					["G"] = 1,
					["TR"] = 1,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["O"] = 1,
					["useText"] = true,
				},
			},
		},
		["ORIGINATOR_CLASS"] = "PALADIN",
		["POWER_TYPE_COLORS"] = {
			{
				["TG"] = 0,
				["R"] = 1,
				["TB"] = 0,
				["G"] = 0,
				["TR"] = 1,
				["TO"] = 1,
				["B"] = 0,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [1]
			{
				["TG"] = 0.5,
				["R"] = 1,
				["TB"] = 0.25,
				["G"] = 0.5,
				["TR"] = 1,
				["TO"] = 1,
				["B"] = 0.25,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [2]
			{
				["TG"] = 1,
				["R"] = 1,
				["TB"] = 0,
				["G"] = 1,
				["TR"] = 1,
				["TO"] = 1,
				["B"] = 0,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [3]
			{
				["TG"] = 1,
				["R"] = 0,
				["TB"] = 1,
				["G"] = 1,
				["TR"] = 0,
				["TO"] = 1,
				["B"] = 1,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [4]
			nil, -- [5]
			{
				["TG"] = 0.5,
				["R"] = 0.5,
				["TB"] = 0.5,
				["G"] = 0.5,
				["TR"] = 0.5,
				["TO"] = 1,
				["B"] = 0.5,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			}, -- [6]
			[0] = {
				["TG"] = 0,
				["R"] = 0,
				["TB"] = 1,
				["G"] = 0,
				["TR"] = 0,
				["TO"] = 1,
				["B"] = 1,
				["useOpacity"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["useText"] = true,
			},
		},
	}, -- [3]
}
VUHDO_MANUAL_ROLES = {
}
VUHDO_SPELL_LAYOUTS = {
}
VUHDO_USER_CLASS_COLORS = {
	[24] = {
		["TG"] = 0.9,
		["R"] = 0.41,
		["TB"] = 1,
		["G"] = 0.8,
		["useBackground"] = true,
		["TO"] = 1,
		["B"] = 0.94,
		["TR"] = 0.51,
		["useOpacity"] = true,
		["O"] = 1,
		["useText"] = true,
	},
	[25] = {
		["TG"] = 0.61,
		["R"] = 0.58,
		["TB"] = 0.89,
		["G"] = 0.51,
		["useBackground"] = true,
		["TO"] = 1,
		["B"] = 0.79,
		["TR"] = 0.6800000000000001,
		["useOpacity"] = true,
		["O"] = 1,
		["useText"] = true,
	},
	[26] = {
		["TG"] = 0.45,
		["R"] = 0.14,
		["TB"] = 1,
		["G"] = 0.35,
		["useBackground"] = true,
		["TO"] = 1,
		["B"] = 1,
		["TR"] = 0.24,
		["useOpacity"] = true,
		["O"] = 1,
		["useText"] = true,
	},
	[27] = {
		["TG"] = 0.6,
		["R"] = 1,
		["TB"] = 0.04,
		["G"] = 0.49,
		["useBackground"] = true,
		["TO"] = 1,
		["B"] = 0.04,
		["TR"] = 1,
		["useOpacity"] = true,
		["O"] = 1,
		["useText"] = true,
	},
	[28] = {
		["TG"] = 1,
		["R"] = 0.9,
		["TB"] = 1,
		["G"] = 0.9,
		["useBackground"] = true,
		["TO"] = 1,
		["B"] = 0.9,
		["TR"] = 1,
		["useOpacity"] = true,
		["O"] = 1,
		["useText"] = true,
	},
	[29] = {
		["TG"] = 0.22,
		["R"] = 0.77,
		["TB"] = 0.33,
		["G"] = 0.12,
		["useBackground"] = true,
		["TO"] = 1,
		["B"] = 0.23,
		["TR"] = 0.87,
		["useOpacity"] = true,
		["O"] = 1,
		["useText"] = true,
	},
	[21] = {
		["TG"] = 1,
		["R"] = 1,
		["TB"] = 0.51,
		["G"] = 0.96,
		["useBackground"] = true,
		["TO"] = 1,
		["B"] = 0.41,
		["TR"] = 1,
		["useOpacity"] = true,
		["O"] = 1,
		["useText"] = true,
	},
	[20] = {
		["TG"] = 0.71,
		["R"] = 0.78,
		["TB"] = 0.53,
		["G"] = 0.61,
		["useBackground"] = true,
		["TO"] = 1,
		["useText"] = true,
		["TR"] = 0.88,
		["useOpacity"] = true,
		["O"] = 1,
		["B"] = 0.43,
	},
	[40] = {
		["TG"] = 0.9,
		["R"] = 0.4,
		["TB"] = 0.5,
		["G"] = 0.6,
		["useBackground"] = true,
		["TO"] = 1,
		["B"] = 0.4,
		["TR"] = 0.5,
		["useOpacity"] = true,
		["O"] = 1,
		["useText"] = true,
	},
	[22] = {
		["TG"] = 0.9300000000000001,
		["R"] = 0.67,
		["TB"] = 0.55,
		["G"] = 0.83,
		["useBackground"] = true,
		["TO"] = 1,
		["B"] = 0.45,
		["TR"] = 0.77,
		["useOpacity"] = true,
		["O"] = 1,
		["useText"] = true,
	},
	[23] = {
		["TG"] = 0.65,
		["R"] = 0.96,
		["TB"] = 0.83,
		["G"] = 0.55,
		["useBackground"] = true,
		["TO"] = 1,
		["B"] = 0.73,
		["TR"] = 1,
		["useOpacity"] = true,
		["O"] = 1,
		["useText"] = true,
	},
	["petClassColor"] = false,
}
VUHDO_DEBUFF_BLACKLIST = {
	["Sated"] = true,
	["Dungeon Cooldown"] = true,
	["Chill of the Throne"] = true,
}
VUHDO_BOUQUETS = {
	["VERSION"] = 2,
	["STORED"] = {
		["Border: Multi + Aggro"] = {
			{
				["name"] = "AGGRO",
				["others"] = false,
				["color"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = false,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
			{
				["name"] = "PLAYER_TARGET",
				["others"] = false,
				["color"] = {
					["TG"] = 0.7,
					["B"] = 0.9,
					["TB"] = 0.7,
					["G"] = 0.9,
					["TR"] = 0.7,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 0.9,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [2]
			{
				["name"] = "MOUSE_TARGET",
				["others"] = false,
				["color"] = {
					["TG"] = 0.4,
					["B"] = 0.113,
					["TB"] = 0.4,
					["G"] = 0.47,
					["TR"] = 0.4,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 0.635,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [3]
			{
				["name"] = "ALWAYS",
				["others"] = false,
				["color"] = {
					["TG"] = 0.1,
					["B"] = 0,
					["TB"] = 0.1,
					["G"] = 0,
					["TR"] = 0.1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.7,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 1,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [4]
		},
		["Manabars: Mana only"] = {
			{
				["name"] = "NO_RANGE",
				["others"] = false,
				["color"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["isManuallySet"] = true,
					["TO"] = 0.25,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.25,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = false,
						["useText"] = false,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 2,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = false,
						["useText"] = false,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
			{
				["name"] = "STATUS_MANA",
				["others"] = false,
				["color"] = {
					["R"] = 0,
					["G"] = 0,
					["useBackground"] = true,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["useText"] = false,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["B"] = 0.8,
						["useText"] = false,
						["useOpacity"] = true,
						["TO"] = 1,
						["useBackground"] = true,
						["G"] = 0,
						["O"] = 1,
						["R"] = 0,
					},
					["radio"] = 1,
					["grad_low"] = {
						["B"] = 0.6,
						["useText"] = false,
						["useOpacity"] = true,
						["TO"] = 1,
						["useBackground"] = true,
						["G"] = 0,
						["O"] = 1,
						["R"] = 0,
					},
				},
			}, -- [2]
		},
		["Tank Cooldowns"] = {
			{
				["name"] = "Last Stand",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["R"] = 1,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["useOpacity"] = true,
					["isDefault"] = true,
					["useText"] = true,
					["O"] = 1,
					["useBackground"] = true,
				},
				["mine"] = true,
				["icon"] = 1,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
			{
				["name"] = "Shield Wall",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["R"] = 1,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["useOpacity"] = true,
					["isDefault"] = true,
					["useText"] = true,
					["O"] = 1,
					["useBackground"] = true,
				},
				["mine"] = true,
				["icon"] = 1,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [2]
			{
				["name"] = "Survival Instincts",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["useBackground"] = true,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["isDefault"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 1,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [3]
			{
				["name"] = "Frenzied Regeneration",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["useBackground"] = true,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["isDefault"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 1,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [4]
		},
		["PW:S & Weakened Soul"] = {
			{
				["name"] = "Weakened Soul",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["B"] = 0.305,
					["TB"] = 1,
					["G"] = 0.623,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 9,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
			{
				["name"] = "Power Word: Shield",
				["others"] = false,
				["color"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 0.749,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 0.074,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 8,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [2]
		},
		["Threat: Status Bar"] = {
			{
				["name"] = "THREAT_ABOVE",
				["others"] = true,
				["color"] = {
					["TG"] = 0,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 0,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					85, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
			{
				["name"] = "STATUS_THREAT",
				["others"] = false,
				["color"] = {
					["R"] = 0,
					["G"] = 1,
					["useBackground"] = true,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["useText"] = false,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["B"] = 0.6,
						["useText"] = false,
						["useOpacity"] = true,
						["TO"] = 1,
						["useBackground"] = true,
						["G"] = 0.6,
						["O"] = 1,
						["R"] = 0,
					},
					["radio"] = 1,
					["grad_low"] = {
						["B"] = 0.3,
						["useText"] = false,
						["useOpacity"] = true,
						["TO"] = 1,
						["useBackground"] = true,
						["G"] = 0.3,
						["O"] = 1,
						["R"] = 0,
					},
				},
			}, -- [2]
		},
		["Mouseover: Multi"] = {
			{
				["name"] = "MOUSE_TARGET",
				["others"] = false,
				["color"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 0.5,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
			{
				["name"] = "MOUSE_GROUP",
				["others"] = false,
				["color"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 0.25,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.25,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [2]
		},
		["Cluster: Mouse Hover"] = {
			{
				["name"] = "MOUSE_CLUSTER",
				["others"] = false,
				["color"] = {
					["TG"] = 0.5,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0.5,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.8,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
		},
		["Health (generic, class col)"] = {
			{
				["name"] = "DISCONNECTED",
				["others"] = true,
				["color"] = {
					["TG"] = 0.576,
					["B"] = 0.298,
					["TB"] = 0.576,
					["G"] = 0.298,
					["TR"] = 0.576,
					["isManuallySet"] = true,
					["TO"] = 0.58,
					["R"] = 0.298,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.21,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [1]
			{
				["name"] = "NO_RANGE",
				["others"] = true,
				["color"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["isManuallySet"] = true,
					["TO"] = 0.5,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.25,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [2]
			{
				["name"] = "RESURRECTION",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 0.4,
					["useText"] = true,
					["TR"] = 0.4,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["O"] = 1,
					["G"] = 1,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [3]
			{
				["name"] = "DEAD",
				["others"] = true,
				["color"] = {
					["TG"] = 0.5,
					["B"] = 0.3,
					["TB"] = 0.5,
					["G"] = 0.3,
					["TR"] = 0.5,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 0.3,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [4]
			{
				["name"] = "OVERHEAL_HIGHLIGHT",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [5]
			{
				["name"] = "DEBUFF_BAR_COLOR",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [6]
			{
				["name"] = "ALWAYS",
				["others"] = true,
				["color"] = {
					["TG"] = 0.82,
					["R"] = 1,
					["TB"] = 0,
					["useText"] = true,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["useOpacity"] = false,
					["useBackground"] = false,
					["B"] = 1,
					["O"] = 1,
					["G"] = 1,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [7]
			{
				["name"] = "STATUS_HEALTH",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["B"] = 0.7,
					["TB"] = 1,
					["G"] = 0.7,
					["useBackground"] = true,
					["isManuallySet"] = true,
					["TO"] = 1,
					["TR"] = 1,
					["useOpacity"] = true,
					["O"] = 1,
					["R"] = 0.7,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 2,
				},
			}, -- [8]
		},
		["Swiftmendable"] = {
			{
				["name"] = "SWIFTMEND",
				["others"] = false,
				["color"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 6,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
		},
		["Mouseover: Single"] = {
			{
				["name"] = "MOUSE_TARGET",
				["others"] = false,
				["color"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 0.5,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
		},
		["Background: Solid"] = {
			{
				["name"] = "DISCONNECTED",
				["others"] = false,
				["color"] = {
					["TG"] = 0.576,
					["B"] = 0.298,
					["TB"] = 0.576,
					["G"] = 0.298,
					["TR"] = 0.576,
					["isManuallySet"] = true,
					["TO"] = 0.58,
					["R"] = 0.298,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.21,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = false,
						["useText"] = false,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 2,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = false,
						["useText"] = false,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
			{
				["name"] = "NO_RANGE",
				["others"] = false,
				["color"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["isManuallySet"] = true,
					["TO"] = 0.25,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.25,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = false,
						["useText"] = false,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 2,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = false,
						["useText"] = false,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [2]
			{
				["name"] = "DEBUFF_BAR_COLOR",
				["others"] = false,
				["color"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 1,
				["custom"] = {
					1, -- [1]
					["bright"] = 0.4,
					["grad_med"] = {
						["TG"] = 1,
						["B"] = 1,
						["TB"] = 1,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 1,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 1,
						["B"] = 1,
						["TB"] = 1,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 1,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [3]
			{
				["name"] = "ALWAYS",
				["others"] = false,
				["color"] = {
					["TG"] = 0.1,
					["B"] = 0,
					["TB"] = 0.1,
					["G"] = 0,
					["TR"] = 0.1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.7,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 1,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [4]
		},
		["LowMana"] = {
			{
				["name"] = "MANA_BELOW",
				["others"] = true,
				["color"] = {
					["TG"] = 0,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 0.1647058823529412,
					["TR"] = 0,
					["isManuallySet"] = true,
					["TO"] = 1,
					["useText"] = false,
					["useOpacity"] = true,
					["useBackground"] = true,
					["O"] = 1,
					["B"] = 0,
				},
				["mine"] = true,
				["icon"] = 9,
				["custom"] = {
					20, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 1,
						["B"] = 0,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 1,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["B"] = 0,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 1,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
			{
				["name"] = "MANA_BELOW",
				["others"] = false,
				["color"] = {
					["TG"] = 0,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 0.7764705882352941,
					["TR"] = 0,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 0.06274509803921569,
					["useBackground"] = true,
					["useText"] = false,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 9,
				["custom"] = {
					40, -- [1]
					["grad_med"] = {
						["TG"] = 0,
						["B"] = 0.8,
						["TB"] = 0.8,
						["G"] = 0,
						["TR"] = 0,
						["TO"] = 1,
						["R"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0,
						["TR"] = 0,
						["TO"] = 1,
						["R"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [2]
		},
		["Threat: Marks"] = {
			{
				["name"] = "THREAT_LEVEL_HIGH",
				["others"] = false,
				["color"] = {
					["TG"] = 0.5,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
			{
				["name"] = "THREAT_LEVEL_MEDIUM",
				["others"] = false,
				["color"] = {
					["TG"] = 0.5,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0.5,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [2]
		},
		["Health (generic, solid)"] = {
			{
				["name"] = "DISCONNECTED",
				["others"] = true,
				["color"] = {
					["TG"] = 0.576,
					["B"] = 0.298,
					["TB"] = 0.576,
					["G"] = 0.298,
					["TR"] = 0.576,
					["isManuallySet"] = true,
					["TO"] = 0.58,
					["R"] = 0.298,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.21,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [1]
			{
				["name"] = "NO_RANGE",
				["others"] = true,
				["color"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["isManuallySet"] = true,
					["TO"] = 0.5,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.25,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [2]
			{
				["name"] = "RESURRECTION",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 0.4,
					["useText"] = true,
					["TR"] = 0.4,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["O"] = 1,
					["G"] = 1,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [3]
			{
				["name"] = "DEAD",
				["others"] = true,
				["color"] = {
					["TG"] = 0.5,
					["B"] = 0.3,
					["TB"] = 0.5,
					["G"] = 0.3,
					["TR"] = 0.5,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 0.3,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [4]
			{
				["name"] = "OVERHEAL_HIGHLIGHT",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [5]
			{
				["name"] = "DEBUFF_BAR_COLOR",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [6]
			{
				["name"] = "ALWAYS",
				["others"] = true,
				["color"] = {
					["TG"] = 0.82,
					["R"] = 1,
					["TB"] = 0,
					["useText"] = true,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["useOpacity"] = false,
					["useBackground"] = false,
					["B"] = 1,
					["O"] = 1,
					["G"] = 1,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [7]
			{
				["name"] = "STATUS_HEALTH",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["B"] = 0.7,
					["TB"] = 1,
					["G"] = 0.7,
					["useBackground"] = true,
					["isManuallySet"] = true,
					["TO"] = 1,
					["TR"] = 1,
					["useOpacity"] = true,
					["O"] = 1,
					["R"] = 0.7,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [8]
		},
		["Manabars: All Powers"] = {
			{
				["name"] = "STATUS_MANA",
				["others"] = false,
				["color"] = {
					["R"] = 0,
					["G"] = 0,
					["useBackground"] = true,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["useText"] = false,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["B"] = 0.8,
						["useText"] = false,
						["useOpacity"] = true,
						["TO"] = 1,
						["useBackground"] = true,
						["G"] = 0,
						["O"] = 1,
						["R"] = 0,
					},
					["radio"] = 1,
					["grad_low"] = {
						["B"] = 0.6,
						["useText"] = false,
						["useOpacity"] = true,
						["TO"] = 1,
						["useBackground"] = true,
						["G"] = 0,
						["O"] = 1,
						["R"] = 0,
					},
				},
			}, -- [1]
			{
				["name"] = "STATUS_OTHER_POWERS",
				["others"] = false,
				["color"] = {
					["R"] = 1,
					["G"] = 1,
					["useBackground"] = true,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["useText"] = false,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["B"] = 0.6,
						["useText"] = false,
						["useOpacity"] = true,
						["TO"] = 1,
						["useBackground"] = true,
						["G"] = 0.6,
						["O"] = 1,
						["R"] = 0.6,
					},
					["radio"] = 1,
					["grad_low"] = {
						["B"] = 0.3,
						["useText"] = false,
						["useOpacity"] = true,
						["TO"] = 1,
						["useBackground"] = true,
						["G"] = 0.3,
						["O"] = 1,
						["R"] = 0.3,
					},
				},
			}, -- [2]
			{
				["name"] = "NO_RANGE",
				["others"] = false,
				["color"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["isManuallySet"] = true,
					["TO"] = 0.25,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.25,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = false,
						["useText"] = false,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 2,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = false,
						["useText"] = false,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [3]
		},
		["Aggro Indicator"] = {
			{
				["name"] = "MANA_BELOW",
				["others"] = false,
				["color"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
		},
		["Health Bar: (generic, gradient)"] = {
			{
				["name"] = "DISCONNECTED",
				["others"] = true,
				["color"] = {
					["TG"] = 0.576,
					["B"] = 0.298,
					["TB"] = 0.576,
					["G"] = 0.298,
					["TR"] = 0.576,
					["isManuallySet"] = true,
					["TO"] = 0.58,
					["R"] = 0.298,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.21,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [1]
			{
				["name"] = "NO_RANGE",
				["others"] = true,
				["color"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["isManuallySet"] = true,
					["TO"] = 0.5,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.25,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [2]
			{
				["name"] = "RESURRECTION",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 0.4,
					["useText"] = true,
					["TR"] = 0.4,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["O"] = 1,
					["G"] = 1,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [3]
			{
				["name"] = "DEAD",
				["others"] = true,
				["color"] = {
					["TG"] = 0.5,
					["B"] = 0.3,
					["TB"] = 0.5,
					["G"] = 0.3,
					["TR"] = 0.5,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 0.3,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.5,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [4]
			{
				["name"] = "OVERHEAL_HIGHLIGHT",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [5]
			{
				["name"] = "DEBUFF_BAR_COLOR",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["R"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["B"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [6]
			{
				["name"] = "ALWAYS",
				["others"] = true,
				["color"] = {
					["TG"] = 0.82,
					["R"] = 1,
					["TB"] = 0,
					["useText"] = true,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["useOpacity"] = false,
					["useBackground"] = false,
					["B"] = 1,
					["O"] = 1,
					["G"] = 1,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 0,
						["R"] = 1,
						["TB"] = 0,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["B"] = 0,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
				},
			}, -- [7]
			{
				["name"] = "STATUS_HEALTH",
				["others"] = true,
				["color"] = {
					["TG"] = 1,
					["B"] = 0,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["useBackground"] = true,
					["useOpacity"] = true,
					["O"] = 1,
					["R"] = 0,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["grad_med"] = {
						["TG"] = 1,
						["B"] = 0,
						["TB"] = 1,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["useOpacity"] = true,
						["useBackground"] = true,
						["O"] = 1,
						["R"] = 1,
					},
					["bright"] = 1,
					["grad_low"] = {
						["TG"] = 1,
						["B"] = 0,
						["TB"] = 1,
						["G"] = 0,
						["TR"] = 1,
						["TO"] = 1,
						["useOpacity"] = true,
						["useBackground"] = true,
						["O"] = 1,
						["R"] = 1,
					},
					["radio"] = 3,
				},
			}, -- [8]
		},
		["Background: Class Color"] = {
			{
				["name"] = "DISCONNECTED",
				["others"] = false,
				["color"] = {
					["TG"] = 0.576,
					["B"] = 0.298,
					["TB"] = 0.576,
					["G"] = 0.298,
					["TR"] = 0.576,
					["isManuallySet"] = true,
					["TO"] = 0.58,
					["R"] = 0.298,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.21,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = false,
						["useText"] = false,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 2,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = false,
						["useText"] = false,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
			{
				["name"] = "NO_RANGE",
				["others"] = false,
				["color"] = {
					["TG"] = 0,
					["B"] = 0,
					["TB"] = 0,
					["G"] = 0,
					["TR"] = 0,
					["isManuallySet"] = true,
					["TO"] = 0.25,
					["R"] = 0,
					["useBackground"] = false,
					["useText"] = false,
					["O"] = 0.25,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = false,
						["useText"] = false,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 2,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = false,
						["useText"] = false,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [2]
			{
				["name"] = "DEBUFF_BAR_COLOR",
				["others"] = false,
				["color"] = {
					["TG"] = 1,
					["B"] = 1,
					["TB"] = 1,
					["G"] = 1,
					["TR"] = 1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 1,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 1,
				["custom"] = {
					1, -- [1]
					["bright"] = 0.4,
					["grad_med"] = {
						["TG"] = 1,
						["B"] = 1,
						["TB"] = 1,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 1,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 1,
						["B"] = 1,
						["TB"] = 1,
						["G"] = 1,
						["TR"] = 1,
						["TO"] = 1,
						["R"] = 1,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [3]
			{
				["name"] = "CLASS_COLOR",
				["others"] = false,
				["color"] = {
					["TG"] = 0.1,
					["B"] = 0,
					["TB"] = 0.1,
					["G"] = 0,
					["TR"] = 0.1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.7,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 1,
				["custom"] = {
					1, -- [1]
					["bright"] = 0.4,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [4]
		},
		["Border: Simple"] = {
			{
				["name"] = "ALWAYS",
				["others"] = false,
				["color"] = {
					["TG"] = 0.1,
					["B"] = 0,
					["TB"] = 0.1,
					["G"] = 0,
					["TR"] = 0.1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.7,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 1,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
		},
		["Border: Multi"] = {
			{
				["name"] = "PLAYER_TARGET",
				["others"] = false,
				["color"] = {
					["TG"] = 0.7,
					["B"] = 0.9,
					["TB"] = 0.7,
					["G"] = 0.9,
					["TR"] = 0.7,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 0.9,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [1]
			{
				["name"] = "MOUSE_TARGET",
				["others"] = false,
				["color"] = {
					["TG"] = 0.4,
					["B"] = 0.113,
					["TB"] = 0.4,
					["G"] = 0.47,
					["TR"] = 0.4,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 0.635,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 1,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 2,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [2]
			{
				["name"] = "ALWAYS",
				["others"] = false,
				["color"] = {
					["TG"] = 0.1,
					["B"] = 0,
					["TB"] = 0.1,
					["G"] = 0,
					["TR"] = 0.1,
					["isManuallySet"] = true,
					["TO"] = 1,
					["R"] = 0,
					["useBackground"] = true,
					["useText"] = true,
					["O"] = 0.7,
					["useOpacity"] = true,
				},
				["mine"] = true,
				["icon"] = 1,
				["custom"] = {
					1, -- [1]
					["bright"] = 1,
					["grad_med"] = {
						["TG"] = 0.6,
						["B"] = 0.6,
						["TB"] = 0.6,
						["G"] = 0.6,
						["TR"] = 0.6,
						["TO"] = 1,
						["R"] = 0.6,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
					["radio"] = 1,
					["grad_low"] = {
						["TG"] = 0.3,
						["B"] = 0.3,
						["TB"] = 0.3,
						["G"] = 0.3,
						["TR"] = 0.3,
						["TO"] = 1,
						["R"] = 0.3,
						["useBackground"] = true,
						["useText"] = true,
						["O"] = 1,
						["useOpacity"] = true,
					},
				},
			}, -- [3]
		},
	},
	["SELECTED"] = "Manabars: All Powers",
}
VUHDO_COMBAT_LOG_TRACE = {
}
end

local SetWIM = function()
if(WIM3_Data) then table.wipe(WIM3_Data) end

WIM3_Data = {
	["escapeToHide"] = true,
	["stats"] = {
		["startDate"] = "",
		["versions"] = 1,
		["whispers"] = 0,
		["mostConvos"] = 0,
	},
	["pop_rules"] = {
		["whisper"] = {
			["other"] = {
				["keepfocus"] = false,
				["supress"] = true,
				["onSend"] = true,
				["autofocus"] = false,
				["onReceive"] = true,
			},
			["combat"] = {
				["keepfocus"] = false,
				["supress"] = false,
				["onSend"] = false,
				["autofocus"] = false,
				["onReceive"] = false,
			},
			["intercept"] = true,
			["party"] = {
				["keepfocus"] = false,
				["supress"] = true,
				["onSend"] = true,
				["autofocus"] = false,
				["onReceive"] = true,
			},
			["pvp"] = {
				["keepfocus"] = false,
				["supress"] = true,
				["onSend"] = true,
				["autofocus"] = false,
				["onReceive"] = true,
			},
			["resting"] = {
				["keepfocus"] = true,
				["supress"] = true,
				["onSend"] = true,
				["autofocus"] = true,
				["onReceive"] = true,
			},
			["raid"] = {
				["keepfocus"] = false,
				["supress"] = true,
				["onSend"] = true,
				["autofocus"] = false,
				["onReceive"] = true,
			},
			["arena"] = {
				["keepfocus"] = false,
				["supress"] = false,
				["onSend"] = false,
				["autofocus"] = false,
				["onReceive"] = false,
			},
			["alwaysOther"] = false,
		},
		["chat"] = {
			["other"] = {
				["keepfocus"] = false,
				["supress"] = false,
				["onSend"] = false,
				["autofocus"] = false,
				["onReceive"] = false,
			},
			["bn"] = {
				["keepfocus"] = false,
				["supress"] = false,
				["onSend"] = false,
				["autofocus"] = false,
				["onReceive"] = false,
			},
			["combat"] = {
				["keepfocus"] = false,
				["supress"] = false,
				["onSend"] = false,
				["autofocus"] = false,
				["onReceive"] = false,
			},
			["intercept"] = false,
			["party"] = {
				["keepfocus"] = false,
				["supress"] = false,
				["onSend"] = false,
				["autofocus"] = false,
				["onReceive"] = false,
			},
			["pvp"] = {
				["keepfocus"] = false,
				["supress"] = false,
				["onSend"] = false,
				["autofocus"] = false,
				["onReceive"] = false,
			},
			["resting"] = {
				["keepfocus"] = false,
				["supress"] = false,
				["onSend"] = false,
				["autofocus"] = false,
				["onReceive"] = false,
			},
			["raid"] = {
				["keepfocus"] = false,
				["supress"] = false,
				["onSend"] = false,
				["autofocus"] = false,
				["onReceive"] = false,
			},
			["arena"] = {
				["keepfocus"] = false,
				["supress"] = false,
				["onSend"] = false,
				["autofocus"] = false,
				["onReceive"] = false,
			},
			["alwaysOther"] = true,
		},
	},
	["timeStampFormat"] = "%H:%M",
	["windowAlpha"] = 80,
	["sounds"] = {
		["force_game_sound"] = false,
		["whispers"] = {
			["msgout_sml"] = "IM",
			["msgout"] = false,
			["guild"] = false,
			["bnet_sml"] = "IM",
			["msgin_sml"] = "IM",
			["msgin"] = true,
			["friend_sml"] = "IM",
			["guild_sml"] = "IM",
			["bnet"] = false,
			["friend"] = false,
		},
		["chat"] = {
			["msgout_sml"] = "Chat Blip",
			["msgout"] = false,
			["world_sml"] = "Chat Blip",
			["msgin_sml"] = "Chat Blip",
			["msgin"] = true,
			["party_sml"] = "Chat Blip",
			["custom_sml"] = "Chat Blip",
			["say_sml"] = "Chat Blip",
			["raid_sml"] = "Chat Blip",
			["officer_sml"] = "Chat Blip",
			["guild_sml"] = "Chat Blip",
			["raidleader_sml"] = "Chat Blip",
			["battlegroundleader_sml"] = "Chat Blip",
			["battleground_sml"] = "Chat Blip",
		},
	},
	["formatting"] = {
		["bracketing"] = {
			["enabled"] = true,
			["type"] = 1,
		},
	},
	["whoLookups"] = true,
	["ignoreArrowKeys"] = true,
	["w2w"] = {
		["shareTyping"] = true,
		["shareTalentSpec"] = true,
		["shareCoordinates"] = true,
	},
	["keepFocus"] = true,
	["alertedPrivateServer"] = false,
	["winSize"] = {
		["height"] = 220,
		["strata"] = "DIALOG",
		["scale"] = 100,
		["width"] = 333,
	},
	["winCascade"] = {
		["enabled"] = true,
		["direction"] = 8,
	},
	["lastState"] = "other",
	["messageFormat"] = "Default",
	["displayColors"] = {
		["wispOut"] = {
			["r"] = 1,
			["g"] = 0.07843137254901961,
			["b"] = 0.9882352941176471,
		},
		["wispIn"] = {
			["r"] = 0.5607843137254902,
			["g"] = 0.03137254901960784,
			["b"] = 0.7607843137254902,
		},
		["sysMsg"] = {
			["r"] = 1,
			["g"] = 0.6627450980392157,
			["b"] = 0,
		},
		["BNwispOut"] = {
			["r"] = 0.1725490196078431,
			["g"] = 0.6352941176470588,
			["b"] = 1,
		},
		["historyIn"] = {
			["r"] = 0.4705882352941176,
			["g"] = 0.4705882352941176,
			["b"] = 0.4705882352941176,
		},
		["errorMsg"] = {
			["r"] = 1,
			["g"] = 0,
			["b"] = 0,
		},
		["useSkin"] = true,
		["BNwispIn"] = {
			["r"] = 0,
			["g"] = 0.4862745098039216,
			["b"] = 0.6549019607843137,
		},
		["historyOut"] = {
			["r"] = 0.7058823529411764,
			["g"] = 0.7058823529411764,
			["b"] = 0.7058823529411764,
		},
		["webAddress"] = {
			["r"] = 1,
			["g"] = 1,
			["b"] = 1,
		},
	},
	["fontSize"] = 12,
	["showToolTips"] = true,
	["minimap"] = {
		["free_position"] = {
			["y"] = -84.74680065716132,
			["x"] = -115.1444884354835,
			["point"] = "TOPRIGHT",
		},
		["position"] = 200,
		["rightClickNew"] = false,
		["free"] = false,
	},
	["windowOnTop"] = true,
	["wordwrap_indent"] = true,
	["enabled"] = true,
	["winAnimation"] = true,
	["autoFocus"] = false,
	["expose"] = {
		["protect"] = 1,
		["borderSize"] = 20,
		["combat"] = true,
		["direction"] = 1,
		["border"] = false,
		["groupOnly"] = false,
	},
	["alias"] = {
		["title_string"] = "{n} - {a}",
	},
	["modules"] = {
		["ChatSounds"] = {
			["enabled"] = true,
		},
		["ShortcutBar"] = {
			["enabled"] = 1,
		},
		["Emoticons"] = {
			["enabled"] = true,
		},
		["ChatAlerts"] = {
			["enabled"] = true,
		},
		["Sounds"] = {
			["enabled"] = true,
		},
		["Expose"] = {
			["enabled"] = true,
		},
		["WhisperEngine"] = {
			["enabled"] = true,
		},
		["MinimapIcon"] = {
			["enabled"] = false,
		},
		["TimeStamps"] = {
			["enabled"] = true,
		},
		["OffScreenTracker"] = {
			["enabled"] = true,
		},
		["History"] = {
			["enabled"] = true,
		},
		["LDB"] = {
			["enabled"] = true,
		},
		["Negotiate"] = {
			["enabled"] = true,
		},
		["ClickControl"] = {
			["enabled"] = true,
		},
		["W2W"] = {
			["enabled"] = true,
		},
		["URLHandler"] = {
			["enabled"] = true,
		},
		["Filters"] = {
			["enabled"] = true,
		},
		["Tabs"] = {
			["enabled"] = true,
		},
		["Menu"] = {
			["enabled"] = true,
		},
		["Tutorials"] = {
			["enabled"] = false,
		},
	},
	["winLoc"] = {
		["left"] = 217,
		["top"] = 664,
	},
	["clampToScreen"] = true,
	["coloredNames"] = true,
	["ClickControl"] = {
		["clickSensitivity"] = 0.2,
	},
	["skin"] = {
		["font_outline"] = "",
		["selected"] = "WIM Classic",
		["font"] = "ChatFontNormal",
		["suggest"] = true,
	},
	["disableAddonMessages"] = false,
	["hoverLinks"] = false,
	["winFade"] = true,
	["chat"] = {
		["bn"] = {
			["showAlerts"] = true,
		},
		["guild"] = {
			["showAlerts"] = true,
		},
		["party"] = {
			["showAlerts"] = true,
		},
		["custom"] = {
			["enabled"] = false,
			["channelSettings"] = {
			},
		},
		["say"] = {
		},
		["world"] = {
			["enabled"] = false,
			["channelSettings"] = {
				["LocalDefense"] = {
				},
				["GuildRecruitment"] = {
				},
				["General"] = {
				},
				["Trade"] = {
				},
			},
		},
		["raid"] = {
			["showAlerts"] = true,
		},
		["officer"] = {
			["showAlerts"] = true,
		},
		["battleground"] = {
		},
	},
	["history"] = {
		["ageLimit"] = true,
		["maxPer"] = true,
		["previewCount"] = 25,
		["whispers"] = {
			["friends"] = true,
			["all"] = false,
			["guild"] = true,
		},
		["maxAge"] = 1209600,
		["preview"] = true,
		["maxCount"] = 500,
		["chat"] = {
			["ageLimit"] = true,
			["maxAge"] = 1209600,
			["maxPer"] = true,
			["preview"] = true,
			["maxCount"] = 500,
			["previewCount"] = 25,
		},
	},
	["tabs"] = {
		["sortBy"] = 2,
		["whispers"] = {
			["enabled"] = false,
			["guild"] = false,
			["friends"] = false,
		},
		["chat"] = {
			["enabled"] = false,
			["aswhisper"] = false,
		},
	},
	["shownTutorials"] = {
		["Expose__"] = true,
		["Right_Mouse_Click_"] = true,
		["Resizing_Windows"] = true,
		["WIM_Slash_Commands"] = true,
	},
	["keepFocusRested"] = true,
	["tabAdvance"] = false,
	["menuSortActivity"] = true,
	["rememberWho"] = false,
}
WIM3_Filters = {
	{
		["enabled"] = true,
		["type"] = 1,
		["pattern"] = "^<T>PartyQuests[^A-Z]+\n^<M_N>\n^ItemDB-Request:\n^LVBM\n^YOU ARE BEING WATCHED!\n^YOU ARE MARKED!\n^YOU ARE CURSED!\n^YOU HAVE THE PLAGUE!\n^YOU ARE BURNING!\n^YOU ARE THE BOMB!\nVOLATILE INFECTION\n^/^GA[^A-Z]+\n^<METAMAP\n^<CT",
		["sent"] = true,
		["name"] = "Whispers Sent by Addons",
		["received"] = true,
		["protected"] = true,
		["stats"] = 0,
		["action"] = 2,
		["tag"] = "addons",
	}, -- [1]
	{
		["enabled"] = false,
		["type"] = 2,
		["action"] = 1,
		["friend"] = true,
		["party"] = true,
		["name"] = "WhisperSelect Part 1",
		["stats"] = 0,
		["raid"] = true,
		["received"] = true,
		["guild"] = true,
	}, -- [2]
	{
		["enabled"] = false,
		["type"] = 3,
		["name"] = "Example Spam Blocker",
		["notify"] = true,
		["stats"] = 0,
		["level"] = 2,
		["received"] = true,
		["action"] = 3,
	}, -- [3]
	{
		["enabled"] = false,
		["type"] = 2,
		["name"] = "WhisperSelect Part 2",
		["stats"] = 0,
		["all"] = true,
		["received"] = true,
		["action"] = 2,
	}, -- [4]
}
WIM3_ChatFilters = {
}
WIM3_Alias = nil
end

local SetrBBSPSV = function()
if(rBottomBarStyler) then table.wipe(rBottomBarStyler) end

rBottomBarStyler = {
	["movable"] = 1,
	["scalevalue"] = 1.01,
	["artvalue"] = "aion",
	["manaorb"] = 3,
	["locked"] = 1,
	["healthorb"] = 0,
	["barvalue"] = "bar2",
	["automana"] = 1,
}
end

local SetTidyPlatesPSV = function()
if(TidyPlatesOptions) then table.wipe(TidyPlatesOptions) end

TidyPlatesOptions = {
	["EnableCastWatcher"] = 1,
	["primary"] = "None",
	["autohide"] = 1,
	["secondary"] = "Neon/DPS",
}
end

local SetTPNeonDPSPSV = function()
if(TidyPlatesNeonDPSSavedVariables) then table.wipe(TidyPlatesNeonDPSSavedVariables) end

TidyPlatesNeonDPSSavedVariables = {
	["WidgetTug"] = true,
	["RangeMode"] = 1,
	["WidgetClassIcon"] = false,
	["HealthText"] = 2,
	["AggroSafeColor"] = {
		["a"] = 0.9999978030100465,
		["r"] = 0.05882340017706156,
		["g"] = 0.5215674815699458,
		["b"] = 0.9999978030100465,
	},
	["TugWidgetLooseColor"] = {
		["a"] = 0.9999978030100465,
		["r"] = 0.1411761604249477,
		["g"] = 0.7490179622545838,
		["b"] = 0.9999978030100465,
	},
	["WidgetRange"] = false,
	["WidgetDebuffList"] = {
		["Rake"] = true,
		["Rip"] = true,
	},
	["OpacityHideNonElites"] = false,
	["ScaleDanger"] = 1.200000047683716,
	["AggroDangerColor"] = {
		["a"] = 0.9999978030100465,
		["r"] = 0.9999978030100465,
		["g"] = 0.5019596815109253,
		["b"] = 0,
	},
	["AggroHealth"] = true,
	["WidgetSelect"] = true,
	["WidgetWheel"] = true,
	["TugWidgetAggroColor"] = {
		["a"] = 0.9999978030100465,
		["r"] = 0.9999978030100465,
		["g"] = 0.6705867620185018,
		["b"] = 0.1411761604249477,
	},
	["LevelText"] = false,
	["WidgetDebuff"] = true,
	["ScaleGeneral"] = 1,
	["ScaleIgnoreNonElite"] = false,
	["OpacityHideNeutral"] = false,
	["AggroBorder"] = true,
	["WidgetCombo"] = true,
	["WidgetDebuffMode"] = 1,
	["OpacityNonTarget"] = 0.5,
}
end

local SetVuhDOPSV = function()
if(VUHDO_CONFIG) then table.wipe(VUHDO_CONFIG) end

VUHDO_CONFIG = {
	["SMARTCAST_CLEANSE"] = false,
	["RANGE_SPELL"] = "Flash of Light",
	["OMIT_MAIN_TANKS"] = false,
	["OMIT_DFT_MTS"] = true,
	["BLIZZ_UI_HIDE_PLAYER"] = true,
	["DIRECTION"] = {
		["isDistanceText"] = false,
		["scale"] = 76,
		["isDeadOnly"] = true,
		["enable"] = true,
	},
	["STANDARD_TOOLTIP"] = true,
	["LOCK_PANELS"] = true,
	["RANGE_PESSIMISTIC"] = false,
	["SMARTCAST_RESURRECT"] = true,
	["BLIZZ_UI_HIDE_PET"] = true,
	["INC_HOTS_SECS"] = 3,
	["SMARTCAST_BUFF"] = false,
	["HIDE_PANELS_PARTY"] = false,
	["SHOW_PANELS"] = true,
	["HIDE_EMPTY_PANELS"] = true,
	["RANGE_CHECK_DELAY"] = 260,
	["SHOW_MINIMAP"] = false,
	["INC_CHANNELLED_SECS"] = 3,
	["IS_SCAN_TALENTS"] = true,
	["OMIT_OWN_GROUP"] = false,
	["MODE"] = 1,
	["INC_CASTED_SECS"] = 3,
	["DETECT_DEBUFFS_REMOVABLE_ONLY"] = true,
	["CLUSTER"] = {
		["REFRESH"] = 180,
		["CHAIN_MAX_JUMP"] = 5,
		["DISPLAY_DESTINATION"] = 2,
		["IS_NUMBER"] = false,
		["MODE"] = 1,
		["DISPLAY_SOURCE"] = 2,
		["RANGE"] = 8,
		["THRESH_GOOD"] = 5,
		["COOLDOWN_SPELL"] = "",
		["BELOW_HEALTH_PERC"] = 90,
		["THRESH_FAIR"] = 3,
	},
	["OMIT_MAIN_ASSIST"] = false,
	["INC_BOMBED_SECS"] = 3,
	["SHOW_INC_BOMBED"] = true,
	["IS_CLIQUE_COMPAT_MODE"] = false,
	["SHOW_INC_HOTS"] = true,
	["SHOW_INC_CHANNELLED"] = true,
	["DETECT_DEBUFFS_IGNORE_DURATION"] = true,
	["CUSTOM_DEBUFF"] = {
		["animate"] = true,
		["max_num"] = 5,
		["point"] = "TOPRIGHT",
		["selected"] = "",
		["scale"] = 0.800000011920929,
		["isIcon"] = true,
		["isColor"] = false,
		["STORED"] = {
			"Acid-Drenched Mandibles", -- [1]
			"Boiling Blood", -- [2]
			"Burning Bile", -- [3]
			"Chilled to the Bone", -- [4]
			"Corrosion", -- [5]
			"Defile", -- [6]
			"Delirious Slash", -- [7]
			"Essence of the Blood Queen", -- [8]
			"Expose Weakness", -- [9]
			"Feral Pounce", -- [10]
			"Fire Bomb", -- [11]
			"Frost Beacon", -- [12]
			"Frost Blast", -- [13]
			"Frost Breath", -- [14]
			"Gas Spore", -- [15]
			"Gaseous Bloat", -- [16]
			"Gastric Bloat", -- [17]
			"Glittering Sparks", -- [18]
			"Gravity Bomb", -- [19]
			"Grievous Bite", -- [20]
			"Gut Spray", -- [21]
			"Harvest Soul", -- [22]
			"Ice Tomb", -- [23]
			"Impale", -- [24]
			"Impaled", -- [25]
			"Incinerate Flesh", -- [26]
			"Infest", -- [27]
			"Instability", -- [28]
			"Instant Heal", -- [29]
			"Iron Roots", -- [30]
			"Jagged Knife", -- [31]
			"Legion Flame", -- [32]
			"Mark of the Fallen Champion", -- [33]
			"Mistress' Kiss", -- [34]
			"Mutated Infection", -- [35]
			"Mutated Plague", -- [36]
			"Napalm Shell", -- [37]
			"Necrotic Plague", -- [38]
			"Necrotic Strike", -- [39]
			"Pact of the Darkfallen", -- [40]
			"Paralytic Toxin", -- [41]
			"Penetrating Cold", -- [42]
			"Rune of Blood", -- [43]
			"Sara's Blessing", -- [44]
			"Searing Light", -- [45]
			"Shadow Prison", -- [46]
			"Shroud of Sorrow", -- [47]
			"Slag Pot", -- [48]
			"Snobolled!", -- [49]
			"Spinning Pain Spike", -- [50]
			"Stone Grip", -- [51]
			"Swarming Shadows", -- [52]
			"Touch of Darkness", -- [53]
			"Touch of Light", -- [54]
			"Vile Gas", -- [55]
			"Volatile Ooze Adhesive", -- [56]
			"Web Wrap", -- [57]
		},
		["isStacks"] = true,
		["yAdjust"] = -34,
		["version"] = 13,
		["STORED_SETTINGS"] = {
			["Gastric Bloat"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Snobolled!"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Frost Beacon"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Mutated Plague"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Feral Pounce"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Slag Pot"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Impaled"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Searing Light"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Shroud of Sorrow"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Paralytic Toxin"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Grievous Bite"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Iron Roots"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Incinerate Flesh"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Mistress' Kiss"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Acid-Drenched Mandibles"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Mark of the Fallen Champion"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Shadow Prison"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Gut Spray"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Necrotic Plague"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Ice Tomb"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Spinning Pain Spike"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Corrosion"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Swarming Shadows"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Touch of Darkness"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Instant Heal"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Fire Bomb"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Instability"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Penetrating Cold"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Burning Bile"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Harvest Soul"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Essence of the Blood Queen"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Web Wrap"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Defile"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Vile Gas"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Gravity Bomb"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Legion Flame"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Sara's Blessing"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Impale"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Infest"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Mutated Infection"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Jagged Knife"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Boiling Blood"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Necrotic Strike"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Gaseous Bloat"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Rune of Blood"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Chilled to the Bone"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Napalm Shell"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Glittering Sparks"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Pact of the Darkfallen"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Volatile Ooze Adhesive"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Stone Grip"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Touch of Light"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Frost Blast"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Expose Weakness"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Gas Spore"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Delirious Slash"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
			["Frost Breath"] = {
				["isStacks"] = false,
				["animate"] = true,
				["timer"] = true,
				["isColor"] = false,
				["isIcon"] = true,
			},
		},
		["timer"] = true,
		["isName"] = false,
		["xAdjust"] = -2,
		["BUTTON_FACADE"] = "Blizzard",
	},
	["ON_MOUSE_UP"] = false,
	["OMIT_TARGET"] = false,
	["IS_SHOW_GCD"] = false,
	["BLIZZ_UI_HIDE_FOCUS"] = true,
	["DETECT_DEBUFFS_IGNORE_NO_HARM"] = true,
	["DETECT_DEBUFFS_IGNORE_BY_CLASS"] = true,
	["BLIZZ_UI_HIDE_PARTY"] = true,
	["RES_IS_SHOW_TEXT"] = true,
	["BLIZZ_UI_HIDE_RAID"] = true,
	["SHOW_OVERHEAL"] = true,
	["SHOW_PLAYER_TAGS"] = true,
	["SCAN_RANGE"] = "2",
	["UPDATE_HOTS_MS"] = 50,
	["SHOW_INC_CASTED"] = true,
	["BLIZZ_UI_HIDE_TARGET"] = true,
	["HIDE_PANELS_SOLO"] = false,
	["CURRENT_PROFILE"] = "Heals-Solo",
	["EMERGENCY_TRIGGER"] = 100,
	["SHOW_INCOMING"] = true,
	["RES_ANNOUNCE_TEXT"] = "Come to life, vuhdo!",
	["OMIT_FOCUS"] = false,
	["AUTO_PROFILES"] = {
		["5"] = "Heals-10",
		["1"] = "Heals-Solo",
		["25"] = "Heals-25",
		["10"] = "Heals-10",
	},
	["OMIT_SELF"] = false,
	["SOUND_DEBUFF"] = "Interface\\AddOns\\Ferous Media\\Sounds\\Coin_Dead.wav",
	["IS_PALLY_POWER_COMMS"] = true,
	["DETECT_DEBUFFS_IGNORE_MOVEMENT"] = true,
	["IS_ALWAYS_OVERWRITE_PROFILE"] = true,
	["MAX_EMERGENCIES"] = 5,
	["THREAT"] = {
		["AGGRO_USE_TEXT"] = true,
		["AGGRO_TEXT_LEFT"] = ">>",
		["IS_TANK_MODE"] = true,
		["AGGRO_TEXT_RIGHT"] = "<<",
		["AGGRO_REFRESH_MS"] = 100,
	},
	["SHOW_TEXT_OVERHEAL"] = true,
	["SHOW_OWN_INCOMING"] = true,
	["LOCK_CLICKS_THROUGH"] = false,
	["OMIT_PLAYER_TARGETS"] = false,
}
VUHDO_PANEL_SETUP = {
	{
		["OVERHEAL_TEXT"] = {
			["show"] = true,
			["yAdjust"] = 0,
			["point"] = "LEFT",
			["scale"] = 2,
			["xAdjust"] = 4,
		},
		["POSITION"] = {
			["y"] = 234.527422443344,
			["x"] = 841.3152977380906,
			["scale"] = 1,
			["relativePoint"] = "BOTTOMLEFT",
			["orientation"] = "TOPLEFT",
			["height"] = 34.00000070288635,
			["growth"] = "TOPLEFT",
			["width"] = 99.99999465806371,
		},
		["RAID_ICON"] = {
			["show"] = true,
			["yAdjust"] = -20,
			["point"] = "TOP",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["frameStrata"] = "MEDIUM",
		["MODEL"] = {
			["ordering"] = 0,
			["groups"] = {
				1, -- [1]
				2, -- [2]
				3, -- [3]
				4, -- [4]
				5, -- [5]
				6, -- [6]
				7, -- [7]
				8, -- [8]
			},
			["sort"] = 0,
			["isReverse"] = false,
		},
		["TOOLTIP"] = {
			["BACKGROUND"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["inFight"] = false,
			["BORDER"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["showBuffs"] = false,
			["show"] = true,
			["x"] = 100,
			["position"] = 2,
			["SCALE"] = 1,
			["relativePoint"] = "TOPLEFT",
			["point"] = "TOPLEFT",
			["y"] = -100,
		},
		["PANEL_COLOR"] = {
			["classColorsHeader"] = false,
			["classColorsBackHeader"] = false,
			["TARGET"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BORDER"] = {
				["edgeSize"] = 1,
				["B"] = 0,
				["G"] = 0,
				["useOpacity"] = true,
				["R"] = 0,
				["useBackground"] = true,
				["file"] = "Interface\\None",
				["O"] = 0,
				["insets"] = 0,
			},
			["barTexture"] = "TukTex",
			["HEADER"] = {
				["TG"] = 0.859,
				["R"] = 0.6,
				["TB"] = 0.38,
				["barTexture"] = "fer18",
				["G"] = 0.6,
				["TR"] = 1,
				["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
				["TO"] = 1,
				["useBackground"] = true,
				["textSize"] = 13,
				["useText"] = true,
				["O"] = 0.6,
				["B"] = 0.6,
			},
			["TEXT"] = {
				["maxChars"] = 7,
				["font"] = "Interface\\Addons\\Ferous Media\\Fonts\\neuropol.ttf",
				["useOpacity"] = true,
				["textSizeLife"] = 11,
				["outline"] = false,
				["textSize"] = 10,
				["useText"] = true,
			},
			["TOT"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BACK"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 0,
				["G"] = 0,
				["B"] = 0,
			},
		},
		["HOTS"] = {
			["textSize"] = 100,
			["size"] = 76,
		},
		["SCALING"] = {
			["headerHeight"] = 20,
			["targetWidth"] = 30,
			["scale"] = 1,
			["maxColumnsWhenStructured"] = 5,
			["alignBottom"] = false,
			["arrangeHorizontal"] = true,
			["targetSpacing"] = 3,
			["targetOrientation"] = 1,
			["ommitEmptyWhenStructured"] = true,
			["showTarget"] = false,
			["damFlashFactor"] = 0.75,
			["sideLeftWidth"] = 6,
			["sideRightWidth"] = 6,
			["headerSpacing"] = 5,
			["borderGapX"] = 0,
			["manaBarHeight"] = 5,
			["headerWidth"] = 33,
			["isDamFlash"] = true,
			["showHeaders"] = false,
			["totWidth"] = 30,
			["totSpacing"] = 3,
			["showTot"] = false,
			["isPlayerOnTop"] = true,
			["maxRowsWhenLoose"] = 6,
			["barHeight"] = 30,
			["columnSpacing"] = 2,
			["borderGapY"] = 0,
			["barWidth"] = 100,
			["rowSpacing"] = 2,
		},
		["ID_TEXT"] = {
			["showClass"] = false,
			["showName"] = true,
			["version"] = 2,
			["position"] = "CENTER+CENTER",
			["showTags"] = true,
			["_spacing"] = 10.00000014057727,
			["showPetOwners"] = true,
		},
		["LIFE_TEXT"] = {
			["show"] = true,
			["hideIrrelevant"] = false,
			["position"] = 1,
			["mode"] = 3,
			["verbose"] = false,
		},
	}, -- [1]
	{
		["OVERHEAL_TEXT"] = {
			["show"] = true,
			["yAdjust"] = 0,
			["point"] = "LEFT",
			["scale"] = 1.5,
			["xAdjust"] = 0,
		},
		["POSITION"] = {
			["y"] = 987.6000146481516,
			["x"] = 10.89999944471978,
			["scale"] = 1,
			["relativePoint"] = "BOTTOMLEFT",
			["orientation"] = "TOPLEFT",
			["height"] = 24.99999866451593,
			["growth"] = "TOPLEFT",
			["width"] = 234.0000035144318,
		},
		["RAID_ICON"] = {
			["show"] = true,
			["yAdjust"] = -20,
			["point"] = "TOP",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["frameStrata"] = "MEDIUM",
		["MODEL"] = {
			["ordering"] = 0,
			["groups"] = {
				41, -- [1]
			},
			["sort"] = 0,
			["isReverse"] = false,
		},
		["TOOLTIP"] = {
			["BACKGROUND"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["inFight"] = false,
			["BORDER"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["showBuffs"] = false,
			["show"] = true,
			["x"] = 100,
			["position"] = 2,
			["SCALE"] = 1,
			["relativePoint"] = "TOPLEFT",
			["point"] = "TOPLEFT",
			["y"] = -100,
		},
		["PANEL_COLOR"] = {
			["classColorsHeader"] = false,
			["classColorsBackHeader"] = false,
			["TARGET"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BORDER"] = {
				["edgeSize"] = 1,
				["B"] = 0,
				["G"] = 0,
				["useOpacity"] = true,
				["R"] = 0,
				["useBackground"] = true,
				["file"] = "Interface\\None",
				["O"] = 0,
				["insets"] = 0,
			},
			["barTexture"] = "fer14",
			["HEADER"] = {
				["TG"] = 0.859,
				["R"] = 0.6,
				["TB"] = 0.38,
				["barTexture"] = "fer18",
				["G"] = 0.6,
				["TR"] = 1,
				["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
				["TO"] = 1,
				["useBackground"] = true,
				["textSize"] = 13,
				["useText"] = true,
				["O"] = 0.6,
				["B"] = 0.6,
			},
			["TEXT"] = {
				["maxChars"] = 8,
				["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
				["useOpacity"] = true,
				["textSizeLife"] = 8,
				["outline"] = false,
				["textSize"] = 10,
				["useText"] = true,
			},
			["TOT"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BACK"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 0,
				["G"] = 0,
				["B"] = 0,
			},
		},
		["HOTS"] = {
			["textSize"] = 100,
			["size"] = 76,
		},
		["SCALING"] = {
			["headerHeight"] = 20,
			["targetWidth"] = 105,
			["scale"] = 1,
			["maxColumnsWhenStructured"] = 2,
			["alignBottom"] = false,
			["arrangeHorizontal"] = false,
			["targetSpacing"] = 0,
			["targetOrientation"] = 1,
			["ommitEmptyWhenStructured"] = true,
			["showTarget"] = true,
			["damFlashFactor"] = 0.75,
			["sideLeftWidth"] = 6,
			["sideRightWidth"] = 6,
			["headerSpacing"] = 5,
			["borderGapX"] = 0,
			["manaBarHeight"] = 5,
			["headerWidth"] = 100,
			["isDamFlash"] = true,
			["showHeaders"] = true,
			["totWidth"] = 30,
			["totSpacing"] = 3,
			["showTot"] = false,
			["isPlayerOnTop"] = true,
			["maxRowsWhenLoose"] = 4,
			["barHeight"] = 30,
			["columnSpacing"] = 0,
			["borderGapY"] = 0,
			["barWidth"] = 129,
			["rowSpacing"] = 1,
		},
		["ID_TEXT"] = {
			["showClass"] = false,
			["showName"] = true,
			["version"] = 2,
			["position"] = "CENTER+CENTER",
			["showTags"] = true,
			["_spacing"] = 10.00000014057727,
			["showPetOwners"] = true,
		},
		["LIFE_TEXT"] = {
			["show"] = true,
			["hideIrrelevant"] = false,
			["position"] = 1,
			["mode"] = 1,
			["verbose"] = false,
		},
	}, -- [2]
	{
		["OVERHEAL_TEXT"] = {
			["show"] = true,
			["yAdjust"] = 0,
			["point"] = "LEFT",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["POSITION"] = {
			["y"] = 652,
			["x"] = 328.5,
			["scale"] = 1,
			["relativePoint"] = "BOTTOMLEFT",
			["orientation"] = "TOPLEFT",
			["height"] = 128.8,
			["growth"] = "TOPLEFT",
			["width"] = 85,
		},
		["RAID_ICON"] = {
			["show"] = true,
			["yAdjust"] = -20,
			["point"] = "TOP",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["frameStrata"] = "MEDIUM",
		["MODEL"] = {
			["ordering"] = 0,
			["sort"] = 0,
			["isReverse"] = false,
		},
		["TOOLTIP"] = {
			["BACKGROUND"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["inFight"] = false,
			["BORDER"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["showBuffs"] = false,
			["show"] = true,
			["x"] = 100,
			["position"] = 2,
			["SCALE"] = 1,
			["relativePoint"] = "TOPLEFT",
			["point"] = "TOPLEFT",
			["y"] = -100,
		},
		["PANEL_COLOR"] = {
			["classColorsHeader"] = false,
			["classColorsBackHeader"] = false,
			["TARGET"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BORDER"] = {
				["edgeSize"] = 1,
				["B"] = 0,
				["G"] = 0,
				["useOpacity"] = true,
				["R"] = 0,
				["useBackground"] = true,
				["file"] = "Interface\\None",
				["O"] = 0,
				["insets"] = 0,
			},
			["barTexture"] = "fer14",
			["HEADER"] = {
				["TG"] = 0.859,
				["R"] = 0.6,
				["TB"] = 0.38,
				["barTexture"] = "fer18",
				["G"] = 0.6,
				["TR"] = 1,
				["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
				["TO"] = 1,
				["useBackground"] = true,
				["textSize"] = 13,
				["useText"] = true,
				["O"] = 0.6,
				["B"] = 0.6,
			},
			["TEXT"] = {
				["maxChars"] = 8,
				["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
				["useOpacity"] = true,
				["textSizeLife"] = 8,
				["outline"] = false,
				["textSize"] = 10,
				["useText"] = true,
			},
			["TOT"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BACK"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 0,
				["G"] = 0,
				["B"] = 0,
			},
		},
		["HOTS"] = {
			["textSize"] = 100,
			["size"] = 76,
		},
		["SCALING"] = {
			["headerHeight"] = 20,
			["targetWidth"] = 30,
			["scale"] = 1,
			["maxColumnsWhenStructured"] = 5,
			["alignBottom"] = false,
			["arrangeHorizontal"] = true,
			["targetSpacing"] = 3,
			["targetOrientation"] = 1,
			["ommitEmptyWhenStructured"] = true,
			["showTarget"] = false,
			["damFlashFactor"] = 0.75,
			["sideLeftWidth"] = 6,
			["sideRightWidth"] = 6,
			["headerSpacing"] = 5,
			["borderGapX"] = 0,
			["manaBarHeight"] = 5,
			["headerWidth"] = 33,
			["isDamFlash"] = true,
			["showHeaders"] = false,
			["totWidth"] = 30,
			["totSpacing"] = 3,
			["showTot"] = false,
			["isPlayerOnTop"] = false,
			["maxRowsWhenLoose"] = 6,
			["barHeight"] = 30,
			["columnSpacing"] = 2,
			["borderGapY"] = 0,
			["barWidth"] = 100,
			["rowSpacing"] = 2,
		},
		["ID_TEXT"] = {
			["showClass"] = false,
			["showName"] = true,
			["version"] = 2,
			["position"] = "CENTER+CENTER",
			["showTags"] = true,
			["_spacing"] = 10,
			["showPetOwners"] = true,
		},
		["LIFE_TEXT"] = {
			["show"] = true,
			["hideIrrelevant"] = false,
			["position"] = 1,
			["mode"] = 3,
			["verbose"] = false,
		},
	}, -- [3]
	{
		["OVERHEAL_TEXT"] = {
			["show"] = true,
			["yAdjust"] = 0,
			["point"] = "LEFT",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["POSITION"] = {
			["y"] = 708,
			["x"] = 347.3,
			["scale"] = 1,
			["relativePoint"] = "BOTTOMLEFT",
			["orientation"] = "TOPLEFT",
			["height"] = 128.8,
			["growth"] = "TOPLEFT",
			["width"] = 85,
		},
		["RAID_ICON"] = {
			["show"] = true,
			["yAdjust"] = -20,
			["point"] = "TOP",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["frameStrata"] = "MEDIUM",
		["MODEL"] = {
			["ordering"] = 0,
			["sort"] = 0,
			["isReverse"] = false,
		},
		["TOOLTIP"] = {
			["BACKGROUND"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["inFight"] = false,
			["BORDER"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["showBuffs"] = false,
			["show"] = true,
			["x"] = 100,
			["position"] = 2,
			["SCALE"] = 1,
			["relativePoint"] = "TOPLEFT",
			["point"] = "TOPLEFT",
			["y"] = -100,
		},
		["PANEL_COLOR"] = {
			["classColorsHeader"] = false,
			["classColorsBackHeader"] = false,
			["TARGET"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BORDER"] = {
				["edgeSize"] = 1,
				["B"] = 0,
				["G"] = 0,
				["useOpacity"] = true,
				["R"] = 0,
				["useBackground"] = true,
				["file"] = "Interface\\None",
				["O"] = 0,
				["insets"] = 0,
			},
			["barTexture"] = "fer14",
			["HEADER"] = {
				["TG"] = 0.859,
				["R"] = 0.6,
				["TB"] = 0.38,
				["barTexture"] = "fer18",
				["G"] = 0.6,
				["TR"] = 1,
				["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
				["TO"] = 1,
				["useBackground"] = true,
				["textSize"] = 13,
				["useText"] = true,
				["O"] = 0.6,
				["B"] = 0.6,
			},
			["TEXT"] = {
				["maxChars"] = 8,
				["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
				["useOpacity"] = true,
				["textSizeLife"] = 8,
				["outline"] = false,
				["textSize"] = 10,
				["useText"] = true,
			},
			["TOT"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BACK"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 0,
				["G"] = 0,
				["B"] = 0,
			},
		},
		["HOTS"] = {
			["textSize"] = 100,
			["size"] = 76,
		},
		["SCALING"] = {
			["headerHeight"] = 20,
			["targetWidth"] = 30,
			["scale"] = 1,
			["maxColumnsWhenStructured"] = 5,
			["alignBottom"] = false,
			["arrangeHorizontal"] = true,
			["targetSpacing"] = 3,
			["targetOrientation"] = 1,
			["ommitEmptyWhenStructured"] = true,
			["showTarget"] = false,
			["damFlashFactor"] = 0.75,
			["sideLeftWidth"] = 6,
			["sideRightWidth"] = 6,
			["headerSpacing"] = 5,
			["borderGapX"] = 0,
			["manaBarHeight"] = 5,
			["headerWidth"] = 33,
			["isDamFlash"] = true,
			["showHeaders"] = false,
			["totWidth"] = 30,
			["totSpacing"] = 3,
			["showTot"] = false,
			["isPlayerOnTop"] = false,
			["maxRowsWhenLoose"] = 6,
			["barHeight"] = 30,
			["columnSpacing"] = 2,
			["borderGapY"] = 0,
			["barWidth"] = 100,
			["rowSpacing"] = 2,
		},
		["ID_TEXT"] = {
			["showClass"] = false,
			["showName"] = true,
			["version"] = 2,
			["position"] = "CENTER+CENTER",
			["showTags"] = true,
			["_spacing"] = 17.99999985846689,
			["showPetOwners"] = true,
		},
		["LIFE_TEXT"] = {
			["show"] = true,
			["hideIrrelevant"] = false,
			["position"] = 1,
			["mode"] = 3,
			["verbose"] = false,
		},
	}, -- [4]
	{
		["OVERHEAL_TEXT"] = {
			["show"] = true,
			["yAdjust"] = 0,
			["point"] = "LEFT",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["POSITION"] = {
			["y"] = 668,
			["x"] = 100,
			["scale"] = 1,
			["relativePoint"] = "BOTTOMLEFT",
			["orientation"] = "TOPLEFT",
			["height"] = 200,
			["growth"] = "TOPLEFT",
			["width"] = 200,
		},
		["RAID_ICON"] = {
			["show"] = true,
			["yAdjust"] = -20,
			["point"] = "TOP",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["frameStrata"] = "MEDIUM",
		["MODEL"] = {
			["ordering"] = 0,
			["sort"] = 0,
			["isReverse"] = false,
		},
		["TOOLTIP"] = {
			["BACKGROUND"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["inFight"] = false,
			["BORDER"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["showBuffs"] = false,
			["show"] = true,
			["x"] = 100,
			["position"] = 2,
			["SCALE"] = 1,
			["relativePoint"] = "TOPLEFT",
			["point"] = "TOPLEFT",
			["y"] = -100,
		},
		["PANEL_COLOR"] = {
			["classColorsHeader"] = false,
			["classColorsBackHeader"] = false,
			["TARGET"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BORDER"] = {
				["edgeSize"] = 1,
				["B"] = 0,
				["G"] = 0,
				["useOpacity"] = true,
				["R"] = 0,
				["useBackground"] = true,
				["file"] = "Interface\\None",
				["O"] = 0,
				["insets"] = 0,
			},
			["barTexture"] = "fer14",
			["HEADER"] = {
				["TG"] = 0.859,
				["R"] = 0.6,
				["TB"] = 0.38,
				["barTexture"] = "fer18",
				["G"] = 0.6,
				["TR"] = 1,
				["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
				["TO"] = 1,
				["useBackground"] = true,
				["textSize"] = 13,
				["useText"] = true,
				["O"] = 0.6,
				["B"] = 0.6,
			},
			["TEXT"] = {
				["maxChars"] = 8,
				["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
				["useOpacity"] = true,
				["textSizeLife"] = 8,
				["outline"] = false,
				["textSize"] = 10,
				["useText"] = true,
			},
			["TOT"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BACK"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 0,
				["G"] = 0,
				["B"] = 0,
			},
		},
		["HOTS"] = {
			["textSize"] = 100,
			["size"] = 76,
		},
		["SCALING"] = {
			["headerHeight"] = 20,
			["targetWidth"] = 30,
			["scale"] = 1,
			["maxColumnsWhenStructured"] = 5,
			["alignBottom"] = false,
			["arrangeHorizontal"] = true,
			["targetSpacing"] = 3,
			["targetOrientation"] = 1,
			["ommitEmptyWhenStructured"] = true,
			["showTarget"] = false,
			["damFlashFactor"] = 0.75,
			["sideLeftWidth"] = 6,
			["sideRightWidth"] = 6,
			["headerSpacing"] = 5,
			["borderGapX"] = 0,
			["manaBarHeight"] = 5,
			["headerWidth"] = 33,
			["isDamFlash"] = true,
			["showHeaders"] = false,
			["totWidth"] = 30,
			["totSpacing"] = 3,
			["showTot"] = false,
			["isPlayerOnTop"] = false,
			["maxRowsWhenLoose"] = 6,
			["barHeight"] = 30,
			["columnSpacing"] = 2,
			["borderGapY"] = 0,
			["barWidth"] = 100,
			["rowSpacing"] = 2,
		},
		["ID_TEXT"] = {
			["showClass"] = false,
			["showName"] = true,
			["version"] = 2,
			["position"] = "CENTER+CENTER",
			["showTags"] = true,
			["showPetOwners"] = true,
		},
		["LIFE_TEXT"] = {
			["show"] = true,
			["hideIrrelevant"] = false,
			["position"] = 1,
			["mode"] = 3,
			["verbose"] = false,
		},
	}, -- [5]
	{
		["OVERHEAL_TEXT"] = {
			["show"] = true,
			["yAdjust"] = 0,
			["point"] = "LEFT",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["POSITION"] = {
			["y"] = 668,
			["x"] = 100,
			["scale"] = 1,
			["relativePoint"] = "BOTTOMLEFT",
			["orientation"] = "TOPLEFT",
			["height"] = 200,
			["growth"] = "TOPLEFT",
			["width"] = 200,
		},
		["RAID_ICON"] = {
			["show"] = true,
			["yAdjust"] = -20,
			["point"] = "TOP",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["frameStrata"] = "MEDIUM",
		["MODEL"] = {
			["ordering"] = 0,
			["sort"] = 0,
			["isReverse"] = false,
		},
		["TOOLTIP"] = {
			["BACKGROUND"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["inFight"] = false,
			["BORDER"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["showBuffs"] = false,
			["show"] = true,
			["x"] = 100,
			["position"] = 2,
			["SCALE"] = 1,
			["relativePoint"] = "TOPLEFT",
			["point"] = "TOPLEFT",
			["y"] = -100,
		},
		["PANEL_COLOR"] = {
			["classColorsHeader"] = false,
			["classColorsBackHeader"] = false,
			["TARGET"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BORDER"] = {
				["edgeSize"] = 1,
				["B"] = 0,
				["G"] = 0,
				["useOpacity"] = true,
				["R"] = 0,
				["useBackground"] = true,
				["file"] = "Interface\\None",
				["O"] = 0,
				["insets"] = 0,
			},
			["barTexture"] = "fer14",
			["HEADER"] = {
				["TG"] = 0.859,
				["R"] = 0.6,
				["TB"] = 0.38,
				["barTexture"] = "fer18",
				["G"] = 0.6,
				["TR"] = 1,
				["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
				["TO"] = 1,
				["useBackground"] = true,
				["textSize"] = 13,
				["useText"] = true,
				["O"] = 0.6,
				["B"] = 0.6,
			},
			["TEXT"] = {
				["maxChars"] = 8,
				["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
				["useOpacity"] = true,
				["textSizeLife"] = 8,
				["outline"] = false,
				["textSize"] = 10,
				["useText"] = true,
			},
			["TOT"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BACK"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 0,
				["G"] = 0,
				["B"] = 0,
			},
		},
		["HOTS"] = {
			["textSize"] = 100,
			["size"] = 76,
		},
		["SCALING"] = {
			["headerHeight"] = 20,
			["targetWidth"] = 30,
			["scale"] = 1,
			["maxColumnsWhenStructured"] = 5,
			["alignBottom"] = false,
			["arrangeHorizontal"] = true,
			["targetSpacing"] = 3,
			["targetOrientation"] = 1,
			["ommitEmptyWhenStructured"] = true,
			["showTarget"] = false,
			["damFlashFactor"] = 0.75,
			["sideLeftWidth"] = 6,
			["sideRightWidth"] = 6,
			["headerSpacing"] = 5,
			["borderGapX"] = 0,
			["manaBarHeight"] = 5,
			["headerWidth"] = 33,
			["isDamFlash"] = true,
			["showHeaders"] = false,
			["totWidth"] = 30,
			["totSpacing"] = 3,
			["showTot"] = false,
			["isPlayerOnTop"] = false,
			["maxRowsWhenLoose"] = 6,
			["barHeight"] = 30,
			["columnSpacing"] = 2,
			["borderGapY"] = 0,
			["barWidth"] = 100,
			["rowSpacing"] = 2,
		},
		["ID_TEXT"] = {
			["showClass"] = false,
			["showName"] = true,
			["version"] = 2,
			["position"] = "CENTER+CENTER",
			["showTags"] = true,
			["showPetOwners"] = true,
		},
		["LIFE_TEXT"] = {
			["show"] = true,
			["hideIrrelevant"] = false,
			["position"] = 1,
			["mode"] = 3,
			["verbose"] = false,
		},
	}, -- [6]
	{
		["OVERHEAL_TEXT"] = {
			["show"] = true,
			["yAdjust"] = 0,
			["point"] = "LEFT",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["POSITION"] = {
			["y"] = 668,
			["x"] = 100,
			["scale"] = 1,
			["relativePoint"] = "BOTTOMLEFT",
			["orientation"] = "TOPLEFT",
			["height"] = 200,
			["growth"] = "TOPLEFT",
			["width"] = 200,
		},
		["RAID_ICON"] = {
			["show"] = true,
			["yAdjust"] = -20,
			["point"] = "TOP",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["frameStrata"] = "MEDIUM",
		["MODEL"] = {
			["ordering"] = 0,
			["sort"] = 0,
			["isReverse"] = false,
		},
		["TOOLTIP"] = {
			["BACKGROUND"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["inFight"] = false,
			["BORDER"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["showBuffs"] = false,
			["show"] = true,
			["x"] = 100,
			["position"] = 2,
			["SCALE"] = 1,
			["relativePoint"] = "TOPLEFT",
			["point"] = "TOPLEFT",
			["y"] = -100,
		},
		["PANEL_COLOR"] = {
			["classColorsHeader"] = false,
			["classColorsBackHeader"] = false,
			["TARGET"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BORDER"] = {
				["edgeSize"] = 1,
				["B"] = 0,
				["G"] = 0,
				["useOpacity"] = true,
				["R"] = 0,
				["useBackground"] = true,
				["file"] = "Interface\\None",
				["O"] = 0,
				["insets"] = 0,
			},
			["barTexture"] = "fer14",
			["HEADER"] = {
				["TG"] = 0.859,
				["R"] = 0.6,
				["TB"] = 0.38,
				["barTexture"] = "fer18",
				["G"] = 0.6,
				["TR"] = 1,
				["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
				["TO"] = 1,
				["useBackground"] = true,
				["textSize"] = 13,
				["useText"] = true,
				["O"] = 0.6,
				["B"] = 0.6,
			},
			["TEXT"] = {
				["maxChars"] = 8,
				["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
				["useOpacity"] = true,
				["textSizeLife"] = 8,
				["outline"] = false,
				["textSize"] = 10,
				["useText"] = true,
			},
			["TOT"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BACK"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 0,
				["G"] = 0,
				["B"] = 0,
			},
		},
		["HOTS"] = {
			["textSize"] = 100,
			["size"] = 76,
		},
		["SCALING"] = {
			["headerHeight"] = 20,
			["targetWidth"] = 30,
			["scale"] = 1,
			["maxColumnsWhenStructured"] = 5,
			["alignBottom"] = false,
			["arrangeHorizontal"] = true,
			["targetSpacing"] = 3,
			["targetOrientation"] = 1,
			["ommitEmptyWhenStructured"] = true,
			["showTarget"] = false,
			["damFlashFactor"] = 0.75,
			["sideLeftWidth"] = 6,
			["sideRightWidth"] = 6,
			["headerSpacing"] = 5,
			["borderGapX"] = 0,
			["manaBarHeight"] = 5,
			["headerWidth"] = 33,
			["isDamFlash"] = true,
			["showHeaders"] = false,
			["totWidth"] = 30,
			["totSpacing"] = 3,
			["showTot"] = false,
			["isPlayerOnTop"] = false,
			["maxRowsWhenLoose"] = 6,
			["barHeight"] = 30,
			["columnSpacing"] = 2,
			["borderGapY"] = 0,
			["barWidth"] = 100,
			["rowSpacing"] = 2,
		},
		["ID_TEXT"] = {
			["showClass"] = false,
			["showName"] = true,
			["version"] = 2,
			["position"] = "CENTER+CENTER",
			["showTags"] = true,
			["showPetOwners"] = true,
		},
		["LIFE_TEXT"] = {
			["show"] = true,
			["hideIrrelevant"] = false,
			["position"] = 1,
			["mode"] = 3,
			["verbose"] = false,
		},
	}, -- [7]
	{
		["OVERHEAL_TEXT"] = {
			["show"] = true,
			["yAdjust"] = 0,
			["point"] = "LEFT",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["POSITION"] = {
			["y"] = 668,
			["x"] = 100,
			["scale"] = 1,
			["relativePoint"] = "BOTTOMLEFT",
			["orientation"] = "TOPLEFT",
			["height"] = 200,
			["growth"] = "TOPLEFT",
			["width"] = 200,
		},
		["RAID_ICON"] = {
			["show"] = true,
			["yAdjust"] = -20,
			["point"] = "TOP",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["frameStrata"] = "MEDIUM",
		["MODEL"] = {
			["ordering"] = 0,
			["sort"] = 0,
			["isReverse"] = false,
		},
		["TOOLTIP"] = {
			["BACKGROUND"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["inFight"] = false,
			["BORDER"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["showBuffs"] = false,
			["show"] = true,
			["x"] = 100,
			["position"] = 2,
			["SCALE"] = 1,
			["relativePoint"] = "TOPLEFT",
			["point"] = "TOPLEFT",
			["y"] = -100,
		},
		["PANEL_COLOR"] = {
			["classColorsHeader"] = false,
			["classColorsBackHeader"] = false,
			["TARGET"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BORDER"] = {
				["edgeSize"] = 1,
				["B"] = 0,
				["G"] = 0,
				["useOpacity"] = true,
				["R"] = 0,
				["useBackground"] = true,
				["file"] = "Interface\\None",
				["O"] = 0,
				["insets"] = 0,
			},
			["barTexture"] = "fer14",
			["HEADER"] = {
				["TG"] = 0.859,
				["R"] = 0.6,
				["TB"] = 0.38,
				["barTexture"] = "fer18",
				["G"] = 0.6,
				["TR"] = 1,
				["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
				["TO"] = 1,
				["useBackground"] = true,
				["textSize"] = 13,
				["useText"] = true,
				["O"] = 0.6,
				["B"] = 0.6,
			},
			["TEXT"] = {
				["maxChars"] = 8,
				["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
				["useOpacity"] = true,
				["textSizeLife"] = 8,
				["outline"] = false,
				["textSize"] = 10,
				["useText"] = true,
			},
			["TOT"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BACK"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 0,
				["G"] = 0,
				["B"] = 0,
			},
		},
		["HOTS"] = {
			["textSize"] = 100,
			["size"] = 76,
		},
		["SCALING"] = {
			["headerHeight"] = 20,
			["targetWidth"] = 30,
			["scale"] = 1,
			["maxColumnsWhenStructured"] = 5,
			["alignBottom"] = false,
			["arrangeHorizontal"] = true,
			["targetSpacing"] = 3,
			["targetOrientation"] = 1,
			["ommitEmptyWhenStructured"] = true,
			["showTarget"] = false,
			["damFlashFactor"] = 0.75,
			["sideLeftWidth"] = 6,
			["sideRightWidth"] = 6,
			["headerSpacing"] = 5,
			["borderGapX"] = 0,
			["manaBarHeight"] = 5,
			["headerWidth"] = 33,
			["isDamFlash"] = true,
			["showHeaders"] = false,
			["totWidth"] = 30,
			["totSpacing"] = 3,
			["showTot"] = false,
			["isPlayerOnTop"] = false,
			["maxRowsWhenLoose"] = 6,
			["barHeight"] = 30,
			["columnSpacing"] = 2,
			["borderGapY"] = 0,
			["barWidth"] = 100,
			["rowSpacing"] = 2,
		},
		["ID_TEXT"] = {
			["showClass"] = false,
			["showName"] = true,
			["version"] = 2,
			["position"] = "CENTER+CENTER",
			["showTags"] = true,
			["showPetOwners"] = true,
		},
		["LIFE_TEXT"] = {
			["show"] = true,
			["hideIrrelevant"] = false,
			["position"] = 1,
			["mode"] = 3,
			["verbose"] = false,
		},
	}, -- [8]
	{
		["OVERHEAL_TEXT"] = {
			["show"] = true,
			["yAdjust"] = 0,
			["point"] = "LEFT",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["POSITION"] = {
			["y"] = 668,
			["x"] = 100,
			["scale"] = 1,
			["relativePoint"] = "BOTTOMLEFT",
			["orientation"] = "TOPLEFT",
			["height"] = 200,
			["growth"] = "TOPLEFT",
			["width"] = 200,
		},
		["RAID_ICON"] = {
			["show"] = true,
			["yAdjust"] = -20,
			["point"] = "TOP",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["frameStrata"] = "MEDIUM",
		["MODEL"] = {
			["ordering"] = 0,
			["sort"] = 0,
			["isReverse"] = false,
		},
		["TOOLTIP"] = {
			["BACKGROUND"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["inFight"] = false,
			["BORDER"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["showBuffs"] = false,
			["show"] = true,
			["x"] = 100,
			["position"] = 2,
			["SCALE"] = 1,
			["relativePoint"] = "TOPLEFT",
			["point"] = "TOPLEFT",
			["y"] = -100,
		},
		["PANEL_COLOR"] = {
			["classColorsHeader"] = false,
			["classColorsBackHeader"] = false,
			["TARGET"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BORDER"] = {
				["edgeSize"] = 1,
				["B"] = 0,
				["G"] = 0,
				["useOpacity"] = true,
				["R"] = 0,
				["useBackground"] = true,
				["file"] = "Interface\\None",
				["O"] = 0,
				["insets"] = 0,
			},
			["barTexture"] = "fer14",
			["HEADER"] = {
				["TG"] = 0.859,
				["R"] = 0.6,
				["TB"] = 0.38,
				["barTexture"] = "fer18",
				["G"] = 0.6,
				["TR"] = 1,
				["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
				["TO"] = 1,
				["useBackground"] = true,
				["textSize"] = 13,
				["useText"] = true,
				["O"] = 0.6,
				["B"] = 0.6,
			},
			["TEXT"] = {
				["maxChars"] = 8,
				["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
				["useOpacity"] = true,
				["textSizeLife"] = 8,
				["outline"] = false,
				["textSize"] = 10,
				["useText"] = true,
			},
			["TOT"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BACK"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 0,
				["G"] = 0,
				["B"] = 0,
			},
		},
		["HOTS"] = {
			["textSize"] = 100,
			["size"] = 76,
		},
		["SCALING"] = {
			["headerHeight"] = 20,
			["targetWidth"] = 30,
			["scale"] = 1,
			["maxColumnsWhenStructured"] = 5,
			["alignBottom"] = false,
			["arrangeHorizontal"] = true,
			["targetSpacing"] = 3,
			["targetOrientation"] = 1,
			["ommitEmptyWhenStructured"] = true,
			["showTarget"] = false,
			["damFlashFactor"] = 0.75,
			["sideLeftWidth"] = 6,
			["sideRightWidth"] = 6,
			["headerSpacing"] = 5,
			["borderGapX"] = 0,
			["manaBarHeight"] = 5,
			["headerWidth"] = 33,
			["isDamFlash"] = true,
			["showHeaders"] = false,
			["totWidth"] = 30,
			["totSpacing"] = 3,
			["showTot"] = false,
			["isPlayerOnTop"] = false,
			["maxRowsWhenLoose"] = 6,
			["barHeight"] = 30,
			["columnSpacing"] = 2,
			["borderGapY"] = 0,
			["barWidth"] = 100,
			["rowSpacing"] = 2,
		},
		["ID_TEXT"] = {
			["showClass"] = false,
			["showName"] = true,
			["version"] = 2,
			["position"] = "CENTER+CENTER",
			["showTags"] = true,
			["showPetOwners"] = true,
		},
		["LIFE_TEXT"] = {
			["show"] = true,
			["hideIrrelevant"] = false,
			["position"] = 1,
			["mode"] = 3,
			["verbose"] = false,
		},
	}, -- [9]
	{
		["OVERHEAL_TEXT"] = {
			["show"] = true,
			["yAdjust"] = 0,
			["point"] = "LEFT",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["POSITION"] = {
			["y"] = 668,
			["x"] = 100,
			["scale"] = 1,
			["relativePoint"] = "BOTTOMLEFT",
			["orientation"] = "TOPLEFT",
			["height"] = 200,
			["growth"] = "TOPLEFT",
			["width"] = 200,
		},
		["RAID_ICON"] = {
			["show"] = true,
			["yAdjust"] = -20,
			["point"] = "TOP",
			["scale"] = 1,
			["xAdjust"] = 0,
		},
		["frameStrata"] = "MEDIUM",
		["MODEL"] = {
			["ordering"] = 0,
			["sort"] = 0,
			["isReverse"] = false,
		},
		["TOOLTIP"] = {
			["BACKGROUND"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["inFight"] = false,
			["BORDER"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["showBuffs"] = false,
			["show"] = true,
			["x"] = 100,
			["position"] = 2,
			["SCALE"] = 1,
			["relativePoint"] = "TOPLEFT",
			["point"] = "TOPLEFT",
			["y"] = -100,
		},
		["PANEL_COLOR"] = {
			["classColorsHeader"] = false,
			["classColorsBackHeader"] = false,
			["TARGET"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BORDER"] = {
				["edgeSize"] = 1,
				["B"] = 0,
				["G"] = 0,
				["useOpacity"] = true,
				["R"] = 0,
				["useBackground"] = true,
				["file"] = "Interface\\None",
				["O"] = 0,
				["insets"] = 0,
			},
			["barTexture"] = "fer14",
			["HEADER"] = {
				["TG"] = 0.859,
				["R"] = 0.6,
				["TB"] = 0.38,
				["barTexture"] = "fer18",
				["G"] = 0.6,
				["TR"] = 1,
				["font"] = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF",
				["TO"] = 1,
				["useBackground"] = true,
				["textSize"] = 13,
				["useText"] = true,
				["O"] = 0.6,
				["B"] = 0.6,
			},
			["TEXT"] = {
				["maxChars"] = 8,
				["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf",
				["useOpacity"] = true,
				["textSizeLife"] = 8,
				["outline"] = false,
				["textSize"] = 10,
				["useText"] = true,
			},
			["TOT"] = {
				["TR"] = 1,
				["TO"] = 1,
				["TB"] = 1,
				["useText"] = true,
				["TG"] = 1,
			},
			["BACK"] = {
				["useBackground"] = true,
				["R"] = 0,
				["useOpacity"] = true,
				["O"] = 0,
				["G"] = 0,
				["B"] = 0,
			},
		},
		["HOTS"] = {
			["textSize"] = 100,
			["size"] = 76,
		},
		["SCALING"] = {
			["headerHeight"] = 20,
			["targetWidth"] = 30,
			["scale"] = 1,
			["maxColumnsWhenStructured"] = 5,
			["alignBottom"] = false,
			["arrangeHorizontal"] = true,
			["targetSpacing"] = 3,
			["targetOrientation"] = 1,
			["ommitEmptyWhenStructured"] = true,
			["showTarget"] = false,
			["damFlashFactor"] = 0.75,
			["sideLeftWidth"] = 6,
			["sideRightWidth"] = 6,
			["headerSpacing"] = 5,
			["borderGapX"] = 0,
			["manaBarHeight"] = 5,
			["headerWidth"] = 33,
			["isDamFlash"] = true,
			["showHeaders"] = false,
			["totWidth"] = 30,
			["totSpacing"] = 3,
			["showTot"] = false,
			["isPlayerOnTop"] = false,
			["maxRowsWhenLoose"] = 6,
			["barHeight"] = 30,
			["columnSpacing"] = 2,
			["borderGapY"] = 0,
			["barWidth"] = 100,
			["rowSpacing"] = 2,
		},
		["ID_TEXT"] = {
			["showClass"] = false,
			["showName"] = true,
			["version"] = 2,
			["position"] = "CENTER+CENTER",
			["showTags"] = true,
			["showPetOwners"] = true,
		},
		["LIFE_TEXT"] = {
			["show"] = true,
			["hideIrrelevant"] = false,
			["position"] = 1,
			["mode"] = 3,
			["verbose"] = false,
		},
	}, -- [10]
	["RAID_ICON_FILTER"] = {
		true, -- [1]
		true, -- [2]
		true, -- [3]
		true, -- [4]
		true, -- [5]
		true, -- [6]
		true, -- [7]
		true, -- [8]
	},
	["PANEL_COLOR"] = {
		["classColorsName"] = false,
		["BARS"] = {
			["useBackground"] = true,
			["R"] = 0.7,
			["useOpacity"] = true,
			["O"] = 1,
			["G"] = 0.7,
			["B"] = 0.7,
		},
		["TEXT"] = {
			["TR"] = 1,
			["TO"] = 1,
			["TB"] = 0,
			["useText"] = true,
			["TG"] = 0.82,
		},
	},
	["HOTS"] = {
		["font"] = "Interface\\AddOns\\VuhDo\\Fonts\\ariblk.ttf",
		["SLOTS"] = {
			"Sacred Shield", -- [1]
			"Beacon of Light", -- [2]
			"BOUQUET_Tank Cooldowns", -- [3]
			"OTHER", -- [4]
			"CLUSTER", -- [5]
			[9] = "Beacon of Light",
		},
		["BARS"] = {
			["radioValue"] = 1,
			["width"] = 25,
		},
		["radioValue"] = 21,
		["iconRadioValue"] = 1,
		["SLOTCFG"] = {
			["1"] = {
				["mine"] = true,
				["others"] = false,
			},
			["3"] = {
				["mine"] = false,
				["others"] = true,
			},
			["2"] = {
				["mine"] = false,
				["others"] = true,
			},
			["5"] = {
				["mine"] = true,
				["others"] = false,
			},
			["4"] = {
				["mine"] = true,
				["others"] = false,
			},
			["7"] = {
				["mine"] = true,
				["others"] = false,
			},
			["6"] = {
				["mine"] = true,
				["others"] = false,
			},
			["9"] = {
				["mine"] = true,
				["others"] = false,
			},
			["8"] = {
				["mine"] = true,
				["others"] = false,
			},
			["10"] = {
				["mine"] = true,
				["others"] = false,
			},
		},
		["stacksRadioValue"] = 2,
		["BUTTON_FACADE"] = "Blizzard",
	},
	["BAR_COLORS"] = {
		["OVERHEAL_TEXT"] = {
			["TR"] = 0.8,
			["TO"] = 1,
			["TB"] = 0.8,
			["TG"] = 1,
			["useText"] = true,
			["useOpacity"] = true,
		},
		["HOT7"] = {
			["useBackground"] = true,
			["R"] = 1,
			["O"] = 0.75,
			["G"] = 1,
			["B"] = 1,
		},
		["CLUSTER_FAIR"] = {
			["TG"] = 1,
			["B"] = 0,
			["TB"] = 0,
			["G"] = 0.8,
			["TR"] = 1,
			["TO"] = 1,
			["useText"] = true,
			["useBackground"] = true,
			["O"] = 1,
			["R"] = 0.8,
		},
		["HOT1"] = {
			["TG"] = 0.6,
			["countdownMode"] = 2,
			["B"] = 0.3,
			["TB"] = 0.6,
			["G"] = 0.3,
			["TR"] = 1,
			["TO"] = 1,
			["useText"] = true,
			["isFullDuration"] = true,
			["useBackground"] = true,
			["O"] = 1,
			["R"] = 1,
		},
		["DEBUFF0"] = {
			["useBackground"] = false,
			["useText"] = false,
			["useOpacity"] = false,
		},
		["HOT3"] = {
			["TG"] = 1,
			["countdownMode"] = 2,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["TR"] = 1,
			["TO"] = 1,
			["useText"] = true,
			["isFullDuration"] = false,
			["useBackground"] = true,
			["O"] = 1,
			["R"] = 1,
		},
		["RAID_ICONS"] = {
			["1"] = {
				["TG"] = 1,
				["R"] = 1,
				["TB"] = 0.607,
				["G"] = 0.976,
				["TR"] = 0.98,
				["TO"] = 1,
				["B"] = 0.305,
				["useText"] = true,
				["O"] = 1,
				["useBackground"] = true,
			},
			["filterOnly"] = false,
			["3"] = {
				["TG"] = 0.674,
				["B"] = 0.8,
				["TB"] = 0.921,
				["G"] = 0.29,
				["TR"] = 1,
				["TO"] = 1,
				["useText"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["R"] = 0.788,
			},
			["2"] = {
				["TG"] = 0.827,
				["B"] = 0.039,
				["TB"] = 0.419,
				["G"] = 0.513,
				["TR"] = 1,
				["TO"] = 1,
				["useText"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["R"] = 1,
			},
			["enable"] = false,
			["4"] = {
				["TG"] = 1,
				["B"] = 0.015,
				["TB"] = 0.698,
				["G"] = 0.8,
				["TR"] = 0.698,
				["TO"] = 1,
				["useText"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["R"] = 0,
			},
			["7"] = {
				["TG"] = 0.627,
				["B"] = 0.129,
				["TB"] = 0.619,
				["G"] = 0.184,
				["TR"] = 1,
				["TO"] = 1,
				["useText"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["R"] = 0.8,
			},
			["6"] = {
				["TG"] = 0.831,
				["B"] = 0.972,
				["TB"] = 1,
				["G"] = 0.69,
				["TR"] = 0.662,
				["TO"] = 1,
				["useText"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["R"] = 0.121,
			},
			["8"] = {
				["TG"] = 0.231,
				["B"] = 0.89,
				["TB"] = 0.231,
				["G"] = 0.866,
				["TR"] = 0.231,
				["TO"] = 1,
				["useText"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["R"] = 0.847,
			},
			["5"] = {
				["TG"] = 0.87,
				["B"] = 0.8,
				["TB"] = 1,
				["G"] = 0.717,
				["TR"] = 0.725,
				["TO"] = 1,
				["useText"] = true,
				["useBackground"] = true,
				["O"] = 1,
				["R"] = 0.466,
			},
		},
		["IRRELEVANT"] = {
			["TG"] = 0.82,
			["B"] = 0.4,
			["TB"] = 0,
			["G"] = 0,
			["TR"] = 1,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = false,
			["useText"] = false,
			["O"] = 0.5,
			["R"] = 0,
		},
		["HOT9"] = {
			["TG"] = 1,
			["countdownMode"] = 1,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["TR"] = 0.6,
			["TO"] = 1,
			["useText"] = true,
			["isFullDuration"] = false,
			["useBackground"] = true,
			["O"] = 1,
			["R"] = 0.3,
		},
		["HOT_CHARGE_4"] = {
			["TG"] = 1,
			["B"] = 0.8,
			["TB"] = 1,
			["G"] = 0.8,
			["TR"] = 1,
			["TO"] = 1,
			["useText"] = true,
			["useBackground"] = true,
			["O"] = 1,
			["R"] = 0.8,
		},
		["HOT_CHARGE_3"] = {
			["TG"] = 1,
			["B"] = 0.3,
			["TB"] = 0.6,
			["G"] = 1,
			["TR"] = 0.6,
			["TO"] = 1,
			["useText"] = true,
			["useBackground"] = true,
			["O"] = 1,
			["R"] = 0.3,
		},
		["CLUSTER_GOOD"] = {
			["TG"] = 1,
			["B"] = 0,
			["TB"] = 0,
			["G"] = 0.8,
			["TR"] = 0,
			["TO"] = 1,
			["useText"] = true,
			["useBackground"] = true,
			["O"] = 1,
			["R"] = 0,
		},
		["DEBUFF3"] = {
			["TG"] = 0.957,
			["B"] = 0.8,
			["TB"] = 1,
			["G"] = 0.4,
			["TR"] = 0.329,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 1,
			["R"] = 0.4,
		},
		["INCOMING"] = {
			["TG"] = 0.82,
			["B"] = 0,
			["TB"] = 0,
			["G"] = 0,
			["TR"] = 1,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = false,
			["useText"] = false,
			["O"] = 0.33,
			["R"] = 0,
		},
		["HOT6"] = {
			["useBackground"] = true,
			["R"] = 1,
			["O"] = 0.75,
			["G"] = 1,
			["B"] = 1,
		},
		["HOT4"] = {
			["TG"] = 0.6,
			["countdownMode"] = 1,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 0.3,
			["TR"] = 0.6,
			["TO"] = 1,
			["useText"] = true,
			["isFullDuration"] = false,
			["useBackground"] = true,
			["O"] = 1,
			["R"] = 0.3,
		},
		["DEBUFF6"] = {
			["TG"] = 0.5,
			["B"] = 0,
			["TB"] = 0,
			["G"] = 0.3,
			["TR"] = 0.8,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 1,
			["R"] = 0.6,
		},
		["HOT5"] = {
			["TG"] = 0.6,
			["countdownMode"] = 1,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 0.3,
			["TR"] = 1,
			["TO"] = 1,
			["useText"] = true,
			["isFullDuration"] = false,
			["useBackground"] = true,
			["O"] = 1,
			["R"] = 1,
		},
		["NO_EMERGENCY"] = {
			["TG"] = 0.82,
			["B"] = 0.4,
			["TB"] = 0,
			["G"] = 0,
			["TR"] = 1,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 1,
			["R"] = 0,
		},
		["HOTS"] = {
			["useColorText"] = true,
			["WARNING"] = {
				["TG"] = 0.6,
				["lowSecs"] = 3,
				["B"] = 0.2,
				["TB"] = 0.6,
				["G"] = 0.2,
				["TR"] = 1,
				["TO"] = 1,
				["enabled"] = false,
				["useBackground"] = true,
				["useText"] = true,
				["O"] = 1,
				["R"] = 0.5,
			},
			["TEXT"] = {
				["outline"] = true,
				["shadow"] = false,
			},
			["isFadeOut"] = false,
			["factorDivineAegis"] = 1.2,
			["showShieldAbsorb"] = true,
			["useColorBack"] = true,
		},
		["GCD_BAR"] = {
			["useBackground"] = true,
			["R"] = 0.4,
			["O"] = 0.5,
			["G"] = 0.4,
			["B"] = 0.4,
		},
		["HOT2"] = {
			["TG"] = 1,
			["countdownMode"] = 2,
			["B"] = 0.3,
			["TB"] = 0.6,
			["G"] = 1,
			["TR"] = 1,
			["TO"] = 1,
			["useText"] = true,
			["isFullDuration"] = true,
			["useBackground"] = true,
			["O"] = 1,
			["R"] = 1,
		},
		["DEAD"] = {
			["TG"] = 0.5,
			["B"] = 0.3,
			["TB"] = 0.5,
			["G"] = 0.3,
			["TR"] = 0.5,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 0.5,
			["R"] = 0.3,
		},
		["OFFLINE"] = {
			["TG"] = 0.576,
			["B"] = 0.298,
			["TB"] = 0.576,
			["G"] = 0.298,
			["TR"] = 0.576,
			["TO"] = 0.58,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 0.21,
			["R"] = 0.298,
		},
		["OUTRANGED"] = {
			["TG"] = 0,
			["B"] = 0,
			["TB"] = 0,
			["G"] = 0,
			["TR"] = 0,
			["TO"] = 0.5,
			["useOpacity"] = true,
			["useBackground"] = false,
			["useText"] = false,
			["O"] = 0.25,
			["R"] = 0,
		},
		["HOT8"] = {
			["useBackground"] = true,
			["R"] = 1,
			["O"] = 0.75,
			["G"] = 1,
			["B"] = 1,
		},
		["useDebuffIcon"] = true,
		["DEBUFF2"] = {
			["TG"] = 0,
			["B"] = 0.4,
			["TB"] = 0,
			["G"] = 0.4,
			["TR"] = 1,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 1,
			["R"] = 0.8,
		},
		["CHARMED"] = {
			["TG"] = 0.31,
			["B"] = 0.263,
			["TB"] = 0.31,
			["G"] = 0.082,
			["TR"] = 1,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 1,
			["R"] = 0.51,
		},
		["DEBUFF1"] = {
			["TG"] = 1,
			["B"] = 0.8,
			["TB"] = 0.6860000000000001,
			["G"] = 0.592,
			["TR"] = 0,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 1,
			["R"] = 0,
		},
		["HOT10"] = {
			["TG"] = 1,
			["countdownMode"] = 1,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["TR"] = 0.6,
			["TO"] = 1,
			["useText"] = true,
			["isFullDuration"] = false,
			["useBackground"] = true,
			["O"] = 1,
			["R"] = 0.3,
		},
		["THREAT"] = {
			["LOW"] = {
				["useBackground"] = true,
				["R"] = 0,
				["O"] = 1,
				["G"] = 1,
				["B"] = 1,
			},
			["HIGH"] = {
				["useBackground"] = true,
				["R"] = 1,
				["O"] = 1,
				["G"] = 0,
				["B"] = 1,
			},
		},
		["DEBUFF4"] = {
			["TG"] = 0,
			["B"] = 0.7,
			["TB"] = 1,
			["G"] = 0,
			["TR"] = 1,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 1,
			["R"] = 0.7,
		},
		["EMERGENCY"] = {
			["TG"] = 0.82,
			["B"] = 0,
			["TB"] = 0,
			["G"] = 0,
			["TR"] = 1,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 1,
			["R"] = 1,
		},
		["BAR_FRAMES"] = {
			["useBackground"] = true,
			["R"] = 0,
			["useOpacity"] = true,
			["O"] = 0.7,
			["G"] = 0,
			["B"] = 0,
		},
		["LIFE_LEFT"] = {
			["GOOD"] = {
				["useBackground"] = true,
				["R"] = 0,
				["O"] = 1,
				["G"] = 1,
				["B"] = 0,
			},
			["LOW"] = {
				["useBackground"] = true,
				["R"] = 1,
				["O"] = 1,
				["G"] = 0,
				["B"] = 0,
			},
			["FAIR"] = {
				["useBackground"] = true,
				["R"] = 1,
				["O"] = 1,
				["G"] = 1,
				["B"] = 0,
			},
		},
		["HOT_CHARGE_2"] = {
			["TG"] = 1,
			["B"] = 0.3,
			["TB"] = 0.6,
			["G"] = 1,
			["TR"] = 1,
			["TO"] = 1,
			["useText"] = true,
			["useBackground"] = true,
			["O"] = 1,
			["R"] = 1,
		},
	},
}
VUHDO_SPELL_ASSIGNMENTS = {
	["altshift14"] = {
		"alt-shift-", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["altctrlshift15"] = {
		"alt-ctrl-shift-", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["alt13"] = {
		"alt-", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["altshift13"] = {
		"alt-shift-", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["altctrlshift16"] = {
		"alt-ctrl-shift-", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["altctrl13"] = {
		"alt-ctrl-", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["shift3"] = {
		"shift-", -- [1]
		"3", -- [2]
		"Hand of Sacrifice", -- [3]
	},
	["ctrl12"] = {
		"ctrl-", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["alt6"] = {
		"alt-", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["altctrlshift12"] = {
		"alt-ctrl-shift-", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["alt2"] = {
		"alt-", -- [1]
		"2", -- [2]
		"Cleanse", -- [3]
	},
	["shift14"] = {
		"shift-", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["altshift2"] = {
		"alt-shift-", -- [1]
		"2", -- [2]
		"", -- [3]
	},
	["altshift16"] = {
		"alt-shift-", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["altctrlshift9"] = {
		"alt-ctrl-shift-", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["altctrlshift6"] = {
		"alt-ctrl-shift-", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["ctrl3"] = {
		"ctrl-", -- [1]
		"3", -- [2]
		"menu", -- [3]
	},
	["altctrlshift14"] = {
		"alt-ctrl-shift-", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["shift16"] = {
		"shift-", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["altctrl16"] = {
		"alt-ctrl-", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["ctrlshift6"] = {
		"ctrl-shift-", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["altctrl5"] = {
		"alt-ctrl-", -- [1]
		"5", -- [2]
		"", -- [3]
	},
	["shift8"] = {
		"shift-", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["altshift6"] = {
		"alt-shift-", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["altshift10"] = {
		"alt-shift-", -- [1]
		"10", -- [2]
		"", -- [3]
	},
	["ctrl9"] = {
		"ctrl-", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["shift15"] = {
		"shift-", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["ctrl11"] = {
		"ctrl-", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["13"] = {
		"", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["ctrlshift1"] = {
		"ctrl-shift-", -- [1]
		"1", -- [2]
		"Cure Toxins", -- [3]
	},
	["ctrlshift14"] = {
		"ctrl-shift-", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["alt15"] = {
		"alt-", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["shift7"] = {
		"shift-", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["altctrlshift5"] = {
		"alt-ctrl-shift-", -- [1]
		"5", -- [2]
		"", -- [3]
	},
	["ctrlshift4"] = {
		"ctrl-shift-", -- [1]
		"4", -- [2]
		"", -- [3]
	},
	["altctrl3"] = {
		"alt-ctrl-", -- [1]
		"3", -- [2]
		"", -- [3]
	},
	["altctrlshift8"] = {
		"alt-ctrl-shift-", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["altshift15"] = {
		"alt-shift-", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["altshift1"] = {
		"alt-shift-", -- [1]
		"1", -- [2]
		"", -- [3]
	},
	["altctrlshift2"] = {
		"alt-ctrl-shift-", -- [1]
		"2", -- [2]
		"", -- [3]
	},
	["altctrl1"] = {
		"alt-ctrl-", -- [1]
		"1", -- [2]
		"Purge", -- [3]
	},
	["altshift5"] = {
		"alt-shift-", -- [1]
		"5", -- [2]
		"", -- [3]
	},
	["ctrl15"] = {
		"ctrl-", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["ctrl16"] = {
		"ctrl-", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["ctrlshift15"] = {
		"ctrl-shift-", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["ctrl4"] = {
		"ctrl-", -- [1]
		"4", -- [2]
		"", -- [3]
	},
	["altctrlshift11"] = {
		"alt-ctrl-shift-", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["shift6"] = {
		"shift-", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["altshift12"] = {
		"alt-shift-", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["12"] = {
		"", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["altctrlshift3"] = {
		"alt-ctrl-shift-", -- [1]
		"3", -- [2]
		"", -- [3]
	},
	["ctrlshift9"] = {
		"ctrl-shift-", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["shift1"] = {
		"shift-", -- [1]
		"1", -- [2]
		"Holy Shock", -- [3]
	},
	["altshift4"] = {
		"alt-shift-", -- [1]
		"4", -- [2]
		"", -- [3]
	},
	["shift2"] = {
		"shift-", -- [1]
		"2", -- [2]
		"Divine Light", -- [3]
	},
	["alt5"] = {
		"alt-", -- [1]
		"5", -- [2]
		"Divine Intervention", -- [3]
	},
	["altctrl11"] = {
		"alt-ctrl-", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["alt3"] = {
		"alt-", -- [1]
		"3", -- [2]
		"", -- [3]
	},
	["ctrlshift16"] = {
		"ctrl-shift-", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["shift9"] = {
		"shift-", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["altctrlshift7"] = {
		"alt-ctrl-shift-", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["ctrlshift13"] = {
		"ctrl-shift-", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["shift10"] = {
		"shift-", -- [1]
		"10", -- [2]
		"", -- [3]
	},
	["altctrl7"] = {
		"alt-ctrl-", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["ctrlshift12"] = {
		"ctrl-shift-", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["ctrl7"] = {
		"ctrl-", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["ctrlshift3"] = {
		"ctrl-shift-", -- [1]
		"3", -- [2]
		"", -- [3]
	},
	["alt11"] = {
		"alt-", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["shift11"] = {
		"shift-", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["alt1"] = {
		"alt-", -- [1]
		"1", -- [2]
		"Purify", -- [3]
	},
	["3"] = {
		"", -- [1]
		"3", -- [2]
		"Word of Glory", -- [3]
	},
	["ctrlshift7"] = {
		"ctrl-shift-", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["ctrl1"] = {
		"ctrl-", -- [1]
		"1", -- [2]
		"target", -- [3]
	},
	["ctrlshift8"] = {
		"ctrl-shift-", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["ctrl6"] = {
		"ctrl-", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["altctrl10"] = {
		"alt-ctrl-", -- [1]
		"10", -- [2]
		"", -- [3]
	},
	["altctrlshift4"] = {
		"alt-ctrl-shift-", -- [1]
		"4", -- [2]
		"", -- [3]
	},
	["alt14"] = {
		"alt-", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["alt4"] = {
		"alt-", -- [1]
		"4", -- [2]
		"", -- [3]
	},
	["alt9"] = {
		"alt-", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["1"] = {
		"", -- [1]
		"1", -- [2]
		"Flash of Light", -- [3]
	},
	["8"] = {
		"", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["altshift9"] = {
		"alt-shift-", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["2"] = {
		"", -- [1]
		"2", -- [2]
		"Holy Light", -- [3]
	},
	["ctrlshift2"] = {
		"ctrl-shift-", -- [1]
		"2", -- [2]
		"Cure Toxins", -- [3]
	},
	["4"] = {
		"", -- [1]
		"4", -- [2]
		"Hand of Protection", -- [3]
	},
	["7"] = {
		"", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["6"] = {
		"", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["9"] = {
		"", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["15"] = {
		"", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["altctrlshift10"] = {
		"alt-ctrl-shift-", -- [1]
		"10", -- [2]
		"", -- [3]
	},
	["ctrl5"] = {
		"ctrl-", -- [1]
		"5", -- [2]
		"", -- [3]
	},
	["altctrlshift1"] = {
		"alt-ctrl-shift-", -- [1]
		"1", -- [2]
		"", -- [3]
	},
	["shift13"] = {
		"shift-", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["11"] = {
		"", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["altctrl12"] = {
		"alt-ctrl-", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["5"] = {
		"", -- [1]
		"5", -- [2]
		"Beacon of Light", -- [3]
	},
	["altctrl2"] = {
		"alt-ctrl-", -- [1]
		"2", -- [2]
		"Purge", -- [3]
	},
	["altctrlshift13"] = {
		"alt-ctrl-shift-", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["ctrl14"] = {
		"ctrl-", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["altctrl8"] = {
		"alt-ctrl-", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["alt10"] = {
		"alt-", -- [1]
		"10", -- [2]
		"", -- [3]
	},
	["ctrlshift5"] = {
		"ctrl-shift-", -- [1]
		"5", -- [2]
		"", -- [3]
	},
	["16"] = {
		"", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["alt16"] = {
		"alt-", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["shift12"] = {
		"shift-", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["altctrl14"] = {
		"alt-ctrl-", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["altctrl6"] = {
		"alt-ctrl-", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["ctrlshift11"] = {
		"ctrl-shift-", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["ctrlshift10"] = {
		"ctrl-shift-", -- [1]
		"10", -- [2]
		"", -- [3]
	},
	["altshift11"] = {
		"alt-shift-", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["shift4"] = {
		"shift-", -- [1]
		"4", -- [2]
		"Hand of Freedom", -- [3]
	},
	["alt7"] = {
		"alt-", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["ctrl10"] = {
		"ctrl-", -- [1]
		"10", -- [2]
		"", -- [3]
	},
	["altshift3"] = {
		"alt-shift-", -- [1]
		"3", -- [2]
		"", -- [3]
	},
	["altctrl4"] = {
		"alt-ctrl-", -- [1]
		"4", -- [2]
		"", -- [3]
	},
	["alt8"] = {
		"alt-", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["altshift8"] = {
		"alt-shift-", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["altctrl9"] = {
		"alt-ctrl-", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["shift5"] = {
		"shift-", -- [1]
		"5", -- [2]
		"Lay on Hands", -- [3]
	},
	["14"] = {
		"", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["altshift7"] = {
		"alt-shift-", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["ctrl8"] = {
		"ctrl-", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["altctrl15"] = {
		"alt-ctrl-", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["ctrl2"] = {
		"ctrl-", -- [1]
		"2", -- [2]
		"assist", -- [3]
	},
	["alt12"] = {
		"alt-", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["ctrl13"] = {
		"ctrl-", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["10"] = {
		"", -- [1]
		"10", -- [2]
		"", -- [3]
	},
}
VUHDO_HOSTILE_SPELL_ASSIGNMENTS = {
	["altshift14"] = {
		"alt-shift-", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["altctrlshift15"] = {
		"alt-ctrl-shift-", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["shift3"] = {
		"shift-", -- [1]
		"3", -- [2]
		"", -- [3]
	},
	["altshift13"] = {
		"alt-shift-", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["altctrlshift16"] = {
		"alt-ctrl-shift-", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["altctrl13"] = {
		"alt-ctrl-", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["alt13"] = {
		"alt-", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["ctrl12"] = {
		"ctrl-", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["alt12"] = {
		"alt-", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["altctrlshift12"] = {
		"alt-ctrl-shift-", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["altctrl15"] = {
		"alt-ctrl-", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["shift14"] = {
		"shift-", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["altshift2"] = {
		"alt-shift-", -- [1]
		"2", -- [2]
		"", -- [3]
	},
	["altshift6"] = {
		"alt-shift-", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["altshift11"] = {
		"alt-shift-", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["altctrlshift6"] = {
		"alt-ctrl-shift-", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["altshift8"] = {
		"alt-shift-", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["ctrlshift9"] = {
		"ctrl-shift-", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["shift16"] = {
		"shift-", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["altctrl16"] = {
		"alt-ctrl-", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["ctrlshift6"] = {
		"ctrl-shift-", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["altctrl14"] = {
		"alt-ctrl-", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["ctrlshift15"] = {
		"ctrl-shift-", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["altshift16"] = {
		"alt-shift-", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["altshift10"] = {
		"alt-shift-", -- [1]
		"10", -- [2]
		"", -- [3]
	},
	["ctrl9"] = {
		"ctrl-", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["shift15"] = {
		"shift-", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["ctrl11"] = {
		"ctrl-", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["13"] = {
		"", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["ctrlshift10"] = {
		"ctrl-shift-", -- [1]
		"10", -- [2]
		"", -- [3]
	},
	["ctrlshift14"] = {
		"ctrl-shift-", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["alt15"] = {
		"alt-", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["shift7"] = {
		"shift-", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["altctrlshift5"] = {
		"alt-ctrl-shift-", -- [1]
		"5", -- [2]
		"", -- [3]
	},
	["altctrlshift14"] = {
		"alt-ctrl-shift-", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["altctrl3"] = {
		"alt-ctrl-", -- [1]
		"3", -- [2]
		"", -- [3]
	},
	["ctrl2"] = {
		"ctrl-", -- [1]
		"2", -- [2]
		"", -- [3]
	},
	["altshift15"] = {
		"alt-shift-", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["altshift1"] = {
		"alt-shift-", -- [1]
		"1", -- [2]
		"", -- [3]
	},
	["altctrlshift2"] = {
		"alt-ctrl-shift-", -- [1]
		"2", -- [2]
		"", -- [3]
	},
	["altctrl1"] = {
		"alt-ctrl-", -- [1]
		"1", -- [2]
		"", -- [3]
	},
	["altctrl5"] = {
		"alt-ctrl-", -- [1]
		"5", -- [2]
		"", -- [3]
	},
	["ctrl15"] = {
		"ctrl-", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["ctrl16"] = {
		"ctrl-", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["shift8"] = {
		"shift-", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["shift1"] = {
		"shift-", -- [1]
		"1", -- [2]
		"", -- [3]
	},
	["altctrlshift11"] = {
		"alt-ctrl-shift-", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["shift6"] = {
		"shift-", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["16"] = {
		"", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["12"] = {
		"", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["ctrlshift5"] = {
		"ctrl-shift-", -- [1]
		"5", -- [2]
		"", -- [3]
	},
	["ctrlshift4"] = {
		"ctrl-shift-", -- [1]
		"4", -- [2]
		"", -- [3]
	},
	["altshift12"] = {
		"alt-shift-", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["altshift4"] = {
		"alt-shift-", -- [1]
		"4", -- [2]
		"", -- [3]
	},
	["alt10"] = {
		"alt-", -- [1]
		"10", -- [2]
		"", -- [3]
	},
	["alt5"] = {
		"alt-", -- [1]
		"5", -- [2]
		"", -- [3]
	},
	["altctrl11"] = {
		"alt-ctrl-", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["alt3"] = {
		"alt-", -- [1]
		"3", -- [2]
		"", -- [3]
	},
	["ctrlshift16"] = {
		"ctrl-shift-", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["shift9"] = {
		"shift-", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["altctrlshift7"] = {
		"alt-ctrl-shift-", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["ctrlshift13"] = {
		"ctrl-shift-", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["shift10"] = {
		"shift-", -- [1]
		"10", -- [2]
		"", -- [3]
	},
	["ctrl5"] = {
		"ctrl-", -- [1]
		"5", -- [2]
		"", -- [3]
	},
	["ctrlshift12"] = {
		"ctrl-shift-", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["ctrl7"] = {
		"ctrl-", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["alt4"] = {
		"alt-", -- [1]
		"4", -- [2]
		"", -- [3]
	},
	["alt11"] = {
		"alt-", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["shift11"] = {
		"shift-", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["1"] = {
		"", -- [1]
		"1", -- [2]
		"target", -- [3]
	},
	["altctrlshift3"] = {
		"alt-ctrl-shift-", -- [1]
		"3", -- [2]
		"", -- [3]
	},
	["ctrlshift2"] = {
		"ctrl-shift-", -- [1]
		"2", -- [2]
		"", -- [3]
	},
	["ctrl1"] = {
		"ctrl-", -- [1]
		"1", -- [2]
		"", -- [3]
	},
	["ctrlshift8"] = {
		"ctrl-shift-", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["ctrl6"] = {
		"ctrl-", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["altctrl10"] = {
		"alt-ctrl-", -- [1]
		"10", -- [2]
		"", -- [3]
	},
	["altctrlshift4"] = {
		"alt-ctrl-shift-", -- [1]
		"4", -- [2]
		"", -- [3]
	},
	["alt14"] = {
		"alt-", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["ctrlshift3"] = {
		"ctrl-shift-", -- [1]
		"3", -- [2]
		"", -- [3]
	},
	["7"] = {
		"", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["alt1"] = {
		"alt-", -- [1]
		"1", -- [2]
		"", -- [3]
	},
	["8"] = {
		"", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["altshift9"] = {
		"alt-shift-", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["2"] = {
		"", -- [1]
		"2", -- [2]
		"assist", -- [3]
	},
	["5"] = {
		"", -- [1]
		"5", -- [2]
		"menu", -- [3]
	},
	["4"] = {
		"", -- [1]
		"4", -- [2]
		"menu", -- [3]
	},
	["alt9"] = {
		"alt-", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["6"] = {
		"", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["9"] = {
		"", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["15"] = {
		"", -- [1]
		"15", -- [2]
		"", -- [3]
	},
	["altctrlshift10"] = {
		"alt-ctrl-shift-", -- [1]
		"10", -- [2]
		"", -- [3]
	},
	["alt8"] = {
		"alt-", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["altctrlshift1"] = {
		"alt-ctrl-shift-", -- [1]
		"1", -- [2]
		"", -- [3]
	},
	["shift13"] = {
		"shift-", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["11"] = {
		"", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["altctrl12"] = {
		"alt-ctrl-", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["ctrlshift7"] = {
		"ctrl-shift-", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["altctrl2"] = {
		"alt-ctrl-", -- [1]
		"2", -- [2]
		"", -- [3]
	},
	["altctrlshift13"] = {
		"alt-ctrl-shift-", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["ctrl14"] = {
		"ctrl-", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["altctrl8"] = {
		"alt-ctrl-", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["shift2"] = {
		"shift-", -- [1]
		"2", -- [2]
		"", -- [3]
	},
	["3"] = {
		"", -- [1]
		"3", -- [2]
		"focus", -- [3]
	},
	["altctrl7"] = {
		"alt-ctrl-", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["alt16"] = {
		"alt-", -- [1]
		"16", -- [2]
		"", -- [3]
	},
	["shift12"] = {
		"shift-", -- [1]
		"12", -- [2]
		"", -- [3]
	},
	["altshift5"] = {
		"alt-shift-", -- [1]
		"5", -- [2]
		"", -- [3]
	},
	["altctrl6"] = {
		"alt-ctrl-", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["ctrlshift11"] = {
		"ctrl-shift-", -- [1]
		"11", -- [2]
		"", -- [3]
	},
	["ctrlshift1"] = {
		"ctrl-shift-", -- [1]
		"1", -- [2]
		"", -- [3]
	},
	["altctrlshift9"] = {
		"alt-ctrl-shift-", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["shift4"] = {
		"shift-", -- [1]
		"4", -- [2]
		"", -- [3]
	},
	["alt7"] = {
		"alt-", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["ctrl10"] = {
		"ctrl-", -- [1]
		"10", -- [2]
		"", -- [3]
	},
	["altshift3"] = {
		"alt-shift-", -- [1]
		"3", -- [2]
		"", -- [3]
	},
	["altctrl4"] = {
		"alt-ctrl-", -- [1]
		"4", -- [2]
		"", -- [3]
	},
	["ctrl4"] = {
		"ctrl-", -- [1]
		"4", -- [2]
		"", -- [3]
	},
	["ctrl3"] = {
		"ctrl-", -- [1]
		"3", -- [2]
		"", -- [3]
	},
	["altctrl9"] = {
		"alt-ctrl-", -- [1]
		"9", -- [2]
		"", -- [3]
	},
	["shift5"] = {
		"shift-", -- [1]
		"5", -- [2]
		"", -- [3]
	},
	["14"] = {
		"", -- [1]
		"14", -- [2]
		"", -- [3]
	},
	["altshift7"] = {
		"alt-shift-", -- [1]
		"7", -- [2]
		"", -- [3]
	},
	["ctrl8"] = {
		"ctrl-", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["alt2"] = {
		"alt-", -- [1]
		"2", -- [2]
		"", -- [3]
	},
	["altctrlshift8"] = {
		"alt-ctrl-shift-", -- [1]
		"8", -- [2]
		"", -- [3]
	},
	["alt6"] = {
		"alt-", -- [1]
		"6", -- [2]
		"", -- [3]
	},
	["ctrl13"] = {
		"ctrl-", -- [1]
		"13", -- [2]
		"", -- [3]
	},
	["10"] = {
		"", -- [1]
		"10", -- [2]
		"", -- [3]
	},
}
VUHDO_MM_SETTINGS = {
	["enabled"] = 1,
	["drag"] = "CIRCLE",
	["position"] = 0,
}
VUHDO_PLAYER_TARGETS = {
}
VUHDO_MAINTANK_NAMES = {
}
VUHDO_BUFF_SETTINGS = {
	["Inner Fire"] = {
		["missingColor"] = {
			["TG"] = 1,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["show"] = false,
			["R"] = 1,
			["TO"] = 1,
			["useBackground"] = true,
			["TR"] = 1,
			["useText"] = true,
			["O"] = 1,
			["useOpacity"] = true,
		},
		["buff"] = "Inner Fire",
		["enabled"] = false,
		["filter"] = {
			[999] = true,
		},
	},
	["Power Infusion"] = {
		["missingColor"] = {
			["TG"] = 1,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["show"] = false,
			["R"] = 1,
			["TO"] = 1,
			["useBackground"] = true,
			["TR"] = 1,
			["useText"] = true,
			["O"] = 1,
			["useOpacity"] = true,
		},
		["enabled"] = false,
		["name"] = "Vassilisa",
		["filter"] = {
			[999] = true,
		},
	},
	["Levitate"] = {
		["missingColor"] = {
			["TG"] = 1,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["show"] = false,
			["R"] = 1,
			["TO"] = 1,
			["useBackground"] = true,
			["TR"] = 1,
			["useText"] = true,
			["O"] = 1,
			["useOpacity"] = true,
		},
		["enabled"] = false,
		["filter"] = {
			[999] = true,
		},
	},
	["CONFIG"] = {
		["SWATCH_EMPTY_GROUP"] = {
			["TG"] = 0.8,
			["B"] = 0,
			["TB"] = 0.8,
			["G"] = 0,
			["TR"] = 0.8,
			["TO"] = 0.6,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 0.5,
			["R"] = 0,
		},
		["SWATCH_COLOR_BUFF_OUT"] = {
			["TG"] = 0,
			["B"] = 0,
			["TB"] = 0,
			["G"] = 0,
			["TR"] = 0.8,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 1,
			["R"] = 0,
		},
		["SHOW_LABEL"] = false,
		["REFRESH_SECS"] = 1,
		["SWATCH_COLOR_BUFF_COOLDOWN"] = {
			["TG"] = 0.6,
			["B"] = 0.3,
			["TB"] = 0.6,
			["G"] = 0.3,
			["TR"] = 0.6,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 1,
			["R"] = 0.3,
		},
		["SWATCH_COLOR_BUFF_OKAY"] = {
			["TG"] = 0.8,
			["B"] = 0,
			["TB"] = 0,
			["G"] = 0,
			["TR"] = 0,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 1,
			["R"] = 0,
		},
		["SHOW"] = true,
		["PANEL_BG_COLOR"] = {
			["useBackground"] = true,
			["useOpacity"] = false,
			["R"] = 0,
			["useText"] = false,
			["O"] = 0.5,
			["G"] = 0,
			["B"] = 0,
		},
		["SWATCH_COLOR_BUFF_LOW"] = {
			["TG"] = 0.7,
			["B"] = 0,
			["TB"] = 0,
			["G"] = 0,
			["TR"] = 1,
			["TO"] = 1,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 1,
			["R"] = 0,
		},
		["VERSION"] = 2,
		["SCALE"] = 1,
		["BAR_COLORS_TEXT"] = true,
		["BAR_COLORS_IN_FIGHT"] = false,
		["HIGHLIGHT_COOLDOWN"] = true,
		["HIDE_CHARGES"] = false,
		["PANEL_MAX_BUFFS"] = 5,
		["COMPACT"] = true,
		["PANEL_BORDER_COLOR"] = {
			["useBackground"] = true,
			["useOpacity"] = false,
			["R"] = 0,
			["useText"] = false,
			["O"] = 0.5,
			["G"] = 0,
			["B"] = 0,
		},
		["BAR_COLORS_BACKGROUND"] = true,
		["SWATCH_COLOR_OUT_RANGE"] = {
			["TG"] = 0,
			["B"] = 0,
			["TB"] = 0,
			["G"] = 0,
			["TR"] = 0,
			["TO"] = 0.5,
			["useOpacity"] = true,
			["useBackground"] = true,
			["useText"] = true,
			["O"] = 0.5,
			["R"] = 0,
		},
		["SWATCH_BG_COLOR"] = {
			["useBackground"] = true,
			["useOpacity"] = false,
			["R"] = 0,
			["useText"] = false,
			["O"] = 1,
			["G"] = 0,
			["B"] = 0,
		},
		["POSITION"] = {
			["y"] = -30.43477443076573,
			["x"] = 9.132384778827319,
			["point"] = "TOPRIGHT",
			["relativePoint"] = "TOPRIGHT",
		},
		["SWATCH_BORDER_COLOR"] = {
			["useBackground"] = true,
			["useOpacity"] = false,
			["R"] = 0.8,
			["useText"] = false,
			["O"] = 0,
			["G"] = 0.8,
			["B"] = 0.8,
		},
		["WHEEL_SMART_BUFF"] = true,
		["REBUFF_AT_PERCENT"] = 25,
		["REBUFF_MIN_MINUTES"] = 3,
		["BUTTON_FACADE"] = "Blizzard",
	},
	["Pain Suppression"] = {
		["missingColor"] = {
			["TG"] = 1,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["show"] = false,
			["R"] = 1,
			["TO"] = 1,
			["useBackground"] = true,
			["TR"] = 1,
			["useText"] = true,
			["O"] = 1,
			["useOpacity"] = true,
		},
		["enabled"] = false,
		["name"] = "Vassilisa",
		["filter"] = {
			[999] = true,
		},
	},
	["Seal"] = {
		["missingColor"] = {
			["TG"] = 1,
			["R"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["show"] = true,
			["B"] = 1,
			["TO"] = 1,
			["useBackground"] = true,
			["TR"] = 1,
			["useText"] = true,
			["O"] = 1,
			["useOpacity"] = true,
		},
		["filter"] = {
			[999] = true,
		},
		["enabled"] = true,
		["buff"] = "Seal of Truth",
	},
	["Vampiric Embrace"] = {
		["enabled"] = false,
		["missingColor"] = {
			["TG"] = 1,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["show"] = false,
			["R"] = 1,
			["TO"] = 1,
			["useBackground"] = true,
			["TR"] = 1,
			["useText"] = true,
			["O"] = 1,
			["useOpacity"] = true,
		},
		["filter"] = {
			[999] = true,
		},
	},
	["Fear Ward"] = {
		["missingColor"] = {
			["TG"] = 1,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["show"] = false,
			["R"] = 1,
			["TO"] = 1,
			["useBackground"] = true,
			["TR"] = 1,
			["useText"] = true,
			["O"] = 1,
			["useOpacity"] = true,
		},
		["enabled"] = false,
		["name"] = "Vassilisa",
		["filter"] = {
			[999] = true,
		},
	},
	["Shadow Protection"] = {
		["missingColor"] = {
			["TG"] = 1,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["show"] = false,
			["R"] = 1,
			["TO"] = 1,
			["useBackground"] = true,
			["TR"] = 1,
			["useText"] = true,
			["O"] = 1,
			["useOpacity"] = true,
		},
		["enabled"] = false,
		["filter"] = {
			[999] = true,
		},
	},
	["Shadowfiend"] = {
		["missingColor"] = {
			["TG"] = 1,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["show"] = false,
			["R"] = 1,
			["TO"] = 1,
			["useBackground"] = true,
			["TR"] = 1,
			["useText"] = true,
			["O"] = 1,
			["useOpacity"] = true,
		},
		["buff"] = "Shadowfiend",
		["enabled"] = false,
		["filter"] = {
			[999] = true,
		},
	},
	["Aura"] = {
		["missingColor"] = {
			["TG"] = 1,
			["R"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["show"] = false,
			["B"] = 1,
			["TO"] = 1,
			["useBackground"] = true,
			["TR"] = 1,
			["useText"] = true,
			["O"] = 1,
			["useOpacity"] = true,
		},
		["filter"] = {
			[999] = true,
		},
		["enabled"] = false,
		["buff"] = "Concentration Aura",
	},
	["Power Word: Fortitude"] = {
		["missingColor"] = {
			["TG"] = 1,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["show"] = false,
			["R"] = 1,
			["TO"] = 1,
			["useBackground"] = true,
			["TR"] = 1,
			["useText"] = true,
			["O"] = 1,
			["useOpacity"] = true,
		},
		["enabled"] = false,
		["filter"] = {
			[999] = true,
		},
	},
	["Blessing"] = {
		["enabled"] = true,
		["filter"] = {
			[999] = true,
		},
		["missingColor"] = {
			["TG"] = 1,
			["B"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["show"] = true,
			["useOpacity"] = true,
			["TO"] = 1,
			["useBackground"] = true,
			["useText"] = true,
			["TR"] = 1,
			["O"] = 1,
			["R"] = 1,
		},
		["buff"] = "Blessing of Kings",
	},
	["Beacon of Light"] = {
		["missingColor"] = {
			["TG"] = 1,
			["R"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["show"] = false,
			["B"] = 1,
			["TO"] = 1,
			["useBackground"] = true,
			["TR"] = 1,
			["useText"] = true,
			["O"] = 1,
			["useOpacity"] = true,
		},
		["enabled"] = false,
		["name"] = "Apiphany",
		["filter"] = {
			[999] = true,
		},
	},
	["Righteous Fury"] = {
		["missingColor"] = {
			["TG"] = 1,
			["R"] = 1,
			["TB"] = 1,
			["G"] = 1,
			["show"] = false,
			["B"] = 1,
			["TO"] = 1,
			["useBackground"] = true,
			["TR"] = 1,
			["useText"] = true,
			["O"] = 1,
			["useOpacity"] = true,
		},
		["filter"] = {
			[999] = true,
		},
		["enabled"] = false,
		["buff"] = "Righteous Fury",
	},
}
VUHDO_POWER_TYPE_COLORS = {
	{
		["TG"] = 0,
		["R"] = 1,
		["TB"] = 0,
		["G"] = 0,
		["TR"] = 1,
		["TO"] = 1,
		["useText"] = true,
		["useOpacity"] = true,
		["useBackground"] = true,
		["O"] = 1,
		["B"] = 0,
	}, -- [1]
	{
		["TG"] = 0.5,
		["R"] = 1,
		["TB"] = 0.25,
		["G"] = 0.5,
		["TR"] = 1,
		["TO"] = 1,
		["useText"] = true,
		["useOpacity"] = true,
		["useBackground"] = true,
		["O"] = 1,
		["B"] = 0.25,
	}, -- [2]
	{
		["TG"] = 1,
		["R"] = 1,
		["TB"] = 0,
		["G"] = 1,
		["TR"] = 1,
		["TO"] = 1,
		["useText"] = true,
		["useOpacity"] = true,
		["useBackground"] = true,
		["O"] = 1,
		["B"] = 0,
	}, -- [3]
	{
		["TG"] = 1,
		["R"] = 0,
		["TB"] = 1,
		["G"] = 1,
		["TR"] = 0,
		["TO"] = 1,
		["useText"] = true,
		["useOpacity"] = true,
		["useBackground"] = true,
		["O"] = 1,
		["B"] = 1,
	}, -- [4]
	nil, -- [5]
	{
		["TG"] = 0.5,
		["R"] = 0.5,
		["TB"] = 0.5,
		["G"] = 0.5,
		["TR"] = 0.5,
		["TO"] = 1,
		["useText"] = true,
		["useOpacity"] = true,
		["useBackground"] = true,
		["O"] = 1,
		["B"] = 0.5,
	}, -- [6]
	[0] = {
		["TG"] = 0,
		["R"] = 0,
		["TB"] = 1,
		["G"] = 0,
		["TR"] = 0,
		["TO"] = 1,
		["useText"] = true,
		["useOpacity"] = true,
		["useBackground"] = true,
		["O"] = 1,
		["B"] = 1,
	},
}
VUHDO_SPELLS_KEYBOARD = {
	["SPELL15"] = "",
	["SPELL6"] = "",
	["SPELL8"] = "",
	["HOSTILE_WHEEL"] = {
		["1"] = {
			"", -- [1]
			"-w1", -- [2]
			"", -- [3]
		},
		["altctrl2"] = {
			"ALT-CTRL-", -- [1]
			"-w10", -- [2]
			"", -- [3]
		},
		["ctrl2"] = {
			"CTRL-", -- [1]
			"-w6", -- [2]
			"", -- [3]
		},
		["2"] = {
			"", -- [1]
			"-w2", -- [2]
			"", -- [3]
		},
		["shift1"] = {
			"SHIFT-", -- [1]
			"-w7", -- [2]
			"", -- [3]
		},
		["shift2"] = {
			"SHIFT-", -- [1]
			"-w8", -- [2]
			"", -- [3]
		},
		["altshift1"] = {
			"ALT-SHIFT-", -- [1]
			"-w11", -- [2]
			"", -- [3]
		},
		["altctrl1"] = {
			"ALT-CTRL-", -- [1]
			"-w9", -- [2]
			"", -- [3]
		},
		["ctrl1"] = {
			"CTRL-", -- [1]
			"-w5", -- [2]
			"", -- [3]
		},
		["altctrlshift2"] = {
			"ALT-CTRL-SHIFT-", -- [1]
			"-w16", -- [2]
			"", -- [3]
		},
		["altshift2"] = {
			"ALT-SHIFT-", -- [1]
			"-w12", -- [2]
			"", -- [3]
		},
		["alt2"] = {
			"ALT-", -- [1]
			"-w4", -- [2]
			"", -- [3]
		},
		["altctrlshift1"] = {
			"ALT-CTRL-SHIFT-", -- [1]
			"-w15", -- [2]
			"", -- [3]
		},
		["ctrlshift1"] = {
			"CTRL-SHIFT-", -- [1]
			"-w13", -- [2]
			"", -- [3]
		},
		["alt1"] = {
			"ALT-", -- [1]
			"-w3", -- [2]
			"", -- [3]
		},
		["ctrlshift2"] = {
			"CTRL-SHIFT-", -- [1]
			"-w14", -- [2]
			"", -- [3]
		},
	},
	["SPELL3"] = "",
	["SPELL4"] = "",
	["SPELL2"] = "",
	["SPELL16"] = "",
	["INTERNAL"] = {
	},
	["SPELL7"] = "",
	["SPELL12"] = "",
	["SPELL5"] = "",
	["SPELL9"] = "",
	["SPELL10"] = "",
	["version"] = 2,
	["SPELL14"] = "",
	["WHEEL"] = {
		["1"] = {
			"", -- [1]
			"-w1", -- [2]
			"", -- [3]
		},
		["altctrl2"] = {
			"ALT-CTRL-", -- [1]
			"-w10", -- [2]
			"", -- [3]
		},
		["ctrl2"] = {
			"CTRL-", -- [1]
			"-w6", -- [2]
			"", -- [3]
		},
		["2"] = {
			"", -- [1]
			"-w2", -- [2]
			"", -- [3]
		},
		["shift1"] = {
			"SHIFT-", -- [1]
			"-w7", -- [2]
			"", -- [3]
		},
		["shift2"] = {
			"SHIFT-", -- [1]
			"-w8", -- [2]
			"", -- [3]
		},
		["altshift1"] = {
			"ALT-SHIFT-", -- [1]
			"-w11", -- [2]
			"", -- [3]
		},
		["altctrl1"] = {
			"ALT-CTRL-", -- [1]
			"-w9", -- [2]
			"", -- [3]
		},
		["ctrl1"] = {
			"CTRL-", -- [1]
			"-w5", -- [2]
			"", -- [3]
		},
		["altctrlshift2"] = {
			"ALT-CTRL-SHIFT-", -- [1]
			"-w16", -- [2]
			"", -- [3]
		},
		["altshift2"] = {
			"ALT-SHIFT-", -- [1]
			"-w12", -- [2]
			"", -- [3]
		},
		["alt2"] = {
			"ALT-", -- [1]
			"-w4", -- [2]
			"", -- [3]
		},
		["altctrlshift1"] = {
			"ALT-CTRL-SHIFT-", -- [1]
			"-w15", -- [2]
			"", -- [3]
		},
		["ctrlshift1"] = {
			"CTRL-SHIFT-", -- [1]
			"-w13", -- [2]
			"", -- [3]
		},
		["alt1"] = {
			"ALT-", -- [1]
			"-w3", -- [2]
			"", -- [3]
		},
		["ctrlshift2"] = {
			"CTRL-SHIFT-", -- [1]
			"-w14", -- [2]
			"", -- [3]
		},
	},
	["SPELL13"] = "",
	["SPELL1"] = "",
	["SPELL11"] = "",
}
VUHDO_SPELL_CONFIG = {
	["IS_LOAD_HOTS"] = false,
	["IS_TOOLTIP_INFO"] = false,
	["IS_FIRE_HOT"] = false,
	["smartCastModi"] = "all",
	["IS_AUTO_FIRE"] = true,
	["IS_FIRE_CUSTOM_2"] = false,
	["IS_FIRE_TRINKET_2"] = true,
	["IS_FIRE_TRINKET_1"] = true,
	["IS_AUTO_TARGET"] = false,
	["IS_KEEP_STANCE"] = false,
	["FIRE_CUSTOM_1_SPELL"] = "",
	["autoBattleRez"] = true,
	["FIRE_CUSTOM_2_SPELL"] = "",
	["IS_FIRE_CUSTOM_1"] = false,
	["IS_FIRE_OUT_FIGHT"] = false,
}
VUHDO_BUFF_ORDER = {
	["04Inner Fire"] = 4,
	["07Vampiric Embrace"] = 7,
	["05Shadowfiend"] = 5,
	["04Beacon of Light"] = 5,
	["01Power Word: Fortitude"] = 1,
	["02Aura"] = 1,
	["05Righteous Fury"] = 2,
	["03Fear Ward"] = 3,
	["09Pain Suppression"] = 9,
	["01Blessing"] = 4,
	["03Seal"] = 3,
	["08Levitate"] = 8,
	["06Power Infusion"] = 6,
	["02Shadow Protection"] = 2,
}
VUHDO_SPEC_LAYOUTS = {
	["1"] = "",
	["selected"] = "",
	["2"] = "",
}
VUHDO_LAST_AUTO_ARRANG = "Heals-Solo"
VUHDO_RAID = {
	["player"] = {
		["zone"] = "Orgrimmar",
		["baseRange"] = true,
		["class"] = "PALADIN",
		["role"] = 63,
		["sortMaxHp"] = 6212,
		["map"] = "Orgrimmar",
		["powermax"] = 6188,
		["mibucateg"] = "Blessing",
		["threatPerc"] = 0,
		["missbuff"] = 4,
		["isPet"] = false,
		["name"] = "Apiphany",
		["number"] = 1,
		["isVehicle"] = false,
		["group"] = 1,
		["classId"] = 23,
		["range"] = true,
		["unit"] = "player",
		["powertype"] = 0,
		["healthmax"] = 6212,
		["connected"] = 1,
		["fullName"] = "Apiphany",
		["power"] = 6188,
		["aggro"] = false,
		["visible"] = 1,
		["mibuvariants"] = {
			{
				"Blessing of Kings", -- [1]
				10, -- [2]
				"Mark of the Wild", -- [3]
			}, -- [1]
		},
		["health"] = 6212,
		["className"] = "Paladin",
		["targetUnit"] = "target",
		["debuff"] = 7,
		["debuffName"] = "",
		["petUnit"] = "pet",
	},
}
VUHDO_INDICATOR_CONFIG = {
	["CUSTOM"] = {
		["THREAT_BAR"] = {
			["invertGrowth"] = false,
			["turnAxis"] = false,
			["HEIGHT"] = 4,
			["WARN_AT"] = 85,
			["TEXTURE"] = "VuhDo - Polished Wood",
		},
		["MOUSEOVER_HIGHLIGHT"] = {
			["TEXTURE"] = "LiteStepLite",
		},
		["AGGRO_BAR"] = {
			["TEXTURE"] = "VuhDo - Polished Wood",
		},
		["BACKGROUND_BAR"] = {
			["TEXTURE"] = "VuhDo - Minimalist",
		},
		["CLUSTER_BORDER"] = {
			["WIDTH"] = 2,
		},
		["SIDE_LEFT"] = {
			["turnAxis"] = false,
			["vertical"] = true,
			["invertGrowth"] = false,
			["TEXTURE"] = "VuhDo - Polished Wood",
		},
		["BAR_BORDER"] = {
			["WIDTH"] = 1,
		},
		["MANA_BAR"] = {
			["turnAxis"] = false,
			["invertGrowth"] = false,
			["TEXTURE"] = "VuhDo - Pipe, light",
		},
		["HEALTH_BAR"] = {
			["turnAxis"] = false,
			["vertical"] = false,
			["invertGrowth"] = false,
		},
		["SIDE_RIGHT"] = {
			["turnAxis"] = false,
			["vertical"] = true,
			["invertGrowth"] = false,
			["TEXTURE"] = "VuhDo - Polished Wood",
		},
		["SWIFTMEND_INDICATOR"] = {
			["SCALE"] = 1,
		},
	},
	["BOUQUETS"] = {
		["THREAT_BAR"] = "Threat: Status Bar",
		["MOUSEOVER_HIGHLIGHT"] = "",
		["AGGRO_BAR"] = "",
		["BACKGROUND_BAR"] = "Background: Solid",
		["DAMAGE_FLASH_BAR"] = "",
		["SIDE_LEFT"] = "",
		["HEALTH_BAR_PANEL"] = {
			"", -- [1]
			"", -- [2]
			"", -- [3]
			"", -- [4]
			"", -- [5]
			"", -- [6]
			"", -- [7]
			"", -- [8]
			"", -- [9]
			"", -- [10]
		},
		["SWIFTMEND_INDICATOR"] = "LowMana",
		["THREAT_MARK"] = "",
		["BAR_BORDER"] = "Border: Multi + Aggro",
		["SIDE_RIGHT"] = "",
		["MANA_BAR"] = "Manabars: All Powers",
		["HEALTH_BAR"] = "Health (generic, class col)",
		["CLUSTER_BORDER"] = "",
		["INCOMING_BAR"] = "",
	},
}
VUHDO_EVENT_TIMES = nil
end

-- ========================= --
-- Profile & Settings Loader --
-- ========================= --
local function AddChar()
	if (CID ~= "") and not HasAdded then 
		tinsert(meekaI_Names, CID)
		HasAdded = true
	end
end

local function CharAnswered(ans)
	AddChar()
	if ans then
		SetacbFT();
		SetAddonLoader();
		SetALT();
		SetAzCastBar();
		SetAzCastBarPSV();
		SetBankStack(); -- Has to be manually done : / until the author fixes profiles.
		SetBartender();
		SetButtonFacade();
		SetDXE();
		SetDXEL();
		SetForte();
		SetFortress();
		SetGCDRing();
		SetMapster();
		SetmDate();
		SetMSBT();
		SetMSBTPSV();
		SetnibCT();
		SetnibMM();
		SetnibSAC();
		SetNugsCB();
		SetonSH();
		SetoPie();
		SetPassLoot();
		SetPocketPlot();
		SetPrat();
		SetQuartz();
		SetQuestGuru();
		SetQuestGuruPSV();
		SetRatingBuster();
		SetrBBSPSV();
		SetSBF();
		SetSkada();
		SetStuf();
		SetTidyPlatesPSV();
		SetTPNeonDPSPSV();
		SetTipTac();
		SetTomTom();
		SetVolumizer();
		SetVuhDo();
		SetVuhDOPSV();
		SetWIM();
		-- Magic
		DisableAddOn("Meeka_Init");
		ReloadUI();
	end
end

local function AskNewChar()
	StaticPopupDialogs["CONFIGURE_KISEKIUI"] = {
		text = "CLICK 1st: Do you wish to load default settings for all addons?",
		button1 = "Yes",
		button2 = "No",
		OnAccept = function()
			CharAnswered(true)
		end,
		OnCancel = function()
			CharAnswered(false)
		end,
		timeout = 0,
		whileDead = true,
		hideOnEscape = false,
		notClosableByLogout = true,
	}
StaticPopup_Show("CONFIGURE_KISEKIUI");
end

local function CheckNewChar()
	CID = string.format("%s - %s", GetRealmName(), UnitName("player"))
	CE = false
	if (meekaI_Names == nil) then meekaI_Names = { }; end
	for i,v in pairs(meekaI_Names) do
		if (v == CID) then CE = true; end
	end
	if not CE then AskNewChar(); end
end

-- Slash command to manually load the installer
SlashCmdList["UII"] = function() AskNewChar() end
SLASH_UII1 = "/uii"

local function eventHandler(self, event, ...)
  if (event == "VARIABLES_LOADED") then
    CheckNewChar()
  end
end
frame:SetScript("OnEvent", eventHandler);